"pftools" is a collection of experimental programs supporting the
generalized profile format and search method of PROSITE.
A description of the generalized profile format is given in file:

   profile.txt

Version 2.2 contains FORTRAN 77 source code and manual pages for
the following programs:

   pfsearch
   pfscan
   psa2msa
   gtop  
   htop
   ptoh
   pfmake
   pfw
   pfscale 
   ptof
   6ft
   2ft

These programs have successfully been compiled and tested under
Solaris, IRIX64, HP-UX, and Linux operating systems, using
the GNU g77 compiler. 

For compilation with native f77 compilers, the Makefile needs
to be modified according to instructions given therein.  

For use under HP-UX, the file sterr.f should also be modified
according to instructions given therein. 

To run the programs on machines with less than 32 MB RAM, modify 
the file ardim.f according to instructions given therein. 

The "Integer*2" declarations may cause problems with early versions
of the g77 compiler; solution: replace "Integer*2" by "Integer". 

In order to compile the programs, type:

   make

This will create the nine binaries listed above. To install the 
the binaries and the corresponding manual pages, first define
the target directories in the Makefile, then type:

   make install

*-----
 
Further included in this release are the following demo data files:

   CVPBR322
   sh3.seq 
   GTPA_HUMAN
   sh3.msf
   ecp.prf
   sh3.gpr
   sh3.prf 
   pfam_sh3.hmm
   prosite13.prf
   standard.random
   blosum45.cmp
   score.lis
   coils.prf
   MYSA_HUMAN
   R76849.seq

plus the following additional substution matrices in old GCG format: 

   blosum30.cmp
   blosum50.cmp
   blosum62.cmp
   blosum65.cmp
   blosum80.cmp
   blosum100.cmp
   gonnet.cmp
   pam30.cmp
   pam40.cmp
   pam80.cmp
   pam120.cmp
   pam160.cmp
   pam200.cmp
   pam220.cmp
   pam250.cmp
   pam400.cmp

a test script: 

   test.sh 

and a test ouput file: 

   test.out

To test the programs, type: 

   sh  test.sh > out 
   diff test.out out 

Some rounding or formatting variation may occur with real number
editing. With g77 there will be lots of small integer rounding
differences in the result of test 7.  

Note that the file pfam_sh3.hmm contains a hidden Markov model from the
PFAM A collection release 4.0 (see http://www.sanger.ac.uk/Pfam).

*-----

Total number of files included in this directory: 101

*-----

Please send bug reports to:

   Philipp Bucher
   E-mail: Philipp.Bucher@isrec.unil.ch

Philipp Bucher, July 1999

[![install with bioconda](https://img.shields.io/badge/install%20with-bioconda-brightgreen.svg?style=flat)](http://bioconda.github.io/recipes/pftools/README.html)
[![install with EasyBuild](https://img.shields.io/badge/install%20with-EasyBuild-brightgreen.svg?style=flat)](#easybuild)
[![install with Docker](https://img.shields.io/badge/install%20with-Docker-brightgreen.svg?style=flat)](#using-docker)
[![install with Singularity](https://img.shields.io/badge/install%20with-Singularity-brightgreen.svg?style=flat)](#using-singularity)
[![Anaconda-Server Badge](https://anaconda.org/bioconda/pftools/badges/license.svg)](https://anaconda.org/bioconda/pftools)
[![Anaconda-Server Badge](https://img.shields.io/conda/dn/bioconda/pftools.svg?style=flat)](https://anaconda.org/bioconda/pftools)

PfTools
=========================================

## Table of Contents

   * [Foreword](#foreword)
   * [Installation](#installation)
     * [Using Docker](#using-docker)
     * [Using Singularity](#using-singularity)
     * [Bioconda](#bioconda)
     * [EasyBuild](#easybuild)
     * [Manually](#manually) 
   * [Generalized profile syntax](#generalized-profile-syntax)
   * [Algorithms description](#algorithms-description)
   * [Applications of the Pftools](#applications-of-the-pftools)
   * [Authors](#authors)

# Foreword

(C) Copyright SIB Swiss Institute of Bioinformatics
available from  https://github.com/sib-swiss/pftools3 under GPL v2. See LICENSE.


Version 3 contains the original FORTRAN 77 pftools (release 2.3)
and the new pftoolsV3 programs.

# Installation

### Using Docker

First you must have [Docker](https://docs.docker.com/get-docker/) installed and running.  
Secondly have a look at the availabe pftools biocontainers at [quay.io](https://quay.io/repository/biocontainers/pftools?tab=tags) or at [Docker Hub](https://hub.docker.com/r/sibswiss/pftools).  
Then:
```sh
# get the chosen pftools container version
docker pull quay.io/biocontainers/pftools:3.2.11--pl5321r41h4b1256a_2
#   or
docker pull sibswiss/pftools:3.2.12
# use an pftools's tool e.g. pfscan 
docker run quay.io/biocontainers/pftools:3.2.11--pl5321r41h4b1256a_2 pfscan -h
#   or
docker run sibswiss/pftools:3.2.12 pfscan -h
```

### Using Singularity

First you must have [Singularity](https://sylabs.io/guides/master/user-guide/quick_start.html) installed and running.
Secondly have a look at the availabe pftools biocontainers at [quay.io](https://quay.io/repository/biocontainers/pftools?tab=tags) or at [Docker Hub](https://hub.docker.com/r/sibswiss/pftools).  
Then:
```sh
# get the chosen pftools container version
singularity pull docker://quay.io/biocontainers/quay.io/biocontainers/pftools:3.2.11--pl5321r41h4b1256a_2
#   or
singularity pull docker://sibswiss/pftools:3.2.12
# run the container
singularity run pftools_3.2.11--pl5321r41h4b1256a_2.sif
```

You are now in the container. You can use an pftools's tool e.g. pfscan doing 
```sh
pfscan -h
```

## Bioconda

```sh
conda install -c bioconda pftools
```

## EasyBuild

```sh
eb --robot --rpath pftoolsV3-3.2.11-foss-2021a.eb
```

## Manually

See [here](./INSTALL) for more information


After installation, in the share/examples/ subdirectory, the *test_V3.sh* shell script is a good starting point for using pfsearchV3/pfscanV3.

# Generalized profile syntax

A description of the generalized profile syntax is given in file:

- [doc/profile.txt](https://raw.githubusercontent.com/sib-swiss/pftools3/master/doc/profile.txt)  (original document)
- [doc/profile.pdf](https://raw.githubusercontent.com/sib-swiss/pftools3/master/doc/profile.pdf)  (revised and completed version)

it was originally published in

* Bucher P, Bairoch A.
  A generalized profile syntax for biomolecular sequence motifs
  and its function in automatic sequence interpretation.
  Proc Int Conf Intell Syst Mol Biol. 1994;2:53-61.
  PubMed PMID: [7584418](https://www.ncbi.nlm.nih.gov/pubmed/7584418).


# Algorithms description

Technical details about how profiles can be constructed and parametrized
are summarized in file:

- [doc/profile.pdf](https://raw.githubusercontent.com/sib-swiss/pftools3/master/doc/profile.pdf)

The very first paper describing the PFTOOLS algorithms is

* Lüthy R, Xenarios I, Bucher P.
  Improving the sensitivity of the sequence profile method.
  Protein Sci. 1994 Jan;3(1):139-46.
  PubMed PMID: [7511453](https://www.ncbi.nlm.nih.gov/pubmed/7511453); PubMed Central PMCID: PMC2142471.

The generalized profile alignment method is closely related to other "classical"
algorithm for aligning sequences. For example, it encompasses the Smith-Waterman
algorithm and the Viterbi decoding of profile-HMM (as implemented in HMMER2 for
example). Relationships between these algorithm were investigated in

* Bucher P, Hofmann K.
  A sequence similarity search algorithm based on a probabilistic interpretation of an alignment scoring system.
  Proc Int Conf Intell Syst Mol Biol. 1996;4:44-51. Review.
  PubMed PMID: [8877503](https://www.ncbi.nlm.nih.gov/pubmed/8877503).

* Bucher P, Karplus K, Moeri N, Hofmann K.
  A flexible motif search technique based on generalized profiles.
  Comput Chem. 1996 Mar;20(1):3-23.
  PubMed PMID: [8867839](https://www.ncbi.nlm.nih.gov/pubmed/8867839).

Relatively detailed explanations about the profile normalized scores, as well as its
comparisons with other popular statistics for sequence alignments can be found in

* Pagni M, Jongeneel CV.
  Making sense of score statistics for sequence alignments.
  Brief Bioinform. 2001 Mar;2(1):51-67.
  PubMed PMID: [11465063](https://www.ncbi.nlm.nih.gov/pubmed/11465053).

The heuristic score is succinctly described in

* Schuepbach T, Pagni M, Bridge A, Bougueleret L, Xenarios I, Cerutti L.
  pfsearchV3: a code acceleration and heuristic to search PROSITE profiles.
  Bioinformatics. 2013 May 1;29(9):1215-7. doi: 10.1093/bioinformatics/btt129.
  PubMed PMID: [23505298](https://www.ncbi.nlm.nih.gov/pubmed/23505298); PubMed Central PMCID: PMC3634184.

# Applications of the Pftools

Two databases were created based on the PFTOOLS technology: PROSITE and HAMAP
and they are still actively maintained

1. https://prosite.expasy.org/
1. https://hamap.expasy.org/

The PFTOOLS were initially designed with handling capabilities of DNA sequences.
The latest released pfsearchV3 feature support for FASTQ and SAM formats. DNA
applications are for example given in

* Pagni M, Niculita-Hirzel H, Pellissier L, Dubuis A, Xenarios I, Guisan A, Sanders IR, Goudet J, Guex N.
  Density-based hierarchical clustering of pyro-sequences on a large scale - the case of fungal ITS1.
  Bioinformatics. 2013 May 15;29(10):1268-74. doi: 10.1093/bioinformatics/btt149.
  PubMed PMID: [23539304](https://www.ncbi.nlm.nih.gov/pubmed/23539304) ; PubMed Central PMCID: PMC3654712.

* Schmid-Siegert E, Richard S, Luraschi A, Mühlethaler K, Pagni M, Hauser PM.
  Mechanisms of Surface Antigenic Variation in the Human Pathogenic Fungus Pneumocystis jirovecii.
  MBio. 2017 Nov 7;8(6). pii: e01470-17. doi: 10.1128/mBio.01470-17.
  PubMed PMID: [29114024](https://www.ncbi.nlm.nih.gov/pubmed/29114024); PubMed Central PMCID: PMC5676039.

# Authors

Mas:
- Philipp Bucher developped the Fortran code
- Thierry Schuepbach developped the C code

Other contributors:
- Kay Hofmann
- Volker Flegel
- Edouard de Castro
- Lorenzo Cerruti
- Marco Pagni
- Sébastien Moretti
- Jerven Tjalling Bolleman

[SIB Swiss Institute of Bioinformatics](https://www.sib.swiss/)
[Vital-IT Group](https://www.vital-it.ch/)
Quartier Sorge - Batiment Amphipole
1015 Lausanne
Switzerland

# Description of *pftools* release 2.3 package and files

Contents:

1. Package description
  * Profile format
  * Programs and manual pages
  * Compilation issues
2. Installation
  * Compiling
  * Installing
3. File list
4. Testing
5. Contact


## Package description
The *pftools* package is a collection of experimental programs supporting the
generalized profile format and search method of PROSITE.
A description of the generalized profile format is given in the file:

   [doc/profile.txt](https://raw.githubusercontent.com/sib-swiss/pftools3/master/doc/profile.txt)

The official web site for the *pftools* package can be found under:

   [pftools](https://web.expasy.org/pftools/)

Further information on PROSITE specific applications of the *pftools* programs
can be found at the following URL:

   [PROSITE](https://prosite.expasy.org/)

Release 2.3 contains FORTRAN 77 source code and manual pages for the following
programs:

```
   pfsearch
   pfscan
   psa2msa
   gtop
   htop
   ptoh
   pfmake
   pfw
   pfscale
   ptof
   6ft
   2ft
```

Some supplementary manual pages describing the *psa* and *xpsa* file formats
have also been included.

These programs have successfully been compiled and tested under Solaris,
IRIX64, HP-UX, Tru64 and Linux operating systems, using the GNU g77 or f77
compilers.

For compilation with native f77 compilers, the Makefile needs to be modified
according to instructions given therein.

For use under HP-UX, the file *sterr.f* should also be modified according to
instructions given therein.

The buffer sizes in release 2.3 of the *pftools* have been significantly
increased to handle large sequences and profiles. Therefore it might be
necessary to reduce the buffer sizes in order to run the programs on machines
with less RAM. This can be achieved by modifying the file *ardim.f* according
to instructions given therein.

The "Integer*2" declarations may cause problems with early versions
of the g77 compiler; solution: replace "Integer*2" by "Integer".


## Installation
The compressed *tar* archive can be extracted to the current directory using
the following command:

```
   tar -xzvf pft2.3.tar.gz
```

This will create a directory containing the source and package files.

In order to compile the programs on Unix like systems with a FORTRAN 77
compiler, change into the source directory and simply type:

```
   make all
```

This will create the 12 binaries listed above. To install the binaries and the
corresponding manual pages, an installation script has been provided. It can
be invoked using:

```
   make install
```

The installation script will ask the user the destination directory for the
*pftools* package. This directory will contain all the supplementary files,
as well as a *bin* directory for the executable programs. The installer will
then create symbolic links to the binary programs in a directory specified by
the user. This directory should be included in the users *PATH* variable for
him to be able to execute the *pftools* programs.
In a last step, the installer will link the man pages in the system wide man
page location, this location can also be specified by the user.
After successful installation, the build directory can safely be deleted.

Note that you should have write permissions on the destination directories
specified during installation. For system wide installation you may need root
privileges, if necessary contact your system administrator.


## File list
Further included in this release are the following demo data files:

```
   CVPBR322
   sh3.seq
   GTPA_HUMAN
   sh3.msf
   ecp.prf
   sh3.gpr
   sh3.prf
   pfam_sh3.hmm
   prosite13.prf
   standard.random
   blosum45.cmp
   score.lis
   coils.prf
   MYSA_HUMAN
   R76849.seq
```

plus the following additional substution matrices in old GCG format:

```
   blosum30.cmp
   blosum50.cmp
   blosum62.cmp
   blosum65.cmp
   blosum80.cmp
   blosum100.cmp
   gonnet.cmp
   pam30.cmp
   pam40.cmp
   pam80.cmp
   pam120.cmp
   pam160.cmp
   pam200.cmp
   pam220.cmp
   pam250.cmp
   pam400.cmp
```

## Testing
A test script is provided. It will simply execute all the *pftools* binaries
with some example files. The test script *test.sh* should be executed in
the same directory as the binaries and the demo files. An example test
output file *test.out* is provided as a reference.
To test the programs, type:

```
   ./test.sh > out
   diff test.out out
```

Some rounding or formatting variation may occur with real number
editing. With g77 there will be lots of small integer rounding
differences in the result of test 7.

Note that the file pfam_sh3.hmm contains a hidden Markov model from the
PFAM A collection release 4.0 (see [Pfam](http://pfam.xfam.org/)).


## Contact
Please send bug reports to:

   pftools@sib.swiss

The pftools package was originaly developed by _Philipp Bucher_ and was
maintained by _Thierry Schuepbach_ at the:

```
SIB Swiss Institute of Bioinformatics
Vital-IT Group
Quartier Sorge, Batiment Amphipole
CH-1015 Lausanne
Switzerland
```

[SIB](https://www.sib.swiss)

ps_scan documentation
=====================

Reference:
Alexandre Gattiker, Elisabeth Gasteiger, Amos Bairoch.
ScanProsite: a reference implementation of a PROSITE scanning tool.
Applied Bioinformatics 2002:1(2) 107-108.

Contact: prosite@expasy.org

ps_scan is a perl program used to scan one or several patterns, rules and/or
profiles from PROSITE against one or several protein sequnces in Swiss-Prot or
FASTA format. It requires two compiled external programs from the PFTOOLS
package : "pfscan" used to scan a sequence against a profile library and
"psa2msa" which is necessary for the "-o msa" output format only.

Authors:
 Alexandre Gattiker
 Edouard de Castro; E-mail: ecastro@sib.swiss
 Elisabeth Gasteiger

Installation
------------

Download a binary package for your platform from

ftp://ftp.expasy.org/databases/prosite/ps_scan/ps_scan_<platform>.tar.gz

or the source packages from

ftp://ftp.lausanne.sib.swiss/pub/software/unix/pftools/

in which case you will need gcc or a compatible fortran compiler to compile the
pftools sources.

You may need to edit the ps_scan.pl to provide absolute paths to the directory
where you have installed the pfscan and psa2msa executables, unless you have
stored them in a directory in your PATH.

A local copy of the PROSITE database is also needed. You may download it
in a single file from

ftp://ftp.expasy.org/databases/prosite/prosite.dat

Usage
-----

perl ps_scan.pl [options] sequence-file(s)
ps_scan version $VERSION options:
-h : this help screen
Input/Output:
  -e : specify the ID or AC of an entry in sequence-file
  -o : specify an output format : $formats_string
  -d : specify a prosite.dat file
  -p : specify a pattern or the AC of a prosite motif
  -f : specify a motif AC to scan against together with all its
       releated post-processing motifs (but show only specified
       motif hits)
Selection:
  -r : do not scan profiles
  -m : only scan profiles
  -s : skip frequently matching (unspecific) patterns and profiles
  -l : cut-off level for profiles (default : 0)
Pattern match mode:
  -x : specify maximum number of accepted matches of X's in sequence
       (default=1)
  -g : Turn greediness off
  -v : Turn overlaps off
  -i : Allow included matches

The sequence-file may be in Swiss-Prot or FASTA format.
If no PROSITE file is submitted, it will be searched in the paths
$PROSITE/prosite.dat and $SPROT/prosite/prosite.dat.
There may be several -d, -p and -q arguments.

Pfsearch options:
  -w pfsearch : Compares a query profile against a protein sequence library.
  A profile file must be specified with option -d.

   $progname -w pfsearch [-C cutoff] [-R] -d profile-file seq-library-file(s)

 -R: use raw scores rather than normalized scores for match selection
 -C=# : Cut-off value. Reports only match score higher than the specified
        parameter.
An integer argument is interpreted as a raw score value,
a decimal argument as a normalized score value. An integer value forces
option -R.


Output formats
--------------

An output format may be specified with the -o option. Here are the available
formats, with an example output with a profile :

-o scan : default ps_scan output format.

YAHD_ECOLI : PS50088 ANK_REPEAT Ankyrin repeat profile.
      12 - 37  -------LAAQQGDIDKVKTCLALGVDINTCDR                           L=-1
      38 - 70  QGKTAITLASLYQQYACVQALIDAGADINKQDH                           L=0
    138 - 175  VGWTPLLEAIVLNDGGikqqaIVQLLLEHGASPHLTDK                      L=0
    176 - 201  YGKTPLELARERGFEEIAQLLIAAGA-------                           L=0

-o fasta : matching sequences in FASTA format.

>YAHD_ECOLI/12-37 : PS50088 ANK_REPEAT L=-1 Ankyrin repeat profile.
LAAQQGDIDKVKTCLALGVDINTCDR
>YAHD_ECOLI/38-70 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
QGKTAITLASLYQQYACVQALIDAGADINKQDH
>YAHD_ECOLI/138-175 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
VGWTPLLEAIVLNDGGIKQQAIVQLLLEHGASPHLTDK
>YAHD_ECOLI/176-201 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
YGKTPLELARERGFEEIAQLLIAAGA

-o psa : profile-to-sequence-alignments with insertions in lowercase and
         deletions marked as dashes.

>YAHD_ECOLI/12-37 : PS50088 ANK_REPEAT L=-1 Ankyrin repeat profile.
-------LAAQQGDIDKVKTCLALGVDINTCDR
>YAHD_ECOLI/38-70 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
QGKTAITLASLYQQYACVQALIDAGADINKQDH
>YAHD_ECOLI/138-175 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
VGWTPLLEAIVLNDGGikqqaIVQLLLEHGASPHLTDK
>YAHD_ECOLI/176-201 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
YGKTPLELARERGFEEIAQLLIAAGA-------

-o msa : multiple sequence alignment of the matches in each sequence, built
         from the psa format with gaps marked as dots.

>YAHD_ECOLI/12-37 : PS50088 ANK_REPEAT L=-1 Ankyrin repeat profile.
-------LAAQQGDID.....KVKTCLALGVDINTCDR
>YAHD_ECOLI/38-70 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
QGKTAITLASLYQQYA.....CVQALIDAGADINKQDH
>YAHD_ECOLI/138-175 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
VGWTPLLEAIVLNDGGikqqaIVQLLLEHGASPHLTDK
>YAHD_ECOLI/176-201 : PS50088 ANK_REPEAT L=0 Ankyrin repeat profile.
YGKTPLELARERGFEE.....IAQLLIAAGA-------

-o pff : tabular format listing bounding positions on the sequence and the
         profile, the raw and normalized profile score, and the cut-off level.

YAHD_ECOLI	12	37	ANK_REPEAT	8	-1	196	6.653	-1
YAHD_ECOLI	38	70	ANK_REPEAT	1	-1	351	10.793	0
YAHD_ECOLI	138	175	ANK_REPEAT	1	-1	288	9.110	0
YAHD_ECOLI	176	201	ANK_REPEAT	1	-8	343	10.579	0

Pattern and rule matches are reported in the same formats, but cut-off levels
are not available. In scan, psa and msa output formats, amino acids matching an
"x" in the pattern are reported in lowercase. In pff format only the first
three columns are available. The "-o matchlist" output format is specific to
patterns and not meant for public use.


Profile and pattern matching parameters
---------------------------------------

Several parameters can be fine-tuned.

- profile cut-off levels (-l option)

  Most profiles contain several cut-off levels. The level 0 cut-off is the
  trusted cut-off for positive matches, but a level -1 is usually defined above
  which a match is potential, especially if there are other matches in the
  sequence with the profile. By default, pfscan is run with the cut-off
  level 0, so that only trusted matches are reported. To retrieve potential
  (weak) matches as well, run ps_scan with the option "-l -1". Weak matches
  are then reported with the indication "L=-1".

- skip frequently matching patterns (-s option)

  Some PROSITE entries such as those describing commonly found post-
  translational modifications (a typical example is N-glycosylation) are found
  in the majority of known protein sequences. While it is generally useful to
  note their presence, some programs may want, in some cases, to ignore those
  entries, which contain the line "CC   /SKIP-FLAG=TRUE;".

Pattern match mode:

- pattern greediness off (-g option)

  A pattern-matching engine is said to be "greedy" if it tries to extend at
  most variable-length pattern elements. The sequence "ABCDC" and the pattern
  "A-x(1,3)-C" will produce the match "ABCDC" with a greedy engine, and the
  match "ABC" with a non-greedy one. By default, PROSITE is scanned in greedy
  mode, unless the -g option is set.

- overlaps (-v option) and included matches (-i option)

  Some patterns may produce distinct but overlapping matches on a given
  sequence.  Additionally, if the pattern contains variable-length elements,
  some of these matches may be completely included in another one. Different
  combinations of -g, -v and -i options may produce differences in match count
  and match positions with patterns that contain variable-length elements. An
  engine which allows overlaps should be greedy in order to reduce the number
  of multiple hits which are almost entirely overlapping except at the
  extremities.

- treatment of X characters in sequences (-x option)

  The PROSITE syntax describes how to treat ambiguities in the pattern, but not
  how to handle ambiguities in the sequence. In rare sequences in Swiss-Prot
  and other databases, the characters B and Z are used according to IUBMB
  nomenclature when a residue may be either Asp or Asn, or Glu or Gln,
  respectively. The ps_scan program will produce a match if the sequence has a
  "B" and the pattern allows either a "D" or a "N", or both (and similarly for
  Z).

  Whether the character X should be allowed to match any position of a pattern
  is more controversial. It is generally useful to accept a single pattern
  position to match X (unless that pattern position is an X itself, in which
  case we can accept more). The maximum number of X characters which are
  allowed to match a non-X position in a pattern can be specified with the -x
  option. The default value is 1.

Examples
--------

examples :

scan 1 sequence with 1 pattern
perl ps_scan.pl -p PS00123 seq.dat
perl ps_scan.pl -p "P-S-[QW]" seq.dat

scan 1 sequence with all prosite, including profiles
perl ps_scan.pl seq.dat

scan 2 profiles or patterns against swiss-prot
perl ps_scan.pl -p PS00123 -p PS00124 sprot.dat

scan all patterns and rules against swiss-prot
perl ps_scan.pl -r sprot.dat

scan a profile file against a sequence file
perl ps_scan.pl -d profile.prf sprot.dat

License
-------

The ps_scan program and the Prosite.pm module are Copyright (C) 2001-2006,
SIB Swiss Institute of Bioinformatics. They are released under the
terms of the GNU General Public License, available at
http://www.gnu.org/copyleft/gpl.html.

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

*----------------------------------------------------------------------*     
* $Id: xalip.f,v 2.7 2003/01/15 14:50:24 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine XALIP(
     *   NABC,LPRF,LPCI,N1,N2,
     *   KCUT,IIPP,IMPP,CHIP,CHMP,IIPX,
     *   BSEQ,LSEQ,ISEQ,LCKS,
     *   IOPM,IOPI,IOPD,
     *   IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2,
     *   NALI,IALS,IALB,IAL1,IAL2,IALE,
     *   LOPT,
     *   IRC)

*----------------------------------------------------------------------* 
* Data Section 
*----------------------------------------------------------------------* 

* profile:

      Include          'ardim.f'
      Include          'gsdat.f'
      Include          'pfdat.f'
      Include          'pxdat.f'
      Include          'sterr.f'

* sequence

      Integer           LSEQ
      Integer           BSEQ
      Integer*2         ISEQ(IDMS)
      Logical           LCKS(IDMS)

* alignments

      Integer           IALS(IDMN)
      Integer           IALB(IDMN)
      Integer           IAL1(IDMN)
      Integer           IAL2(IDMN)
      Integer           IALE(IDMN)

* alignment scores

      Integer           IOPM(0:IDMP)
      Integer           IOPI(0:IDMP)
      Integer           IOPD(0:IDMP)

* alignment positions

      Integer           IOMB(0:IDMP)
      Integer           IOM1(0:IDMP)
      Integer           IOM2(0:IDMP)

      Integer           IOIB(0:IDMP)
      Integer           IOI1(0:IDMP)
      Integer           IOI2(0:IDMP)

      Integer           IODB(0:IDMP)
      Integer           IOD1(0:IDMP)
      Integer           IOD2(0:IDMP)


* search control values 

      Integer           IBEG 
      Integer           ILCP
      Integer           IFCP
      Integer           NLCP
      Integer           JLCP 
      Integer           IFER 

      Integer           NSCA

* search only optimal match

      Logical           LOPT

*----------------------------------------------------------------------* 
* Inititialization Section
*----------------------------------------------------------------------* 

      IRC=0

* alignment list

      IOPT=NLOW
      NALI=0

* search control fields  

      IBEG=BSEQ-1
      JLCP=LPRF/2
      NSCA=0

*----------------------------------------------------------------------* 
* two-step-forwards-one-step-backwards loop  
*----------------------------------------------------------------------* 

 11   Continue
C       Write(6,'(''Searching range:'',I6,'' - '',I6)') IBEG,LSEQ

      I1=IBEG
      JALS=NLOW

* initiate work arrays 
      
      Call InitR(
     *   I1,LPCI,
     *   N1,N2,BSEQ,LSEQ,
     *   IDMP,LPRF,IIPP,IMPP,CHIP,CHMP,IIPX,  
     *   IOPM,IOPI,IOPD,
     *   IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2)

* intitiate search control values 

      ILCP=I1
      IFCP=I1+1
      NLCP=ILCP+JLCP

* move one sequence position forward 

      I1=I1+1

*----------------------------------------------------------------------* 
* loop over sequence positions 
*----------------------------------------------------------------------* 

 12   Continue 

      NSCA=NSCA+1

      Call NextR( 
     *   I1,LPCI,
     *   NABC,LPRF,N1,N2,
     *   KCUT,IDMP,IIPP,IMPP,CHIP,CHMP,IIPX,
     *   IDMS,LSEQ,ISEQ,LCKS,
     *   IOPM,IOPI,IOPD,
     *   IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2,
     *   JALS,JALB,JAL1,JAL2,JALE) 
C          Write(6,'(20I6)') I1,(IOPM(ii1),ii1=0,LPRF)
C          Write(6,'(20I6)') I1,(IOM1(ii1),ii1=0,LPRF)
C          Write(6,'(20I6)') I1,(IOPI(ii1),ii1=0,LPRF)
C          Write(6,'(20I6)') I1,(IOI1(ii1),ii1=0,LPRF)
C          Write(6,'(20I6)') I1,(IOPD(ii1),ii1=0,LPRF)
C          Write(6,'(20I6)') I1,(IOD1(ii1),ii1=0,LPRF)
C          Write(6,'('''')')

*----------------------------------------------------------------------* 
* work arrays updated, what next ?
*----------------------------------------------------------------------* 

* if match found 

      If(JALS.GE.KCUT) then

* - determine first ENTRY of current row 

         IFER=I1
         Do 51 I2=N1,LPRF
            If(IOD1(I2).LT.IFER) IFER=IOD1(I2)
            If(IOM1(I2).LT.IFER) IFER=IOM1(I2)
            If(IOI1(I2).LT.IFER) IFER=IOI1(I2)
 51      Continue

         
C                IFER=I1
C                L1=-1
C                L2=-1
C                L3=-1
C             Do 51 I2=N1,LPRF
C                If(IOD1(I2).LT.IFER) then 
C                   IFER=IOD1(I2)
C                   L1=I2
C                End if 
C                If(IOM1(I2).LT.IFER) then
C                   IFER=IOM1(I2)
C                   L2=I2
C                End if
C                If(IOI1(I2).LT.IFER) then
C                   IFER=IOI1(I2)
C                   L3=I2
C                End if
C  51         Continue
C             Write(6,'(5I8)') I1,IFER,L1,L2,L3

         If(IFER.GT.JAL2.OR.I1.EQ.LSEQ) then 

* - accept alingment
            
            NALI=NALI+1
            IALS(NALI)=JALS
            IALB(NALI)=JALB
            IAL1(NALI)=JAL1
            IAL2(NALI)=JAL2
            IALE(NALI)=JALE
C            Write(NERR,*) 'JAL1: ',JAL1,' JAL2: ',JAL2,' JALS: ',JALS,
C     *         ' JALB: ',JALB,' JALE: ',JALE
            If(JAL2.LT.JAL1) then  
               Write(NERR,*) 'Error: Illegal alignment found' //
     *            ' - no list produced.'
               IRC=1
               Go to 100
            End if 
            
            If(NALI.GE.IDMN) then 
               Write(NERR,*) 'Warning: Too many alignments found'
     *            // ' - list may be imcomplete.'
               IRC=-1
               Go to 100
            End if 

* - protect sequence region 

            Do  55 I2=JAL1,JAL2
               LCKS(I2)=.TRUE.
 55         Continue

* - exit if only searching for optimal alignment

            If(LOPT.AND.NALI.GE.1) then
               Go to 100
            End if

* - move backwards 

C                Write(6,'('' interrupted at:'',I6)') I1
            Go to 11

* - or one sequence position forwards  

         Else 
            I1=I1+1 
            If(I1.LE.LSEQ) Go to  12
         End if 

* if no match found

      Else

* - next check point reached ? 

         If(I1.GE.NLCP) then
            
* - determine first ENTRY of current row 

            IFER=I1
            Do 56 I2=N1+1,LPRF
               If(IOD1(I2).LT.IFER) IFER=IOD1(I2) 
               If(IOM1(I2).LT.IFER) IFER=IOM1(I2) 
               If(IOI1(I2).LT.IFER) IFER=IOI1(I2) 
 56         Continue

* - update reinitialization point

            If(IFER.GE.ILCP) then 
               IBEG=IFCP-1
               IFCP=IFirst(IDMP,LPRF,IOMB,IOIB,IODB)
               ILCP=I1
            End if 

* - calculate next check point

            NLCP=NLCP+JLCP

         End if  

* - move one sequence positions forwards 
         
         I1=I1+1 
         If(I1.LE.LSEQ) Go to  12

      End if 

* done

 99   Continue 
C       Write(6,'(''Sequence length:'',I6,'' -'',I6,
C    *   '' positions scanned.'')') LSEQ,NSCA

 100  Return
      End
*----------------------------------------------------------------------*
      Subroutine NextR( 
     *   I1,LPCI,
     *   NABC,LPRF,N1,N2,
     *   KCUT,IDMP,IIPP,IMPP,CHIP,CHMP,IIPX,
     *   IDMS,LSEQ,ISEQ,LCKS,
     *   IOPM,IOPI,IOPD,
     *   IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2,
     *   JALS,JALB,JAL1,JAL2,JALE) 

* profile:

      Include          'pfdat.f'
      Include          'pxdat.f'

      Logical           LPCI

* sequence

      Integer           LSEQ
      Integer*2         ISEQ(IDMS)
      Logical           LCKS(IDMS)

* alignments

      Integer           JALS
      Integer           JALB
      Integer           JAL1
      Integer           JAL2
      Integer           JALE

* alignment scores

      Integer           IOPM(0:IDMP)
      Integer           IOPI(0:IDMP)
      Integer           IOPD(0:IDMP)

* alignment positions

      Integer           IOMB(0:IDMP)
      Integer           IOM1(0:IDMP)
      Integer           IOM2(0:IDMP)

      Integer           IOIB(0:IDMP)
      Integer           IOI1(0:IDMP)
      Integer           IOI2(0:IDMP)

      Integer           IODB(0:IDMP)
      Integer           IOD1(0:IDMP)
      Integer           IOD2(0:IDMP)

* work fields 

      Integer           DZ

* initializations 

      J1=ISEQ(I1)

      IN=I1+1

      If(I1.GE.LSEQ) then
         MZ=MY
         IZ=IY
         DZ=DY
      Else
         MZ=MX
         IZ=IX
         DZ=DX
      End if

* disable match and insert vertices of protected region

      If(LCKS(I1)) then 
         IOPM(N1-1)=NLOW    
         Do 10 I2=N1,N2-1
            IOPM(I2)=NLOW 
            IOPI(I2)=NLOW 
 10      Continue
      End if 

* profile positions 0 

* - save previous match position

      KOPM=IOPM( 0)
      KOMB=IOMB( 0)
      KOM1=IOM1( 0)
      KOM2=IOM2( 0)

      KI=IOPI( 0)+IIPP(J1, 0) 

* - match position

      JI=KI+IIPP(IM, 0)
      If(JI.GT.IIPX(XM, 0)) then
         IOPM( 0)=JI
         IOMB( 0)=IOIB( 0)
         IOM1( 0)=IOI1( 0)
         IOM2( 0)=IOI2( 0)
      Else
         IOPM( 0)=IIPX(XM, 0)
         IOMB( 0)=IN
         IOM1( 0)=LSEQ+1
         IOM2( 0)=0
      End if

* - deletion position

      JI=KI+IIPP(ID, 0)
      If(JI.GT.IIPX(XD, 0)) then
         IOPD( 0)=JI
         IODB( 0)=IOIB( 0)
         IOD1( 0)=IOI1( 0)
         IOD2( 0)=IOI2( 0)
      Else
         IOPD( 0)=IIPX(XD, 0)
         IODB( 0)=IN
         IOD1( 0)=LSEQ+1
         IOD2( 0)=0
      End if

* - insert position

      JI=KI+IIPP(II, 0)
      If(JI.GT.IIPX(XI, 0)) then
         IOPI( 0)=JI
      Else
         IOPI( 0)=IIPX(XI, 0)
         IOIB( 0)=IN
         IOI1( 0)=LSEQ+1
         IOI2( 0)=0
      End if

* - circular match extensions (presumably not necessary)

C       If(LPCI) then 
C          KM=IOPM(LPRF-1)+IMPP(J1,LPRF)
C          If(KM+IIPP(MM, 0).GT.IOPM( 0)) then
C             IOPM( 0)=KM+IIPP(MM, 0)
C             IOMB( 0)=IOMB(LPRF-1)
C             IOM1( 0)=IOM1(LPRF-1)
C             IOM2( 0)=IOM2(LPRF-1)
C          End if
C          If(KM+IIPP(MI, 0).GT.IOPI( 0)) then
C             IOPI( 0)=KM+IIPP(MI, 0)
C             IOIB( 0)=IOMB(LPRF-1)
C             IOI1( 0)=IOM1(LPRF-1)
C             IOI2( 0)=IOM2(LPRF-1)
C          End if
C          If(KM+IIPP(MD, 0).GT.IOPD( 0)) then
C             IOPD( 0)=KM+IIPP(MD, 0)
C             IODB( 0)=IOMB(LPRF-1)
C             IOD1( 0)=IOM1(LPRF-1)
C             IOD2( 0)=IOM2(LPRF-1)
C          End if
C       End if
* -----------------------------------------------------------

* profile positions 1 to LPRF  

      Do  79 I2=1,LPRF

         KM=KOPM       + IMPP(J1,I2)
         KI=IOPI(I2  ) + IIPP(J1,I2)
         KD=IOPD(I2-1) + IMPP( D,I2)

* - update match vertex

         JB=IIPX(XM,I2)
         JM=KM          + IIPP(MM,I2)
         JI=KI          + IIPP(IM,I2)
         JD=KD          + IIPP(DM,I2)
         KOPM=IOPM(I2)
         Call Nstep(NEWM,IOPM(I2),JB,JM,JI,JD)

* - update insert vertex

         JB=IIPX(XI,I2)
         JM=KM          + IIPP(MI,I2)
         JI=KI          + IIPP(II,I2)
         JD=KD          + IIPP(DI,I2)
         Call Nstep(NEWI,IOPI(I2),JB,JM,JI,JD)

* - update deletion vertex

         JB=IIPX(XD,I2)
         JM=KM          + IIPP(MD,I2)
         JI=KI          + IIPP(ID,I2)
         JD=KD          + IIPP(DD,I2)
         Call Nstep(NEWD,IOPD(I2),JB,JM,JI,JD)

* - compute alignment scores 

         KM=KM+IIPX(MZ,I2)
         KI=KI+IIPX(IZ,I2)
         KD=KD+IIPX(DZ,I2)

         KE=MAX(KM,KI,KD)

* - check for new maxumum 

         If(KE.GT.JALS) then
            JALS=KE
            If     (JALS.EQ.KD) then
               JALB=IODB(I2-1)
               JAL1=IOD1(I2-1)
               JAL2=IOD2(I2-1)
            Else if(JALS.EQ.KM) then
               JALB=KOMB
               JAL1=KOM1
               JAL2=KOM2
            Else
               JALB=IOIB(I2)
               JAL1=IOI1(I2)
               JAL2=IOI2(I2)
            End if
            JALE=I1 
            If(JAL1.EQ.0) JAL1=JALB
            If(JAL2.EQ.0) JAL2=I1
C             Write(6,'(7I8)'),I1,I2,JALS,JALB,JAL1,JAL2,JALE
         End if 

* - update alignment positions  

         JOMB=IOMB(I2)
         JOM1=IOM1(I2)
         JOM2=IOM2(I2)
         If     (NEWM.EQ.0) then 
            IOMB(I2)=IN
            IOM1(I2)=LSEQ+1
            IOM2(I2)=0
         Else if(NEWM.EQ.1) then 
            IOMB(I2)=KOMB
            IOM1(I2)=KOM1
            IOM2(I2)=KOM2
         Else if(NEWM.EQ.2) then 
            IOMB(I2)=IOIB(I2) 
            IOM1(I2)=IOI1(I2) 
            IOM2(I2)=IOI2(I2)
         Else
            IOMB(I2)=IODB(I2-1) 
            IOM1(I2)=IOD1(I2-1) 
            IOM2(I2)=IOD2(I2-1)
         End if  

         If     (NEWD.EQ.0) then 
            IODB(I2)=IN
            IOD1(I2)=LSEQ+1
            IOD2(I2)=0
         Else if(NEWD.EQ.1) then 
            IODB(I2)=KOMB
            IOD1(I2)=KOM1
            IOD2(I2)=KOM2
         Else if(NEWD.EQ.2) then 
            IODB(I2)=IOIB(I2) 
            IOD1(I2)=IOI1(I2) 
            IOD2(I2)=IOI2(I2)
         Else
            IODB(I2)=IODB(I2-1) 
            IOD1(I2)=IOD1(I2-1) 
            IOD2(I2)=IOD2(I2-1)
         End if  

         If     (NEWI.EQ.0) then 
            IOIB(I2)=IN
            IOI1(I2)=LSEQ+1
            IOI2(I2)=0
         Else if(NEWI.EQ.1) then 
            IOIB(I2)=KOMB
            IOI1(I2)=KOM1
            IOI2(I2)=KOM2
         Else if(NEWI.EQ.2) then 
            Continue
         Else
            IOIB(I2)=IODB(I2-1) 
            IOI1(I2)=IOD1(I2-1) 
            IOI2(I2)=IOD2(I2-2)
         End if  

         KOMB=JOMB
         KOM1=JOM1
         KOM2=JOM2

 79   Continue

* - circular extensions

      If(LPCI) then
         If(IOPM(LPRF).GT.IOPM( 0)) then 
            IOPM( 0)=IOPM(LPRF)
            IOMB( 0)=IOMB(LPRF)
            IOM1( 0)=IOM1(LPRF)
            IOM2( 0)=IOM2(LPRF)
         End if
         If(IOPI(LPRF).GT.IOPI( 0)) then 
            IOPI( 0)=IOPI(LPRF)
            IOIB( 0)=IOIB(LPRF)
            IOI1( 0)=IOI1(LPRF)
            IOI2( 0)=IOI2(LPRF)
         End if
         If(IOPD(LPRF).GT.IOPD( 0)) then 
            IOPD( 0)=IOPD(LPRF)
            IODB( 0)=IODB(LPRF)
            IOD1( 0)=IOD1(LPRF)
            IOD2( 0)=IOD2(LPRF)
         End if

         Do  89, I2=1,LPRF
            KD=IOPD(I2-1)+IMPP( D,I2)
            If(IOPD(I2).GE.KD+IIPP(DD,I2)) then
               Go to  90
            Else
               If(KD+IIPP(DM,I2).GT.IOPM(I2)) then 
                  IOPM(I2)=KD+IIPP(DM,I2)
                  IOMB(I2)=IODB(I2-1)
                  IOM1(I2)=IOD1(I2-1)
                  IOM2(I2)=IOD2(I2-1)
               End if
               If(KD+IIPP(DI,I2).GT.IOPI(I2)) then 
                  IOPI(I2)=KD+IIPP(DI,I2)
                  IOIB(I2)=IODB(I2-1)
                  IOI1(I2)=IOD1(I2-1)
                  IOI2(I2)=IOD2(I2-1)
               End if
               IOPD(I2)=KD+IIPP(DD,I2)
               IODB(I2)=IODB(I2-1)
               IOD1(I2)=IOD1(I2-1)
               IOD2(I2)=IOD2(I2-1)
               IOPT    =MAX(KD+IIPX(DX,I2),IOPT)
            End if

* - - check for new maximum 

            KE=KD+IIPX(DZ,I2)

            If(KE.GT.JALS) then
               JALS=KE
               JALB=IODB(I2-1)
               JAL1=IOD1(I2-1)
               JAL2=IOD2(I2-1)
               If(JAL1.EQ.0) JAL1=JALB
               If(JAL2.EQ.0) JAL2=I1
C                Write(6,'(7I8)') I1,I2,JALS,JALB,JAL1,JAL2,JALE


            End if 
 89      Continue
 90      Continue

      End if
* -----------------------------------------------------------

* entry and exit from protected regions:

      IOM1(N1-1)=MIN(IOM1(N1-1),IN)
      IOM2(N1-1)=IN

      Do I2=N1,N2-1
         IOM1(I2)=MIN(IOM1(I2),IN)
         IOI1(I2)=MIN(IOI1(I2),IN)
         IOM2(I2)=IN
         IOI2(I2)=IN
      End do 

      Return 
      End
*----------------------------------------------------------------------*
      Subroutine Nstep(JSTEP,NMAX,JB,JM,JI,JD)

      NMAX=JB
      JSTEP=0

      If(JD.GT.NMAX) then
         NMAX=JD
         JSTEP=3
      End if 

      If(JM.GT.NMAX) then
         NMAX=JM
         JSTEP=1
      End if 

      If(JI.GT.NMAX) then
         NMAX=JI
         JSTEP=2
      End if 
      
      Return
      End 
*----------------------------------------------------------------------*
      Subroutine InitR(
     *   I1,LPCI,
     *   N1,N2,BSEQ,LSEQ,
     *   IDMP,LPRF,IIPP,IMPP,CHIP,CHMP,IIPX,  
     *   IOPM,IOPI,IOPD,
     *   IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2)

* profile

      Include          'pfdat.f'
      Include          'pxdat.f'

      Logical           LPCI
      Integer           BSEQ

* alignment scores

      Integer           IOPM(0:IDMP)
      Integer           IOPI(0:IDMP)
      Integer           IOPD(0:IDMP)

* alignment positions

      Integer           IOMB(0:IDMP)
      Integer           IOM1(0:IDMP)
      Integer           IOM2(0:IDMP)

      Integer           IOIB(0:IDMP)
      Integer           IOI1(0:IDMP)
      Integer           IOI2(0:IDMP)

      Integer           IODB(0:IDMP)
      Integer           IOD1(0:IDMP)
      Integer           IOD2(0:IDMP)
*
      Integer           ZM 
      Integer           ZI 
      Integer           ZD 
*
      If(I1.LT.BSEQ) then
         ZM=YM
         ZI=YI
         ZD=YD
      Else
         ZM=XM
         ZI=XI
         ZD=XD
      End if

      IOPM( 0)=IIPX(ZM, 0)
      IOPI( 0)=IIPX(ZI, 0)
      IOPD( 0)=IIPX(ZD, 0)

      Do   8 I2=1,LPRF

         KD=IOPD(I2-1)+IMPP( D,I2)
         
         IOPM(I2)=MAX(IIPX(ZM,I2),
     *      KD+IIPP(DM,I2)) 
         IOPI(I2)=MAX(IIPX(ZI,I2),
     *      KD+IIPP(DI,I2))
         IOPD(I2)=MAX(IIPX(ZD,I2),
     *      KD+IIPP(DD,I2))
 8    Continue     

* - circular extensions 

      If(LPCI) then
         IOPM( 0)=MAX(IOPM( 0),IOPM(LPRF))
         IOPI( 0)=MAX(IOPI( 0),IOPI(LPRF))
         IOPD( 0)=MAX(IOPD( 0),IOPD(LPRF))

         Do   9 I2=1, LPRF
            KD=IOPD(I2-1)+IMPP( D,I2)
            If(IOPD(I2).GE.KD+IIPP(DD,I2)) then
               Go to 10
            Else
               IOPM(I2)=MAX(KD+IIPP(DM,I2),IOPM(I2))
               IOPI(I2)=MAX(KD+IIPP(DI,I2),IOPI(I2))
               IOPD(I2)=    KD+IIPP(DD,I2)
            End if
 9       Continue
 10      Continue
      End if
* -----------------------------------------------------------

* initialise begin, entry, exit positions

      IN=I1+1
      Do  20 I2=0,LPRF
         IOMB(I2)=IN
         IOM1(I2)=LSEQ+1
         IOM2(I2)=0

         IOIB(I2)=IN
         IOI1(I2)=LSEQ+1
         IOI2(I2)=0

         IODB(I2)=IN
         IOD1(I2)=LSEQ+1
         IOD2(I2)=0
 20   Continue     

* entry and exit positions within protected region

      IOM1(N1-1)=IN
      IOM2(N1-1)=IN

      Do I2=N1,N2-1
         IOM1(I2)=IN
         IOM2(I2)=IN
         IOI1(I2)=IN
         IOI2(I2)=IN
      End do 

      Return
      End 
*----------------------------------------------------------------------*
      Integer Function IFirst(IDMP,LPRF,IOMB,IOIB,IODB)

      Integer           IOMB(0:IDMP)
      Integer           IOIB(0:IDMP)
      Integer           IODB(0:IDMP)

      IFirst=IOMB(LPRF)
      Do   9 I1=LPRF,0,-1
         If(IOMB(I1).LT.IFirst) IFirst=IOMB(I1) 
         If(IOIB(I1).LT.IFirst) IFirst=IOIB(I1) 
         If(IODB(I1).LT.IFirst) IFirst=IODB(I1) 
 9    Continue

      Return
      End

*----------------------------------------------------------------------*     
* $Id: schmm.f,v 2.3 2003/03/24 14:46:10 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine SCHMM 
     *   (NOUT,IDMP,RIHM,RMHM,LHMM,NABC,FLOW,FSCA,OPTF,OPFF,RD,RI)
      

      Real             FNOR(26)

      Include         'pfind.f'
      Include         'hmdat.f'
      Include         'sterr.f'

      Logical          OPTF
      Logical          OPFF

* rescale emission probabilities

      Do  20 I1=0,LHMM
         Do I2=1,NABC
            FNOR(I2)=RIHM(I2,I1)
         End do 
         Call GetNP(FNOR,NABC,RNOR,FLOW)
         If(RNOR.NE.0.0) then 
            Do I2=1,NABC
               If(RIHM(I2,I1).GT.FLOW) RIHM(I2,I1)=RIHM(I2,I1)+RNOR
            End do 
            If(RIHM(IM,I1).GT.FLOW) RIHM(IM,I1)=RIHM(IM,I1)-RNOR
            If(RIHM(II,I1).GT.FLOW) RIHM(II,I1)=RIHM(II,I1)-RNOR
            If(RIHM(ID,I1).GT.FLOW) RIHM(ID,I1)=RIHM(ID,I1)-RNOR
         End if 

         If(RIHM(II,I1).GE.0) then 
            Write(NOUT,'(''# Insert position '',I4,
     *         '': Log Prob(I->I)='',F8.4,'' reset to -0.01'')')
     *         I1,RIHM(II,I1)
            RIHM(II,I1)=-0.01
         End if 

         If(I1.EQ.0) then
            Do I2=1,NABC
               RMHM(I2,I1)=FLOW
            End do
            Go to  20 
         End if

         Do I2=1,NABC
            FNOR(I2)=RMHM(I2,I1)
         End do 
         Call GetNP(FNOR,NABC,RNOR,FLOW)
         If(RNOR.NE.0.0) then 
            Do I2=1,NABC
               If(RMHM(I2,I1).GT.FLOW) RMHM(I2,I1)=RMHM(I2,I1)+RNOR
            End do 
            If(RIHM(MM,I1).GT.FLOW) RIHM(MM,I1)=RIHM(MM,I1)-RNOR
            If(RIHM(MI,I1).GT.FLOW) RIHM(MI,I1)=RIHM(MI,I1)-RNOR
            If(RIHM(MD,I1).GT.FLOW) RIHM(MD,I1)=RIHM(MD,I1)-RNOR
         End if

         If(RMHM( D,I1).GT.FLOW) then
            RNOR=-RMHM( D,I1)
            RMHM( D,I1)=0.0
            RIHM(DM,I1)=RIHM(DM,I1)-RNOR
            RIHM(DI,I1)=RIHM(DI,I1)-RNOR
            RIHM(DD,I1)=RIHM(DD,I1)-RNOR
         End if 

 20   Continue

* transitions 

      Do  50 I1=LHMM,0,-1

* - insert positions

         FNOR( 1)=RIHM(IM,I1)
         FNOR( 2)=RIHM(ID,I1)
         Call GetNP(FNOR, 2,RNOR,FLOW)
         If(RIHM(II,  I1).GT.FLOW)
     *      RNOR=RNOR+LOG(1.0-EXP(RIHM(II,I1)))
         If(RIHM(IM,I1).GT.FLOW) RIHM(IM,I1)=RIHM(IM,I1)+RNOR
         If(RIHM(ID,I1).GT.FLOW) RIHM(ID,I1)=RIHM(ID,I1)+RNOR
         If(RIHM(MI,I1).GT.FLOW) RIHM(MI,I1)=RIHM(MI,I1)-RNOR
         If(RIHM(DI,I1).GT.FLOW) RIHM(DI,I1)=RIHM(DI,I1)-RNOR

         If(I1.EQ.0) go to 50

* -match positions 

         FNOR( 1)=RIHM(MM,I1)
         FNOR( 2)=RIHM(MI,I1)
         FNOR( 3)=RIHM(MD,I1)
         Call GetNP(FNOR, 3,RNOR,FLOW)
         If(RIHM(MM,I1).GT.FLOW) RIHM(MM,I1)=RIHM(MM,I1)+RNOR
         If(RIHM(MI,I1).GT.FLOW) RIHM(MI,I1)=RIHM(MI,I1)+RNOR
         If(RIHM(MD,I1).GT.FLOW) RIHM(MD,I1)=RIHM(MD,I1)+RNOR
         J1=I1-1
         If(RIHM(MM,J1).GT.FLOW) RIHM(MM,J1)=RIHM(MM,J1)-RNOR
         If(RIHM(IM,J1).GT.FLOW) RIHM(IM,J1)=RIHM(IM,J1)-RNOR
         If(RIHM(DM,J1).GT.FLOW) RIHM(DM,J1)=RIHM(DM,J1)-RNOR

* - delete positions 

         FNOR( 1)=RIHM(DM,I1)
         FNOR( 2)=RIHM(DI,I1)
         FNOR( 3)=RIHM(DD,I1)
         Call GetNP(FNOR, 3,RNOR,FLOW)
         If(RIHM(DM,I1).GT.FLOW) RIHM(DM,I1)=RIHM(DM,I1)+RNOR
         If(RIHM(DI,I1).GT.FLOW) RIHM(DI,I1)=RIHM(DI,I1)+RNOR
         If(RIHM(DD,I1).GT.FLOW) RIHM(DD,I1)=RIHM(DD,I1)+RNOR
         J1=I1-1
         If(RIHM(MD,J1).GT.FLOW) RIHM(MD,J1)=RIHM(MD,J1)-RNOR
         If(RIHM(ID,J1).GT.FLOW) RIHM(ID,J1)=RIHM(ID,J1)-RNOR
         If(RIHM(DD,J1).GT.FLOW) RIHM(DD,J1)=RIHM(DD,J1)-RNOR

 50   Continue 

      FNOR( 1)=RIHM(MM, 0)
      FNOR( 2)=RIHM(MI, 0)
      FNOR( 3)=RIHM(MD, 0)
      Call GetNP(FNOR, 3,RNOR,FLOW)
      If(RIHM(MM, 0).GT.FLOW) RIHM(MM, 0)=RIHM(MM, 0)+RNOR
      If(RIHM(MI, 0).GT.FLOW) RIHM(MI, 0)=RIHM(MI, 0)+RNOR
      If(RIHM(MD, 0).GT.FLOW) RIHM(MD, 0)=RIHM(MD, 0)+RNOR

      FSCA=-RNOR

* add FIMs

      If(OPTF.OR.OPFF) then

         If(RD.GT.0.99999) RD=0.99999
         If(RI.GT.0.99999) RI=0.99999

         If(RD.GT.0.0) then
            RD=LOG(RD)
         Else
            RD=FLOW
         End if 
         If(RI.GT.0.0) then
            RI=LOG(RI)
         Else
            RI=FLOW
         End if 

* - state M(   0)

         RIHM(MD,   0)=RD
         FNOR( 1)=RIHM(MI,   0)
         FNOR( 2)=RIHM(MM,   0)
         Call GetNP(FNOR, 2,RNOR,FLOW)
         If(RIHM(MD,   0).GT.FLOW)
     *      RNOR=RNOR+LOG(1.0-EXP(RIHM(MD,   0)))
         RIHM(MI,   0)=RIHM(MI,   0)+RNOR
         RIHM(MM,   0)=RIHM(MM,   0)+RNOR

         RIHM(MI,   0)=RD
         FNOR( 1)=RIHM(MD,   0)
         FNOR( 2)=RIHM(MM,   0)
         Call GetNP(FNOR, 2,RNOR,FLOW)
         If(RIHM(MI,   0).GT.FLOW)
     *      RNOR=RNOR+LOG(1.0-EXP(RIHM(MI,   0)))
         RIHM(MD,   0)=RIHM(MD,   0)+RNOR
         RIHM(MM,   0)=RIHM(MM,   0)+RNOR

* - state I(   0)

         RIHM(ID,   0)=RD
         FNOR( 1)=RIHM(II,   0)
         FNOR( 2)=RIHM(IM,   0)
         Call GetNP(FNOR, 2,RNOR,FLOW)
         If(RIHM(ID,   0).GT.FLOW)
     *      RNOR=RNOR+LOG(1.0-EXP(RIHM(ID,   0)))
         RIHM(II,   0)=RIHM(II,   0)+RNOR
         RIHM(IM,   0)=RIHM(IM,   0)+RNOR

         RIHM(II,   0)=RI
         FNOR( 1)=RIHM(ID,   0)
         FNOR( 2)=RIHM(IM,   0)
         Call GetNP(FNOR, 2,RNOR,FLOW)
         If(RIHM(II,   0).GT.FLOW)
     *      RNOR=RNOR+LOG(1.0-EXP(RIHM(II,   0)))
         RIHM(ID,   0)=RIHM(ID,   0)+RNOR
         RIHM(IM,   0)=RIHM(IM,   0)+RNOR

* - state M(LHMM)

         RIHM(ID,LHMM)=RD
         FNOR( 1)=RIHM(II,LHMM)
         FNOR( 2)=RIHM(IM,LHMM)
         Call GetNP(FNOR, 2,RNOR,FLOW)
         If(RIHM(ID,LHMM).GT.FLOW)
     *      RNOR=RNOR+LOG(1.0-EXP(RIHM(ID,LHMM)))
         RIHM(II,LHMM)=RIHM(II,LHMM)+RNOR
         RIHM(IM,LHMM)=RIHM(IM,LHMM)+RNOR

         RIHM(II,LHMM)=RI
         FNOR( 1)=RIHM(ID,LHMM)
         FNOR( 2)=RIHM(IM,LHMM)
         Call GetNP(FNOR, 2,RNOR,FLOW)
         If(RIHM(II,LHMM).GT.FLOW)
     *      RNOR=RNOR+LOG(1.0-EXP(RIHM(II,LHMM)))
         RIHM(ID,LHMM)=RIHM(ID,LHMM)+RNOR
         RIHM(IM,LHMM)=RIHM(IM,LHMM)+RNOR

* - state D(LHMM)

         RIHM(DI,LHMM)=RI
         If(RI.GT.FLOW) then
            RIHM(DM,LHMM)=1-EXP(RI) 
         Else
            RIHM(DM,LHMM)=1.0
         End if
         

* - state I(LHMM)

         RIHM(II,LHMM)=RI
         If(RI.GT.FLOW) then
            RIHM(IM,LHMM)=1-EXP(RI) 
         Else
            RIHM(IM,LHMM)=1.0
         End if

      End if

* - internal delete states

      If(OPFF.AND.RD.GT.FLOW) then
         RD=LOG(EXP(RD)/(1-EXP(RD)))
         Do I1=1,LHMM-1
            RIHM(DD,I1)=RD
            FNOR( 1)=RIHM(DD,I1)
            FNOR( 2)=RIHM(DI,I1)
            FNOR( 3)=RIHM(DM,I1)
            Call GetNP(FNOR, 3,RNOR,FLOW)
            RIHM(DD,I1)=RIHM(DD,I1)+RNOR
            RIHM(DI,I1)=RIHM(DI,I1)+RNOR
            RIHM(DM,I1)=RIHM(DM,I1)+RNOR
         End do
      End if 

 100  Return
      End
*----------------------------------------------------------------------*
      Subroutine GetNP(FNOR,INOR,RNOR,FLOW)

      Real              FNOR(*)

      RNOR=0.0

      RMAX=FLOW
      Do I1=1,INOR
         RMAX=MAX(RMAX,FNOR(I1))
      End do 

      If(RMAX.LE.FLOW) go to 100

      RSUM=0.0
      RCUT=MAX(FLOW,RMAX-20.0)
      Do I1=1,INOR
         If(FNOR(I1).GT.RCUT) RSUM=RSUM+EXP(FNOR(I1)-RMAX)
      End do 
      RNOR=-RMAX-LOG(RSUM) 

 100  Return
      End
*----------------------------------------------------------------------*

      SUBROUTINE RQ0(M,N,M5,N2,A,B,T,TOLER,IFT,X,E,S,WA,WB)
C
C     Modified to remove SOL and related vars -- only good for single tau
C     M Number of Observations
C     N Number of Parameters
C     M5 = M+5  row dimension for WA
C     N2 = N+2  col dimension for WA
C     A is the X matrix
C     B is the y vector
C     T, the desired quantile
C     TOLER, smallest detectable |x-y|/x machine precision to the 2/3
C     IFT exit code:
C		0-ok
C		else dimensions inconsistent or T not in (0,1)
C     X the parameter estimate betahat
C     E is the residual vector
C     S is an integer work array (M)
C     WA is a real work array (M5,N2)
C     WB is another real work array (M)
C     Utilization:  If you just want a solution at a single quantile you
C     The algorithm  is a slightly modified version of Algorithm AS 229 
C     described in Koenker and D'Orey, "Computing Regression Quantiles,
C     Applied Statistics, pp. 383-393. 
C
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER I,J,K,KL,KOUNT,KR,M,M1,M2,M3,M4,M5,IFT
      INTEGER N,N1,N2,OUT,S(M)
      LOGICAL STAGE,TEST,INIT,IEND
      DOUBLE PRECISION MIN,MAX
      DOUBLE PRECISION B(M),A(M,N),X(N),WA(M5,N2),WB(M),E(M)
      DATA BIG/1.D37/
      DATA ZERO/0.00D0/
      DATA HALF/0.50D0/
      DATA ONE/1.00D0/
      DATA TWO/2.00D0/
C
C  CHECK DIMENSION PARAMETERS
C
      IFT=0
      IF(N2 .NE. N+2)IFT = 4
      IF(M.LE.ZERO.OR.N.LE.ZERO)IFT = 5
      IF(IFT .GT. TWO)RETURN
C
C  INITIALIZATION
C
      M1 = M+1
      N1 = N+1
      M2 = M+2
      M3 = M+3
      M4 = M+4
      M5 = M+5
      DO 2 I=1,M
      WB(I)=B(I)
      DO 1 J=1,N
      WA(I,J)=A(I,J)
  1   CONTINUE
  2   CONTINUE
      WA(M2,N1)=ZERO
      DIF = ZERO
      IEND = .TRUE.
      IF(T .GE. ZERO .AND. T .LE. ONE)GOTO 3
      IFT = 6
      RETURN
  3   CONTINUE
      INIT = .FALSE.
      KOUNT = 0
      DO 9 K=1,N
      WA(M5,K) = ZERO
      DO 8 I=1,M
      WA(M5,K) = WA(M5,K) + WA(I,K)
  8   CONTINUE
      WA(M5,K) = WA(M5,K)/FLOAT(M)
  9   CONTINUE
      DO 10 J=1,N
      WA(M4,J) = J
      X(J) = ZERO
 10   CONTINUE
      DO 40 I=1,M
      WA(I,N2) = N+I
      WA(I,N1) = WB(I)
      IF(WB(I).GE.ZERO)GOTO 30
      DO 20 J=1,N2
      WA(I,J) = -WA(I,J)
 20   CONTINUE
 30   E(I) = ZERO
 40   CONTINUE
      DO 42 J=1,N
      WA(M2,J) = ZERO
      WA(M3,J) = ZERO
      DO 41 I=1,M
      AUX = SIGN(ONE,WA(M4,J)) * WA(I,J)
      WA(M2,J) = WA(M2,J) + AUX * (ONE - SIGN(ONE,WA(I,N2)))
      WA(M3,J) = WA(M3,J) + AUX * SIGN(ONE,WA(I,N2))
 41   CONTINUE
      WA(M3,J) = TWO * WA(M3,J)
 42   CONTINUE
      GOTO 48
 43   CONTINUE
      DO 44 I=1,M
      S(I) = ZERO
 44   CONTINUE
      DO 45 J=1,N
      X(J) = ZERO
 45   CONTINUE
C
C  COMPUTE NEXT T
C
      SMAX = TWO
      DO 47 J=1,N
      B1 =  WA(M3,J)
      A1 = (-TWO - WA(M2,J))/B1
      B1 = -WA(M2,J)/B1
      IF(A1 .LT. T)GOTO 46
      IF(A1 .GE. SMAX) GOTO 46
      SMAX = A1
      DIF = (B1 - A1 )/TWO
 46   IF(B1 .LE. T) GOTO 47
      IF(B1 .GE. SMAX)GOTO 47
      SMAX = B1
      DIF = (B1 - A1)/TWO
 47   CONTINUE
      TNT = SMAX + TOLER * (ONE + ABS(DIF)) 
      IF(TNT .GE. T1 + TOLER)IEND = .TRUE.
      T = TNT
      IF(IEND)T = T1
 48   CONTINUE
C
C COMPUTE NEW MARGINAL COSTS
C
      DO 49 J=1,N
      WA(M1,J) = WA(M2,J) + WA(M3,J) * T
 49   CONTINUE
      IF(INIT) GOTO 265
C
C STAGE 1
C
C DETERMINE THE VECTOR TO ENTER THE BASIS
C
      STAGE=.TRUE.
      KR=1
      KL=1
 70   MAX=-ONE
      DO 80 J=KR,N
      IF(ABS(WA(M4,J)).GT.N)GOTO 80
      D=ABS(WA(M1,J))
      IF(D.LE.MAX)GOTO 80
      MAX=D
      IN=J
 80   CONTINUE
      IF(WA(M1,IN).GE.ZERO)GOTO 100
      DO 90 I=1,M4
      WA(I,IN)=-WA(I,IN)
 90   CONTINUE
C
C DETERMINE THE VECTOR TO LEAVE THE BASIS
C
 100  K=0
      DO 110 I=KL,M
      D=WA(I,IN)
      IF(D.LE.TOLER)GOTO 110
      K=K+1
      WB(K)=WA(I,N1)/D
      S(K)=I
      TEST=.TRUE.
 110  CONTINUE
 120  IF(K.GT.0)GOTO 130
      TEST=.FALSE.
      GOTO 150
 130  MIN=BIG
      DO 140 I=1,K
      IF(WB(I).GE.MIN)GOTO 140
      J=I
      MIN=WB(I)
      OUT=S(I)
 140  CONTINUE
      WB(J)=WB(K)
      S(J)=S(K)
      K=K-1
C
C CHECK FOR LINEAR DEPENDENCE IN STAGE 1
C
 150  IF(TEST.OR..NOT.STAGE)GOTO 170
      DO 160 I=1,M4
      D=WA(I,KR)
      WA(I,KR)=WA(I,IN)
      WA(I,IN)=D
 160  CONTINUE
      KR=KR+1
      GOTO 260
 170  IF(TEST)GOTO 180
      WA(M2,N1)=TWO
      GOTO 390
 180  PIVOT=WA(OUT,IN)
      IF(WA(M1,IN)-PIVOT-PIVOT.LE.TOLER)GOTO 200
      DO 190 J=KR,N1
      D=WA(OUT,J)
      WA(M1,J)=WA(M1,J)-D-D
      WA(M2,J)=WA(M2,J)-D-D
      WA(OUT,J)=-D
 190  CONTINUE
      WA(OUT,N2)=-WA(OUT,N2)
      GOTO 120
C
C PIVOT ON WA(OUT,IN)
C
 200  DO 210 J=KR,N1
      IF(J.EQ.IN)GOTO 210
      WA(OUT,J)=WA(OUT,J)/PIVOT
 210  CONTINUE
      DO 230 I=1,M3
      IF(I.EQ.OUT)GOTO 230
      D=WA(I,IN)
      DO 220 J=KR,N1
      IF(J.EQ.IN)GOTO 220
      WA(I,J)=WA(I,J)-D*WA(OUT,J)
 220  CONTINUE
 230  CONTINUE
      DO 240 I=1,M3
 
      IF(I.EQ.OUT)GOTO 240
      WA(I,IN)=-WA(I,IN)/PIVOT
 240  CONTINUE
      WA(OUT,IN)=ONE/PIVOT
      D=WA(OUT,N2)
      WA(OUT,N2)=WA(M4,IN)
      WA(M4,IN)=D
      KOUNT=KOUNT+1
      IF(.NOT.STAGE)GOTO 270
C
C INTERCHANGE ROWS IN STAGE 1
C
      KL=KL+1
      DO 250 J=KR,N2
      D=WA(OUT,J)
      WA(OUT,J)=WA(KOUNT,J)
      WA(KOUNT,J)=D
 250  CONTINUE
 260  IF(KOUNT+KR.NE.N1)GOTO 70
C
C STAGE 2
C
 265  STAGE=.FALSE.
C
C DETERMINE THE VECTOR TO ENTER THE BASIS
C
 270  MAX=-BIG
      DO 290 J=KR,N
      D=WA(M1,J)
      IF(D.GE.ZERO)GOTO 280
      IF(D.GT.(-TWO))GOTO 290
      D=-D-TWO
 280  IF(D.LE.MAX)GOTO 290
      MAX=D
      IN=J
 290  CONTINUE
      IF(MAX.LE.TOLER)GOTO 310
      IF(WA(M1,IN).GT.ZERO)GOTO 100
      DO 300 I=1,M4
      WA(I,IN)=-WA(I,IN)
 300  CONTINUE
      WA(M1,IN)=WA(M1,IN)-TWO
      WA(M2,IN)=WA(M2,IN)-TWO
      GOTO 100
C
C COMPUTE QUANTILES
C
 310  CONTINUE
      DO 320 I=1,KL-1
      K=WA(I,N2)*SIGN(ONE,WA(I,N2))
      X(K) = WA(I,N1) * SIGN(ONE,WA(I,N2))
 320  CONTINUE
 390  SUM = ZERO
      DO 400 I=KL,M
      K = WA(I,N2) * SIGN(ONE,WA(I,N2))
      D = WA(I,N1) * SIGN(ONE,WA(I,N2))
      SUM = SUM + D * SIGN(ONE,D) * (HALF + SIGN(ONE,D)*(T-HALF))
      K=K-N
      E(K)=D
 400  CONTINUE
      RETURN
      END

*----------------------------------------------------------------------*     
* $Id: pmali.f,v 1.5 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine PMALI
     *   (LPRF,CHIP,CHMP,IDMP,LSEQ,LREV,
     *   CALI,JALB,
     *   MK3E,MK3B,MJ1E,MJ1B,NW)

      Character*01      CHIP(0:IDMP)
      Character*01      CHMP(IDMP)
      Character*01      CALI(*)
      Logical           LREV

* multiple match

      Integer           MK3E
      Integer           MK3B

      Character*512     RCPR
      Character*512     RCSQ
      Character*534     RCOUT
      

* Find beginning of alignment, sequence, profile                

      JB=MK3B-1
      KB=MJ1B
      LB=JALB

C      Write(NERR,*) '***Multiple match Info (Begin)***'
C      Write(NERR,*) 'JB: ',JB,' KB: ',KB,' LB: ',LB
C      Write(NERR,*) 'MK3B: ',MK3B,' MJ1B: ',MJ1B,' JALB: ',JALB

* Find end of alignment, sequence, profile                

      JE=MK3E
      KE=MJ1E 
      
C      Write(NERR,*) 'JE: ',JE,' KE: ',KE,' LALI: ',LALI
C      Write(NERR,*) 'MK3E: ',MK3E,' MJ1E: ',MJ1E,' LALI: ',LALI
C      Write(NERR,*) '***Multiple match Info (End)***'

* Write alignment  

      IX=0

      Do I1=KB,KE

         If(IX.GE.NW) then 
            NPE=JB
            If(.NOT.LREV) then 
               NSE=LB
C               If(RCSQ(1:1).NE.'-') NSE=NSE-1
               NSE=NSE-1
            Else
               NSE=LSEQ-LB+1 
C               If(RCSQ(1:1).NE.'-') NSE=NSE+1
               NSE=NSE+1
            End if
            NPE=NPE-LPRF-1
            NSE=NSE-LSEQ-1
            Write(6,'(''#'')')
            Write(RCOUT(1:),'(''# P'',I9,'' '')') NPB
            RCOUT(14:)=RCPR(1:NW)
            Write(RCOUT(14+NW:),'(I9)') NPE
            Write(6,'(534A)')(RCOUT(ii1:ii1),ii1=1,NW+22)
            Write(RCOUT(1:),'(''# S'',I9,'' '')') NSB
            RCOUT(14:)=RCSQ(1:NW)
            Write(RCOUT(14+NW:),'(I9)') NSE
            Write(6,'(534A)')(RCOUT(ii1:ii1),ii1=1,NW+22)
            Write(6,'(''#'')')    
            IX=0
         End if 

         IX=IX+1
         K1=Ichar(CALI(I1))
         If     (K1.GE.65.AND.K1.LE. 90) then 
            JB=JB+1
            If(JB.GT.LPRF) JB=JB-LPRF
            LB=LB+1
            RCPR(IX:IX)=CHMP(JB)
            RCSQ(IX:IX)=CALI(I1)
         Else if(K1.GE.97.AND.K1.LE.122) then 
            LB=LB+1
            RCPR(IX:IX)=CHIP(JB)
            RCSQ(IX:IX)=CALI(I1)
         Else if(CALI(I1).EQ.'-') then 
C            Write(NERR,*) 'Found a - at IX: ',IX
            JB=JB+1
            If(JB.GT.LPRF) JB=JB-LPRF
            RCPR(IX:IX)=CHMP(JB)
            RCSQ(IX:IX)=CALI(I1)
         End if 
         
         If(IX.EQ.1) then
            NPB=JB
            If(K1.GE.97.AND.K1.LE.122) NPB=NPB+1 
            If(.NOT.LREV) then 
               NSB=LB
               If(RCSQ(1:1).NE.'-') NSB=NSB-1
            Else
               NSB=LSEQ-LB+1 
               If(RCSQ(1:1).NE.'-') NSB=NSB+1
            End if
         End if
         
      End do  

      If(IX.GT.0) then 
         NPE=JB
         If(.NOT.LREV) then 
            NSE=LB
C            If(RCSQ(1:1).NE.'-') NSE=NSE-1
            NSE=NSE-1
         Else
            NSE=LSEQ-LB+1 
C            If(RCSQ(1:1).NE.'-') NSE=NSE+1
            NSE=NSE+1
         End if
         NPE=NPE-LPRF-1
         NSE=NSE-LSEQ-1
         Write(6,'(''#'')')    
         RCPR(IX+1:)=' '
         RCSQ(IX+1:)=' '
         Write(RCPR(IX+1:IX+10),'(I9)') NPE
         Write(RCSQ(IX+1:IX+10),'(I9)') NSE
         IX=IX+9
         Write(6,'(''# P'',I9,'' '',512A)')
     *      NPB,(RCPR(ii1:ii1),ii1=1,IX)
         Write(6,'(''# S'',I9,'' '',512A)')
     *      NSB,(RCSQ(ii1:ii1),ii1=1,IX)
      End if
      Write(6,'(''#'')')    

      Return 
      End

*----------------------------------------------------------------------*     
* $Id: regpr.f,v 2.5 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine REGPR
     *   (NGPR,FGPR,
     *   RG,RE,RF,RO,LSYM,
     *   CPID,CPAC,CPDE,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP, 
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT, 
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   CHID,IIPD,CHMD,IMPD,
     *   IRC)

      Character*(*)     FGPR
      Character*512     RCIN  
      Character         B

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'

      Include          'sterr.f'
      
      Integer           IPRF(32)
      Character         CPRF

      Logical           LSYM

      Integer           Getc

      IRC=0

* open input file
      
      If(FGPR.EQ.'-') then
 1       Open(NGPR,Status='SCRATCH',Err=901)
 2       Continue 
         Do I1=1,512
            If(Getc(B).NE.0) go to 3
            If(Ichar(B).EQ.10) then
               Write(NGPR,'(512A)',Err=903)(RCIN(ii1:ii1),ii1=1,I1-1)
               Go to   2  
            Else
               RCIN(I1:I1)=B
            End if
         End do 
         Go to 905
 3       Rewind(NGPR)
      Else
         Open(NGPR,File=FGPR,Status='OLD',Err=900)
      End if
      
* initialize 

* - profile header

      CPID='GCG_PROFILE'
      CPAC='GC99999'
      CPDE='Automatically reformatted from file ''' 
     *   // FGPR(1:Lblnk(FGPR))
     *   // '''.' 

* - accessories

      LPCI=.FALSE.

      JNOR=1
      MNOR(1)=1
      NNOR(1)=1
      NNPR(1)=1   
      CNTX(1)='OrigScore'
      RNOP(1,1)=0.0
      RNOP(2,1)=1/RF

      JCUT=1
      MCLE(1)=0
      CCUT(1)=' '
      ICUT(1)=0
      JCNM(1)=1
      RCUT(1,1)=0.0
      MCUT(1,1)=1 

* - defaults for match and insert position  

      CHID='-'
      Do  15 I1=1,26 
         IIPD(I1)=0
 15   Continue
      
      IIPD(B0)=0
      IIPD(B1)=NLOW
      IIPD(E0)=0
      IIPD(E1)=NLOW

      IIPD(BM)=0
      IIPD(BI)=NLOW
      IIPD(BD)=NLOW
      IIPD(BE)=NLOW
      IIPD(MM)=0
      IIPD(MI)=NLOW
      IIPD(MD)=NLOW
      IIPD(ME)=0
      IIPD(IM)=0
      IIPD(II)=0
      IIPD(ID)=NLOW
      IIPD(IE)=NLOW
      IIPD(DM)=0
      IIPD(DI)=NLOW
      IIPD(DD)=0
      IIPD(DE)=NLOW

      IIPD(I0)=0

      CHMD='X'
      Do  16 I1=1,26 
         IMPD(I1)=0
 16   Continue

      IIPD(M0)=0 
      IMPD(D )=0

      Do  18 I1=0,27
         IMPP(I1,0)=NLOW
 18   Continue 

* read alphabet

 25   Read(NGPR,'(A)',End=905,Err=902) RCIN
      If(RCIN( 1: 4).NE.'Cons') go to  25
      
      IC1=Index(RCIN,'Gap')
      K1=0
      Do  29 I1=5,IC1-1
         If(RCIN(I1:I1).NE.' ') then
            K1=K1+1
            CABC(K1)=RCIN(I1:I1)
         End if
 29   Continue
      NABC=K1

* read numbers

      K1=0
 30   Read(NGPR,'(A)',End= 50,Err=902) RCIN
      If(RCIN( 1: 1).EQ.'!') go to  30

* - input line

C      RCIN(1024:1024)='@'
      CPRF=RCIN(2:2)
      Read(RCIN(3:512),*,Err=910,End= 50)
     *   (IPRF(ii1),ii1=1,NABC+2)
      Do  34 I2=1,NABC
         IPRF(I2)=NINT(Real(IPRF(I2))/100*RF+RO)
 34   Continue
      If(LSYM) then 
         NGO=-NINT(Real(IPRF(NABC+1))/200*RF*RG)
      Else
         NGO=-NINT(Real(IPRF(NABC+1))/100*RF*RG)
      End if 
      NGE=-NINT(Real(IPRF(NABC+2))/100*RF*RE)

* - build insert position 

      CHIP(K1)=CHID 
      Do  36 I1=0,46
         IIPP(I1,K1)=IIPD(I1)
 36   Continue
      Do  37 I1=1,NABC
         IIPP(I1,K1)=NGE
 37   Continue
      IIPP(MI,K1)=NGO
      IIPP(MD,K1)=NGO
      If(LSYM) then
         IIPP(IM,K1)=NGO
         IIPP(DM,K1)=NGO
      End if 

* - build match position

      K1=K1+1
      If(K1.GT.IDMP) go to 915
      CHMP(K1)=CPRF
      Do  43 I1=1,NABC
         IMPP(I1,K1)=IPRF(I1)
 43   Continue 
      IMPP( 0,K1)=0
      IMPP(D ,K1)=NGE

      Go to  30

 50   LPRF=K1
      If(LPRF.LE.0) go to 920

* - disjointness definition

      MDIS=2
      NDIP(1)=1+LPRF/10
      NDIP(2)=LPRF-LPRF/10

* - defaults for gap weights

      NGO=IIPP(MI,0) 
      NGE=IMPP( D,1) 
      Do  53 I1=1,LPRF-1
         NGO=MIN(NGO,IIPP(MI,I1))
         NGE=MIN(NGE,IMPP( D,I1+1))
 53   Continue

      IIPD(MI)=NGO
      IIPD(MD)=NGO
      If(LSYM) then 
         IIPD(DM)=NGO
         IIPD(IM)=NGO
      End if
      
      Do  54 I1=1,NABC
         IIPD(I1)=NGE
 54   Continue 
      IMPD( D)=NGE

* - last insert position 

      CHIP(K1)=CHID 
      Do  60 I1=0,46
         IIPP(I1,K1)=IIPD(I1)
 60   Continue

* - domain global mode:

      IIPP(B1,   0)=0
      IIPP(E1,LPRF)=0

* - move DM scores one position forward: 

      If(LSYM) then
         IIPP(DM, 0)=IIPD(DM)
         Do  65 I1=LPRF, 1,-1
            IIPP(DM,I1)=IIPP(DM,I1-1)
 65      Continue
      End if  

 100  Return 

* errors
 
 900  Write(NERR,*) 'Error: Unable to open profile file'//
     *   ' ''',FGPR(1:Lblnk(FGPR)),'''.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Unable to create temporary file.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: Unable to read profile file.'
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Unable to write to temporary file.'
      IRC=1
      Go to 100
 905  Write(NERR,*) 'Error: Unexpected end of file. '//
     *   'Unable to find profile alphabet.'
      IRC=1
      Go to 100
 910  Write(NERR,*) 'Error: Unable to read profile values.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100
 915  Write(NERR,*) 'Error: Profile length exceeds buffer size (',
     *   IDMP,').'
      IRC=1
      Go to 100
 920  Write(NERR,*) 'Error: Unexpected end of profile. Profile has '//
     *   'zero length. Check profile syntax.'
      IRC=1
      Go to 100

      End

*       Program psa2msa
*----------------------------------------------------------------------*
* $Id: psa2msa.f,v 2.11 2003/11/28 11:53:33 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Converts a pfsearch -x output file into Pearson/Fasta
*                 multiple sequence alignment format
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

      Include          'ardim.f'

      Parameter        (NSEQ=  11)

      Character*4096    FSEQ
      Character*01      CSEQ(IDMS)
      Integer           IPRF(0:IDMP)

      Character*512     RCIO
      Character         B

      Logical           OPTL
      Logical           OPTU
      Logical           OPTP
      Logical           OPTD
      Logical           LEOF

      Integer           Getc

      Include          'sterr.f'

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      RC=0
      LPRF=0
      RCIO=' '
      IRC=0
      LEOF=.FALSE.
      NBSQ=0

* command line arguments

      Call Repar
     *   (FSEQ,OPTL,OPTU,OPTP,OPTD,NM,NW,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''psa2msa 2.3 revision 5.d'',//
     *      ''Usage: psa2msa [ -dhlpuMW ] [ psa-file | - ] '',
     *      ''[ parameters ]'',//
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -d: replace periods by dashes on output.'',/
     *      ''    -h: print usage help text.'',/
     *      ''    -l: replace upper case letters by lower case.'',/
     *      ''    -p: replace dashes by periods on output.'',/
     *      ''    -u: replace lower case letters by upper case.''
     *      )')
         Write(NERR,'(
     *      ''    -M<value>:'',/
     *      ''        maximal insertion length (default: -1).'',/
     *      ''    -W<value>:'',/
     *      ''        specifies the output width (default: 60).'',/
     *      )')
         Write(NERR,'(
     *      ''   valid (but deprecated) parameters are:'',/,
     *      ''    [M=max-insert-length]  use option -M instead'',/
     *      ''    [W=output-width]       use option -W instead'',/
     *      )')
         Call Exit(IRC)
      End if

* open input file

      If(FSEQ.EQ.'-') then
 1       Open(NSEQ,Status='SCRATCH',Err=901)
 2       Continue
         Do I1=1,512
            If(Getc(B).NE.0) go to 3
            If(Ichar(B).EQ.10) then
               Write(NSEQ,'(512A)')(CSEQ(ii1),ii1=1,I1-1)
               Go to   2
            Else
               CSEQ(I1)=B
            End if
         End do
         Go to   2
 3       Rewind(NSEQ)
      Else
         Open(NSEQ,File=FSEQ,Status='OLD',Err=900)
      End if

* first sequence:

      Call GetSeq(NSEQ,CSEQ,LSEQ,RCIO,LDES,NBSQ,IDMS,IRC)
      If(IRC.GT.0.OR.NBSQ.EQ.0) go to 100
      If(IRC.LT.0) LEOF=.TRUE.

      Call UpdIPRF(CSEQ,LSEQ,LPRF,IPRF,IDMP,IRC)
      If(IRC.NE.0) Go to 100

* next sequence

 10   If(.NOT.LEOF) then
         Call GetSeq(NSEQ,CSEQ,LSEQ,RCIO,LDES,NBSQ,IDMS,IRC)
         If     (IRC.EQ.-1) then
            LEOF=.TRUE.
         Else if(IRC.NE. 0) then
            Go to 100
         End if

         Call UpdIPRF(CSEQ,LSEQ,LPRF,IPRF,IDMP,IRC)
         If(IRC.NE.0) Go to 100

         Go to  10
      End if

 50   Continue

      Rewind(NSEQ)
      NBSQ=0
      LEOF=.FALSE.

      LMSA=LPRF
      Do I1=0,LPRF
         LMSA=LMSA+IPRF(I1)
      End do
      LMSB=LMSA

 60   Call GetSeq(NSEQ,CSEQ,LSEQ,RCIO,LDES,NBSQ,IDMS,IRC)
      If     (IRC.EQ.-1) then
         LEOF=.TRUE.
         IRC=0
         Go to  70
      Else if(IRC.NE. 0) then
         Go to 100
      End if

 70   Call UpdSeq(CSEQ,LSEQ,LMSA,IPRF,LPRF,IDMP)
      Call EdtSeq(CSEQ,LMSA,OPTL,OPTU,OPTP,OPTD)
      If(NM.GE.0) Call CutSeq(CSEQ,LMSA,LMSB,IPRF,LPRF,NM,IDMP)

      Write(6,'((512A))')(RCIO(ii1:ii1),ii1=1,LDES)
      Call PRSQ(CSEQ,LMSB,NW)

      If(.NOT.LEOF) Go to  60

 100  Call Exit(IRC)

* errors

 900  Write(NERR,*) 'Error: Unable to open PSA file'//
     *   ' ''',FSEQ(1:Lblnk(FSEQ)),'''.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Unable to create temporary file.'
      IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine Repar
     *   (FSEQ,OPTL,OPTU,OPTP,OPTD,NM,NW,IRC)

      Character*(*)     FSEQ
      Character*4096    CARG

      Logical           OPTL
      Logical           OPTU
      Logical           OPTP
      Logical           OPTD

      IRC=0

      OPTL=.FALSE.
      OPTU=.FALSE.
      OPTP=.FALSE.
      OPTD=.FALSE.

      NM=-1
      NW=60

      N1=Iargc()
      K1=0
      I2=1
      Do  I1=1,N1
         Call GetArg(I2,CARG)
         If(CARG(1:1).EQ.'-'.AND.CARG(2:2).NE.' ') then
            If(Index(CARG,'h').NE.0) go to 900
            If(Index(CARG,'l').NE.0) OPTL=.TRUE.
            If(Index(CARG,'u').NE.0) OPTU=.TRUE.
            If(Index(CARG,'p').NE.0) OPTP=.TRUE.
            If(Index(CARG,'d').NE.0) OPTD=.TRUE.
            If(Index(CARG,'M').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) NM
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) NM
               End if
            End if
            If(Index(CARG,'W').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) NW
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) NW
               End if
            End if
         Else if(CARG(1:2).EQ.'M=') then
            Read(CARG(3:),*,Err=900) NM
         Else if(CARG(1:2).EQ.'W=') then
            Read(CARG(3:),*,Err=900) NW
         Else
            FSEQ=CARG
            K1=K1+1
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 20
      End do

 20   If(K1.LT.1) then
         FSEQ='-'
      Else if(K1.GT.1) then
         Go to 900
      End if
      If(NM.LT.0) NM=-1
      If(NW.LE.0.OR.NW.GT.512) NW=60

 100  Return
 900  IRC=-1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine GetSeq(NSEQ,CSEQ,LSEQ,RCIO,LDES,NBSQ,IDMS,IRC)

      Include          'sterr.f'

      Character*01      CSEQ(*)
      Character*(*)     RCIO

      Character*512     RCIN
      Save              RCIN

      IRC=0
      LSEQ=0
      LDES=0

 1    Continue
      If(RCIN(1:1).NE.'>') then
         Read(NSEQ,'(A)',Err=901,End=902) RCIN
         Go to   1
      End if

      LDES=Lblnk(RCIN)
      RCIO(1:LDES)=RCIN(1:LDES)

 2    RCIN=' '
      Read(NSEQ,'(A)',Err=901,End=900) RCIN
 5    L1=Lblnk(RCIN)
      If(RCIN(1:1).EQ.'>') then
         Go to 90
      Else
         Do I1=1,L1
            K1=Ichar(RCIN(I1:I1))
            If((K1.GE.65.AND.K1.LE. 90).OR.
     *         (K1.GE.97.AND.K1.LE.122).OR.
     *         (RCIN(I1:I1).EQ.'-').OR.
     *         (RCIN(I1:I1).EQ.'.')) then
               LSEQ=LSEQ+1
               If(LSEQ.GT.IDMS) go to 903
               CSEQ(LSEQ)=RCIN(I1:I1)
            End if
         End do
      End if
      If(IRC.NE.-1) go to   2

 90   If(LSEQ.EQ.0) go to 904
      NBSQ=NBSQ+1

 100  Return

 110  Write(NERR,*) '       While processing sequence ',
     *   RCIO(1:LDES)
      Go to 100

* errors

 900  If(RCIN.EQ.' '.AND.LSEQ.EQ.0) then
         Write(NERR,*) 'Error: Unexpected end of sequence.'//
     *      ' Sequence has zero length.'
         IRC=1
      Else
         IRC=-1
         Go to 5
      End if
      Go to 110

 901  Write(NERR,*) 'Error: Unable to read PSA sequence file.'
      IRC=1
      Go to 100
 902  If(NBSQ.EQ.0) then
         Write(NERR,*) 'Error: Unable to find sequences in PSA file.'
         IRC=1
      Else
         IRC=-1
      End if
      Go to 100
 903  Write(NERR,*) 'Error: Sequence length exceeds buffer ',
     *   'size (',IDMS,').'
      IRC=1
      Go to 110
 904  Write(NERR,*) 'Error: Unexpected end of sequence.'//
     *   ' Sequence has zero length.'
      IRC=1
      Go to 110

      End
*----------------------------------------------------------------------*
      Subroutine UpdIPRF(CSEQ,LSEQ,LPRF,IPRF,IDMP,IRC)

      Include          'sterr.f'

      Character*01      CSEQ(*)
      Integer           IPRF(0:IDMP)

      IRC=0

      If(LPRF.EQ.0) then
         Do I1=1,LSEQ
            K1=Ichar(CSEQ(I1))
            If((K1.GE.65.AND.K1.LE. 90).OR.
     *         (CSEQ(I1).EQ.'-')) then
               LPRF=LPRF+1
            End if
         End do
         If(LPRF.GT.IDMP) go to 901
         Do I1=0,LPRF
            IPRF(I1)=0
         End do
      End if

      J1=0
      M1=0
      Do I1=1,LSEQ
         K1=Ichar(CSEQ(I1))
         If((K1.GE.65.AND.K1.LE. 90).OR.
     *      (CSEQ(I1).EQ.'-')) then
            IPRF(J1)=MAX(IPRF(J1),M1)
            J1=J1+1
            M1=0
         Else
            M1=M1+1
         End if
      End do
      IPRF(J1)=MAX(IPRF(J1),M1)

      If(J1.NE.LPRF) go to 900

 100  Return

* errors

 900  Write(NERR,*) 'Error: Conflicting sequence length after ',
     *   'insertion removal.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Sequence length exceeds buffer ',
     *   'size (',IDMP,').'
      IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine UpdSeq(CSEQ,LSEQ,LMSA,IPRF,LPRF,IDMP)

      Character*01      CSEQ(*)
      Integer           IPRF(0:IDMP)

      J1=LPRF
      M1=LMSA
      N1=0

      Do I1=LSEQ,1,-1
         K1=Ichar(CSEQ(I1))
         If((K1.GE.65.AND.K1.LE. 90).OR.
     *      (CSEQ(I1).EQ.'-')) then
            K1=IPRF(J1)-N1
            M1=M1-K1
            Do I2=M1+1,M1+K1
               CSEQ(I2)='.'
            End do
            If(J1.EQ.LPRF) then
               Do I2=M1+1,M1+N1
                  CSEQ(I2)=CSEQ(I2+K1)
               End do
               Do I2=M1+N1+1,M1+N1+K1
                  CSEQ(I2)='.'
               End do
            Else

* place dots at the center of insert region

               L1=(N1+1)/2
               Do I2=M1+1,M1+L1
                  CSEQ(I2)=CSEQ(I2+K1)
               End do
               Do I2=M1+L1+1,M1+L1+K1
                  CSEQ(I2)='.'
               End do
            End if
            CSEQ(M1)=CSEQ(I1)
            M1=M1-1
            N1=0
            J1=J1-1
         Else
            CSEQ(M1)=CSEQ(I1)
            M1=M1-1
            N1=N1+1
         End if
      End do
      Do I2=N1+1,IPRF(J1)
         CSEQ(M1)='.'
         M1=M1-1
      End do

 100  Return
      End
*----------------------------------------------------------------------*
      Subroutine EdtSeq(CSEQ,LMSA,OPTL,OPTU,OPTP,OPTD)

      Character*01      CSEQ(*)

      Logical           OPTU
      Logical           OPTL
      Logical           OPTP
      Logical           OPTD

      If(OPTU) then
         Do  I1=1,LMSA
            K1=Ichar(CSEQ(I1))
            If(K1.LE.122.AND.K1.GE.97) CSEQ(I1)=Char(K1-32)
         End do
      End if

      If(OPTL) then
         Do  I1=1,LMSA
            K1=Ichar(CSEQ(I1))
            If(K1.LE.90.AND.K1.GE.65) CSEQ(I1)=Char(K1+32)
         End do
      End if

      If(OPTP) then
         Do  I1=1,LMSA
            If(CSEQ(I1).EQ.'-') CSEQ(I1)='.'
         End do
      End if

      If(OPTD) then
         Do  I1=1,LMSA
            If(CSEQ(I1).EQ.'.') CSEQ(I1)='-'
         End do
      End if

      Return
      End
*----------------------------------------------------------------------*
      Subroutine CutSeq(CSEQ,LMSA,LMSB,IPRF,LPRF,NM,IDMP)

      Character*01      CSEQ(*)
      Integer           IPRF(0:IDMP)

      M1=NM/2
      L1=NM-M1
      J1=0
      K1=0
      Do I1=0,LPRF
         If(IPRF(I1).GT.NM) then
            Do I2=1,M1
               J1=J1+1
               K1=K1+1
               CSEQ(J1)=CSEQ(K1)
            End do
            K1=K1+IPRF(I1)-NM
            Do I2=1,L1
               J1=J1+1
               K1=K1+1
               CSEQ(J1)=CSEQ(K1)
            End do
         Else
            Do I2=1,IPRF(I1)
               J1=J1+1
               K1=K1+1
               CSEQ(J1)=CSEQ(K1)
            End do
         End if
         If(I1.NE.LPRF) then
            J1=J1+1
            K1=K1+1
            CSEQ(J1)=CSEQ(K1)
         End if
      End do
      LMSB=J1

      Return
      End
*----------------------------------------------------------------------*
      Subroutine PRSQ(CSEQ,LMSB,NW)

      Character*01      CSEQ(*)
      Character*512     RCOUT

      INB=LMSB/NW
      INR=LMSB-INB*NW
      IN1=0

      Do IN2=1,INB
         Do ii1=1,NW
            RCOUT(ii1:ii1)=CSEQ(IN1+ii1)
         End do
         IN1=IN1+NW
         Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,NW)
      End do
      If(INR.GT.0) then
         Do ii1=1,INR
            RCOUT(ii1:ii1)=CSEQ(IN1+ii1)
         End do
         Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,INR)
      End if

 100  Return
      End

*----------------------------------------------------------------------*
      Include          'lblnk.f'

*       Program pfw
*----------------------------------------------------------------------*
* $Id: pfw.f,v 2.10 2004/01/09 09:27:36 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Calculate weights for individual sequences of a
*                 multiple sequence alignment.
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

* array sizes, I/O units

C       Parameter        (IDM1=16777216)
C        Parameter        (IDM1=1048576)
C        Parameter        (IDM2=   9999)
C        Parameter        (IDM3=   2024)

      Include          'ardim.f'

      Parameter        (NMSF=     11)
      Parameter        (ICSL=IDMS/26)

      Include          'sterr.f'

* weights and distances

      Real*4            RWGT(IDMF)
      Integer           NDIS(IDMF)
      Integer           NIND(IDMF)

* multiple sequence alignment:

      Character*4096    FMSF

      Character*64      SQID(IDMF)
      Character         CSEQ(IDMS)
      Character         CSQR(IDMP)

      Logical           LXSC(IDMP)

* character set

      Character         CSET(26,ICSL)
      Integer           NSET(   ICSL)

* work fields

      Character*512     RCIO
      Character*512     ROUT
      Character*32      RCTM
      Logical           OPTM
      Character         B

* functions

      Integer           Getc
C       Integer           Fputc

* character translation

      Character*27      ABCU
      Character*27      ABCL

      Data              ABCU/'ABCDEFGHIJKLMNOPQRSTUVWXYZ-'/
      Data              ABCL/'abcdefghijklmnopqrstuvwxyz.'/

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      IRC=0
      IDUM=-2

*read command line

      Call Repar
     *   (FMSF,NRAN,RX,RW,IRAN,OPTM,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''pfw 2.3 revision 5.d'',//
     *      ''Usage: pfw [ -hmNXRW ] [ msf-file | - ] '',
     *      ''[ parameters ]'',//
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -h: print usage help text.'',/
     *      ''    -m: input sequences in MSA format.'',/
     *      ''    -N<value>:'',/
     *      ''        number of shuffles per sequence (default:'',
     *      '' 100).'',/
     *      ''    -X<value>:'',/
     *      ''        gap excision threshold (default: 0.5).'',/
     *      ''    -R<value>:'',/
     *      ''        random number seed, negative integer '',
     *      ''(default: -123456789).'',/
     *      ''    -W<value>:'',/
     *      ''        total weight (default: 1).'',/
     *      )')
         Write(NERR,'(
     *      '' valid (but deprecated) parameters are:'',/,
     *      ''  [N=shuffles-per-seq]      use option -N instead'',/
     *      ''  [X=gap-excision]          use option -X instead'',/
     *      ''  [R=random-seed]           use option -R instead'',/
     *      ''  [W=total-weight]          use option -W instead'',/
     *      )')
         Call Exit(IRC)
      End if

* read msf-file

C       If(FMSF.EQ.'-') then
C   1      Open(NMSF,Status='SCRATCH')
C          Do I1=1,2*IDM1
C             If(Getc(B).NE.0) go to   2
C             N1=Fputc(NMSF,B)
C          End do
C   2      Rewind(NMSF)
C       End if

      If(FMSF.EQ.'-') then
 1       Open(NMSF,Status='SCRATCH',Err=901)
 2       Continue
         Do I1=1,512
            If(Getc(B).NE.0) go to 3
            If(Ichar(B).EQ.10) then
               Write(NMSF,'(512A)',Err=903)(CSEQ(ii1),ii1=1,I1-1)
               Go to   2
            Else
               CSEQ(I1)=B
            End if
         End do
         Go to   2
 3       Rewind(NMSF)

      End if

      If(OPTM) then
         Call REMSA
     *      (NERR,NMSF,FMSF,
     *      IDMS,CSEQ,NSEQ,LSEQ,
     *      IDMF,RWGT,SQID,
     *      IRC)
      Else
         Call REMSF
     *      (NERR,NMSF,FMSF,
     *      IDMS,CSEQ,NSEQ,LSEQ,
     *      IDMF,RWGT,SQID,
     *      IRC)
      End if
      If(IRC.NE.0) go to 100

* Check needed buffer size

      If((NSEQ*LSEQ).GT.ICSL) go to 904

*----------------------------------------------------------------------*
* DATA PROCESSING
*----------------------------------------------------------------------*

* make sequence uppercase

      Do I1=1,LSEQ*NSEQ
         If     (Index(ABCU,CSEQ(I1)).NE.0) then
            Continue
         Else
            IX=Index(ABCL,CSEQ(I1))
            If(IX.GT.0) then
               CSEQ(I1)=ABCU(IX:IX)
            Else
               CSEQ(I1)='-'
            End if
         End if
      End do

* gap excision

      NXSC=INT(RX*NSEQ)

      Do I1=1,LSEQ
         J1=I1
         K1=0
         Do I2=1,NSEQ
            If(CSEQ(J1).EQ.'-') K1=K1+1
            J1=J1+LSEQ
         End do
         If(K1.LE.NXSC) then
            LXSC(I1)=.TRUE.
         Else
            LXSC(I1)=.FALSE.
         End if
      End do

* generate character set profile

      Call GCSET
     *   (IDMS,CSEQ,NSEQ,LSEQ,
     *   ICSL,NSET,CSET)

* major loop

* - initialize new weights

*       Do  10 I1=1,NSEQ
      RWGT(I1)=0
 10   Continue

      Do  20 I1=1,NRAN*NSEQ

* - generate random sequences

         Call RanSQ(IRAN,ICSL,NSET,CSET,LSEQ,CSQR)

* - compare random sequence to real sequences
*
*      NDIS(i): distance of random sequence to real sequence i
*      MIND   : minimal distance
*      KMIN   : # of real sequences with minimal distance
*      NIND(i): indices of real sequences with minimal distance

         J3=1
         MIND=LSEQ
         KMIN=0
         Do  15 I2=1,NSEQ
            NDIS(I2)=0
            Do  12 I3=1,LSEQ
               If(LXSC(I3)) then
                  If(CSQR(I3).NE.CSEQ(J3)) NDIS(I2)=NDIS(I2)+1
               End if
               J3=J3+1
 12         Continue
            If     (NDIS(I2).LT.MIND) then
               MIND=NDIS(I2)
               KMIN=1
               NIND(1)=I2
            Else if(NDIS(I2).EQ.MIND) then
               KMIN=KMIN+1
               NIND(KMIN)=I2
            End if
 15      Continue

         R1=1.0/KMIN
         Do  16 I2=1,KMIN
            J2=NIND(I2)
            RWGT(J2)=RWGT(J2)+R1
 16      Continue

 20   Continue

      Do  30 I1=1,NSEQ
         RWGT(I1)=RWGT(I1)/(NSEQ*NRAN)
C          Write(6,'(A16,''Weight: '',F6.4)')
C    *        SQID(I1)(1:16),RWGT(I1)
 30   Continue

*----------------------------------------------------------------------*
* OUTPUT SECTION
*----------------------------------------------------------------------*

      Rewind(NMSF)

* output msa format with xpsa header

      If(OPTM) then
         K1=0
 40      Read(NMSF,'(A)',End=900,Err=902) RCIO
         If(RCIO(1:1).NE.'>') go to 40

* build 'weight=value' pair

 41      K1=K1+1
         RCTM=' weight= '
         Write(RCTM(10:),*) RW*RWGT(K1)

* remove extraoneous blanks

         J1=8
         Do I1=9,Lblnk(RCTM)
            If(RCTM(I1:I1).NE.' ') then
               J1=J1+1
               RCTM(J1:J1)=RCTM(I1:I1)
               RCTM(I1:I1)=' '
            End if
         End do
         ILTM=Lblnk(RCTM)

* find and replace preexisting 'weight=value' in xpsa header

         L=Lblnk(RCIO)
         IX=Index(RCIO(1:L),' weight=')

         If(IX.EQ.0) then
            If((L+ILTM+1).GE.512) L=L-ILTM-1
            RCIO(L+1:L+1+ILTM)=RCTM
            Write(6,'(512A)')(RCIO(ii1:ii1),ii1=1,L+1+ILTM)
         Else
            Do I1=IX+7,L
               If(RCIO(I1:I1).NE.' ') go to 45
            End do
 45         Do I2=I1,L
               If(RCIO(I2:I2).EQ.' ') go to 46
            End do
 46         ROUT(1:IX)=RCIO(1:IX)
            ROUT(IX:IX+ILTM)=RCTM
            ROUT(IX+ILTM:)=RCIO(I2:L)
            L=Lblnk(ROUT)
            Write(6,'(512A)')(ROUT(ii1:ii1),ii1=1,L)
         End if

 48      RCIO=' '
         Read(NMSF,'(A)',Err=902,Iostat=IOS) RCIO
         If(RCIO(1:1).EQ.'>') go to 41
         L=Lblnk(RCIO)
         If(L.EQ.0.AND.IOS.EQ.-1) go to 100
         Write(6,'(512A)')(RCIO(ii1:ii1),ii1=1,L)
         Go to  48

* output MSF format

      Else
 51      Read(NMSF,'(A)',End=900,Err=902) RCIO
         L=Lblnk(RCIO)
         Write(6,'(512A)')(RCIO(ii1:ii1),ii1=1,L)
         If(Index(RCIO(1:L),'..').EQ.0) go to  51

         K1=1
 52      Read(NMSF,'(A)',End=900,Err=902) RCIO
         L=Lblnk(RCIO)
         IX=Index(RCIO(1:L),'Weight: ')
         If(IX.NE.0) then
            If(RW*RWGT(K1).LT.10) then
               Write(RCIO(IX+8:),'(F6.4)') RW*RWGT(K1)
               L=IX+13
            Else
               Write(RCIO(IX+8:),*) RW*RWGT(K1)
               L=Lblnk(RCIO)
            End if
            K1=K1+1
         End if
         Write(6,'(512A)')(RCIO(ii1:ii1),ii1=1,L)
         If(RCIO(1:2).NE.'//') go to  52

 53      Read(NMSF,'(A)',End=100,Err=902) RCIO
         L=Lblnk(RCIO)
         Write(6,'(512A)')(RCIO(ii1:ii1),ii1=1,L)
         Go to  53
      End if


 100  Call Exit(IRC)

* errors

 900  Go to 100

 901  Write(NERR,*) 'Error: Unable to create temporary file.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: Unable to read MSF file.'
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Unable to write to temporary file.'
      IRC=1
      Go to 100
 904  Write(NERR,*) 'Error: Sequence length times sequence number ',
     *   'exceeds buffer size (',ICSL,').'
      IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine Repar
     *   (FMSF,NRAN,RX,RW,IRAN,OPTM,IRC)

      Character*(*)     FMSF
      Character*4096    CPAR
      Logical           OPTM

      NRAN=100
      RX=0.5
      IRAN=-123456789
      RW=1.0
      IRC=0
      FMSF=' '
      OPTM=.FALSE.

      N1=Iargc()
      If(N1.LT.1) go to 900

      K1=0
      I2=1
      Do  50 I1=1,N1
         Call GetArg(I2,CPAR)
         If     (CPAR(1:1).EQ.'-'.AND.CPAR(2:2).NE.' ') then
            If(Index(CPAR,'h').NE.0) then
               IRC=1
               Go to 100
            End if
            If(Index(CPAR,'m').NE.0) OPTM=.TRUE.
            If(Index(CPAR,'N').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) NRAN
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) NRAN
               End if
            End if
            If(Index(CPAR,'X').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RX
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RX
               End if
            End if
            If(Index(CPAR,'R').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) IRAN
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) IRAN
               End if
            End if
            If(Index(CPAR,'W').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RW
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RW
               End if
            End if

         Else if(CPAR(1:2).EQ.'N=') then
            Read(CPAR(3:),*,Err=900) NRAN
         Else if(CPAR(1:2).EQ.'X=') then
            Read(CPAR(3:),*,Err=900) RX
         Else if(CPAR(1:2).EQ.'R=') then
            Read(CPAR(3:),*,Err=900) IRAN
         Else if(CPAR(1:2).EQ.'W=') then
            Read(CPAR(3:),*,Err=900) RW

         Else if(FMSF.EQ.' ') then
            FMSF=CPAR
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 60

 50   Continue

 60   If(FMSF.EQ.' ') go to 900
      If(NRAN.LE.0) go to 900
      If(IRAN.GT.0) IRAN=-1-IRAN
      If(IRAN.EQ.0) IRAN=-123456789

 100  Return
 900  IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine GCSET
     *   (IDMS,CSEQ,NSEQ,LSEQ,
     *   ICSL,NSET,CSET)

* CSEQ(IDMS)
* NSET(ICSL)

      Character         CSEQ(*)
      Integer           NSET(*)
      Character         CSET(26,ICSL)

      Do  10 I1=1,LSEQ
         NSET(   I1)=0
         J2=I1-LSEQ
         Do   8 I2=1,NSEQ
            J2=J2+LSEQ
            Do   5 I3=1,NSET(I1)
               If(CSEQ(J2).EQ.CSET(I3,I1)) go to   8
 5          Continue
            NSET(I1)=NSET(I1)+1
            CSET(NSET(I1),I1)=CSEQ(J2)
 8       Continue
 10   Continue

C       Do  20 I1=1,LSEQ
C          Write(6,'(I6,'' '',26A)')
C    *        NSET(I1),(CSET(ii1,I1),ii1=1,NSET(I1))
C  20   Continue

      Return
      End
*----------------------------------------------------------------------*
      Subroutine RanSQ(IRAN,ICSL,NSET,CSET,LSEQ,CSQR)

      Integer         NSET(*)
      Character       CSET(26,ICSL)
      Character       CSQR(*)

      Do  10 I1=1,LSEQ
         If(NSET(I1).EQ.0) then
            CSQR(I1)='-'
         Else
            K1=RAN2(IRAN)*NSET(I1)+1
            CSQR(I1)=CSET(K1,I1)
         End if
 10   Continue

      Return
      End
*----------------------------------------------------------------------*
      FUNCTION RAN2(IDUM)
      PARAMETER (M=714025,IA=1366,IC=150889,RM=1.4005112E-6)
      DIMENSION IR(97)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
         IFF=1
         IDUM=MOD(IC-IDUM,M)
         DO 11 J=1,97
            IDUM=MOD(IA*IDUM+IC,M)
            IR(J)=IDUM
 11      CONTINUE
         IDUM=MOD(IA*IDUM+IC,M)
         IY=IDUM
      ENDIF
      J=1+(97*IY)/M
      IF(J.GT.97.OR.J.LT.1) PAUSE
      IY=IR(J)
      RAN2=IY*RM
      IDUM=MOD(IA*IDUM+IC,M)
      IR(J)=IDUM
      RETURN
      END
*----------------------------------------------------------------------*
      Include          'remsf.f'
      Include          'remsa.f'
      Include          'lblnk.f'

*----------------------------------------------------------------------*     
* $Id: reseq.f,v 2.12 2003/11/18 10:50:07 vflegel Exp $
*----------------------------------------------------------------------*     
*        Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine RESEQ
     *   (NSEQ,FSEQ,NABC,CABC,CSID,CSAC,CSDE,LSEQ,ISEQ,LEOF,
     *   INBS,OPTV,IRC)

      Include          'ardim.f'
      Include          'sterr.f'
     

* function return types

      Integer           Xblnk
      External          Xblnk

* reads sequence file in Swiss-Prot/EMBL format 

      Character*(*)     FSEQ
      Character         CABC(0:26)
      Character*(*)     CSID
      Character*(*)     CSAC
      Character*(*)     CSDE
      Integer*2         ISEQ(*)
      Logical           LEOF 
      Logical           LOPN
      Logical           LIDF
      Logical           OPTV
      Character*2       CMIS
      Character*256     RCIN
      
      IRC=0
      LIDF=.FALSE.
      LEOF=.FALSE.
      CMIS='ID'
      Inquire(File=FSEQ,OPENED=LOPN)
      If(LOPN) go to   1
      If(FSEQ.NE.'-') Open(NSEQ,File=FSEQ,Status='OLD',Err=900)
 1    Read(NSEQ,'(A)',Err=901,End=999,Iostat=IOS) RCIN
      If(RCIN(1:1).EQ.'>') go to 903
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:2).NE.'ID') go to   1   
      IC=Index(RCIN(6:17),' ')+5
      CSID=RCIN( 6:IC)
      LIDF=.TRUE.

      CMIS='AC'
 2    Read(NSEQ,'(A)',Err=901,End=902,Iostat=IOS) RCIN
      If(RCIN(1:2).NE.'AC'.AND.RCIN(1:2).NE.'DE') go to   2   
      If(RCIN(1:2).EQ.'AC') then 
         IX=Index(RCIN,';')-1
         If(IX.LE.0) go to 916
         CSAC=RCIN(6:IX) // '|'
      Else
         CSDE=RCIN( 6:Xblnk(RCIN,64))
         Go to   4
      End if 

      CMIS='DE'
 3    Read(NSEQ,'(A)',Err=901,End=902,Iostat=IOS) RCIN
      If(RCIN(1:2).NE.'DE') go to   3   
      CSDE=RCIN( 6:Xblnk(RCIN,64))

      CMIS='SQ'
 4    Read(NSEQ,'(A)',Err=901,End=902,Iostat=IOS) RCIN
      If(RCIN(1:2).NE.'DE') go to   5   
      LR=Xblnk(CSDE,64)
      If(CSDE(LR:LR).EQ.Char(13)) LR=LR-1
      JN=Xblnk(RCIN,64)
      If((LR+JN-4).LT.512)
     *   CSDE=CSDE(1:LR) // ' ' // RCIN( 6:JN)

 5    Continue
      If(RCIN(1:2).EQ.'SQ') go to   7

 6    Read(NSEQ,'(A)',Err=901,End=902,Iostat=IOS) RCIN
      If(RCIN(1:2).NE.'SQ') go to   6   

 7    Continue

      J1=0
 10   Read(NSEQ,'(A)',Err=901,End= 20,Iostat=IOS) RCIN
      If(RCIN(1:2).EQ.'//') go to  20

      Do 15 I1=1,Xblnk(RCIN,64)
         N1=0
         K1=Ichar(RCIN(I1:I1))
         If(K1.GE.97) then 
            K1=K1-32
            RCIN(I1:I1)=Char(K1)
         End if
         If(K1.GT.90.OR.K1.LT.65) go to  15 

         Do 13 I2=1,NABC
            If(CABC(I2).EQ.RCIN(I1:I1)) then
               N1=I2
               Go to   14
            End if
 13      Continue
 14      J1=J1+1
         If(J1.GT.IDMS) go to 915
         ISEQ(J1)=N1
 15   Continue
      Go to  10 

 20   LSEQ=J1
      If(LSEQ.LE.0) go to 917
      INBS=INBS+1

 100  If(IOS.EQ.-1.AND.IRC.LT.1) then
         LEOF=.TRUE.
         If(INBS.LT.1) go to 921
      End if

 105  Return

 110  If(LIDF) then
         Write(NERR,*) '       While processing sequence ',
     *      CSID(1:Lblnk(CSID))
      End if
      Go to 100


* errors

 900  Write(NERR,*) 'Error: Unable to open sequence file'//
     *   ' ''',FSEQ(1:Xblnk(FSEQ,64)),'''.'
      IRC=1
      Go to 110
 901  Write(NERR,*) 'Error: Unable to read sequence file'//
     *   ' ''',FSEQ(1:Xblnk(FSEQ,64)),'''.'
      IRC=1
      Go to 110
 902  Write(NERR,*) 'Error: Unexpected end of file. '//
     *   'Unable to find sequence ',CMIS,' line.'
      Write(NERR,*) '       No sequence read.'
      IRC=1
      Go to 110
 903  Write(NERR,*) 'Error: Sequence file in wrong format.'//
     *   ' Try option -f.'
      IRC=1
      Go to 110
 915  Write(NERR,*) 'Error: Sequence length exceeds buffer ',
     *   'size (',IDMS,').'
      IRC=1
      Go to 110
 916  Write(NERR,*) 'Error: Missing semicolon.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 917  Write(NERR,*) 'Error: Unexpected end of sequence.'//
     *   ' Sequence has zero length.'
      IRC=1
      Go to 110

* warnings

 920  If(.NOT.OPTV) then
         Write(NERR,*)'Warning: Unexpected sequence separator (''//'')',
     *      ' found. Unable to find sequence '//CMIS//' line.'
         If(LIDF) then
            Write(NERR,*) '       While processing sequence ',
     *         CSID(1:Lblnk(CSID))
         End if
         Write(NERR,*) '         Reading next sequence.'
      End if
      IRC=0
      LIDF=.FALSE.
      CMIS='ID'
      Go to 1
 921  If(.NOT.OPTV) then
         Write(NERR,*) 'Warning: No sequence has been read.'
         Write(NERR,*) '         No alignment produced.'
      End if
      IRC=1
      Go to 105

 999  IRC=-1
      Go to 100

      End

*       Program pfmake
*----------------------------------------------------------------------*
* $Id: pfmake.f,v 2.11 2003/11/28 11:53:33 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Constructs a profile from a multiple sequence
*                 alignment
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

* array sizes, I/O units

      Include          'ardim.f'

C      Parameter        (IDM1=1048576)
C      Parameter        (IDM2=   2048)

      Parameter        (NOUT=      6)
      Parameter        (NMSF=      5)
      Parameter        (NCMP=     12)
      Parameter        (NPRF=     13)

* profile and sequence fields :

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'
      Include          'sterr.f'

C      Character*64      FOUT

* weights and distances

      Real*4            RWGT(IDMF)

* multiple sequence alignment:

      Character*4096    FMSF

      Character*64      SQID(IDMF)
      Character         CSEQ(IDMS)

* frequency profile

      Real              RPRF(26,IDMP)
      Real              FUNK(IDMP)
      Real              FRES(IDMP)
      Real              FDEL(IDMP)

* score profile

      Real              SPRF(26,IDMP)
      Real              SDEL(IDMP)
      Real              SINS(0:IDMP)

* symbol comparison table

      Character*4096    FCMP

      Real              RCMP(26,26)

* profile

      Character*4096    FPRF
      Character*30      FDAT


* function return types

      Integer           Xblnk
      External          Xblnk

* options

      Logical           OPT0
      Logical           OPT1
      Logical           OPT2
      Logical           OPT3
      Logical           OPTC
      Logical           LLLT
      Logical           OPTM
      Logical           LRNM
      Logical           LEOF

      Logical           LBLK
      Logical           LSYM
      Logical           LWGE
      Real              RE
      Real              RF
      Real              RG
      Real              RH
      Real              RI
      Real              RL
      Real              RM
      Real              RS
      Real              RT
      Real              RX

* character translation

      Character*27      ABCU
      Character*27      ABCL

      Data              ABCU/'ABCDEFGHIJKLMNOPQRSTUVWXYZ-'/
      Data              ABCL/'abcdefghijklmnopqrstuvwxyz.'/

* initialization of controlled vocabularies

      Include          'cvini.f'

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      IRC=0
      IDUM=-2
      BLOG=0.0
      LEOF=.FALSE.
      LRNM=.FALSE.

* read command line

      Call Repar
     *   (FMSF,FCMP,FPRF,OPT0,OPT1,OPT2,OPT3,OPTC,LSYM,LWGE,LBLK,
     *   LLLT,OPTM,RE,RF,RG,RH,RI,RL,RM,RS,RT,RX,NLOW,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''pfmake 2.3 revision 5.d'',//
     *      ''Usage: pfmake [ -0123abcehlsEFGHILMSTX ] [ msf-file'',
     *      '' | - ] score-matrix [ profile-file ] [ parameters ]'',//
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -0: global alignment mode.'',/
     *      ''    -1: domain global alignment mode.'',/
     *      ''    -2: semi-global alignment mode.'',/
     *      ''    -3: local alignment mode.'',/
     *      ''    -a: asymmetrical gap weighting.'',/
     *      ''    -b: block profile mode.'',/
     *      ''    -c: circular profile.'',/
     *      ''    -e: enable endgap-weighting mode.'',/
     *      ''    -h: print usage help text.'',/
     *      ''    -m: input sequences in MSA format.'',/
     *      ''    -l: do not impose limit on line length.'',/
     *      ''    -s: symmetrical gap weighting.''
     *      )')
         Write(NERR,'(
     *      ''    -E<value>:'',/
     *      ''        gap extension penalty (default: 0.2).'',/
     *      ''    -F<value>:'',/
     *      ''        output score multiplier (default: 100)'',/
     *      ''    -G<value>:'',/
     *      ''        gap opening penalty (default: 2.1)'',/
     *      ''    -H<value>:'',/
     *      ''        high cost initiation/termination score (default'',
     *      '': *)'',/
     *      ''    -I<value>:'',/
     *      ''        gap penalty multiplier increment (default:'',
     *      '' 0.1)''
     *      )')
         Write(NERR,'(
     *      ''    -L<value>:'',/
     *      ''        low cost initiation/termination score (default:'',
     *      ''  0).'',/
     *      ''    -M<value>:'',/
     *      ''        maximum gap penalty multiplier (default:'',
     *      '' 0.333).'',/
     *      ''    -S<value>:'',/
     *      ''        score matrix multiplier (default: 0.1)'',/
     *      ''    -T<value>:'',/
     *      ''        gap region threshold (default: 0.01)'',/
     *      ''    -X<value>:'',/
     *      ''        gap excision threshold (default: 0.5)'',/
     *      )')
         Write(NERR,'(
     *      '' valid (but deprecated) parameters are:'',/,
     *      ''  [E=gap-extension-weight]      use option -E instead'',/
     *      ''  [F=output-score-multiplier]   use option -F instead'',/
     *      ''  [G=gap-weigth]                use option -G instead'',/
     *      ''  [H=high-cost-init-term-score] use option -H instead'',/
     *      ''  [I=Ginc-multiplier]           use option -I instead'',/
     *      ''  [L=low-cost-init-term-score]  use option -L instead'',/
     *      ''  [M=Gmax-multiplier]           use option -M instead'',/
     *      ''  [S=score-matrix-multiplier]   use option -S instead'',/
     *      ''  [T=gap-region-threshhold]     use option -T instead'',/
     *      ''  [X=gap-excision-threshold]    use option -X instead'',/
     *      )')
         Call Exit(IRC)
      End if

* read msf or msa-file

      If(OPTM) then
         Call REMSA
     *      (NERR,NMSF,FMSF,
     *      IDMS,CSEQ,NSEQ,LSEQ,
     *      IDMF,RWGT,SQID,
     *      IRC)
      Else
         Call REMSF
     *      (NERR,NMSF,FMSF,
     *      IDMS,CSEQ,NSEQ,LSEQ,
     *      IDMF,RWGT,SQID,
     *      IRC)
      End if
      If(IRC.NE.0) go to 100

* read score-matrix

      Call RECMP(NERR,NCMP,FCMP,NABC,CABC,RCMP,IRC)
      If(IRC.NE.0) go to 100

* read input profile

      If(FPRF.NE.' ')
     *   Call REPRF
     *   (NPRF,FPRF,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   BLOG,FABC,P0,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,CHIL,IIPL,ILIP,
     *   CHID,IIPD,CHMD,IMPD,
     *   INBP,LEOF,.FALSE.,IRC)

      If(IRC.GT.0) go to 100
      If(IRC.NE.0.OR.FPRF.EQ.' ') then
         IRC=0
         CPID=' '
         CPAC=' '
         CPDT=' '
         CPDE=' '
         MDIS=0
         JNOR=0
         JCUT=0
         LHDR=0
         LFTR=0
      End if

*----------------------------------------------------------------------*
* DATA PROCESSING SECTION
*----------------------------------------------------------------------*

* normalize weights

      R1=0.0
      Do I1=1,NSEQ
         R1=R1+RWGT(I1)
      End do
      If(R1.EQ.0.0) then
         R1=1/Real(NSEQ)
         Do I1=1,NSEQ
            RWGT(I1)=R1
         End do
      Else
         Do I1=1,NSEQ
            RWGT(I1)=RWGT(I1)/R1
         End do
      End if

* make sequences uppercase

      Do I1=1,LSEQ*NSEQ
         If     (Index(ABCU,CSEQ(I1)).EQ.0) then
            IX=Index(ABCL,CSEQ(I1))
            If(IX.GT.0) then
               CSEQ(I1)=ABCU(IX:IX)
            Else
               CSEQ(I1)='-'
            End if
         End if
      End do

* remove endgaps

      If(.NOT.LWGE) then
         J1=0
         Do  10 I1=1,NSEQ
            Do   6 I2=J1+1,J1+LSEQ
               If(CSEQ(I2).NE.'-') go to  7
               CSEQ(I2)=' '
 6          Continue
 7          Continue

            Do   8 I2=J1+LSEQ,J1+1,-1
               If(CSEQ(I2).NE.'-') go to  9
               CSEQ(I2)=' '
 8          Continue
 9          Continue
            J1=J1+LSEQ
 10      Continue
      End if

* make frequency profile
*
*   for residue i and profile position j:
*      RPRF(i,j) = residue frequency(residue,position)
*   for profile position j:
*      FUNK(  j) = fraction of unknown residues
*      FRES(  j) = fraction of residues and gaps
*      RDEL(  l) = fraction of gaps

* - initialize

      Do  12  I1=1,LSEQ
         Do  11 I2=1,NABC
            RPRF(I2,I1)=0.0
 11      Continue
         FUNK(I1)=0.0
         FRES(I1)=0.0
         FDEL(I1)=0.0
 12   Continue

      J1=0
      K1=1
      Do  20 I1=1,NSEQ
         K2=1
         Do  19 I2=J1+1,J1+LSEQ
            IX=0
            Do  15 I3=1,NABC
               If(CSEQ(I2).EQ.CABC(I3)) then
                  IX=I3
                  Go to  16
               End if
 15         Continue
 16         Continue

            FRES(   K2)=FRES(   K2)+RWGT(K1)
            If     (IX.NE.0) then
               RPRF(IX,K2)=RPRF(IX,K2)+RWGT(K1)
            else if(CSEQ(I2).EQ.'-') then
               FDEL(   K2)=FDEL(   K2)+RWGT(K1)
            else if(CSEQ(I2).EQ.' ') then
               FRES(   K2)=FRES(   K2)-RWGT(K1)
            else
               FUNK(   K2)=FUNK(   K2)+RWGT(K1)
            end if
            K2=K2+1
 19      Continue
         J1=J1+LSEQ
         K1=K1+1
 20   Continue

* normalize frequencies:

      Do  25 I1=1,LSEQ
         FDEL(I1)=FDEL(I1)/FRES(I1)
         R1=FRES(I1)-FUNK(I1)
         If(R1.EQ.0) go to  25
         Do  23 I2=1,NABC
            RPRF(I2,I1)=RPRF(I2,I1)/R1
 23      Continue
 25   Continue

* construct score profile:
*
*   for known residue i and profile match position j:
*      SPRF(i,j) = match extension score
*   for profile position j:
*      SDEL(  j) = gap penalty multipliers for deletion gaps
*      SINS(  j) = gap penalty multipliers for insertion gaps

* - gap penalty multipliers:

      K1=0
      J1=0
      SINS(0)=1.0
      Do   30 I1=1,LSEQ
         If(FDEL(I1).LE.RT) then
            If(K1.GT.0) then
               XDEL=RM/(1.0+K1*RI)
               SINS(J1-1)=XDEL
               Do  27 I2=J1,I1-1
                  SINS(I2)=XDEL
                  SDEL(I2)=XDEL
 27            Continue
               K1=0
            End if
            SINS(I1)=1.0
            SDEL(I1)=1.0
         else
            If(K1.EQ.0) J1=I1
            K1=K1+1
         end if
 30   Continue

      K1=0
      J1=0
      Do  50 I1=1,LSEQ
         If(FDEL(I1).GT.1-RX) then

* - gap excision

            J1=J1+1
         else
            K1=K1+1

* - score matrix application

            Do  33 I2=1,NABC
               SPRF(I2,K1)=0.0
               Do  32 I3=1,NABC
                  SPRF(I2,K1)=SPRF(I2,K1)+RCMP(I3,I2)*RPRF(I3,I1)
 32            Continue
               SPRF(I2,K1)=RS*SPRF(I2,K1)
C                Write(6,'(I4,1x,A,F10.4)') K1,CABC(I2),SPRF(I2,K1)
 33         Continue
            If(J1.GT.0) then
               SINS(K1-1)=-SINS(I1-1)
               J1=0
            End if
            SDEL(K1)=SDEL(I1)
            SINS(K1)=SINS(I1)
            FDEL(K1)=FDEL(I1)
         end if
 50   Continue
      If(J1.GT.0) SINS(K1)=-SINS(K1)
      LPRF=K1


* initialize generalized profile

* - header

      If(CPID.EQ.' ') CPID='SEQUENCE_PROFILE'
      If(CPAC.EQ.' ') CPAC='ZZ99999'
      CALL Fdate(FDAT)
      If(CPDT.NE.' ') then
         CPDT=FDAT(1:Lblnk(FDAT)) // ' ! ' // CPDT
      Else
         CPDT=FDAT(1:Lblnk(FDAT))
      End if
      If(FMSF.EQ.'-') FMSF='stdin'
      If(CPDE.EQ.' ') CPDE='Generated from MSF file: '''
     *   // FMSF(1:Lblnk(FMSF))
     *   // '''.'

* - accessories

      If(MDIS.EQ.0) then
         MDIS=2
         N1=MIN(5,LPRF/10)
         NDIP(1)=1   +N1
         NDIP(2)=LPRF-N1
      End If

      If(JNOR.EQ.0.OR.JCUT.EQ.0) then
         JNOR=1
         MNOR(1)=1
         NNOR(1)=1
         NNPR(1)=1
         CNTX(1)='No_units'
         RNOP(1,1)=0.0
         RNOP(2,1)=1/RF
      End if

      If(JCUT.EQ.0) then
         JCUT=2

         MCLE(1)=0
         CCUT(1)='!'
         ICUT(1)=INT(RF*8.5)
         JCNM(1)=1
         RCUT(1,1)=8.5
         MCUT(1,1)=1

         MCLE(2)=-1
         CCUT(2)='?'
         ICUT(2)=INT(RF*6.5)
         JCNM(2)=1
         RCUT(1,2)=6.5
         MCUT(1,2)=1
      End if

* - defaults for match and insert position

      CHID='-'
      Do  65 I1=1,26
         IIPD(I1)=0
 65   Continue

      If(LSYM) then
         N1=-NINT(RF*RG/2)
         N2=-NINT(RF*RG/2)
      Else
         N1=-NINT(RF*RG)
         N2=0
      End if
      N3=-NINT(RF*RE)

      IIPD(B0)=0
      IIPD(B1)=NLOW
      IIPD(E0)=0
      IIPD(E1)=NLOW

      IIPD(BM)=0
      IIPD(BI)=NLOW
      IIPD(BD)=NLOW
      IIPD(BE)=NLOW
      IIPD(MM)=0
      IIPD(MI)=N1
      IIPD(MD)=N1
      IIPD(ME)=0
      IIPD(IM)=N2
      IIPD(II)=0
      IIPD(ID)=NLOW
      IIPD(IE)=NLOW
      IIPD(DM)=N2
      IIPD(DI)=NLOW
      IIPD(DD)=0
      IIPD(DE)=NLOW

      IIPD(I0)=0

      CHMD='X'
      CHID='-'
      Do  66 I1=1,26
         IIPD(I1)=N3
         IMPD(I1)=0
 66   Continue

      IIPD(M0)=0

      IMPD(D )=N3

      Do  68 I1=0,27
         IMPP(I1,0)=NLOW
 68   Continue

* build insert positions

      Do  75 I1=0,LPRF

         CHIP(I1)=CHID

         Do I2=0,46
            IIPP(I2,I1)=IIPD(I2)
         End do

         If(SINS(I1).LT.0) then
            XINS=0.0
            SINS(I1)=-SINS(I1)
         Else
            XINS=SINS(I1)
         End if

         NINS=-NINT(RF*RE*SINS(I1))
         Do  I2=1,NABC
            IIPP(I2,I1)=NINS
         End do

         If     (LSYM) then
            IIPP(MI,I1)=-NINT(RF*RG*XINS      /2)
            IIPP(IM,I1)=-NINT(RF*RG*XINS      /2)
            If(XINS.EQ.0) then
               If(I1.NE.LPRF) IIPP(MD,I1)=-NINT(RF*RG*SINS(I1)  /2)
               If(I1.NE.   0) IIPP(DM,I1)=-NINT(RF*RG*SINS(I1)  /2)
            Else
               If(I1.NE.LPRF) IIPP(MD,I1)=-NINT(RF*RG*SDEL(I1+1)/2)
               If(I1.NE.   0) IIPP(DM,I1)=-NINT(RF*RG*SDEL(I1  )/2)
            End if
         Else if(I1.NE.LPRF) then
            IIPP(MI,I1)=-NINT(RF*RG*SDEL(I1+1))
            IIPP(MD,I1)=-NINT(RF*RG*SDEL(I1+1))
         End if

 75   Continue

* - build match position

      Do  80 I1=1,LPRF
         Do  I2=0,27
            IMPP(I2,I1)=IMPD(I2)
         End do
         IMPP( D,I1)=-NINT(RF*RE*SDEL(I1))
         Do  I2=1,NABC
            IMPP(I2,I1)=NINT(RF*SPRF(I2,I1))
         End do

         J2=0
         K2=0
         Do I2=1,NABC
            If(IMPP(I2,I1).GT.K2) then
               J2=I2
               K2=IMPP(I2,I1)
            End if
         End do
         If(J2.NE.0) then
            CHMP(I1)=CABC(J2)
         Else
            CHMP(I1)=CHMD
         End if
 80   Continue

* block profile

      If(LBLK) then
         K1=0
         J1=0
 85      J1=J1+1
         If((FDEL(J1).LE.RT.AND.K1+1.NE.J1).OR.
     *      (FDEL(J1).GT.RT.AND.J1.EQ.LPRF)) then

* - gap region: define center position

            N1=K1
            N3=J1-1
            If(FDEL(J1).GT.RT) N3=LPRF

* - - beginning, end

            If(N1.EQ.0) then
               N2=N3
               GO to 90
            End if

            If(N3.EQ.LPRF) then
               N2=N1
               Go to 90
            End if

* - - gap excision position ?

            N2=N1
            Do I1=N1,N3
               If(IIPP(MI,I1).EQ.0) then
                  N2=I1
                  Go to  90
               End if
            End do

* - - find center position

            R1=0
            R2=0
            Do I1=N1+1,N3
               R1=R1+FDEL(I1)-FDEL(I1-1)
               If(R1.GT.R2) then
                  N2=I1
                  R2=R1
               End if
            End do

* - edit gap region

 90         Continue
            Do I1=N1,N3
               If(I1.LT.N2) then
                  IIPP(DM,I1)=IIPD(DM)
                  IIPP(IM,I1)=IIPD(IM)
                  IIPP(MI,I1)=IIPD(MI)
               End if
               If(I1.GT.N2) then
                  IIPP(MD,I1)=IIPD(MD)
                  IIPP(IM,I1)=IIPD(IM)
                  IIPP(MI,I1)=IIPD(MI)
               End if
            End do

* - gap region done

            K1=J1

* - no gap region

         Else
            If(FDEL(J1).LE.RT) K1=J1
         End if
         If(J1.LT.LPRF) go to 85

      End if

* begin-to, to-end scores

      IIPP(BM,   0)=IIPP(MM,   0)
      IIPP(BI,   0)=IIPP(MI,   0)
      IIPP(BD,   0)=IIPP(MD,   0)
      IIPP(ME,LPRF)=IIPP(MM,LPRF)
      IIPP(IE,LPRF)=IIPP(IM,LPRF)
      IIPP(DE,LPRF)=IIPP(DM,LPRF)

* alignment mode

* - define high and low init/term scores in integer units

      NH=NLOW
      If(RH.GT.Real(NLOW)) then
         RH=-RH*RF
         If(RH.GT.Real(NLOW)) NH=NINT(RH)
      End if
      NL=NLOW
      If(-RF*RL.GT.Real(NLOW)) NL=NINT(-RL*RF)

* - global alignment mode (also initialization for other modes)

      Do I1=0,LPRF
         IIPP(B0,  I1)=NH
         IIPP(B1,  I1)=NH
         IIPP(E0,  I1)=NH
         IIPP(E1,  I1)=NH
         IIPP(BE,  I1)=IIPD(BE)
      End do
      IIPP(B0,   0)=NL
      IIPP(E0,LPRF)=NL

      IIPD(B0)=NH
      IIPD(B1)=NH
      IIPD(E0)=NH
      IIPD(E1)=NH


* - domain-global alignment mode

      If(OPT1.OR.OPT2.OR.OPT3) then
         IIPP(B1,   0)=NL
         IIPP(E1,LPRF)=NL
      End if

* - semiglobal alignment mode

      If(OPT2.OR.OPT3) then
         Do I1=0,LPRF
            IIPP(B0,I1)=NL
            IIPP(E0,I1)=NL
         End do
         IIPD(B0)=NL
         IIPD(E0)=NL
      End if

* - local alignment mode

      If(OPT3) then
         Do I1=1,LPRF-1
            IIPP(B1,I1)=NL
            IIPP(E1,I1)=NL
         End do
         IIPD(B1)=NL
         IIPD(E1)=NL
      End if

* - default M0 value:

      R=0.0
      Do I1=1,LPRF
         Do I2=1,NABC
            R=R+IMPP(I2,I1)
         End do
      End do
      IMPD(M0)=INT(R/(LPRF*NABC))

      Do I1=1,LPRF
         IMPP(M0,I1)=IMPD(M0)
      End do

* linear or circular profile ?

      If(OPTC) then
         Do I1=0,46
            K1=MAX(IIPP(I1,   0),IIPP(I1,LPRF))
            IIPP(I1,   0)=K1
            IIPP(I1,LPRF)=K1
         End do
         IIPP(MM,0)=MAX(IIPP(MM,0),IIPP(BM,0),IIPP(ME,0))
         IIPP(MI,0)=MAX(IIPP(MI,0),IIPP(BI,0))
         IIPP(MD,0)=MAX(IIPP(MD,0),IIPP(BD,0))
         IIPP(IM,0)=MAX(IIPP(IM,0),IIPP(IE,0))
         IIPP(DM,0)=MAX(IIPP(DM,0),IIPP(DE,0))
         LPCI=.TRUE.
      Else
         LPCI=.FALSE.
      End if

*----------------------------------------------------------------------*
* OUTPUT SECTION
*----------------------------------------------------------------------*

C      FOUT='stdout'

* add command-line to footer lines

      LFTR=LFTR+1
      If(LFTR.GT.1024) LFTR=1024
      Do I1=LFTR,2,-1
         CFTR(I1)=CFTR(I1-1)
      End do

      CFTR(1)='CC   /GENERATED_BY="'
      Call Recmd(CFTR(1)(21:130))
      IC=Lblnk(CFTR(1))
      CFTR(1)(IC+1:)='";'

      Call WRPRF
     *   (NOUT,LLLT,LRNM,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   BLOG,FABC,P0,
     *   CHID,IIPD,CHMD,IMPD,
     *   IRC)

 100  Call Exit(IRC)
      End
*----------------------------------------------------------------------*
      Subroutine Repar
     *   (FMSF,FCMP,FPRF,OPT0,OPT1,OPT2,OPT3,OPTC,LSYM,LWGE,LBLK,
     *   LLLT,OPTM,RE,RF,RG,RH,RI,RL,RM,RS,RT,RX,NLOW,IRC)

      Character*4096    CPAR
      Character*(*)     FMSF
      Character*(*)     FCMP
      Character*(*)     FPRF

      Logical           OPT0
      Logical           OPT1
      Logical           OPT2
      Logical           OPT3
      Logical           OPTC
      Logical           LLLT
      Logical           OPTM

      Logical           LBLK
      Logical           LSYM
      Logical           LWGE

      OPT0=.FALSE.
      OPT1=.FALSE.
      OPT2=.TRUE.
      OPT3=.FALSE.
      OPTC=.FALSE.
      LLLT=.TRUE.
      OPTM=.FALSE.

      LBLK=.FALSE.
      LSYM=.TRUE.
      LWGE=.FALSE.

      RE=0.2
      RF=100
      RG=2.1
      RH=Real(NLOW)
      RI=0.1
      RL=0.0
      RM=0.333
      RS=0.1
      RT=0.01
      RX=0.5

      IRC=0
      FMSF=' '
      FCMP=' '
      FPRF=' '

      N1=Iargc()

      K1=0
      I2=1
      Do  10 I1=1,N1
         Call GetArg(I2,CPAR)
         If     (CPAR(1:1).EQ.'-'.AND.CPAR(2:2).NE.' ') then
            If(Index(CPAR,'0').NE.0) then
               OPT0=.TRUE.
               OPT2=.FALSE.
            else if(Index(CPAR,'1').NE.0) then
               OPT1=.TRUE.
               OPT2=.FALSE.
            else if(Index(CPAR,'2').NE.0) then
               OPT2=.TRUE.
            else if(Index(CPAR,'3').NE.0) then
               OPT3=.TRUE.
               OPT2=.FALSE.
            End if
            If(Index(CPAR,'h').NE.0) then
               IRC=1
               Goto 100
            End if
            If(Index(CPAR,'a').NE.0) LSYM=.FALSE.
            If(Index(CPAR,'b').NE.0) LBLK=.TRUE.
            If(Index(CPAR,'c').NE.0) OPTC=.TRUE.
            If(Index(CPAR,'e').NE.0) LWGE=.TRUE.
            If(Index(CPAR,'l').NE.0) LLLT=.FALSE.
            If(Index(CPAR,'m').NE.0) OPTM=.TRUE.
            If(Index(CPAR,'s').NE.0) LSYM=.TRUE.
            If(Index(CPAR,'E').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RE
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RE
               End if
            End if
            If(Index(CPAR,'F').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RF
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RF
               End if
            End if
            If(Index(CPAR,'G').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RG
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RG
               End if
            End if
            If(Index(CPAR,'H').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RH
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RH
               End if
            End if
            If(Index(CPAR,'I').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RI
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RI
               End if
            End if
            If(Index(CPAR,'L').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RL
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RL
               End if
            End if
            If(Index(CPAR,'M').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RM
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RM
               End if
            End if
            If(Index(CPAR,'S').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RS
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RS
               End if
            End if
            If(Index(CPAR,'T').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RT
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RT
               End if
            End if
            If(Index(CPAR,'X').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RX
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RX
               End if
            End if

         Else if(CPAR(1:2).EQ.'E=') then
            Read(CPAR(3:),*,Err=900) RE
         Else if(CPAR(1:2).EQ.'F=') then
            Read(CPAR(3:),*,Err=900) RF
         Else if(CPAR(1:2).EQ.'G=') then
            Read(CPAR(3:),*,Err=900) RG
         Else if(CPAR(1:2).EQ.'H=') then
            Read(CPAR(3:),*,Err=900) RH
         Else if(CPAR(1:2).EQ.'I=') then
            Read(CPAR(3:),*,Err=900) RI
         Else if(CPAR(1:2).EQ.'L=') then
            Read(CPAR(3:),*,Err=900) RL
         Else if(CPAR(1:2).EQ.'M=') then
            Read(CPAR(3:),*,Err=900) RM
         Else if(CPAR(1:2).EQ.'S=') then
            Read(CPAR(3:),*,Err=900) RS
         Else if(CPAR(1:2).EQ.'T=') then
            Read(CPAR(3:),*,Err=900) RT
         Else if(CPAR(1:2).EQ.'X=') then
            Read(CPAR(3:),*,Err=900) RX

         Else if(FMSF.EQ.' ') then
            FMSF=CPAR
         Else if(FCMP.EQ.' ') then
            FCMP=CPAR
         Else if(FPRF.EQ.' ') then
            FPRF=CPAR
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 20
 10   Continue

 20   If(FMSF.EQ.' '.OR.FCMP.EQ.' ') go to 900

      If(LBLK) then
         LSYM=.TRUE.
         LWGE=.FALSE.
      End if

 100  Return
 900  IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine RECMP(NERR,NCMP,FCMP,NABC,CABC,RCMP,IRC)

      Character*(*)    FCMP

      Integer          NABC
      Character        CABC(0:26)

      Real             RCMP(26,26)

      Character*512    RCIN
      Character*32     CMIS


      Open(NCMP,File=FCMP,Status='OLD',Err=900)

      CMIS='..'
 1    Read(NCMP,'(A)',Err=901,End=902) RCIN
      IX=Index(RCIN,'..')
      If(IX.EQ.0) go to   1

* read alphabet

      NABC=0
      Do  10 I1=1,IX-1
         If(RCIN(I1:I1).NE.' ') then
            NABC=NABC+1
            CABC(NABC)=RCIN(I1:I1)
         End if
 10   Continue

      If(NABC.LE.0.OR.NABC.GT.26) go to 905
      Do  20  I1=1,NABC
 11      Read(NCMP,'(A)',Err=901,End=903) RCIN
         If(RCIN.EQ.' ') go to  11
         Read(RCIN,*,Err=904)(RCMP(I1,ii1),ii1=I1,NABC)
         Read(RCIN,*,Err=904)(RCMP(ii1,I1),ii1=I1,NABC)
 20   Continue

 100  Return

* errors

 900  Write(NERR,*) 'Error: Unable to open matrix file'//
     *   ' ''',FCMP(1:Lblnk(FCMP)),'''.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Unable to read matrix file'//
     *   ' ''',FCMP(1:Lblnk(FCMP)),'''.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: Unexpected end of matrix file. '//
     *   'Unable to find ''',CMIS,''' keyword.'
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Unexpected end of matrix file. '//
     *   'Discrepancies between alphabet length and matrix lines.'
      IRC=1
      Go to 100
 904  Write(NERR,*) 'Error: Unable to read matrix values.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100
 905  Write(NERR,*) 'Error: Unable to handle matrix alphabet size.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Include          'remsf.f'
      Include          'remsa.f'
      Include          'recmd.f'
      Include          'reprf.f'
      Include          'wrprf.f'
      Include          'lblnk.f'
      Include          'Xblnk.f'

*----------------------------------------------------------------------*     
* $Id: wrprf.f,v 2.9 2003/11/18 10:52:29 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine WRPRF
     *   (NOUT,LLLT,LRNM,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT, 
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   BLOG,FABC,P0,
     *   CHID,IIPD,CHMD,IMPD, 
     *   IRC)

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'
      Include          'sterr.f'

* work fields
      Integer           SLEN
      Integer           LLEN
      Parameter        (SLEN=78)
      Parameter        (LLEN=132)
      Parameter        (LBUF=512)

      Character*512     CBLK
      Character*512     CPAR
      Character*512     RCEX
      Character*16      CHRP(MAXN) 

      Logical           LPRI
      Logical           LLLT
      Logical           LRNM

* initiation, transition and termination score names

      Character*2       CPSN(27:46)
      Data              CPSN(27)/'B0'/
      Data              CPSN(28)/'B1'/
      Data              CPSN(29)/'E0'/
      Data              CPSN(30)/'E1'/
      Data              CPSN(31)/'BM'/
      Data              CPSN(32)/'BI'/
      Data              CPSN(33)/'BD'/
      Data              CPSN(34)/'BE'/
      Data              CPSN(35)/'MM'/
      Data              CPSN(36)/'MI'/
      Data              CPSN(37)/'MD'/
      Data              CPSN(38)/'ME'/
      Data              CPSN(39)/'IM'/
      Data              CPSN(40)/'II'/
      Data              CPSN(41)/'ID'/
      Data              CPSN(42)/'IE'/
      Data              CPSN(43)/'DM'/
      Data              CPSN(44)/'DI'/
      Data              CPSN(45)/'DD'/
      Data              CPSN(46)/'DE'/
      
      IRC=0

* prevent meaningless parameters from being printed

      If(.NOT.LPCI) then 
         IIPP(MM,   0)=IIPD(MM)
         IIPP(MI,   0)=IIPD(MI)
         IIPP(MD,   0)=IIPD(MD)
         IIPP(ME,   0)=IIPD(ME)
         IIPP(DM,   0)=IIPD(DM)
         IIPP(DI,   0)=IIPD(DI)
         IIPP(DD,   0)=IIPD(DD)
         IIPP(DE,   0)=IIPD(DE)
         IIPP(MM,LPRF)=IIPD(MM)
         IIPP(IM,LPRF)=IIPD(IM)
         IIPP(DM,LPRF)=IIPD(DM)
         IIPP(BM,LPRF)=IIPD(BM)
         IIPP(MD,LPRF)=IIPD(MD)
         IIPP(ID,LPRF)=IIPD(ID)
         IIPP(DD,LPRF)=IIPD(DD)
         IIPP(BD,LPRF)=IIPD(BD)
      End if
      
* write header

* - ID line
      
      RCEX='ID   ' 
     *   // CPID(1:Lblnk(CPID))
     *   // '; MATRIX.'
      Call wline(NOUT,LLLT,SLEN,RCEX)
C      Write(NOUT,'(78A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))

* - AC line 
      
      IX=Lblnk(CPAC)
      If(CPAC(IX:IX).EQ.'|') IX=IX-1
      RCEX='AC   '  // CPAC(1:IX) // ';'
      Call wline(NOUT,LLLT,SLEN,RCEX)
C      Write(NOUT,'(78A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))

* - DT line
      
      If(CPDT.NE.' ') then
         RCEX='DT   ' 
     *      // CPDT(1:Lblnk(CPDT))
         Call wline(NOUT,LLLT,SLEN,RCEX)
C         Write(NOUT,'(132A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))
      End if 

* - DE line
      
      RCEX='DE   ' 
     *   // CPDE(1:Lblnk(CPDE))
      Call wline(NOUT,LLLT,LLEN,RCEX)
C      Write(NOUT,'(132A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))

* - Additional header lines

      Do I1=1,LHDR
         Call wline(NOUT,LLLT,LLEN,CHDR(I1))
C         Write(NOUT,'(132A)')
C     *      (CHDR(I1)(ii1:ii1),ii1=1,Lblnk(CHDR(I1)))
      End do 

* write /GENERAL_SPEC: block 

      CBLK='/GENERAL_SPEC:'   
      JB=14

* - alphapet
      
      Write(CPAR,'(''ALPHABET='''''',26A)')(CABC(ii1),ii1=1,NABC) 
      JP=12+NABC
      CPAR(JP-1:JP)=''';'
      If(JB+JP+1.GT.LBUF) Go to 900
      CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
      JB=JB+JP+1

* - length
C      Write(CPAR,'(''LENGTH='',I6,'';'')') LPRF
      CPAR='LENGTH='
      Write(CPAR(8:),*)LPRF,';'
      JP=Lblnk(CPAR)
      Call slpar(CPAR,JP)
      If(JB+JP+1.GT.LBUF) Go to 900
      CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
      JB=JB+JP+1

* - topology 

      If(LPCI) then
         If(JB+19.GT.LBUF) Go to 900
         CBLK=CBLK(1:JB) // ' TOPOLOGY=CIRCULAR;'
         JB=JB+19
      End if


* - HMM parameters:
*** To be modified ?? Using write(...,*)
      If(BLOG.NE.0) then 
         Write(CPAR,'(''LOG_BASE='',F8.6,'';'')') BLOG
         JP=18
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1

         If(P0.NE.1.0) then
            Write(CPAR,'(''P0='',F6.4,'';'')') P0
            JP=10
            Call slpar(CPAR,JP)
            If(JB+JP+1.GT.LBUF) Go to 900
            CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
            JB=JB+JP+1
         End if 
      End if 
***
      Call wrblk(NOUT,LLLT,LLEN,CBLK,JB)
      If(BLOG.NE.0) Call wrnul(NOUT,LRNM,LLLT,SLEN,NABC,FABC)

* write /DISJOINT: block 

      CBLK='/DISJOINT:'
      JB=10

* - definition

      CPAR='DEFINITION=' // CDIS(MDIS)
      JP=Lblnk(CPAR)+1
      CPAR(JP:JP)=';'
      If(JB+JP+1.GT.LBUF) Go to 900
      CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
      JB=JB+JP+1

* - parameters

      KDIP=JDIP(MDIS)
      JP=0
      Do 20 I1=1,KDIP
         Write(CPAR(JP+1:),*)'N',I1,'=',NDIP(I1),';'
         JP=Lblnk(CPAR)+1
 20   Continue
      Call slpar(CPAR,JP)
      If(JB+JP+1.GT.LBUF) Go to 900
      CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
      JB=JB+JP

      Call wrblk(NOUT,LLLT,LLEN,CBLK,JB)

* write /NORMALIZATION: block

      LPRI=.FALSE.
      Do  21 I1=1,JNOR
         If(NNOR(I1).NE.NNPR(I1)) LPRI=.TRUE.
 21   Continue

      Do  30 I1=1,JNOR

         CBLK='/NORMALIZATION:'
         JB=15

* - mode 

         Write(CPAR(1:),*)'MODE=',NNOR(I1),';' 
         JP=Lblnk(CPAR)
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1

* - priority

         If(LPRI) then
            Write(CPAR(1:),*)'PRIORITY=',NNPR(I1),';' 
            JP=Lblnk(CPAR)
            Call slpar(CPAR,JP)
            If(JB+JP+1.GT.LBUF) Go to 900
            CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
            JB=JB+JP+1
         End if         

* - function

         CPAR='FUNCTION=' // CNOR(MNOR(I1))
         JP=Lblnk(CPAR)+1
         CPAR(JP:JP)=';'
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1

* - paramaters
         
         KNOP=JNOP(MNOR(I1))
         JP=0
         Do  22 I2=1,KNOP
            If(ABS(RNOP(I2,I1)).LE.10.0
     *         .AND.ABS(RNOP(I2,I1)).GT.0.0001
     *         .OR.RNOP(I2,I1).EQ.0.0) then
               Write(CHRP(I2),'(F10.7)') RNOP(I2,I1)
            Else 
               Write(CHRP(I2),*) RNOP(I2,I1)
            End if
            Write(CPAR(JP+1:),*)'R',I2,'=',CHRP(I2),'; '
            JP=Lblnk(CPAR)+1
 22      Continue
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP

* - text

         If(CNTX(I1).NE.' ') then 
            CPAR='TEXT=''' // CNTX(I1)(1:Lblnk(CNTX(I1))) // ''''
            JP=Lblnk(CPAR)+1
            CPAR(JP:JP)=';'
            If(JB+JP+1.GT.LBUF) Go to 900
            CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
            JB=JB+JP+1
         End if

         Call wrblk(NOUT,LLLT,LLEN,CBLK,JB)

 30   Continue

* write /CUT_OFF: block

      Do  40 I1=1,JCUT

         CBLK='/CUT_OFF:'
         JB=9

* - level

         Write(CPAR,*)'LEVEL=',MCLE(I1),';' 
         JP=Lblnk(CPAR)
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1

* - score

         Write(CPAR,*)'SCORE=',ICUT(I1),';' 
         JP=Lblnk(CPAR)
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1

* - normalized scores
         
         KCNM=JCNM(I1)
         If(KCNM.GT.0) CPAR='N_SCORE='
         JP=8
         Do 32 I2=1,KCNM
            If(I2.GT.1) then
               JP=JP+2
               CPAR(JP:JP)=','
            End if
            Write(CPAR(JP+1:),*)RCUT(I2,I1)
            JP=Lblnk(CPAR)
C         Write(CPAR,*)'(''N_SCORE='',G12.5,7('','',G12.5))')
C     *      (RCUT(ii1,I1),ii1=1,KCNM)
C         JP=8+13*KCNM
 32      Continue
         JP=JP+2
         CPAR(JP:JP)=';'
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1

* - normalization modes
         
         If(KCNM.GT.0) CPAR='MODE='
         JP=5
         Do 34 I2=1,KCNM
            If(I2.GT.1) then
               JP=JP+2
               CPAR(JP:JP)=','
            End if
            Write(CPAR(JP+1:),*)MCUT(I2,I1)
            JP=Lblnk(CPAR)
 34      Continue
C         Write(CPAR,'(''MODE='',I6,7('','',I6))')
C     *      (MCUT(ii1,I1),ii1=1,KCNM)
C         JP=5+7*KCNM
         JP=JP+2
         CPAR(JP:JP)=';'
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
         
* - text

         If(CCUT(I1).NE.' ') then 
            CPAR='TEXT=''' // CCUT(I1)(1:Lblnk(CCUT(I1))) // ''''
            JP=Lblnk(CPAR)+1
            CPAR(JP:JP)=';'
            If(JB+JP+1.GT.LBUF) Go to 900
            CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
            JB=JB+JP+1
         End if

         Call wrblk(NOUT,LLLT,LLEN,CBLK,JB)

 40   Continue

* write /DEFAULT: block 

* - transfer defaults to pos. LPRF+1

      I1=LPRF+1

      Do  51 I2=0,46
         IIPP(I2,I1)=IIPD(I2)
 51   Continue
      CHIP(I1)=CHID
      Do  52 I2=0,27
         IMPP(I2,I1)=IMPD(I2)
 52   Continue
      CHMP(I1)=CHMD

* - reinitialize defaults for match and insert position  

      CHID='-'
      Do  53 I2=1,26 
         IIPD(I2)=0
 53   Continue
      
      IIPD(B0)=0
      IIPD(B1)=0
      IIPD(E0)=0
      IIPD(E1)=0

      IIPD(BM)=0
      IIPD(BI)=NLOW
      IIPD(BD)=NLOW
      IIPD(BE)=NLOW
      IIPD(MM)=0
      IIPD(MI)=NLOW
      IIPD(MD)=NLOW
      IIPD(ME)=0
      IIPD(IM)=NLOW
      IIPD(II)=0
      IIPD(ID)=NLOW
      IIPD(IE)=NLOW
      IIPD(DM)=NLOW
      IIPD(DI)=NLOW
      IIPD(DD)=0
      IIPD(DE)=NLOW

      IIPD(I0)=0

      CHMD='X'
      Do  54 I2=1,26 
         IMPD(I2)=0
 54   Continue

      IMPD(M0)=0 
      IMPD(D )=0

      Do  55 I2=0,27
         IMPP(I2,0)=NLOW
 55   Continue 

* - symbols

      CBLK='/DEFAULT:'
      JB=9

      If(CHMP(I1).NE.CHMD) then
         Write(CPAR,'(''SY_M='''''',A,'''''';'')') CHMP(I1)
         JP=9
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
      End if 

      If(CHIP(I1).NE.CHID) then
         Write(CPAR,'(''SY_I='''''',A,'''''';'')') CHIP(I1)
         JP=9
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
      End if 

* - match extension scores

      K1=0
      Do  56 I2=1,NABC
         If(IMPP(I2,I1).NE.IMPD(I2)) K1=1
 56   Continue 
      Do  57 I2=1,NABC
         If(IMPP(I2,I1).NE.IMPP( 1,I1)) K1=2
 57   Continue 

      If(K1.EQ.0) then
         JP=0 
      Else
         CPAR='M='
         JP=3
         If(K1.EQ.1) then
            If(IMPP( 1,I1).LE.NLOW) then
               CPAR(JP:)='*'
            Else 
               Write(CPAR(JP:),*)IMPP( 1,I1)
            End if 
            JP=Lblnk(CPAR)+1
            CPAR(JP:JP)=';'
         Else
            Do 58 I2=1,NABC
               If(I2.GT.1) then
                  JP=JP+2
                  CPAR(JP:JP)=','
               End if
               If(IMPP(I2,I1).LE.NLOW) then 
                  CPAR(JP+1:)='*'
               Else
                  Write(CPAR(JP+1:),*)IMPP(I2,I1)
               End if
               JP=Lblnk(CPAR)
 58         Continue
            JP=JP+1
            CPAR(JP:JP)=';'


C            Write(CPAR,'(''M='',I6,25('','',I6))')
C     *         (IMPP(ii1,I1),ii1=1,NABC)
C            JP=2+NABC*7
C            CPAR(JP:JP)=';'
C            J2=JP-NABC*7+1
C            Do  59 I2=1,NABC
C               If(IMPP(I2,I1).EQ.NLOW) CPAR(J2:J2+5)='     *'
C               J2=J2+7
C 59         Continue
         End if

         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
      End if

* match extension score for unknown character

      If(IMPP( 0,I1).NE.IMPD( 0)) then
         CPAR='M0='
         JP=4
         If(IMPP( 0,I1).LE.NLOW) then
            CPAR(JP:)='*'
         Else
            Write(CPAR(JP:),*)IMPP( 0,I1)
         End if
         JP=LBlnk(CPAR)+1
         CPAR(JP:JP)=';'
C         Call slpar(CPAR,JP)
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
      End if 

* - deletion extension score

      If(IMPP(27,I1).NE.IMPD(27)) then
         CPAR='D='
         JP=3
         If(IMPP(27,I1).LE.NLOW) then
            CPAR(JP:)='*'
         Else
            Write(CPAR(JP:),*)IMPP(27,I1)
         End if
         JP=LBlnk(CPAR)+1
         CPAR(JP:JP)=';'
C         Call slpar(CPAR,JP)
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
      End if 

* - insert extension scores

      K1=0
      Do  61 I2=1,NABC
         If(IIPP(I2,I1).NE.IIPD(I2)) K1=1
 61   Continue 
      Do  62 I2=1,NABC
         If(IIPP(I2,I1).NE.IIPP( 1,I1)) K1=2
 62   Continue 

      If(K1.EQ.0) then
         JP=0 
      Else
         CPAR='I='
         JP=3
         If(K1.EQ.1) then
            If(IIPP( 1,I1).LE.NLOW) then 
               CPAR(JP:)='*'
            Else
               Write(CPAR(JP:),*)IIPP( 1,I1)
            End if 
            JP=Lblnk(CPAR)+1
            CPAR(JP:JP)=';'
         Else
            Do 64 I2=1,NABC
               If(I2.GT.1) then
                  JP=JP+2
                  CPAR(JP:JP)=','
               End if
               If(IMPP(I2,I1).LE.NLOW) then 
                  CPAR(JP+1:)='*'
               Else
                  Write(CPAR(JP+1:),*)IIPP(I2,I1)
               End if
               JP=Lblnk(CPAR)
 64         Continue
            JP=JP+1
            CPAR(JP:JP)=';'

C            Write(CPAR,'(''I='',I6,25('','',I6))')
C     *         (IIPP(ii1,I1),ii1=1,NABC)
C            JP=2+NABC*7
C            CPAR(JP:JP)=';'
C            J2=JP-NABC*7+1
C            Do  65 I2=1,NABC
C               If(IIPP(I2,I1).EQ.NLOW) CPAR(J2:J2+5)='     *'
C               J2=J2+7
C 65         Continue
         End if

         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
      End if

      If(IIPP( 0,I1).NE.IIPD( 0)) then
         CPAR='I0='
         JP=4
         Write(CPAR(JP:),*)IIPP( 0,I1)
         JP=Lblnk(CPAR)+1
         CPAR(JP:JP)=';'
C         Call slpar(CPAR,JP)
         Call slpar(CPAR,JP)
         If(JB+JP+1.GT.LBUF) Go to 900
         CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
         JB=JB+JP+1
      End if 

* - initiation, transition and termination scores

      Do  67 I2=27,46
         If(IIPP(I2,I1).NE.IIPD(I2)) then
            If(IIPP(I2,I1).LE.NLOW) then
               Write(CPAR,*) CPSN(I2),'=*'
            Else
               Write(CPAR,*)CPSN(I2),'=',IIPP(I2,I1)
            End if 
            JP=Lblnk(CPAR)+1
            CPAR(JP:JP)=';'
            Call slpar(CPAR,JP)
            If(JB+JP+1.GT.LBUF) Go to 900
            CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
            JB=JB+JP+1
         End if 
 67   Continue  

      Call wrblk(NOUT,LLLT,LLEN,CBLK,JB)

* - restore previous defaults from pos. LPRF+1 

      I1=LPRF+1

      Do  68 I2=0,46
         IIPD(I2)=IIPP(I2,I1)
 68   Continue
      CHID=CHIP(I1)
      Do  69 I2=0,27
         IMPD(I2)=IMPP(I2,I1)
 69   Continue
      CHMD=CHMP(I1)

      Do  90 I1=0,LPRF

* write /M: block 

         If(I1.NE.0) then

* - symbol

            CBLK='/M:'
            JB=3

            If(CHMP(I1).NE.CHMD) then
               Write(CPAR,'(''SY='''''',A,'''''';'')') CHMP(I1)
               JP=7
               If(JB+JP+1.GT.LBUF) Go to 900
               CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
               JB=JB+JP+1
            End if 

* - match extension scores

            K1=0
            Do  71 I2=1,NABC
               If(IMPP(I2,I1).NE.IMPD(I2)) K1=1
 71         Continue 
            Do  72 I2=1,NABC
               If(IMPP(I2,I1).NE.IMPP( 1,I1)) K1=2
 72         Continue 

            If(K1.EQ.0) then
               JP=0 
            Else
               CPAR='M='
               JP=3
               If(K1.EQ.1) then
                  If(IMPP( 1,I1).LE.NLOW) then
                     CPAR(JP:)='*'
                  Else 
                     Write(CPAR(JP:),*)IMPP( 1,I1)
                  End if 
                  JP=Lblnk(CPAR)+1
                  CPAR(JP:JP)=';'
               Else
                  Do 73 I2=1,NABC
                     If(I2.GT.1) then
                        JP=JP+2
                        CPAR(JP:JP)=','
                     End if
                     If(IMPP(I2,I1).LE.NLOW) then 
                        CPAR(JP+1:)='*'
                     Else
                        Write(CPAR(JP+1:),*)IMPP(I2,I1)
                     End if
                     JP=Lblnk(CPAR)
 73               Continue
                  JP=JP+1
                  CPAR(JP:JP)=';'



C                  Write(CPAR,'(''M='',I6,25('','',I6))')
C     *               (IMPP(ii1,I1),ii1=1,NABC)
C                  JP=2+NABC*7
C                  CPAR(JP:JP)=';'
C                  J2=JP-NABC*7+1
C                  Do  75 I2=1,NABC
C                     If(IMPP(I2,I1).EQ.NLOW) CPAR(J2:J2+5)='     *'
C                     J2=J2+7
C 75               Continue
               End if

               Call slpar(CPAR,JP)
               If(JB+JP+1.GT.LBUF) Go to 900
               CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
               JB=JB+JP+1
            End if

* match extension score for unknown character

            If(IMPP( 0,I1).NE.IMPD( 0)) then
               CPAR='M0='
               JP=4
               If(IMPP( 0,I1).LE.NLOW) then
                  CPAR(JP:)='*'
               Else
                  Write(CPAR(JP:),*)IMPP( 0,I1)
               End if
               JP=LBlnk(CPAR)+1
               CPAR(JP:JP)=';'
C               Call slpar(CPAR,JP)
               Call slpar(CPAR,JP)
               If(JB+JP+1.GT.LBUF) Go to 900
               CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
               JB=JB+JP+1
            End if 

* - deletion extension score

            If(IMPP(27,I1).NE.IMPD(27)) then
               CPAR='D='
               JP=3
               If(IMPP(27,I1).EQ.NLOW) then
                  CPAR(JP:)='*'
               Else
                  Write(CPAR(JP:),*)IMPP(27,I1)
               End if
               JP=LBlnk(CPAR)+1
               CPAR(JP:JP)=';'
C               Call slpar(CPAR,JP)
               Call slpar(CPAR,JP)
               If(JB+JP+1.GT.LBUF) Go to 900
               CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
               JB=JB+JP+1
            End if 

            Call wrblk(NOUT,LLLT,LLEN,CBLK,JB)

         End if

* write /I: block 

         If(I1.NE.LPRF.OR..NOT.LPCI) then 

            CBLK='/I:'
            JB=3

* - symbol

            If(CHIP(I1).NE.CHID) then
               Write(CPAR,'(''SY='''''',A,'''''';'')') CHIP(I1)
               JP=7
               If(JB+JP+1.GT.LBUF) Go to 900
               CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
               JB=JB+JP+1
            End if 

* - insert extension scores

            K1=0
            Do  81 I2=1,NABC
               If(IIPP(I2,I1).NE.IIPD(I2)) K1=1
 81         Continue 
            Do  82 I2=1,NABC
               If(IIPP(I2,I1).NE.IIPP( 1,I1)) K1=2
 82         Continue 

            If(K1.EQ.0) then
               JP=0 
            Else
               CPAR='I='
               JP=3
               If(K1.EQ.1) then
                  If(IIPP( 1,I1).LE.NLOW) then
                     CPAR(JP:)='*'
                  Else 
                     Write(CPAR(JP:),*)IIPP( 1,I1)
                  End if 
                  JP=Lblnk(CPAR)+1
                  CPAR(JP:JP)=';'
               Else
                  Do 83 I2=1,NABC
                     If(I2.GT.1) then
                        JP=JP+2
                        CPAR(JP:JP)=','
                     End if
                     If(IIPP(I2,I1).LE.NLOW) then 
                        CPAR(JP+1:)='*'
                     Else
                        Write(CPAR(JP+1:),*)IIPP(I2,I1)
                     End if
                     JP=Lblnk(CPAR)
 83               Continue
                  JP=JP+1
                  CPAR(JP:JP)=';'



C                  Write(CPAR,'(''I='',I6,25('','',I6))')
C     *               (IIPP(ii1,I1),ii1=1,NABC)
C                  JP=2+NABC*7
C                  CPAR(JP:JP)=';'
C                  J2=JP-NABC*7+1
C                  Do  85 I2=1,NABC
C                     If(IIPP(I2,I1).EQ.NLOW) CPAR(J2:J2+5)='     *'
C                     J2=J2+7
C 85               Continue
               End if

               Call slpar(CPAR,JP)
               If(JB+JP+1.GT.LBUF) Go to 900
               CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
               JB=JB+JP+1
            End if

* insert extension score for unknown character

            If(IIPP( 0,I1).NE.IIPD( 0)) then
               CPAR='I0='
               JP=4
               If(IIPP( 0,I1).LE.NLOW) then
                  CPAR(JP:)='*'
               Else
                  Write(CPAR(JP:),*)IIPP( 0,I1)
               End if
               JP=LBlnk(CPAR)+1
               CPAR(JP:JP)=';'
C               Call slpar(CPAR,JP)
               Call slpar(CPAR,JP)
               If(JB+JP+1.GT.LBUF) Go to 900
               CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
               JB=JB+JP+1
            End if 

* - initiation, transition and termination scores

            Do  87 I2=27,46
               If(IIPP(I2,I1).NE.IIPD(I2)) then
                  If(IIPP(I2,I1).LE.NLOW) then
                     Write(CPAR,*) CPSN(I2),'=*'
                  Else
                     Write(CPAR,*)CPSN(I2),'=',IIPP(I2,I1)
                  End if 
                  JP=Lblnk(CPAR)+1
                  CPAR(JP:JP)=';'
                  Call slpar(CPAR,JP)
                  If(JB+JP+1.GT.LBUF) Go to 900
                  CBLK(JB+2:JB+JP+1)=CPAR(1:JP)
                  JB=JB+JP+1
               End if 
 87         Continue  

            If(CBLK.NE.'/I:') Call wrblk(NOUT,LLLT,LLEN,CBLK,JB)

         End if 

 90   Continue

* - Footer lines

      Do I1=1,LFTR
         Call wline(NOUT,LLLT,LLEN,CFTR(I1))
C         Write(NOUT,'(132A)')
C     *      (CFTR(I1)(ii1:ii1),ii1=1,Lblnk(CFTR(I1)))
      End do 

      Write(NOUT,'(''//'')')

 100  Return

 900  Write(NERR,*) 'Error: Line length exceeds buffer size (',
     *   LBUF,').'
      IRC=1
      Go to 100

      End
*----------------------------------------------------------------------*
      Subroutine slpar(CPAR,JP)

      Character*(*)     CPAR

      K1=0
      Do  10 I1=1,JP
         If(CPAR(I1:I1).NE.' '.OR.CPAR(I1-1:I1-1).EQ.';') then 
            K1=K1+1
            CPAR(K1:K1)=CPAR(I1:I1)
         Else if
     *         (CPAR(I1:I1+1).EQ.' ;'.AND.CPAR(K1:K1).EQ.'.') then
            K1=K1+1
            CPAR(K1:K1)='0' 
         Else if
     *         (CPAR(I1:I1+1).EQ.' ,'.AND.CPAR(K1:K1).EQ.'.') then
            K1=K1+1
            CPAR(K1:K1)='0' 
         End if
 10   Continue
      JP=K1
      
      Return
      End
*----------------------------------------------------------------------*
      Subroutine wrblk(NOUT,LLLT,LEN,CBLK,JB)

      Parameter        (LBUF=512)
      Character*(*)     CBLK
      Character*512     RCEX
      Logical           LLLT
      Integer           LEN
      Integer           NW

      RCEX='MA'


      If(LLLT) then
         NW=LEN
      Else
         NW=LBUF
      End if

      If(JB.LE.NW-5) then
         RCEX(6:)=CBLK(1:JB)
         Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,JB+5)
      Else
         Do  14 I1=NW-6,1,-1
            If(CBLK(I1:I1).EQ.';'
     *         .OR.CBLK(I1:I1).EQ.',') go to 15 
 14      Continue
 15      RCEX(6:)=CBLK(1:I1)
         Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,I1+5)
         RCEX='MA'
         KB=I1+1
         
 20      Continue
         
         Do  22 I1=KB,JB
            If(CBLK(I1:I1).NE.' ') go to 23 
 22      Continue
 23      KB=I1
         Do  24 I1=MIN(KB+NW-2,JB),KB,-1
            If(   CBLK(I1:I1).EQ.';'
     *         .OR.CBLK(I1:I1).EQ.',') go to  25
 24      Continue
 25      RCEX(9:)=CBLK(KB:I1)
         Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))
         RCEX='MA'
         KB=I1+1
         If(KB.LT.JB) go to  20 
         
      End if
      
      Return
      End
*----------------------------------------------------------------------*
      Subroutine  wrnul(NOUT,LRNM,LLLT,LEN,NABC,FABC)

      Parameter        (LBUF=512)
      Real              FABC(0:26)
      Character*512     RCEX
      Logical           LRNM
      Integer           NMRS
      Logical           LLLT
      Integer           LEN
      Integer           NW

      If(LLLT) then
         NW=LEN
      Else
         NW=LBUF
      End if
      If(LRNM) then
         NMRS=100
      Else
         NMRS=1
      End if

      RCEX='MA      P='
      JP=11
      Do 5, I1=1,NABC
         Write(RCEX(JP:),*)NMRS*FABC(I1)
         JN=Lblnk(RCEX)
         If(RCEX(JN:JN).EQ.'.') then
            JN=JN+1
            RCEX(JN:JN)='0'
         End if
         If(I1.NE.NABC) then
            JN=JN+1
            RCEX(JN:JN)=','
         End if

         If(JN.GE.NW) then
            Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,JP)
            RCEX(1:10)='MA        '
 3          If(RCEX(JP+1:JP+1).EQ.' ') then
               JP=JP+1
               Go to 3
            End if
    
            RCEX(12:)=RCEX(JP:JN)
            JP=13+JN-JP
         Else
            JP=JN+1
         End if
 5    Continue
      
      If(JP.GT.10) then
         RCEX(JP:JP)=';'
         Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,JP)
      End if


 100  Return

      End
*----------------------------------------------------------------------*
      Subroutine  wline(NOUT,LLLT,LEN,RCEX)
      
      Character*(*)     RCEX
      Logical           LLLT
      Integer           LEN
      Integer           NW

      NW=Lblnk(RCEX)
      If(LLLT.AND.NW.GT.LEN) NW=LEN
      Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,NW)
      
 100  Return
      End

*       Program ptoh
*----------------------------------------------------------------------*
* $Id: ptoh.f,v 2.11 2003/12/01 13:33:05 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Reformats profile -> hmm: in-fmt=PROSITE / out-fmt=SAM
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

      Include          'ardim.f'

* array dimensions and I/O units

      Parameter        (NOUT=   6)

      Parameter        (NPRF=  11)
      Parameter        (NNUL=  12)

* profile

      Character*4096    FPRF

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'

      Include          'sterr.f'

* null model

      Character*4096    FNUL

      Integer           IABC(26)
      Integer           JABC(26)
      Character*20      DABC

* HMM

      Include          'hmdat.f'


* function return types

      Integer           Xblnk
      External          Xblnk

* parameters and options

      Logical           OPTF
      Logical           OPFF
      Logical           OPTH
      Logical           OPTS
      Logical           LEOF

      Real              RD
      Real              RI
      Real*8            DL
      Integer           INBP

* initialization of controlled vocabularies

      Include          'cvini.f'

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      IRC=0
      FPRF='stdout'
      INBP=0

* command line arguments

      Call Repar(FPRF,FNUL,OPTF,OPFF,OPTH,OPTS,RD,RI,DL,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''ptoh 2.3 revision 5.d'',//
     *      ''Usage: ptoh [ -fhsFDIL ] [ profile-file | - ] '',
     *      ''[ random-model-file ] [ parameters ]'',//
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -f: emulate domain- or semi-global alignment mode.'',/
     *      ''    -h: print usage help text.'',/
     *      ''    -s: output in SAM format (if not set: HMMER1 '',
     *      ''format).'',/
     *      ''    -F: emulate local alignment mode.''
     *      )')
         Write(NERR,'(
     *      ''    -D<value>:'',/
     *      ''        delete-to-delete transition probabilities '',
     *      ''(default: 0.9).'',/
     *      ''    -I<value>:'',/
     *      ''        insert-to-insert transition probabilities '',
     *      ''(default: 0.99).'',/
     *      ''    -L<value>:'',/
     *      ''        logarithmic base (default: 1.0233739).'',/
     *      )')
         Write(NERR,'(
     *      ''   valid (but deprecated) parameters are:'',/,
     *      ''    [D=del-to-del-prob]  use option -D instead'',/
     *      ''    [I=ins-to-ins-prob]  use option -I instead'',/
     *      ''    [L=log-base]         use option -L instead'',/
     *      )')
         Call Exit(IRC)
      End if

* read profile

      If(FPRF.EQ.'-') then
         MPRF=5
      Else
         MPRF=NPRF
      End if

      Call REPRF
     *   (MPRF,FPRF,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   BLOG,FABC,P0,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,CHIL,IIPL,ILIP,
     *   CHID,IIPD,CHMD,IMPD,
     *   INBP,LEOF,.FALSE.,IRC)

      If(IRC.NE.0) go to 100

      If(NABC.GE.20) then
         DABC='ACDEFGHIKLMNPQRSTVWY'
         MABC=20
      Else
         DABC='ACGT'
         MABC=4
      End if

* read null model

      If     (FNUL.NE.' ') then
         Call RHNUL(NNUL,FNUL,FABC,MABC,IRC)
         If(IRC.NE.0) go to 100
      Else if(P0.GT.0.0) then
         Call NRNUL(NABC,CABC,FABC,P0,DABC,MABC)
      Else
         Call DFNUL(FABC,P0,DABC,MABC)
      End if

* reduce / rearrange alphabet

      K1=0
      Do I1=1,NABC
         N1=Index(DABC(1:MABC),CABC(I1))
         If(N1.NE.0) then
            IABC(N1)=I1
            K1=K1+1
         End if
      End do

      If(K1.NE.MABC) go to 901

      Do I1=0,LPRF
         Do I2=1,MABC
            JABC(I2)=IIPP(IABC(I2),I1)
         End do
         Do I2=1,MABC
            IIPP(I2,I1)=JABC(I2)
         End do
         If(I1.NE.0) then
            Do I2=1,MABC
               JABC(I2)=IMPP(IABC(I2),I1)
            End do
            Do I2=1,MABC
               IMPP(I2,I1)=JABC(I2)
            End do
         End if
      End do
      NABC=MABC
      Do I1=1,NABC
         CABC(I1)=DABC(I1:I1)
      End do

* convert profile into Log(Prob)

      If     (DL  .NE.0.0) then
         DL=LOG(DL)
      Else if(BLOG.NE.0.0) then
         DL=LOG(BLOG)
      Else
         DL=(LOG(2.0)/30.0)
      End if

      Do I1=0,LPRF
         Do I2=0,46
            If(I1.EQ.0.OR.I2.GT.27) then
               RIHM(I2,I1)=Real(IIPP(I2,I1))*DL
            Else
               RMHM(I2,I1)=Real(IMPP(I2,I1))*DL
               RIHM(I2,I1)=Real(IIPP(I2,I1))*DL
            End if
         End do
      End do
      FLOW=Real(NLOW)*DL

* subtract null model

      Do I1=1,NABC
         R1=LOG(FABC(I1))
         RIHM(I1, 0)=RIHM(I1, 0)+R1
         Do I2=1,LPRF
            RIHM(I1,I2)=RIHM(I1,I2)+R1
            RMHM(I1,I2)=RMHM(I1,I2)+R1
         End do
      End do

* modify begin state

      RIHM(MM,   0)=RIHM(BM,   0)
      RIHM(MI,   0)=RIHM(BI,   0)
      RIHM(MD,   0)=RIHM(BD,   0)
      RIHM(DM,   0)=FLOW
      RIHM(DI,   0)=FLOW
      RIHM(DD,   0)=FLOW

* modify end state

      RIHM(MM,LPRF)=RIHM(ME,LPRF)
      RIHM(IM,LPRF)=RIHM(IE,LPRF)
      RIHM(DM,LPRF)=RIHM(DE,LPRF)
      RIHM(MD,   0)=FLOW
      RIHM(ID,   0)=FLOW
      RIHM(DD,   0)=FLOW

* scale HMM

      If(OPTS) then
         Call SCHMM(NOUT,
     *      IDMP,RIHM,RMHM,LPRF,NABC,FLOW,FSCA,OPTF,OPFF,RD,RI)
      Else
         Call SCHMM(NERR,
     *      IDMP,RIHM,RMHM,LPRF,NABC,FLOW,FSCA,OPTF,OPFF,RD,RI)
      End if

* print HMM

      If(OPTS) then
         If(NABC.EQ.4) then
            R         =RIHM(3, 0)
            RIHM(3, 0)=RIHM(2, 0)
            RIHM(2, 0)=R
            Do I1=1,LPRF
               R         =RIHM(3,I1)
               RIHM(3,I1)=RIHM(2,I1)
               RIHM(2,I1)=R
               R         =RMHM(3,I1)
               RMHM(3,I1)=RMHM(2,I1)
               RMHM(2,I1)=R
            End do
         End if
         Call WRSAM(NOUT,
     *      IDMP,RIHM,RMHM,LPRF,NABC,FABC,FLOW,FSCA,DL)
      Else
         Call WRHMR(NOUT,NERR,
     *      IDMP,RIHM,RMHM,LPRF,NABC,CABC,FLOW,FSCA,DL)
      End if

 100  Call Exit(IRC)

* errors

 901  Write(NERR,*) 'Error: Incompatible alphabets between profile and',
     *   ' null model.'
      IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine Repar
     *   (FPRF,FNUL,OPTF,OPFF,OPTH,OPTS,RD,RI,DL,IRC)

      Character*(*)     FPRF
      Character*(*)     FNUL
      Character*4096    CARG

      Logical           OPTF
      Logical           OPFF
      Logical           OPTH
      Logical           OPTS

      Real*8            DL

      IRC=0

* initializations

      FPRF='-'
      FNUL=' '

      OPTF=.FALSE.
      OPFF=.FALSE.
      OPTH=.TRUE.
      OPTS=.FALSE.

      DL=1.0233739
      RI=0.99
      RD=0.9

      N1=Iargc()

      K1=0
      I2=1
      Do I1=1,N1
         Call GetArg(I2,CARG)
         If     (CARG(1:1).EQ.'-'.AND.CARG(2:2).NE.' ') then
            If(Index(CARG,'h').NE.0) go to 900
            If(Index(CARG,'f').NE.0) OPTF=.TRUE.
            If(Index(CARG,'F').NE.0) OPFF=.TRUE.
            If(Index(CARG,'s').NE.0) then
               OPTS=.TRUE.
               OPTH=.FALSE.
            End if
            If(Index(CARG,'D').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RD
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RD
               End if
            End if
            If(Index(CARG,'I').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RI
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RI
               End if
            End if
            If(Index(CARG,'L').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) DL
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) DL
               End if
            End if
         Else if(CARG(1:2).EQ.'D=') then
            Read(CARG(3:),*,Err=900) RD
         Else if(CARG(1:2).EQ.'I=') then
            Read(CARG(3:),*,Err=900) RI
         Else if(CARG(1:2).EQ.'L=') then
            Read(CARG(3:),*,Err=900) DL
         Else if(K1.LE.1) then
            K1=K1+1
            If     (K1.EQ.1) then
               FPRF=CARG
            Else if(K1.EQ.2) then
               FNUL=CARG
            End if
         Else
            Go to 900
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 20
      End do

 20   Continue

 100  Return
 900  IRC=-1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine NRNUL(NABC,CABC,FABC,P0,DABC,MABC)

      Character         CABC(0:26)
      Real              FABC(0:26)
      Character*(*)     DABC
      Real              RABC(20)

      X=0
      Do I1=1,NABC
         N1=Index(DABC(1:MABC),CABC(I1))
         If(N1.NE.0) then
            RABC(N1)=FABC(I1)
            X=X+RABC(N1)
         End if
      End do

      X=P0/X

      Do I1=1,MABC
         FABC(I1)=RABC(I1)*X
      End do

      Return
      End
*----------------------------------------------------------------------*
      Include          'reprf.f'
      Include          'rhnul.f'
      Include          'wrsam.f'
      Include          'wrhmr.f'
      Include          'schmm.f'
      Include          'dfnul.f'
      Include          'lblnk.f'
      Include          'Xblnk.f'

*----------------------------------------------------------------------*     
* $Id: ardim.f,v 2.7 2003/03/21 15:55:44 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      
* Note: for use on machines with less than 32 MB RAM, replace the actual 
*       array Parameter instructions by commented Parameter instructions 
*       or modify the array size definitions manually. 
      
* max. profile length  
      
      Parameter        (IDMP=19999)
C     Parameter        (IDMP= 9999)
C     Parameter        (IDMP= 2499)
      
* max. sequence length 
      
      Parameter        (IDMS=10000000)
C     Parameter        (IDMS= 1000000)
C     Parameter        (IDMS=  250000)
      
* max. number of matches per sequence
      
      Parameter        (IDMN=4000) 
C     Parameter        (IDMN=2000) 
C     Parameter        (IDMN= 500) 

* max. alignment length 

      Parameter        (IDMA=40000)
C     Parameter        (IDMA=20000)
C     Parameter        (IDMA= 5000)

* max. path matrix surface

      Parameter        (IDMM=40000000)
C     Parameter        (IDMM= 4000000)
C     Parameter        (IDMM= 1000000)

* max. repeats per circular profile match

      Parameter        (IDML=512)

* max. nb of sequences in MSF files

      Parameter        (IDMF=2048)

* max. nb of scores in score list

      Parameter        (IDMC=262144)

*       Program gtop
*----------------------------------------------------------------------*
* $Id: gtop.f,v 2.9 2003/11/28 11:53:33 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Reformats profiles: in-fmt=GRIBSKOV / out-fmt=PROSITE
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
*
* DATA
*----------------------------------------------------------------------*

* array dimensions and I/O units

      Include          'ardim.f'

      Parameter        (NOUT=   6)
      Parameter        (NGPR=  11)

* profile and sequence fields

      Character*4096    FGPR

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'
      Include          'sterr.f'

* command line options and parameters

      Logical           LSYM
      Logical           LLLT
      Logical           LRNM

* initialization of controlled vocabularies

      Include          'cvini.f'

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      IRC=0
      FGPR='-'
      BLOG=0.0
      LRNM=.FALSE.

* read command line

      RL=NLOW
      Call Repar
     *   (FGPR,LSYM,LLLT,RG,RE,RF,RO,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''gtop 2.3 revision 5.d'',//
     *      ''Usage: gtop [ -aslhGEFO ] gcg-profile | - ''
     *      ''[ parameters ]'',/
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -a: apply asymmetric gap weighting mode.'',/
     *      ''    -s: apply symmetric gap weighting mode (default).'',/
     *      ''    -l: do not impose limit on line length.'',/
     *      ''    -h: print usage help text.'',/
     *      ''    -G<value>:'',/
     *      ''        gap opening penalty (default: 4.5).'',/
     *      ''    -E<value>:'',/
     *      ''        gap extension penalty (default: 0.05).'',/
     *      ''    -F<value>:'',/
     *      ''        rescaling factor (default: 100).'',/
     *      ''    -O<value>:'',/
     *      ''        output score offset (default: 0). '',/
     *      ''        Added to match scores after multiplication by '',
     *      ''the rescaling factor F.'',/
     *      )')
         Write(NERR,'(
     *      ''   valid (but deprecated) parameters are:'',//,
     *      ''    [G=gap-weigth]              use option -G instead'',/,
     *      ''    [E=gap-extension-weight]    use option -E instead'',/,
     *      ''    [F=output-score-multiplier] use option -F instead'',/
     *      ''    [O=output-score-offset]     use option -O instead'',/
     *      )')
         Call Exit(IRC)
      End if

* read profile

      Call REGPR
     *   (NGPR,FGPR,
     *   RG,RE,RF,RO,LSYM,
     *   CPID,CPAC,CPDE,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   CHID,IIPD,CHMD,IMPD,
     *   IRC)

      If(IRC.NE.0) go to 100

      CPDT=' '
      LHDR=0
      LFTR=0

      Call WRPRF
     *   (NOUT,LLLT,LRNM,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   BLOG,FABC,P0,
     *   CHID,IIPD,CHMD,IMPD,
     *   IRC)

 100  Call Exit(IRC)
      End
*----------------------------------------------------------------------*
      Subroutine Repar
     *   (FGPR,LSYM,LLLT,RG,RE,RF,RO,IRC)

      Character*4096    CPAR
      Character*(*)     FGPR

      Logical           LSYM
      Logical           LLLT

      LSYM=.TRUE.
      LLLT=.TRUE.
      RG=4.5
      RE=0.05
      RF=100
      RO=0

      FGPR=' '

      N1=Iargc()

      K1=0
      I2=1
      Do  50 I1=1,N1
         Call GetArg(I2,CPAR)
         If     (CPAR(1:1).EQ.'-'
     *      .AND.CPAR(2:2).NE.' '.AND.K1.EQ.0) then
            If(Index(CPAR,'h').NE.0)go to 900
            If(Index(CPAR,'a').NE.0) LSYM=.FALSE.
            If(Index(CPAR,'l').NE.0) LLLT=.FALSE.
            If(Index(CPAR,'G').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RG
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RG
               End if
            End if
            If(Index(CPAR,'E').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RE
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RE
               End if
            End if
            If(Index(CPAR,'F').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RF
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RF
               End if
            End if
            If(Index(CPAR,'O').NE.0) then
               If(CPAR(3:3).NE.' ') then
                  Read(CPAR(3:),*,Err=900) RO
               Else
                  I2=I2+1
                  Call GetArg(I2,CPAR)
                  Read(CPAR,*,Err=900) RO
               End if
            End if
         Else if(K1.EQ.0) then
            K1=K1+1
            FGPR=CPAR
         Else
            If     (CPAR(1:2).EQ.'G=') then
               Read(CPAR(3:),*,Err=900) RG
            Else if(CPAR(1:2).EQ.'E=') then
               Read(CPAR(3:),*,Err=900) RE
            Else if(CPAR(1:2).EQ.'F=') then
               Read(CPAR(3:),*,Err=900) RF
            Else if(CPAR(1:2).EQ.'O=') then
               Read(CPAR(3:),*,Err=900) RO
            End if
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 60
 50   Continue

 60   If(K1.NE.1) Go to 900
 100  Return
 900  IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Include          'lblnk.f'
      Include          'regpr.f'
      Include          'wrprf.f'

*----------------------------------------------------------------------*     
* $Id: rfseq.f,v 2.10 2003/11/18 10:50:07 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine RFSEQ
     *   (NSEQ,FSEQ,NABC,CABC,CSID,CSAC,CSDE,CSFH,LSEQ,ISEQ,LEOF,
     *   INBS,OPTV,IRC)
      
      Include          'ardim.f'
      Include          'sterr.f'


* function return types

      Integer           Xblnk
      External          Xblnk

* reads sequence file in Pearson Fasta format 

      Character*(*)     FSEQ
      Character         CABC(0:26)
      Character*(*)     CSID
      Character*(*)     CSAC
      Character*(*)     CSFH
      Character*(*)     CSDE
      Integer*2         ISEQ(*)
      Logical           LEOF
      Logical           LOPN
      Logical           OPTV
      Character*512     RCIN
      
      IRC=0
      LEOF=.FALSE.
      CSID=' '
      CSAC=' '
      CSDE=' '

      If(RCIN(1:1).EQ.'>') Go to  2

      Inquire(File=FSEQ,OPENED=LOPN)
      If(LOPN) go to   1
      If(FSEQ.NE.'-') Open(NSEQ,File=FSEQ,Status='OLD',Err=900)
 1    Read(NSEQ,'(A)',Err=901,End=999,Iostat=IOS) RCIN
      If(RCIN(1:1).NE.'>') go to   1   

 2    L=Xblnk(RCIN,64)
      IX2=Index(RCIN(1:L),' ')-1
      If(IX2.LE.0) IX2=L
      Do I1=IX2,2,-1
         If(Index(':;|',RCIN(I1:I1)).NE.0) go to   3
      End do
 3    IX1=I1
      Do I1=IX2+1,L
         If(RCIN(I1:I1).NE.' ') go to  4
      End do
 4    IX3=I1 
      CSAC=RCIN(2:IX1)
*      FIXME
*      Write(NERR,*) 'SEQUENCE_READ=',CSAC
      CSID=RCIN(IX1+1:IX2)
      CSDE=RCIN(IX3:L)
      CSFH=RCIN(2:IX2)

      J1=0
 10   Read(NSEQ,'(A)',Err=901,End= 20,Iostat=IOS) RCIN
      L=Xblnk(RCIN,64)
      If(RCIN(1:1).EQ.'>') go to  20

      Do 15 I1=1,L
         N1=0
         K1=Ichar(RCIN(I1:I1))
         If(K1.GE.97) then 
            K1=K1-32
            RCIN(I1:I1)=Char(K1)
         End if
         If(K1.GT.90.OR.K1.LT.65) go to  15 
         
         Do 13 I2=1,NABC
            If(CABC(I2).EQ.RCIN(I1:I1)) then
               N1=I2
               Go to   14
            End if
 13      Continue
 14      J1=J1+1
         If(J1.GT.IDMS) go to 915
         ISEQ(J1)=N1
 15   Continue
      Go to  10 

 20   LSEQ=J1
      If(LSEQ.LE.0) go to 916
      INBS=INBS+1
 100  If(IOS.EQ.-1.AND.IRC.LT.1) then
         LEOF=.TRUE.
         If(INBS.LT.1) go to 920
      End if

 105  Return

 110  IX=Lblnk(CSID)
      If(IX.GT.1) then
         Write(NERR,*) '       While processing sequence ',
     *      CSID(1:IX)
      End if
      Go to 100

* errors

 900  Write(NERR,*) 'Error: Unable to open sequence file'//
     *   ' ''',FSEQ(1:Xblnk(FSEQ,64)),'''.'
      IRC=1
      Go to 110
 901  Write(NERR,*) 'Error: Unable to read sequence file'//
     *   ' ''',FSEQ(1:Xblnk(FSEQ,64)),'''.'
      IRC=1
      Go to 110
 915  Write(NERR,*) 'Error: Sequence length exceeds buffer ',
     *   'size (',IDMS,').'
      IRC=1
      Go to 110
 916  Write(NERR,*) 'Error: Unexpected end of sequence.'//
     *   ' Sequence has zero length.'
      IRC=1
      Go to 110

 920  If(.NOT.OPTV) then
         Write(NERR,*) 'Warning: No sequence has been read.'
         Write(NERR,*) '         No alignment produced.'
      End if
      IRC=-1
      Go to 105

 999  IRC=-1
      Go to 100 
      End

*----------------------------------------------------------------------*     
* $Id: prsp.f,v 1.4 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*        Print sequence or psa alignment
*        Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine PRSP
     *   (CABC,ISEQ,CALI,IABG,IAED,NW,OPTS,OPTX)
      
      Character         CABC(0:26)
      Integer*2         ISEQ(*)
      Character*01      CALI(*)
      Integer           IABG
      Integer           IAED
      Logical           OPTS
      Logical           OPTX

      Character*512     RCOUT


      INL=IAED-IABG+1
      INB=INL/NW
      INR=INL-INB*NW
      IN1=IABG-1

* write sequence of aligned region

      If(OPTS) then
         Do IN2=1,INB
            Do ii1=1,NW
               RCOUT(ii1:ii1)=CABC(ISEQ(IN1+ii1))
            End do
            IN1=IN1+NW
            Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,NW)
         End do
         If(INR.GT.0) then
            Do ii1=1,INR
               RCOUT(ii1:ii1)=CABC(ISEQ(IN1+ii1))
            End do
            Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,INR)
         End if            

* write psa style alignment
* Do NOT use to display individual matches of a circular profile
* use prxp() instead.

      Else if(OPTX) then
         Do IN2=1,INB
            Do ii1=1,NW
               RCOUT(ii1:ii1)=CALI(IN1+ii1)
            End do
            IN1=IN1+NW
            Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,NW)
         End do
         If(INR.GT.0) then
            Do ii1=1,INR
               RCOUT(ii1:ii1)=CALI(IN1+ii1)
            End do
            Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,INR)
         End if            
      End if

      Return

      End

*----------------------------------------------------------------------*     
* $Id: remsf.f,v 2.7 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine REMSF
     *   (NERR,NMSF,FMSF,
     *   IDMS,CSEQ,NSEQ,LSEQ,
     *   IDMF,RWGT,SQID,
     *   IRC)

      Character*(*)    FMSF

      Character        CSEQ(*) 
      Real*4           RWGT(*)
      Character*(*)    SQID(*) 

      Logical          LBKS
      Character*512    RCIN 
      Character*32     CMIS

      IRC=0
      LBKS=.FALSE.

      If(FMSF.NE.'-') then 
         Open(NMSF,File=FMSF,Status='OLD',Err=900)
      End if 

      CMIS='..'
 1    Read(NMSF,'(A)',Err=901,End=902) RCIN        
      If(Index(RCIN,'..').EQ.0) go to   1

* read length

      CMIS='MSF'
      IX=Index(RCIN,'MSF:')
      If(IX.EQ.0) Go to 904
      CMIS='length'
      Read(RCIN(IX+4:),*,Err=903) LSEQ

* names

      NSEQ=0
 2    Read(NMSF,'(A)',Err=901,End=905) RCIN        
      If(RCIN(1:2).EQ.'//') go to   3
      IX1=Index(RCIN,'Name: ')
      If(IX1.EQ.0) go to   2 
      IX2=Index(RCIN,'Len: ')
      If(IX2.EQ.0) go to   2 
      NSEQ=NSEQ+1
      If(NSEQ.GT.IDMF) go to 910
      SQID(NSEQ)=RCIN(IX1+5:IX2-1)
      IX=Index(RCIN,'Weight: ') 
      CMIS='Weight'
      If(IX.EQ.0) go to 904
      Read(RCIN(IX+9:),*,Err=903)  RWGT(NSEQ)
      Go to   2

* sequence offset -> NOFS

 3    Read(NMSF,'(A)',Err=901,End=905) RCIN        
      If(RCIN.EQ.' ') go to   3
      N1=1
      N2=0

* read sequences 

 10   Read(RCIN,*,Iostat=IOS) K1,K2
      If(IOS.NE.0.OR.K1.LE.0.OR.K2.LE.0) then 
         L1=Lblnk(RCIN) 
         Do I1=1,L1
            If(RCIN(I1:I1).NE.' ') go to  11
         End do
 11      J1=I1
         Do I1=J1,L1
            If(RCIN(I1:I1).EQ.' ') go to  12
         End do
 12      J1=I1
         Do I1=J1+1,L1
            If(RCIN(I1:I1).NE.' ') go to  13
         End do 
 13      NOFS=I1-1
         J1=I1
         Do I1=J1,L1
            If(RCIN(I1:I1).NE.' ') N2=N2+1 
         End do 
C          Backspace(NMSF,Err=907)
         LBKS=.TRUE.
      Else if(NOFS.EQ.0) then
         NOFS=Index(RCIN,' 1')
         N2=K2
         If(NOFS.EQ.0) go to   3
      Else
         N1=K1
         N2=K2
      End if 

      Do  20 I1=0,NSEQ-1

         If(LBKS) then
            LBKS=.FALSE.
            Go to 16
         End if           

 15      Read(NMSF,'(A)',Err=901,End=905) RCIN        
 16      If(RCIN(1:NOFS).EQ.' ') go to  15

         J1=I1*LSEQ+N1
         N5=(I1+1)*LSEQ
         Do  19 I2=NOFS+1,Lblnk(RCIN) 
            If(RCIN(I2:I2).NE.' ') then
               If(J1.GT.IDMS) go to 906
               If(J1.GT.N5) go to 911
               CSEQ(J1)=RCIN(I2:I2)
               J1=J1+1
            End if 
 19      Continue
         If(I1.NE.0.AND.N4.NE.N2-N1+1) go to 909
         
         If(J1.NE.I1*LSEQ+N2+1) then
            N3=J1-I1*LSEQ-1
            If(N3.NE.LSEQ) then
               Go to 909
            End if
         End if 
         N4=N2-N1+1

 20   Continue

      If(N2.GE.LSEQ) go to 100 

 25   Read(NMSF,'(A)',Err=901,End=905) RCIN        
      If(RCIN.EQ.' ') go to  25 
      N1=N2+1
      Go to  10

 100  Return

* errors

 900  Write(NERR,*) 'Error: Unable to open MSF file'//
     *   ' ''',FMSF(1:Lblnk(FMSF)),'''.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Unable to read MSF file'//
     *   ' ''',FMSF(1:Lblnk(FMSF)),'''.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: Unexpected end of MSF file. '//
     *   'Unable to find ''',CMIS(1:Lblnk(CMIS)),''' keyword.'
      Write(NERR,*) '       No sequences read.'
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Badly formatted MSF file. '//
     *   'Unable to read ''',CMIS(1:Lblnk(CMIS)),''' parameter.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      Write(NERR,*) '       No sequences read.'
      IRC=1
      Go to 100
 904  Write(NERR,*) 'Error: Badly formatted MSF file. '//
     *   'Unable to find ''',CMIS(1:Lblnk(CMIS)),''' keyword.'
      Write(NERR,*) '       No sequences read.'
      IRC=1
      Go to 100
 905  Write(NERR,*) 'Error: Unexpected end of MSF file. '//
     *   'Unable to read sequences in MSF file.'
      IRC=1
      Go to 100
 906  Write(NERR,*) 'Error: Multiple sequence length exceeds ',
     *   'buffer size (',IDMS,').'
      IRC=1
      Go to 100
 909  Write(NERR,*) 'Error: Sequence length differs from expected ',
     *   'length.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100
 910  Write(NERR,*) 'Error: Number of sequences in MSF file exceeds ',
     *   'buffer size (',IDMF,').'
      IRC=1
      Go to 100
 911  Write(NERR,*) 'Error: Sequence length exceeds expected ',
     *   'length.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100

      End

*----------------------------------------------------------------------*     
* $Id: xprsm.f,v 2.12 2003/12/09 13:42:42 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine XPRSM(JSEQ,JMMA,LPMM,
     *   LUNI,LOUT,LNOR,LREV,OPTZ,OPTL,OPLU,OPTB,
     *   CHID,CHAC,CHFH,CPID,CPAC,OPTR,OPTF,LDRS,
     *   IOPT,JALB,JALE,NALI,IPMB,IPME,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   RNOP,KNPM,MAXN,INOR,IFUN,MNUM,LSEQ,RAVE)

* profile parameters

      Include          'codat.f'

      Real              RNOP(KNPM,MAXN)

* logical switches 

      Logical           LUNI
      Logical           LOUT
      Logical           LNOR
      Logical           LREV
      Logical           OPTL
      Logical           OPLU
      Logical           OPTZ 
      Logical           OPTB 
      Logical           OPTR
      Logical           OPTF

      Logical           LPMM
      Logical           LFCL
      Logical           LDRS


* sequence and profile header 
      
      Character*(*)     CHID
      Character*(*)     CHAC
      Character*(*)     CHFH
      Character*(*)     CPID
      Character*(*)     CPAC

* Output fields 

      Character*13      CHLE
      Character*20      CHNS
      Character*17      CHRS 
      Character*64      CHLO
      Character*21      CHSE
      Character*17      CHTY
      
      Character*21      CHPP

      Character*24      CHPS
      Character*24      CHPE
      Character*09      CHST 
      Character*64      CHER 
      Character*64      CHMN 
      Character*22      CHRN 
      Character*26      CHPN 
      
      Character*64      CHMO
      Character*64      CHMI
      Character*64      CHRP

      Character*512     RCEX

* prepare output fields 

* - norm-score
      If(LNOR) then
         Call RtoN
     *      (IOPT,XOPT,RNOP,KNPM,MAXN,INOR,IFUN,LSEQ,RAVE)
         R=XOPT         

         If(R.GT.9999.999) R=9999.999 
         If(R.LT.-999.999) R=-999.999
         CHNS='norm_score= '
         Write(CHNS(13:),'(F8.3)') R

         J1=11
         Do I1=12,Lblnk(CHNS)
            If(CHNS(I1:I1).NE.' ') then 
               J1=J1+1
               CHNS(J1:J1)=CHNS(I1:I1)
               CHNS(I1:I1)=' '
            End if
         End do
         ILNS=Lblnk(CHNS)

*         Write(NERR,*) 'CHNS: ', CHNS,' ILNS: ',ILNS

      End if 

* - cut-off level

      If(OPTL.OR.OPLU) then
         LFCL=.FALSE.
         If(.NOT.OPTR) then
            KI=0
            KJ=0
            Do I1=1,JCUT
               Do I2=1,JCNM(I1)
                  If(MCUT(I2,I1).EQ.MNUM) then
                     If(KI.EQ.0) then
                        KI=I1
                        KJ=I2
                     Else if(RCUT(I2,I1).LT.RCUT(KJ,KI)) then
                        KI=I1
                        KJ=I2
                     End if
                  End if
               End do
            End do
            Do I1=1,JCUT
               Do I2=1,JCNM(I1)
                  If(MCUT(I2,I1).EQ.MNUM) then 
                     If(XOPT.GE.RCUT(I2,I1)
     *                  .AND.RCUT(I2,I1).GE.RCUT(KJ,KI)
     *                  .AND.MCLE(I1).GE.MCLE(KI)) then
                        LFCL=.TRUE.
                        KI=I1
                        KJ=I2
                     End if
                  End if
               End do
            End do
         Else
            KI=1
            Do I1=2,JCUT
               If(ICUT(I1).LT.ICUT(KI)) KI=I1
            End do 
            Do I1=1,JCUT
               If(IOPT.GE.ICUT(I1).AND.ICUT(I1).GE.ICUT(KI)
     *            .AND.MCLE(I1).GE.MCLE(KI)) then
                  LFCL=.TRUE.
                  KI=I1
               End if
            End do 
         End if 
         K=MCLE(KI)
         If(OPLU) then
            If(.NOT.LFCL.OR.CCUT(KI)(1:1).EQ.' ') then
               Write(CHLE,'(''level_tag=NA'')')
            Else
               Write(CHLE,'(''level_tag='',(A2))') CCUT(KI)
            End if
         Else
            If(.NOT.LFCL) then
               Write(CHLE,'(''level=NA'')')
            Else
               If(K.LT.0.OR.K.GT.9) then 
                  Write(CHLE,'(''level='',I2,'' '')') K 
               Else
                  Write(CHLE,'(''level='',I1,''  '')') K 
               End if
            End if
         End if
         ILLE=Lblnk(CHLE)
*         Write(NERR,*) 'CHLE: ', CHLE,' ILLE: ',ILLE
      End if  
      
* - raw-score

      I=IOPT
      If(I.GT.999999) I=999999
      If(I.LE.-99999) I=-99999
      Write(CHRS,'(''raw_score='',I7)') I
      J1=10
      Do I1=11,Lblnk(CHRS)
         If(CHRS(I1:I1).NE.' ') then 
            J1=J1+1
            CHRS(J1:J1)=CHRS(I1:I1)
            CHRS(I1:I1)=' '
         End if
      End do
      ILRS=Lblnk(CHRS)
*      Write(NERR,*) 'CHRS: ', CHRS,' ILRS: ',ILRS
      
* - location in sequence

      If(.NOT.LUNI.OR.LOUT) then 
         If(LREV) then 
            JALB=LSEQ-JALB+1
            JALE=LSEQ-JALE+1
            CHSE='seq_end= '
            Write(CHSE(10:),*) JALB-LSEQ-1
         Else 
*         Write(CHLO,'('' pos. '',I6,'' -'',I6)') JALB,JALE
            CHSE='seq_end= '
            Write(CHSE(10:),*) JALE-LSEQ-1
         End if
         J1=8
         Do I1=9,Lblnk(CHSE)
            If(CHSE(I1:I1).NE.' ') then 
               J1=J1+1
               CHSE(J1:J1)=CHSE(I1:I1)
               CHSE(I1:I1)=' '
            End if
         End do
         ILSE=Lblnk(CHSE)

         Write(CHLO,*) JALB,'-',JALE
         J1=0
         Do I1=1,Lblnk(CHLO)
            If(CHLO(I1:I1).NE.' ') then 
               J1=J1+1
               CHLO(J1:J1)=CHLO(I1:I1)
               CHLO(I1:I1)=' '
            End if
         End do
         If(LREV) then 
            JALB=LSEQ-JALB+1
            JALE=LSEQ-JALE+1
         End if 
         ILLO=Lblnk(CHLO)
*         Write(NERR,*) 'CHLO: ', CHLO,' ILLO: ',ILLO

* - location in profile

         If(OPTZ) then
*            CHPS='motif_start= '
*            Write(CHPS(14:),*) IPMB
            Write(CHPS,'(''motif_start='',I7)') IPMB
            J1=12
            Do I1=13,Lblnk(CHPS)
               If(CHPS(I1:I1).NE.' ') then 
                  J1=J1+1
                  CHPS(J1:J1)=CHPS(I1:I1)
                  CHPS(I1:I1)=' '
               End if
            End do
*            CHPE='motif_end= '
*            Write(CHPE(12:),*) IPME
            Write(CHPE,'(''motif_end='',I7)') IPME
            J1=10
            Do I1=11,Lblnk(CHPE)
               If(CHPE(I1:I1).NE.' ') then 
                  J1=J1+1
                  CHPE(J1:J1)=CHPE(I1:I1)
                  CHPE(I1:I1)=' '
               End if
            End do
*            Write(CHPP,'('' ['',I5,'','',I6,'']'')') IPMB,IPME
            ILPS=Lblnk(CHPS)
*            Write(NERR,*) 'CHPS: ',CHPS,' ILPS: ',ILPS
            ILPE=Lblnk(CHPE)
*            Write(NERR,*) 'CHPE: ',CHPE,' ILPE: ',ILPE
         End if
      End if 

* - entry-ref 

      If(OPTF) then
         L1=Lblnk(CHFH)
         If (L1.EQ.0) then
            CHMI='unknown'
            ILMI=7
         Else
            CHMI=CHFH(1:L1)
            ILMI=MIN(64,L1)
         Endif
      Else
         L1=Lblnk(CHAC)
         L2=Lblnk(CHID)
         CHMI=CHAC(1:L1) // CHID(1:L2)
         ILMI=MIN(64,L1+L2)
C      CHER=CHAC(1:L1) // CHID(1:L2)
C      LNER=MIN(64,L1+L2)
      End if

      If(OPTB) then
         If(LREV) then 
*         CHER=CHER(1:LNER) // '(-)' 
*         LNER=LNER+3
            CHST='strand=r' 
         Else
            CHST='strand=s'
         End if 
         ILST=8
*        Write(NERR,*) 'CHST: ',CHST
      End if 
      
*      ILER=Lblnk(CHER)
*      Write(NERR,*) 'CHER: ',CHER,' ILER: ',ILER

* - match-number

      If(NALI.GT.1.AND..NOT.LPMM) then 
         CHMN='match_nb= '
         Write(CHMN(11:),*) JSEQ
         J1=9
         Do I1=10,Lblnk(CHMN)
            If(CHMN(I1:I1).NE.' ') then 
               J1=J1+1
               CHMN(J1:J1)=CHMN(I1:I1)
               CHMN(I1:I1)=' '
            End if
         End do
         ILMN=Lblnk(CHMN)
*         Write(NERR,*) 'CHMN: ',CHMN,' ILMN: ',ILMN
      End if
      If(.NOT.LPMM.AND.(JMMA.GT.1.OR.NALI.GT.1)) then
         CHTY='match_type=region'
         ILTY=17
      End if

* - multiple repeat number and type

      If(LPMM) then
         CHTY='match_type=repeat'
         ILTY=17
         CHRN='repeat_nb= '
         Write(CHRN(12:),*) JMMA
         J1=10
         Do I1=11,Lblnk(CHRN)
            If(CHRN(I1:I1).NE.' ') then 
               J1=J1+1
               CHRN(J1:J1)=CHRN(I1:I1)
               CHRN(I1:I1)=' '
            End if
         End do
         ILRN=Lblnk(CHRN)
*         Write(NERR,*) 'CHRN: ',CHRN,' ILRN: ',ILRN

* -- multiple repeat parent match number

         If(NALI.GT.1) then 
            CHPN='match_parent= '
            Write(CHPN(15:),*) JSEQ
            J1=13
            Do I1=14,Lblnk(CHPN)
               If(CHPN(I1:I1).NE.' ') then 
                  J1=J1+1
                  CHPN(J1:J1)=CHPN(I1:I1)
                  CHPN(I1:I1)=' '
               End if
            End do
            ILPN=Lblnk(CHPN)
C            Write(NERR,*) 'CHPN: ',CHPN,' ILPN: ',ILPN
         End if         
      End if

* - profile name (motif)

      CHMO='motif= '
      
      L1=Lblnk(CPID)
      L2=Lblnk(CPAC)
      L3=6
      If(L2-1.GT.0) then
         CHMO=CHMO(1:L3) // CPAC(1:L2)
         L3=L3+L2
      End if
      If(L1.GT.0) then
         CHMO=CHMO(1:L3) // CPID(1:L1)
      End if
      If(L2-1.LE.0.AND.L1.EQ.0) then
         CHMO=CHMO(1:6) // 'unknown'
      End if

      ILMO=Lblnk(CHMO)
*      Write(NERR,*) 'CHMO: ',CHMO,' ILMO: ',ILMO

* assemble ouput record

      LNEX=0 

      RCEX(LNEX+1:)='>' // CHMI 
      LNEX=LNEX+ILMI+2

      If(.NOT.LUNI.OR.LOUT) then 
         RCEX(LNEX:)='/' // CHLO
         LNEX=LNEX+ILLO+1
      End if

      RCEX(LNEX+1:)=CHMO 
      LNEX=LNEX+ILMO+1

      If(LNOR.AND..NOT.LDRS) then 
         RCEX(LNEX+1:)=CHNS
         LNEX=LNEX+ILNS+1
      End if

      RCEX(LNEX+1:)=CHRS
      LNEX=LNEX+ILRS+1

      If(OPTB) then 
         RCEX(LNEX+1:)=CHST
         LNEX=LNEX+ILST+1
      End if

      If(NALI.GT.1) then 
         If(.NOT.LPMM) then
            RCEX(LNEX+1:)=CHMN
            LNEX=LNEX+ILMN+1
         Else
            RCEX(LNEX+1:)=CHPN
            LNEX=LNEX+ILPN+1
         End if
      End if

      If(.NOT.LPMM.AND.(JMMA.GT.1.OR.NALI.GT.1)) then
         RCEX(LNEX+1:)=CHTY
         LNEX=LNEX+ILTY+1
      End if

      If(LPMM) then
         RCEX(LNEX+1:)=CHRN
         LNEX=LNEX+ILRN+1
         RCEX(LNEX+1:)=CHTY
         LNEX=LNEX+ILTY+1
      End if

      If(OPTL.OR.OPLU) then
         RCEX(LNEX+1:)=CHLE
         LNEX=LNEX+ILLE+1
*         If(OPLU) LNEX=LNEX-2
      End if

      If(.NOT.LUNI.OR.LOUT) then 
*         RCEX(LNEX+1:)=CHLO
*         LNEX=LNEX+ILLO
         RCEX(LNEX+1:)=CHSE
         LNEX=LNEX+ILSE+1
         
         If(OPTZ) then
            RCEX(LNEX+1:)=CHPS
            LNEX=LNEX+ILPS+1
            RCEX(LNEX+1:)=CHPE
            LNEX=LNEX+ILPE+1
         End if
      End if   

* - match ID and repeat number for standard output and option -x
      
*      If (.NOT.LPFA.AND.LPMM) then
*         Write(CHRP,*) JSEQ,'_REP'
*         L2=Lblnk(CHRP)
*         Write(CHRP(L2+1:),*) JMMA
*         J1=L2
*         Do I1=L2+1,Lblnk(CHRP)
*            If(CHRP(I1:I1).NE.' ') then 
*               J1=J1+1
*               CHRP(J1:J1)=CHRP(I1:I1)
*            End if
*         End do
*         RCEX(LNEX+1:)=CHRP(1:J1)
*         LNEX=LNEX+J1
*      End if

*      RCEX(LNEX+2:)=CHER(1:LNER)
*      LNEX=LNEX+1+LNER

*      L3=MAX(0,MIN(NW-LNEX-1,Lblnk(CHDE)))
*      RCEX(LNEX+2:)=CHDE(1:L3)
*      LNEX=LNEX+1+L3

* Write output record
      If(LNEX.GT.512) then
         LNEX=512
      End if
      Write(6,'(512A)')(RCEX(ii1:ii1),ii1=1,LNEX)

 100  Return 
      End 

*----------------------------------------------------------------------*     
* $Id: prxp.f,v 1.2 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*        Print psa alignment for multiple matches
*        Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine PRXP
     *   (CALI,IABG,IAED,IPBG,IPED,LPRF,NW)
      
      Character*01      CALI(*)
      Integer           IABG
      Integer           IAED
      Integer           LPRF
      Integer           IPBG
      Integer           IPED

      Character*512     RCOUT

      IIDE=LPRF-IPED

      INL=IAED-IABG+IPBG+IIDE
      INB=INL/NW
      INR=INL-INB*NW
C      IN1=IABG-1
      ii2=IABG

      IPOS=1

* write psa style alignment

      Do IN2=1,INB
         Do ii1=1,NW
            If(IPOS.LT.IPBG.OR.IPOS.GT.IPED) then
               RCOUT(ii1:ii1)='-'
               IPOS=IPOS+1
            Else
               RCOUT(ii1:ii1)=CALI(ii2)
               ii2=ii2+1
               K1=Ichar(RCOUT(ii1:ii1))
               If(K1.GE.65.AND.K1.LE. 90) IPOS=IPOS+1
            End if
         End do
C         IN1=IN1+NW
         Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,NW)
      End do
      If(INR.GT.0) then
         Do ii1=1,INR
            If(IPOS.LT.IPBG.OR.IPOS.GT.IPED) then
               RCOUT(ii1:ii1)='-'
               IPOS=IPOS+1
            Else
               RCOUT(ii1:ii1)=CALI(ii2)
               ii2=ii2+1
               K1=Ichar(RCOUT(ii1:ii1))
               If(K1.GE.65.AND.K1.LE. 90) IPOS=IPOS+1
            End if
         End do
         Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,INR)
      End if            
      
      Return

      End

*       Program htop
*----------------------------------------------------------------------*
* $Id: htop.f,v 2.12 2003/12/01 13:33:04 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Reformats profiles: in-fmt=HMMER / out-fmt=PROSITE
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

* array dimensions and I/O units

      Include          'ardim.f'

      Parameter        (NPRF=   5)
      Parameter        (NOUT=   6)
      Parameter        (NNUL=  12)

* profile and sequence fields:

      Character*4096    FPRF

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'

      Include          'sterr.f'

* HMM
      Include          'hmdat.f'

      Character*4096    FNUL

* command line options and parameters

      Real*8            DB
      Real*8            DL

      Logical           OPTF
      Logical           OPTI
      Logical           OPTO
      Logical           OPTR
      Logical           OPTS
      Logical           LLLT
      Logical           LRNM
      Logical           LEOF
      Logical           LRPS

      Integer           INBP

* initialization of controlled vocabularies

      Include          'cvini.f'

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

* initializations

      IRC=0
      LHDR=0
      LEOF=.FALSE.
      LRNM=.TRUE.
      INBP=0

* read command line arguments

      Call Repar
     *   (OPTF,OPTI,OPTO,OPTR,OPTS,LLLT,LRPS,FPRF,FNUL,
     *   DB,RC,DL,NM,RP,RQ,RF,RH,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''htop 2.3 revision 5.d'',//
     *      ''Usage: htop [ -fhilosBCFHLMPQ ] [ hmm-file | - ] ''
     *      ''[ random-model-file ] [ parameters ]'',/
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -f: emulate HMM fragment search (HMMER1 specific).'',/
     *      ''    -h: print usage help text.'',/
     *      ''    -i: force insert extension scores to zero.'',/
     *      ''    -l: do not impose limit on line length.'',/
     *      ''    -o: assume input to be HMMER1 format (default:'',
     *      '' HMMER2).'',/
     *      ''    -s: implement semiglobal alignment.''
     *      )')
         Write(NERR,'(
     *      ''    -B<value>:     (HMMER1 specific)'',/
     *      ''        normalization logarithmic base (default: 2.0).'',/
     *      ''    -C<value>:'',/
     *      ''        level zero cut-off value (default: 8.5).'',/
     *      ''    -F<value>:     (HMMER2 specific)'',/
     *      ''        output score multiplier (default: 100).'',/
     *      ''    -H<value>:     (only effective with option -s)'',/
     *      ''        initiation/termination score (default: *).''
     *      )')
         Write(NERR,'(
     *      ''    -L<value>:     (HMMER1 specific)'',/
     *      ''        score logarithmic base (default: 1.0233739).'',/
     *      ''    -M<value>:'',/
     *      ''        number of unprotected residues at end of '',
     *      ''profile (default: 5).'',/
     *      ''    -P<value>:'',/
     *      ''        percent profile length not included in '',
     *      ''protected area (default: 0).'',/
     *      ''    -Q<value>:'',/
     *      ''        odds ratio of unknown residues (default: 0.8).'',/
     *      )')
         Write(NERR,'(
     *      '' valid (but deprecated) parameters are:'',/,
     *      ''  [B=norm-score-logbase]        use option -B instead'',/,
     *      ''  [C=cut-off-value]             use option -C instead'',/,
     *      ''  [F=rescaling factor]          use option -F instead'',/,
     *      ''  [H=high-cost-init-term-score] use option -H instead'',/,
     *      ''  [L=profile-logbase]           use option -L instead'',/,
     *      ''  [M=length-unprotected-ends]   use option -M instead'',/,
     *      ''  [P=percent-unprotected-ends]  use option -P instead'',/
     *      ''  [Q=prob-of-unknown-residue]   use option -Q instead'',/
     *      )')
         Call Exit(IRC)
      End if

* read profile

 1    Continue

      If(LEOF) go to 100
      If(.NOT.OPTO) then
         Call RHMMER2
     *      (NPRF,FPRF,
     *      CPID,CPAC,CPDT,CPDE,LHDR,CHDR,NABC,CABC,LPRF,LPCI,
     *      CDIS,JDIP,MDIS,NDIP,
     *      CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *      JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *      IDMP,CHIP,IIPP,CHMP,IMPP,
     *      BLOG,FABC,P0,
     *      CHID,IIPD,CHMD,IMPD,
     *      INBP,LEOF,IRC)

         If(LEOF.AND.IRC.LT.0) then
            If(INBP.GE.1) IRC=0
            go to 100
         End if
         If(IRC.NE.0) go to 100

* rescale
*** To be modified: Add to hmmer1 profile reading ???
         Do I1=0,LPRF
            Do I2=0,46
               If(IIPP(I2,I1).NE.NLOW)
     *            IIPP(I2,I1)=NINT(RF*IIPP(I2,I1))
            End do
         End do
         Do I1=1,LPRF
            Do I2=0,27
               If(IMPP(I2,I1).NE.NLOW)
     *            IMPP(I2,I1)=NINT(RF*IMPP(I2,I1))
            End do
         End do

         RNOP(1,1)=RNOP(1,1)+LOG10(350.0)
         RNOP(2,1)=RNOP(2,1)/RF
         BLOG=BLOG**(1/RF)
         RCUT(1,1)=RC
         ICUT(1)=NINT((RCUT(1,1)-RNOP(1,1))/RNOP(2,1))+1

         If(RC.EQ.0) then
            JCUT=2
            MCLE(1)=0
            CCUT(1)='!'
            JCNM(1)=1
            RCUT(1,1)=8.5
            MCUT(1,1)=1
            ICUT(1)=NINT((RCUT(1,1)-RNOP(1,1))/RNOP(2,1))+1
            MCLE(2)=-1
            CCUT(2)='?'
            JCNM(2)=1
            RCUT(1,2)=6.5
            MCUT(1,2)=1
            ICUT(2)=NINT((RCUT(1,2)-RNOP(1,1))/RNOP(2,1))+1
         End if
***

* semilocal alignment mode

         If(OPTS) then
            IIPD(B0)=0
            IIPD(E0)=0
            Do I1=1,LPRF
               IIPP(B0,I1-1)=0
               IIPP(E0,I1)=0
            End do
         End if

* option -i

         If(OPTI) then
            Do I1=0,LPRF
               Do I2=0,NABC
                  IIPP(I2,I1)=0
               End do
            End do
         End if

         Go to  90
      End if


      Call RHMMER(NPRF,FPRF,LPRF,RIHM,RMHM,IDMP,NABC,CABC,INBP,IRC)
      If(IRC.NE.0) go to 100

* read null-model

      If(FNUL.NE.' ') then
         Call RHNUL(NNUL,FNUL,FABC,NABC,IRC)
         If(IRC.NE.0) go to 100
      Else
         Do I2=1,NABC
            FABC(I2)=0.0
         End do
         Do I1=1,LPRF
            Do I2=1,NABC
               FABC(I2)=FABC(I2)+RIHM(I2,I1)
            End do
         End do
         Do I2=1,NABC
            FABC(I2)=FABC(I2)/LPRF
         End do
      End if

* header line definitions

      If(FPRF.EQ.'-') FPRF='stdin'
      CPID='HMMER-HMM'
      CPAC='HH99999'
      CPDT=' '
      CPDE='Automatically reformatted from file '''
     *   // FPRF(1:Lblnk(FPRF))
     *   // '''.'

* accessories

      LPCI=.FALSE.

      BLOG=DL
      DL=1/LOG(DL)
      P0=1.0

      MDIS=2
C      If(NM.GT.0.AND.NM.LT.(LPRF/2)) then
C         NDIP(1)=1   +NM
C         NDIP(2)=LPRF-NM
C      Else
C         NM=LPRF/2
C         N1=MIN(NM,NINT(LPRF*RP/100))
C         NDIP(1)=1   +N1
C         NDIP(2)=LPRF-N1
C      End if
C      If(NDIP(1).GT.NDIP(2)) then
C         ITMP=NDIP(1)
C         NDIP(1)=NDIP(2)
C         NDIP(1)=ITMP
C      End if

      JNOR=1
      MNOR(1)=1
      NNOR(1)=1
      NNPR(1)=1
      CNTX(1)='nscore'
      RNOP(2,1)=1/LOG(DB)/DL
      If(OPTF) then
         RNOP(1,1)=DL*(LOG(Real(1-1000.0/1001))-LOG(4.0))*RNOP(2,1)
      Else
         RNOP(1,1)=0.0
      End if

      JCUT=1
      MCLE(1)=0
      CCUT(1)=' '
      JCNM(1)=1
      RCUT(1,1)=RC
      MCUT(1,1)=1
      ICUT(1)=NINT((RCUT(1,1)-RNOP(1,1))/RNOP(2,1))+1

* defaults for match and insert positions

      If(OPTF) then
         IIPD(B1)=NINT(-DL*(LOG(Real(LPRF-1))))
         IIPD(E1)=IIPD(B1)
         IIPD(BM)=0
         IIPD(BI)=NLOW
         IIPD(BD)=NLOW
         IIPD(ME)=0
         IIPD(IE)=NLOW
         IIPD(DE)=NLOW
      Else
         IIPD(B1)=NLOW
         IIPD(E1)=NLOW
      End if

      If(OPTS) then
         IIPD(B0)=0
         IIPD(E0)=0
      Else
         IIPD(B0)=IIPD(B1)
         IIPD(E0)=IIPD(E1)
      End if

      IMPD( D)=0

      IIPD(BM)=0
      IIPD(BI)=NLOW
      IIPD(BD)=NLOW

      IIPD(ME)=0
      IIPD(IE)=NLOW
      IIPD(DE)=NLOW

      IIPD(BE)=NLOW
      IIPD(MM)=0
      IIPD(MI)=0
      IIPD(MD)=0
      IIPD(IM)=0
      IIPD(II)=0
      IIPD(ID)=0
      IIPD(DM)=0
      IIPD(DI)=0
      IIPD(DD)=0

      IIPD(I0)=NINT(DL*LOG(RQ))
      If(OPTI) IIPD(I0)=0

      CHID='-'
      Do I1=1,26
         IIPD(I1)=0
      End do

      IMPD(M0)=NINT(DL*LOG(RQ))
      IMPD(D )=0
      CHMD='X'
      Do I1=1,26
         IMPD(I1)=0
      End do

      Do I1=0,LPRF
         Do I2=0,27
            IMPP(I2,I1)=IMPD(I2)
         End do
         Do I2=0,46
            IIPP(I2,I1)=IIPD(I2)
         End do
      End do

* convert probabilities into profile-scores

      Do I1=0,LPRF
         IIPP(MM,I1)=NLOW
         IIPP(MD,I1)=NLOW
         IIPP(MI,I1)=NLOW
         IIPP(DM,I1)=NLOW
         IIPP(DD,I1)=NLOW
         IIPP(DI,I1)=NLOW
         IIPP(IM,I1)=NLOW
         IIPP(ID,I1)=NLOW
         IIPP(II,I1)=NLOW
         If(RIHM(MM,I1).GT.0) IIPP(MM,I1)=NINT(DL*LOG(RIHM(MM,I1)))
         If(RIHM(MD,I1).GT.0) IIPP(MD,I1)=NINT(DL*LOG(RIHM(MD,I1)))
         If(RIHM(MI,I1).GT.0) IIPP(MI,I1)=NINT(DL*LOG(RIHM(MI,I1)))
         If(RIHM(DM,I1).GT.0) IIPP(DM,I1)=NINT(DL*LOG(RIHM(DM,I1)))
         If(RIHM(DD,I1).GT.0) IIPP(DD,I1)=NINT(DL*LOG(RIHM(DD,I1)))
         If(RIHM(DI,I1).GT.0) IIPP(DI,I1)=NINT(DL*LOG(RIHM(DI,I1)))
         If(RIHM(IM,I1).GT.0) IIPP(IM,I1)=NINT(DL*LOG(RIHM(IM,I1)))
         If(RIHM(ID,I1).GT.0) IIPP(ID,I1)=NINT(DL*LOG(RIHM(ID,I1)))
         If(RIHM(II,I1).GT.0) IIPP(II,I1)=NINT(DL*LOG(RIHM(II,I1)))

         Do I2=1,NABC
            If(RMHM(I2,I1).GT.0) then
               IMPP(I2,I1)=NINT(DL*LOG(RMHM(I2,I1)/FABC(I2)))
            Else
               IMPP(I2,I1)=NLOW
            End if
         End do

         If(OPTI) then
            IIPP(I2,I1)=0
         Else
            Do I2=1,NABC
               If(RIHM(I2,I1).GT.0) then
                  IIPP(I2,I1)=NINT(DL*LOG(RIHM(I2,I1)/FABC(I2)))
               Else
                  IIPP(I2,I1)=NLOW
               End if
            End do
         End if
      End do

* beginning and end

      If(.NOT.OPTF) then
         IIPP(BM,   0)=IIPP(MM,   0)
         IIPP(BD,   0)=IIPP(MD,   0)
         IIPP(BI,   0)=IIPP(MI,   0)
         IIPP(ME,LPRF)=IIPP(MM,LPRF)
         IIPP(DE,LPRF)=IIPP(DM,LPRF)
         IIPP(IE,LPRF)=IIPP(IM,LPRF)
      End if

      IIPP(B0,   0)=0
      IIPP(B1,   0)=0
      IIPP(E0,LPRF)=0
      IIPP(E1,LPRF)=0

* generate consensus sequence

      CHIP( 0)='-'
      Do I1=1,LPRF
         CHMP(I1)=CABC( 1)
         CHIP(I1)=CHID
         K1=IMPP( 1,I1)
         Do I2=1,NABC
            If(IMPP(I2,I1).GT.K1) then
               K1=IMPP(I2,I1)
               CHMP(I1)=CABC(I2)
            End if
         End do
      End do

 90   Continue

* parameters P,M

      If((.NOT.LRPS).AND.(NM.GT.0.AND.NM.LT.(LPRF/2))) then
         NDIP(1)=1   +NM
         NDIP(2)=LPRF-NM
      Else
         NM=LPRF/2
         N1=MIN(NM,NINT(LPRF*RP/100))
         NDIP(1)=1   +N1
         NDIP(2)=LPRF-N1
      End if
      If(NDIP(1).GT.NDIP(2)) then
         ITMP=NDIP(1)
         NDIP(1)=NDIP(2)
         NDIP(1)=ITMP
      End if
C      If(NM.EQ.0) NM=LPRF/2
C      N1=MIN(NM,NINT(LPRF*RP/100))
C      NDIP(1)=1   +N1
C      NDIP(2)=LPRF-N1


* final modifications (parameter)

      If(RH.GT.0.0) then
         If(OPTR) then
            NH=-RH/RNOP(2,1)
         Else
            NH=-RH*RF
         End if
         IIPD(B0)=MAX(IIPD(B0),NH)
         IIPD(B1)=MAX(IIPD(B1),NH)
         IIPD(E1)=MAX(IIPD(E1),NH)
         IIPD(E0)=MAX(IIPD(E0),NH)
         Do I1=0,LPRF
            IIPP(B0,I1)=MAX(IIPP(B0,I1),NH)
            IIPP(B1,I1)=MAX(IIPP(B1,I1),NH)
            IIPP(E1,I1)=MAX(IIPP(E1,I1),NH)
            IIPP(E0,I1)=MAX(IIPP(E0,I1),NH)
         End do
      End if

* write profile


      LFTR=1
      CFTR(1)='CC   /GENERATED_BY="'
      Call Recmd(CFTR(1)(21:130))
      IC=Lblnk(CFTR(1))
      CFTR(1)(IC+1:)='";'

      Call WRPRF
     *   (NOUT,LLLT,LRNM,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   BLOG,FABC,P0,
     *   CHID,IIPD,CHMD,IMPD,
     *   IRC)

      If(.NOT.OPTO) Go to   1

 100  Call Exit(IRC)
      End
*----------------------------------------------------------------------*
      Subroutine Repar
     *     (OPTF,OPTI,OPTO,OPTR,OPTS,LLLT,LRPS,FPRF,FNUL,
     *     DB,RC,DL,NM,RP,RQ,RF,RH,IRC)

      Character*4096    CARG
      Character*(*)     FPRF
      Character*(*)     FNUL

      Real*8            DB
      Real*8            DL

      Logical           OPTF
      Logical           OPTI
      Logical           OPTO
      Logical           OPTR
      Logical           OPTS
      Logical           LLLT
      Logical           LRPS

*     initializations

      OPTF=.FALSE.
      OPTI=.FALSE.
      OPTR=.FALSE.
      OPTS=.FALSE.
      OPTO=.FALSE.
      LLLT=.TRUE.
      LRPS=.FALSE.
      DB=2.0
      RC=0.0
      DL=1.0233739
      NM=5
      RP=0.0
      RQ=0.8
      RH=0.0

      FPRF=' '
      FNUL=' '
      RF=1.0

      IRC=0

      N1=Iargc()

      K1=0
      I2=1
      Do I1=1,N1
         Call GetArg(I2,CARG)
         If(CARG(1:1).EQ.'-'
     *        .AND.CARG(2:2).NE.' ') then
            If(Index(CARG,'h').NE.0) Go to 900
            If(Index(CARG,'f').NE.0) OPTF=.TRUE.
            If(Index(CARG,'i').NE.0) OPTI=.TRUE.
            If(Index(CARG,'o').NE.0) OPTO=.TRUE.
            If(Index(CARG,'r').NE.0) OPTR=.TRUE.
            If(Index(CARG,'s').NE.0) OPTS=.TRUE.
            If(Index(CARG,'l').NE.0) LLLT=.FALSE.
            If(Index(CARG,'B').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) DB
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) DB
               End if
            End if
            If(Index(CARG,'C').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RC
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RC
               End if
            End if
            If(Index(CARG,'F').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RF
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RF
               End if
            End if
            If(Index(CARG,'L').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) DL
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) DL
               End if
            End if
            If(Index(CARG,'M').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) NM
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) NM
               End if
            End if
            If(Index(CARG,'P').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RP
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RP
               End if
               LRPS=.TRUE.
            End if
            If(Index(CARG,'Q').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RQ
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RQ
               End if
            End if
            If(Index(CARG,'H').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RH
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RH
               End if
            End if
         Else if(CARG(1:2).EQ.'B=') then
            Read(CARG(3:),*,Err=900) DB
         Else if(CARG(1:2).EQ.'C=') then
            Read(CARG(3:),*,Err=900) RC
         Else if(CARG(1:2).EQ.'F=') then
            Read(CARG(3:),*,Err=900) RF
         Else if(CARG(1:2).EQ.'L=') then
            Read(CARG(3:),*,Err=900) DL
         Else if(CARG(1:2).EQ.'M=') then
            Read(CARG(3:),*,Err=900) NM
         Else if(CARG(1:2).EQ.'P=') then
            Read(CARG(3:),*,Err=900) RP
         Else if(CARG(1:2).EQ.'Q=') then
            Read(CARG(3:),*,Err=900) RQ
         Else if(CARG(1:2).EQ.'H=') then
            Read(CARG(3:),*,Err=900) RH
         Else if(K1.LE.1) then
            K1=K1+1
            If     (K1.EQ.1) then
               FPRF=CARG
            Else if(K1.EQ.2) then
               FNUL=CARG
            End if
         Else
            Go to 900
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 20
      End do

 20   If(FPRF.EQ.' ') Go to 900
      If(RP.LT.0.OR.RP.GT.100) Go to 900

 100  Return
 900  IRC=-1
      Go to 100
      End
*----------------------------------------------------------------------*
      Include          'rhmmer.f'
      Include          'rhmmer2.f'
      Include          'rhnul.f'
      Include          'recmd.f'
      Include          'wrprf.f'
      Include          'lblnk.f'

*----------------------------------------------------------------------*     
* $Id: pfind.f,v 2.3 2003/02/23 11:51:56 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
* Profile/HMM indices 

        Integer           B0 
        Integer           B1 
        Integer           E0 
        Integer           E1 
        Integer           BM 
        Integer           BI 
        Integer           BD 
        Integer           BE 
        Integer           MM 
        Integer           MI 
        Integer           MD 
        Integer           ME 
        Integer           DM 
        Integer           DI 
        Integer           DD 
        Integer           DE 
        Integer           IM 
        Integer           II 
        Integer           ID 
        Integer           IE 

        Integer           M0
        Integer           I0
        Integer           D 

        Parameter        (B0=  27) 
        Parameter        (B1=  28)
        Parameter        (E0=  29)
        Parameter        (E1=  30)
        Parameter        (BM=  31)
        Parameter        (BI=  32)
        Parameter        (BD=  33)
        Parameter        (BE=  34)
        Parameter        (MM=  35)
        Parameter        (MI=  36)
        Parameter        (MD=  37)
        Parameter        (ME=  38)
        Parameter        (IM=  39)
        Parameter        (II=  40)
        Parameter        (ID=  41)
        Parameter        (IE=  42)
        Parameter        (DM=  43)
        Parameter        (DI=  44)
        Parameter        (DD=  45)
        Parameter        (DE=  46)

        Parameter        (M0=   0)
        Parameter        (I0=   0)
        Parameter        (D =  27)

*       Program 2ft 
*----------------------------------------------------------------------*     
* $Id: 2ft.f,v 2.8 2003/11/28 11:53:33 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: 2-frame translation of DNA sequence into protein
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*

      Include          'ardim.f' 
      Parameter        (NOUT=   6) 

      Character*512     RCIN
      Character*512     CHDE 
      Character*64      CHID
      Character*512     RCEX

      Integer*2         ISEQ(IDMS)
      Character         CSEQ(IDMS)
      
      Character         CABC(0:63) 
      Character         CNBC(0:15) 

      Character*04      CDNA
      Integer           NBSQ
      Integer           IOS

      Include          'sterr.f'

* options

      Integer           NW
      Logical           OPTS
      Logical           OPTR

* Initializations 

      Data              CABC( 0)/'K'/
      Data              CABC( 1)/'N'/
      Data              CABC( 2)/'K'/
      Data              CABC( 3)/'N'/
      Data              CABC( 4)/'T'/
      Data              CABC( 5)/'T'/
      Data              CABC( 6)/'T'/
      Data              CABC( 7)/'T'/
      Data              CABC( 8)/'R'/
      Data              CABC( 9)/'S'/
      Data              CABC(10)/'R'/
      Data              CABC(11)/'S'/
      Data              CABC(12)/'I'/
      Data              CABC(13)/'I'/
      Data              CABC(14)/'M'/
      Data              CABC(15)/'I'/
      Data              CABC(16)/'Q'/
      Data              CABC(17)/'H'/
      Data              CABC(18)/'Q'/
      Data              CABC(19)/'H'/
      Data              CABC(20)/'P'/
      Data              CABC(21)/'P'/
      Data              CABC(22)/'P'/
      Data              CABC(23)/'P'/
      Data              CABC(24)/'R'/
      Data              CABC(25)/'R'/
      Data              CABC(26)/'R'/
      Data              CABC(27)/'R'/
      Data              CABC(28)/'L'/
      Data              CABC(29)/'L'/
      Data              CABC(30)/'L'/
      Data              CABC(31)/'L'/
      Data              CABC(32)/'E'/
      Data              CABC(33)/'D'/
      Data              CABC(34)/'E'/
      Data              CABC(35)/'D'/
      Data              CABC(36)/'A'/
      Data              CABC(37)/'A'/
      Data              CABC(38)/'A'/
      Data              CABC(39)/'A'/
      Data              CABC(40)/'G'/
      Data              CABC(41)/'G'/
      Data              CABC(42)/'G'/
      Data              CABC(43)/'G'/
      Data              CABC(44)/'V'/
      Data              CABC(45)/'V'/
      Data              CABC(46)/'V'/
      Data              CABC(47)/'V'/
      Data              CABC(48)/'O'/
      Data              CABC(49)/'Y'/
      Data              CABC(50)/'O'/
      Data              CABC(51)/'Y'/
      Data              CABC(52)/'S'/
      Data              CABC(53)/'S'/
      Data              CABC(54)/'S'/
      Data              CABC(55)/'S'/
      Data              CABC(56)/'O'/
      Data              CABC(57)/'C'/
      Data              CABC(58)/'W'/
      Data              CABC(59)/'C'/
      Data              CABC(60)/'L'/
      Data              CABC(61)/'F'/
      Data              CABC(62)/'L'/
      Data              CABC(63)/'F'/

      Data              CNBC( 0)/'X'/ 
      Data              CNBC( 1)/'T'/ 
      Data              CNBC( 2)/'X'/ 
      Data              CNBC( 3)/'X'/ 
      Data              CNBC( 4)/'X'/ 
      Data              CNBC( 5)/'P'/ 
      Data              CNBC( 6)/'R'/ 
      Data              CNBC( 7)/'L'/ 
      Data              CNBC( 8)/'X'/ 
      Data              CNBC( 9)/'A'/ 
      Data              CNBC(10)/'G'/ 
      Data              CNBC(11)/'V'/ 
      Data              CNBC(12)/'X'/ 
      Data              CNBC(13)/'S'/ 
      Data              CNBC(14)/'X'/ 
      Data              CNBC(15)/'X'/ 

      IRC=0
      NBSQ=0
      NW=60
      IOS=0

      CDNA='ACGT'

      Call Repar(OPTS,OPTR,NW,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''2ft 2.3 revision 5.d'',//
     *      ''Usage: 2ft [-[r|s]hW] < seq-library-file '',/
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -r: translate only reverse (antisense) strand.'',/
     *      ''    -s: translate only sense strand.'',/
     *      ''    -h: print usage help text.'',/
     *      ''    -W<value>:'',/
     *      ''        specifies the output width (default: 60).'',/
     *      )')
         Call Exit(IRC)
      End if

 1    Read(5,'(A)',End=920,Err=900) RCIN
      If(RCIN(1:1).NE.'>') go to   1

 2    If(RCIN(1:1).NE.'>') Go to 920 
      J1=Index(RCIN,' ')
      CHID='>x|' // RCIN(2:J1)
      LNID=Lblnk(CHID)
      LNDE=512-LNID+3
      CHDE=RCIN(J1+1:J1+LNDE)
      IF(OPTS.OR.OPTR) then
         RCEX=CHID(1:LNID) // ' ' // CHDE(1:LNDE)  
      Else
         RCEX=CHID(1:LNID) // '   ' // CHDE(1:LNDE)  
      End if 
      
      LSEQ=0
 3    Read(5,'(A)',Iostat=IOS,Err=900) RCIN
 4    If(RCIN(1:1).EQ.'>') go to  10
      L1=Lblnk(RCIN) 

      Do   5 I1=1,L1
         K1=Ichar(RCIN(I1:I1))
         If(K1.GE.97) then 
            K1=K1-32
            RCIN(I1:I1)=char(K1)
         End if
         If(K1.GT.90.OR.K1.LT.65) go to   5
         LSEQ=LSEQ+1
         If(LSEQ.GT.IDMS) Go to 901
         ISEQ(LSEQ)=Index(CDNA,(RCIN(I1:I1)))-1
         If(ISEQ(LSEQ).EQ.-1) ISEQ(LSEQ)=-64
 5    Continue
      RCIN=' '
      If(IOS.EQ.0) Go to 3

 10   Continue 
      
      If(LSEQ.GE.3) then 
         NBSQ=NBSQ+1
      Else
         Go to 902
      End if

* convert sequence into codons. 

      J1=LNID+1
      J2=LNID+2
      J3=Lblnk(RCEX)

* - plus strand

      If(.NOT.OPTR) then

         Do  12 I1=1,LSEQ-2
            N1=ISEQ(I1)*16+ISEQ(I1+1)*4+ISEQ(I1+2)
            If(N1.LT.0) then 
               N1=ISEQ(I1)*4+ISEQ(I1+1)
               If(N1.GE.0) then
                  CSEQ(I1)=CNBC(N1)
               Else 
                  CSEQ(I1)='X'
               End if
            Else
               CSEQ(I1)=CABC(N1)
            End if 
 12      Continue

         If(.NOT.OPTS) RCEX(J1:J2)='_P'
         Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,J3)
         Call Prsq(CSEQ,LSEQ-2,NW)

      End if

* - minus strand

      If(.NOT.OPTS) then

         Do  13 I1=LSEQ,1,-1
            ISEQ(I1)=3-ISEQ(I1)
            If(ISEQ(I1).GT.4) ISEQ(I1)=-64
 13      Continue
         K1=1
         Do  14 I1=LSEQ,3,-1
            N1=ISEQ(I1)*16+ISEQ(I1-1)*4+ISEQ(I1-2)
            If(N1.LT.0) then 
               N1=ISEQ(I1)*4+ISEQ(I1-1)
               If(N1.GE.0) then 
                  CSEQ(K1)=CNBC(N1)
               Else 
                  CSEQ(K1)='X'
               End if
            Else
               CSEQ(K1)=CABC(N1)
            End if 
            K1=K1+1
 14      Continue

         If(.NOT.OPTR) RCEX(J1:J2)='_M'
         Write(NOUT,'(512A)')(RCEX(ii1:ii1),ii1=1,J3)
         Call Prsq(CSEQ,LSEQ-2,NW)

      End if 

      If(IOS.EQ.0) Go to   2

 100  Call Exit(IRC)

 900  Write(NERR,*) 'Error: Unable to read sequence from standard'//
     *   ' input.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: sequence length exceeds buffer size (',
     *   IDMS,').'
      Write(NERR,*) '       While processing sequence ',
     *      CHID(4:Lblnk(CHID))
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: sequence length too short.'
      Write(NERR,*) '       While processing sequence ',
     *      CHID(4:Lblnk(CHID))
      IRC=1
      Go to 100
 920  If(NBSQ.EQ.0) then
         Write(NERR,*) 'Warning: No FASTA sequence found. '
         IRC=-1
      End if
      Go to 100
      End

*----------------------------------------------------------------------*
      Subroutine Repar(OPTS,OPTR,NW,IRC)

      Character*64      CARG

      Integer           NW
      Logical           OPTS
      Logical           OPTR

      IRC=0

      OPTS=.FALSE.
      OPTR=.FALSE.

      N1=Iargc()

      K1=0
      I2=1
      Do I1=1,N1
         Call GetArg(I2,CARG)
         If(CARG(1:1).EQ.'-') then 
            If     (Index(CARG,'h').NE.0) then
               go to 900
            Else if(Index(CARG,'s').NE.0) then
               OPTS=.TRUE.
            Else if(Index(CARG,'r').NE.0) then
               OPTR=.TRUE.
            Else if(Index(CARG,'W').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) NW
               Else
                  I2=I2+1
                  If(I2.GT.N1) Go to 900
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) NW
               End if
            End if
         Else
            K1=K1+1   
         End if 
         I2=I2+1
         If(I2.GT.N1) Go to 20
      End do 
      
 20   If(K1.GT.0.OR.(OPTS.AND.OPTR)) go to 900
      If(NW.LE.0.OR.NW.GT.512) NW=60

 100  Return
 900  IRC=-1
      Go to 100
      End

*----------------------------------------------------------------------*
      Subroutine Prsq(CSEQ,LSEQ,NW)

      Character*512    RCOUT
      Character         CSEQ(*)

      INB=LSEQ/NW
      INR=LSEQ-INB*NW
      IN1=0
      
      Do IN2=1,INB
         Do ii1=1,NW
            RCOUT(ii1:ii1)=CSEQ(ii1+IN1)
         End do
         IN1=IN1+NW
         Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,NW)
      End do
      If(INR.GT.0) then
         Do ii1=1,INR
            RCOUT(ii1:ii1)=CSEQ(ii1+IN1)
         End do
         Write(6,'(512A)')(RCOUT(ii1:ii1),ii1=1,INR)
      End if            
      End
*----------------------------------------------------------------------*
      Include          'lblnk.f'

*----------------------------------------------------------------------*     
* $Id: xprsm.f,v 2.12 2003/12/09 13:42:42 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine JPRSM(CHID,CHAC,CHFH,OPTF,JALB,JALE)

* logical switches 

      Logical           OPTF

* sequence and profile header 
      
      Character*(*)     CHID
      Character*(*)     CHAC
      Character*(*)     CHFH

* Output fields 
      
      Character*64      CHLO
      Character*64      CHMO
      Character*64      CHMI
      Character*512     RCEX

* prepare output fields 

* - profile name (motif)

      CHMO='motif= '
      
      L1=Lblnk(CHID)
      L2=Lblnk(CHAC)
      L3=6
      If(L2-1.GT.0) then
         CHMO=CHMO(1:L3) // CHAC(1:L2)
         L3=L3+L2
      End if
      If(L1.GT.0) then
         CHMO=CHMO(1:L3) // CHID(1:L1)
      End if
      If(L2-1.LE.0.AND.L1.EQ.0) then
         CHMO=CHMO(1:6) // 'unknown'
      End if

      ILMO=Lblnk(CHMO)

* - entry-ref 

      If(OPTF) then
         L1=Lblnk(CHFH)
         If (L1.EQ.0) then
            CHMI='unknown'
            ILMI=7
         Else
            CHMI=CHFH(1:L1)
            ILMI=MIN(64,L1)
         Endif
      Else
         L1=Lblnk(CHAC)
         L2=Lblnk(CHID)
         CHMI=CHAC(1:L1) // CHID(1:L2)
         ILMI=MIN(64,L1+L2)
      End if

* - location
      Write(CHLO,*) JALB,'-',JALE
      J1=0
      Do I1=1,Lblnk(CHLO)
          If(CHLO(I1:I1).NE.' ') then 
             J1=J1+1
             CHLO(J1:J1)=CHLO(I1:I1)
             CHLO(I1:I1)=' '
          End if
      End do
      ILLO=Lblnk(CHLO)

* assemble ouput record

      LNEX=0 

      RCEX(LNEX+1:)='>' // CHMI 
      LNEX=LNEX+ILMI+2
         
      RCEX(LNEX:)='/' // CHLO
      LNEX=LNEX+ILLO+1

      RCEX(LNEX+1:)=CHMO 
      LNEX=LNEX+ILMO+1

* Write output record
      If(LNEX.GT.512) then
         LNEX=512
      End if
      Write(6,'(512A)')(RCEX(ii1:ii1),ii1=1,LNEX)

 100  Return 
      End 

*----------------------------------------------------------------------*     
* $Id: wprsm.f,v 2.13 2003/12/09 13:42:42 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine WPRSM(JSEQ,JMMA,LPMM,
     *   LUNI,LOUT,LNOR,LREV,LPFA,OPTZ,OPTL,OPLU,NW,
     *   CHID,CHAC,CHDE,OPTD,OPTR,LDRS,
     *   IOPT,JALB,JALE,NALI,IPMB,IPME,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   RNOP,KNPM,MAXN,INOR,IFUN,MNUM,LSEQ,RAVE)

* profile parameters

      Include          'codat.f'

      Real              RNOP(KNPM,MAXN)

* logical switches 

      Logical           LUNI
      Logical           LOUT
      Logical           LNOR
      Logical           LREV
      Logical           LPFA
      Logical           OPTL
      Logical           OPLU
      Logical           OPTZ 
      Logical           OPTD
      Logical           OPTR

      Logical           LPMM
      Logical           LFCL
      Logical           LDRS

* function return types

      Integer           Xblnk
      External          Xblnk

* sequence header 
      
      Character*(*)     CHID
      Character*(*)     CHAC
      Character*(*)     CHDE

* Output fields 

      Character*04      CHLE
      Character*08      CHNS
      Character*07      CHRS 
      Character*24      CHLO 
      Character*18      CHPP
      Character*64      CHER 
      Character*64      CHMI
      Character*64      CHRP

      Character*512     RCEX

* prepare output fields 

* - norm-score

      If(LNOR) then
         Call RtoN
     *      (IOPT,XOPT,RNOP,KNPM,MAXN,INOR,IFUN,LSEQ,RAVE)
         R=XOPT
         If(R.GT.9999.999) R=9999.999 
         If(R.LT.-999.999) R=-999.999
         Write(CHNS,'(F8.3)') R
      End if 

* - cut-off level

      If(OPTL.OR.OPLU) then
         LFCL=.FALSE.
         If(.NOT.OPTR) then
            KI=0
            KJ=0
            Do I1=1,JCUT
               Do I2=1,JCNM(I1)
                  If(MCUT(I2,I1).EQ.MNUM) then
                     If(KI.EQ.0) then
                        KI=I1
                        KJ=I2
                     Else if(RCUT(I2,I1).LT.RCUT(KJ,KI)) then
                        KI=I1
                        KJ=I2
                     End if
                  End if
               End do
            End do
            Do I1=1,JCUT
               Do I2=1,JCNM(I1)
                  If(MCUT(I2,I1).EQ.MNUM) then 
                     If(XOPT.GE.RCUT(I2,I1)
     *                  .AND.RCUT(I2,I1).GE.RCUT(KJ,KI)
     *                  .AND.MCLE(I1).GE.MCLE(KI)) then
                        LFCL=.TRUE.
                        KI=I1
                        KJ=I2
                     End if
                  End if
               End do
            End do
         Else
            KI=1
            Do I1=2,JCUT
               If(ICUT(I1).LT.ICUT(KI)) KI=I1
            End do 
            Do I1=1,JCUT
               If(IOPT.GE.ICUT(I1).AND.ICUT(I1).GE.ICUT(KI)
     *            .AND.MCLE(I1).GE.MCLE(KI)) then
                  LFCL=.TRUE.
                  KI=I1
               End if
            End do 
         End if 
         K=MCLE(KI)
         If(.NOT.LFCL) then
            Write(CHLE,'(''NA'')')
         Else if(OPLU) then
            CHLE=CCUT(KI)
         Else if(K.LT.0.OR.K.GT.9) then 
            Write(CHLE,'(''L='',I2)') K 
         Else
            Write(CHLE,'(''L='',I1,'' '')') K 
         End if
      End if  

* - raw-score

      I=IOPT
      If(I.GT.999999) I=999999
      If(I.LE.-99999) I=-99999
      Write(CHRS,'(I7)') I
      
* - location in sequence

      If(.NOT.LUNI.OR.LOUT) then 
         If(LREV) then 
            JALB=LSEQ-JALB+1
            JALE=LSEQ-JALE+1
         End if 
         Write(CHLO,'('' pos. '',I8,'' -'',I8)') JALB,JALE
         If(LREV) then 
            JALB=LSEQ-JALB+1
            JALE=LSEQ-JALE+1
         End if 

* - location in profile 

         If(OPTZ) then 
            Write(CHPP,'('' ['',I5,'','',I6,'']'')') IPMB,IPME
         End if
      End if 

* - entry-ref 

      L1=Lblnk(CHAC)
      L2=Lblnk(CHID)
      CHER=CHAC(1:L1) // CHID(1:L2)
      LNER=MIN(61,L1+L2)

      If(LREV) then 
         CHER=CHER(1:LNER) // '(-)' 
         LNER=LNER+3
      End if 

* - match-id

      If(LPFA.AND.NALI.GT.1) then 
         CHMI=CHID(1:L2) // '_'
         Write(CHMI(L2+2:),*) JSEQ
         J1=L2+1
         Do I1=L2+2,Lblnk(CHMI)
            If(CHMI(I1:I1).NE.' ') then 
               J1=J1+1
               CHMI(J1:J1)=CHMI(I1:I1)
            End if
         End do
         CHMI(J1+1:J1+1)=' '
         LNMI=J1
         L2=J1
      Else
         CHMI=CHID(1:L2)
         LNMI=L2
      End if

* - multiple repeat ID

*      If(LPFA.AND.LPMM) then 
*         CHMI=CHMI(1:L2) // '_REP'
*         Write(CHMI(L2+5:),*) JMMA
*         J1=L2+4
*         Do I1=L2+5,Lblnk(CHMI) 
*            If(CHMI(I1:I1).NE.' ') then 
*               J1=J1+1
*               CHMI(J1:J1)=CHMI(I1:I1)
*            End if
*         End do
*         CHMI(J1+1:J1+1)=' '
*         LNMI=J1
*      End if

* assemble ouput record

      LNEX=0 

      If(LPFA) then  
         RCEX(LNEX+1:)='>' // CHMI // ' ' 
         LNEX=LNEX+LNMI+2
      End if 

      If(OPTL.OR.OPLU) then
         RCEX(LNEX+1:)=CHLE
         LNEX=LNEX+4
         If(OPLU) LNEX=LNEX-2
      End if

      If(LNOR.AND..NOT.LDRS) then 
         RCEX(LNEX+1:)=CHNS
         LNEX=LNEX+8
      End if

      RCEX(LNEX+1:)=CHRS
      LNEX=LNEX+7

      If(.NOT.LUNI.OR.LOUT) then 
         RCEX(LNEX+1:)=CHLO
         LNEX=LNEX+24
         
         If(OPTZ) then
            RCEX(LNEX+1:)=CHPP
            LNEX=LNEX+15
         End if
      End if   

* - match ID, region nb and repeat nb for standard output and option -x
      
      If(.NOT.LPMM.AND.JMMA.GT.1) then
         Write(CHRP,*) 'REGION',JSEQ
         J1=6
         Do I1=7,Lblnk(CHRP)
            If(CHRP(I1:I1).NE.' ') then
               J1=J1+1
               CHRP(J1:J1)=CHRP(I1:I1)
            End if
         End do
         RCEX(LNEX+1:)=CHRP(1:J1)
         LNEX=LNEX+J1
      End if

      If(LPMM) then
         Write(CHRP,*) JSEQ,'REP'
         L2=Lblnk(CHRP)
         Write(CHRP(L2+1:),*) JMMA
         J1=L2
         Do I1=L2+1,Lblnk(CHRP)
            If(CHRP(I1:I1).NE.' ') then 
               J1=J1+1
               CHRP(J1:J1)=CHRP(I1:I1)
            End if
         End do
         RCEX(LNEX+1:)=CHRP(1:J1)
         LNEX=LNEX+J1
      End if

      RCEX(LNEX+2:)=CHER(1:LNER)
      LNEX=LNEX+1+LNER

      If(OPTD) then
         L3=MAX(0,MIN(NW-LNEX-1,Xblnk(CHDE,64)))
      Else
         L3=MAX(0,MIN(510-LNEX-1,Xblnk(CHDE,64)))
      End if
      RCEX(LNEX+2:)=CHDE(1:L3)
      LNEX=LNEX+1+L3

* Write output record
      Write(6,'(512A)')(RCEX(ii1:ii1),ii1=1,LNEX)

 100  Return 
      End 

*----------------------------------------------------------------------*     
* $Id: prali.f,v 2.8 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine PRALI
     *   (LPRF,CHIP,CHMP,IDMP,LSEQ,LREV,
     *   CALI,LALI,JALB,JALE,NW)

      Character*01      CHIP(0:IDMP)
      Character*01      CHMP(IDMP)
      Character*01      CALI(*)
      Logical           LREV

      Character*512     RCPR
      Character*512     RCSQ
      Character*534     RCOUT
      

* Find beginning of alignment, sequence, profile                

      JB=0
      KB=1 
      Do I1=1,LALI
         If(CALI(I1).EQ.'-') then 
            JB=JB+1
            If(JB.GT.LPRF) JB=JB-LPRF
            KB=KB+1
         Else 
            Go to   2
         End if 
      End do 
 2    LB=JALB 
  
C      Write(NERR,*) 'JB: ',JB,' KB: ',KB,' LB: ',LB

* Find end of alignment, sequence, profile                

      JE=LPRF
      KE=LALI 
      Do I1=LALI,KB+1,-1
         If(CALI(I1).EQ.'-') then 
            JE=JE-1
            KE=KE-1
         Else 
            Go to   3
         End if 
      End do 
 3    Continue
      
C      Write(NERR,*) 'JE: ',JE,' KE: ',KE,' LALI: ',LALI

* Write alignment  

      IX=0

      Do I1=KB,KE

         If(IX.GE.NW) then 
            NPE=JB
            If(.NOT.LREV) then 
               NSE=LB
C               If(RCSQ(1:1).NE.'-') NSE=NSE-1
               NSE=NSE-1
            Else
               NSE=LSEQ-LB+1 
C               If(RCSQ(1:1).NE.'-') NSE=NSE+1
               NSE=NSE+1
            End if
            NPE=NPE-LPRF-1
            NSE=NSE-LSEQ-1
            Write(6,'(''#'')')
            Write(RCOUT(1:),'(''# P'',I9,'' '')') NPB
            RCOUT(14:)=RCPR(1:NW)
            Write(RCOUT(14+NW:),'(I9)') NPE
            Write(6,'(534A)')(RCOUT(ii1:ii1),ii1=1,NW+22)
            Write(RCOUT(1:),'(''# S'',I9,'' '')') NSB
            RCOUT(14:)=RCSQ(1:NW)
            Write(RCOUT(14+NW:),'(I9)') NSE
            Write(6,'(534A)')(RCOUT(ii1:ii1),ii1=1,NW+22)
            IX=0
         End if 

         IX=IX+1
         K1=Ichar(CALI(I1))
         If     (K1.GE.65.AND.K1.LE. 90) then 
            JB=JB+1
            If(JB.GT.LPRF) JB=JB-LPRF
            LB=LB+1
            RCPR(IX:IX)=CHMP(JB)
            RCSQ(IX:IX)=CALI(I1)
         Else if(K1.GE.97.AND.K1.LE.122) then 
            LB=LB+1
            RCPR(IX:IX)=CHIP(JB)
            RCSQ(IX:IX)=CALI(I1)
         Else if(CALI(I1).EQ.'-') then 
            JB=JB+1
            If(JB.GT.LPRF) JB=JB-LPRF
            RCPR(IX:IX)=CHMP(JB)
            RCSQ(IX:IX)=CALI(I1)
         End if 
         
         If(IX.EQ.1) then
            NPB=JB
            If(K1.GE.97.AND.K1.LE.122) NPB=NPB+1 
            If(.NOT.LREV) then 
               NSB=LB
               If(RCSQ(1:1).NE.'-') NSB=NSB-1
            Else
               NSB=LSEQ-LB+1 
               If(RCSQ(1:1).NE.'-') NSB=NSB+1
            End if
         End if
         
      End do  

      If(IX.GT.0) then 
         NPE=JB
         If(.NOT.LREV) then 
            NSE=LB
C            If(RCSQ(1:1).NE.'-') NSE=NSE-1
            NSE=NSE-1
         Else
            NSE=LSEQ-LB+1 
C            If(RCSQ(1:1).NE.'-') NSE=NSE+1
            NSE=NSE+1
         End if
         NPE=NPE-LPRF-1
         NSE=NSE-LSEQ-1
         Write(6,'(''#'')')    
         RCPR(IX+1:)=' '
         RCSQ(IX+1:)=' '
         Write(RCPR(IX+1:IX+10),'(I9)') NPE
         Write(RCSQ(IX+1:IX+10),'(I9)') NSE
         IX=IX+10
         Write(6,'(''# P'',I9,'' '',512A)')
     *      NPB,(RCPR(ii1:ii1),ii1=1,IX)
         Write(6,'(''# S'',I9,'' '',512A)')
     *      NSB,(RCSQ(ii1:ii1),ii1=1,IX)
      End if
      Write(6,'(''#'')')    

      Return 
      End

*----------------------------------------------------------------------*     
* $Id: xali1.f,v 2.6 2003/01/15 14:49:05 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine XALI1
     *   (LPRF,LPCI,
     *   KCUT,IIPP,IMPP,IIPX,
     *   BSEQ,LSEQ,ISEQ,
     *   IOPM,IOPI,IOPD,
     *   IOPT,LOPT,  
     *   IRC)

* profile and sequence fields :

      Include           'ardim.f'
      Include           'gsdat.f'
      Include           'pfdat.f'
      Include           'pxdat.f'

* sequence

      Integer           LSEQ
      Integer           BSEQ
      Integer*2         ISEQ(IDMS)

* work fields

      Integer           IOPM(0:IDMP)
      Integer           IOPI(0:IDMP)
      Integer           IOPD(0:IDMP)

      Integer           KOPM

      Logical           LOPT

      IRC=0

      IOPT=NLOW

* beginning of sequence 

      IOPM(0)=IIPX(YM, 0)
      IOPI(0)=IIPX(YI, 0)
      IOPD(0)=IIPX(YD, 0)

      Do   8, I2=1,LPRF

         KD=IOPD(I2-1)+IMPP( D,I2)

         IOPM(I2)=MAX(KD+IIPP(DM,I2), 
     *      IIPX(YM,I2))  
         IOPI(I2)=MAX(KD+IIPP(DI,I2), 
     *      IIPX(YI,I2))  
         IOPD(I2)=MAX(KD+IIPP(DD,I2), 
     *      IIPX(YD,I2))  
 8    Continue

* - circular extensions:

      If(LPCI) then
         IOPM( 0)=MAX(IOPM( 0),IOPM(LPRF))
         IOPI( 0)=MAX(IOPI( 0),IOPI(LPRF))
         IOPD( 0)=MAX(IOPD( 0),IOPD(LPRF))

         Do   9, I2=1, LPRF
            KD=IOPD(I2-1)+IMPP( D,I2)
            If(IOPD(I2).GE.KD+IIPP(DD,I2)) then
               Go to 10
            Else  
               IOPM(I2)=MAX(KD+IIPP(DM,I2),IOPM(I2))
               IOPI(I2)=MAX(KD+IIPP(DI,I2),IOPI(I2))
               IOPD(I2)=    KD+IIPP(DD,I2)
            End if
 9       Continue    
 10      Continue
      End if 

* -----------------------------------------------------------

* internal sequence positions

      Do  50 I1=BSEQ,LSEQ-1

         J1=ISEQ(I1)
         KI=IOPI( 0)+IIPP(J1, 0)

         KOPM=IOPM( 0)

         IOPM( 0)=MAX(KI+IIPP(IM, 0),IIPX(XM, 0))  
         IOPI( 0)=MAX(KI+IIPP(II, 0),IIPX(XI, 0))  
         IOPD( 0)=MAX(KI+IIPP(ID, 0),IIPX(XD, 0))  
         IOPT    =MAX(KI+IIPX(IX, 0),IOPT) 

* - circular match extensions (presumably not necessary)

C             If(LPCI) then 
C                KM=IOPM(LPRF-1)+IMPP(J1,LPRF)
C                IOPM( 0)=MAX(IOPM( 0),KM+IIPP(MM, 0))                   
C                IOPI( 0)=MAX(IOPI( 0),KM+IIPP(MI, 0))                   
C                IOPD( 0)=MAX(IOPD( 0),KM+IIPP(MD, 0))                   
C                IOPT    =MAX(IOPT    ,KM+IIPX(MX, 0)) 
C             End if
* -----------------------------------------------------------

 20      Continue


         Do  38 I2=1,LPRF

            KM=KOPM      +IMPP(J1,I2)
            KI=IOPI(I2  )+IIPP(J1,I2)
            KD=IOPD(I2-1)+IMPP( D,I2)

            KOPM=IOPM(I2)

            IOPM(I2)=MAX(KM+IIPP(MM,I2), 
     *         KI+IIPP(IM,I2), 
     *         KD+IIPP(DM,I2), 
     *         IIPX(XM,I2))  
            IOPI(I2)=MAX(KM+IIPP(MI,I2), 
     *         KI+IIPP(II,I2), 
     *         KD+IIPP(DI,I2), 
     *         IIPX(XI,I2))  
            IOPD(I2)=MAX(KM+IIPP(MD,I2), 
     *         KI+IIPP(ID,I2), 
     *         KD+IIPP(DD,I2), 
     *         IIPX(XD,I2))  

            IOPT    =MAX(IOPT,
     *         KM+IIPX(MX,I2),
     *         KI+IIPX(IX,I2),
     *         KD+IIPX(DX,I2))

 38      Continue

* - circular extensions

         If(LPCI) then
            
            IOPM( 0)=MAX(IOPM( 0),IOPM(LPRF))
            IOPI( 0)=MAX(IOPI( 0),IOPI(LPRF))
            IOPD( 0)=MAX(IOPD( 0),IOPD(LPRF))
            
            Do  39, I2=1,LPRF
               KD=IOPD(I2-1)+IMPP( D,I2)
               If(IOPD(I2).GE.KD+IIPP(DD,I2)) then 
                  Go to  40
               Else
                  IOPM(I2)=MAX(KD+IIPP(DM,I2),IOPM(I2))
                  IOPI(I2)=MAX(KD+IIPP(DI,I2),IOPI(I2)) 
                  IOPD(I2)=MAX(KD+IIPP(DD,I2),IOPD(I2)) 
                  IOPT    =MAX(KD+IIPX(DX,I2),IOPT)
               End if
 39         Continue
 40         Continue
* -----------------------------------------------------------

         End if 

         If(.NOT.LOPT.AND.IOPT.GE.KCUT) go to 100

 50   Continue

* end of sequence 

      J1=ISEQ(LSEQ)

      KI=IOPI( 0)+IIPP(J1, 0)

      KOPM=IOPM( 0)

      IOPD( 0)=MAX(KI+IIPP(ID, 0),IIPX(XD, 0))  
      IOPT    =MAX(KI+IIPX(IY, 0),IOPT       ) 

* - circular match extension (presumably not necessary)

C             If(LPCI) then
C                KM=IOPM(LPRF-1)+IIPP(J1,LPRF)
C                IOPD( 0)=MAX(IOPD( 0),KM+IIPP(MD, 0))
C                IOPT    =MAX(IOPT,    KM+IIPP(MY, 0))
C             End if
* -----------------------------------------------------------

 60   Continue

      Do  68 I2=1,LPRF

         KM=KOPM      +IMPP(J1,I2)
         KI=IOPI(I2  )+IIPP(J1,I2)
         KD=IOPD(I2-1)+IMPP( D,I2)

         KOPM=IOPM(I2)

         IOPD(I2)=MAX(KM+IIPP(MD,I2), 
     *      KI+IIPP(ID,I2), 
     *      KD+IIPP(DD,I2), 
     *      IIPX(XD,I2))  

         IOPT    =MAX(IOPT,
     *      KM+IIPX(MY,I2),
     *      KI+IIPX(IY,I2),
     *      KD+IIPX(DY,I2))

 68   Continue

* - circular extensions

      If(LPCI) then

         IOPD( 0)=MAX(IOPD( 0),IOPD(LPRF))

         Do  69, I2=1,LPRF
            KD=IOPD(I2-1)+IMPP( D,I2)
            If(IOPD(I2).GE.KD+IIPP(DD,I2)) then 
               Go to 100 
            Else  
               IOPD(I2)=MAX(KD+IIPP(DD,I2),IOPD(I2))
               IOPT    =MAX(KD+IIPP(DY,I2),IOPT    )
            End if
 69      Continue

      End if 
* -----------------------------------------------------------

 100  Return

      End 

*----------------------------------------------------------------------*     
* $Id: rhnul.f,v 2.5 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine RHNUL(NNUL,FNUL,FABC,NABC,IRC)   

      Include          'sterr.f'

      Character*(*)     FNUL 

      Real              FABC(0:26)

      Character*512     RCIN
      Character*512     CBUF     
      Integer           IOST

      IOST=0

      Open(NNUL,File=FNUL,Status='OLD',Err=900)

 1    Read(NNUL,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:1).EQ.'#') Go to   1

      If(RCIN(1:5).EQ.'Amino'.AND.NABC.LT.20) then
         Go to 903
      Else if(RCIN(1:5).EQ.'Amino'.AND.NABC.GE.20) then
         Continue
      Else if(RCIN(1:7).EQ.'Nucleic'.AND.NABC.NE.4) then
         Go to 903
      Else if(RCIN(1:7).EQ.'Nucleic'.AND.NABC.EQ.4) then
         Continue
      Else 
         Go to 1
      End if 

      M=0
 2    RCIN=' '
      Read(NNUL,'(A)',Err=901,Iostat=IOST) RCIN
      If(IOST.NE.0.AND.RCIN.EQ.' ') Go to 5
      If(RCIN(1:1).EQ.'#'.OR.Lblnk(RCIN).EQ.0) Go to   2
      
      L=Index(RCIN,'#')
      If(L.EQ.0) then 
         L=Lblnk(RCIN)
      Else
         L=Lblnk(RCIN(1:L-1))
      End if 
      CBUF(M+1:)=RCIN(1:L)
      M=M+L+1
      If(M.GT.512) Go to 907
      Go to 2
      
 5    Read(CBUF(1:M+1),*,End=905,Err=906)(FABC(ii1),ii1=1,NABC)
 
 100  Return

 900  Write(NERR,*) 'Error: Unable to open random model file'//
     *   ' ''',FNUL(1:Lblnk(FNUL)),'''.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Unable to read random model file'//
     *   ' ''',FNUL(1:Lblnk(FNUL)),'''.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: Unexpected end of file. '//
     *      'Unable to read random model.'
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Random model alphabet does not match '//
     *      'profile alphabet.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100
 905  Write(NERR,*) 'Error: Not enough values in random model.'
      Write(NERR,*) '       values read: ',
     *   CBUF(1:Lblnk(CBUF))
      IRC=1
      Go to 100
 906  Write(NERR,*) 'Error: Unable to read random model values.'
      IRC=1
      Go to 100
 907  Write(NERR,*) 'Error: Random model exceeds buffer size.'
      Write(NERR,*) '       at line: ',
     *   CBUF(1:Lblnk(CBUF))
      IRC=1
      Go to 100

      End

*       Program pfscale
*----------------------------------------------------------------------*
* $Id: pfscale.f,v 2.11 2003/11/28 11:53:33 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Fits paramters of an extreme value distribution to a
*                 profile score distribution. Input: sorted score list.
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

* array sizes, I/O units

      Include          'ardim.f'

      Parameter        (NOUT=   6)
      Parameter        (NSCL=  10)
      Parameter        (NPRF=  11)


* function return types

      Integer           Xblnk
      External          Xblnk

* Parameters and options

      Character*4096    FSCL
      Character*4096    FPRF

      Real*8            DL
      Integer           NN
      Integer           IMNB
      Real              RP
      Real              RQ

* Profile fields

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'
      Include          'sterr.f'
      Include          'cvini.f'

* score statistics

      Real              XSCO(IDMC)
      Real              XFRQ(IDMC)
      Real              XWGT(IDMC)
      Logical           LMNB
      Logical           LLLT
      Logical           LRNM
      Logical           LEOF

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      IRC=0
      LRNM=.FALSE.
      LEOF=.FALSE.

* read command line

      Call Repar(FSCL,FPRF,LLLT,DL,NN,RP,RQ,LMNB,IMNB,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''pfscale 2.3 revision 5.d'',//
     *      ''Usage: pfscale [ -lhLMNPQ ] [ score-list | - ] ''
     *      ''[ profile-file ] [ parameters ]'',/
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -h: print usage help text.'',/
     *      ''    -l: do not impose limit on line length.'',/
     *      ''    -L<value>:'',/
     *      ''        logarithmic base of parameters (default: 10).'',/
     *      ''    -M<value>:'',/
     *      ''        profile mode number to scale.'',/
     *      ''    -N<value>:'',/
     *      ''        database size (default: 14147368).'',/
     *      ''    -P<value>:'',/
     *      ''        upper threshold of probability range (default:'',
     *      '' 0.0001).'',/
     *      ''    -Q<value>:'',/
     *      ''        lower threshold of probability range (default:'',
     *      '' 0.000001).'',/
     *      )')
         Write(NERR,'(
     *      ''   valid (but deprecated) parameters are:'',/,
     *      ''    [L=log-base]        use option -L instead'',/,
     *      ''    [M=mode-nb]         use option -M instead'',/,
     *      ''    [N=db-size]         use option -N instead'',/,
     *      ''    [P=upper-threshold] use option -P instead'',/
     *      ''    [Q=lower-threshold] use option -Q instead'',/
     *      )')
         Call Exit(IRC)
      End if

      If(FSCL.NE.' '.AND.FSCL.NE.'-') then
         MSCL=NSCL
         Open(MSCL,File=FSCL,Status='OLD',Err=900)
      Else
         MSCL=5
      End if

      RL=1/LOG(DL)

      RDBS=RL*LOG(Real(NN))
      If(RQ.NE.0) then
         EMAX=-RL*(LOG(RQ))
      Else
         EMAX=100
      End if
      EMIN=-RL*(LOG(RP))

      Do   5 I1=1,IDMC
         Read(MSCL,*,End= 10,Err=901) XSCO(I1)
         XFRQ(I1)=RDBS-RL*LOG(I1-0.5)
         XWGT(I1)=I1*0.5
 5    Continue

 10   NSCO=I1-1
      If(NSCO.LT.1) Go to 904

      XSM=0
      XFM=0
      XWM=0
      Do  20 I1=1,NSCO
         If(XFRQ(I1).GE.EMIN.AND.XFRQ(I1).LE.EMAX) then
            XSM=XSM+XWGT(I1)*XSCO(I1)
            XFM=XFM+XWGT(I1)*XFRQ(I1)
            XWM=XWM+XWGT(I1)
         End if
 20   Continue
      XSM=XSM/XWM
      XFM=XFM/XWM


      XSV=0
      XFV=0
      XCO=0
      Do  30 I1=1,NSCO
         If(XFRQ(I1).GE.EMIN.AND.XFRQ(I1).LE.EMAX) then
            XSV=XSV+XWGT(I1)*( (XSCO(I1)-XSM)**2 )
            XFV=XFV+XWGT(I1)*( (XFRQ(I1)-XFM)**2 )
            XCO=XCO+XWGT(I1)*(XFRQ(I1)-XFM)*(XSCO(I1)-XSM)
         End if
 30   Continue
      XSV=(XSV/XWM)**0.5
      XFV=(XFV/XWM)**0.5
      XCO=(XCO/XWM)/(XFV*XSV)

      XB=XCO*XFV/XSV
      XA=XFM-XB*XSM

      If(FPRF.NE.' ') Go to  50

* Case 1: no profile input file - print list

      Write(NOUT,
     *   '(''# -LogP ='',F8.4,'' + '',F12.8,'' * raw-score'')') XA,XB

      Write(NOUT,'(''#'')')
      Write(NOUT,'(''#   rank raw-score  -logFreq  -logProb'')')
      Write(NOUT,'(''#'')')

      Do  40 I1=1,NSCO
         XPRE=XA+XB*XSCO(I1)
         Write(NOUT,'(I8,F10.2,F10.4,F10.4)')
     *      I1,XSCO(I1),XFRQ(I1),XPRE
 40   Continue
      Go to 100

* Case 2: Modify profile input file

 50   Continue

      Call REPRF
     *   (NPRF,FPRF,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   BLOG,FABC,P0,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,CHIL,IIPL,ILIP,
     *   CHID,IIPD,CHMD,IMPD,
     *   INBP,LEOF,.FALSE.,IRC)

      If(IRC.NE.0) go to 100

* Check normalization modes (Lowest priority mode will be updated)

      If(LMNB) then
         Do I1=1,JNOR
            If(NNOR(I1).EQ.IMNB) then
               J1=I1
               Go to 55
            End if
         End do
         Go to 903
      Else
         J1=1
         K1=NNPR(J1)
         Do I1=2,JNOR
            If(NNPR(I1).LT.K1) then
               K1=NNPR(I1)
               J1=I1
            End if
         End do
      End if

 55   CNTX(J1)='-LogE'
      If(MNOR(J1).NE.1) go to 902

* add normalisation parameters:

      RNOP(1,J1)=XA
      RNOP(2,J1)=XB

* define cut-offs:

      Do I1=1,JCUT
         Do I2=1,JCNM(I1)
            If(MCUT(I2,I1).EQ.NNOR(J1)) then
               Call NtoR
     *            (RCUT(I2,I1),ICUT(I1),RNOP,KNPM,MAXN,J1,1,LSEQ,RAVE)
               Go to 60
            End if
         End do
 60      Continue
      End do

* rescaling command

      LFTR=LFTR+1
      If(LFTR.GT.1024) LFTR=1024
      Do I1=LFTR,2,-1
         CFTR(I1)=CFTR(I1-1)
      End do

      CFTR(1)='CC   /RESCALED_BY="'
      Call Recmd(CFTR(1)(21:130))
      IC=Lblnk(CFTR(1))
      CFTR(1)(IC+1:)='";'

* write profile

      Call WRPRF
     *   (NOUT,LLLT,LRNM,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   BLOG,FABC,P0,
     *   CHID,IIPD,CHMD,IMPD,
     *   IRC)

 100  Call Exit(IRC)

* errors

 900  Write(NERR,*) 'Error: Unable to open score file'//
     *   ' ''',FSCL(1:Lblnk(FSCL)),'''.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Unable to read score value.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: Normalization mode number',NNOR(J1),
     *   ' is not linear. Scaling impossible.'
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Normalization mode number',IMNB,
     *   ' is not defined in profile.'
      IRC=1
      Go to 100
 904  Write(NERR,*) 'Error: Score list does not contain any ',
     *   'valid scores.'
      IRC=1
      Go to 100

      End
*----------------------------------------------------------------------*
      Subroutine Repar(FSCL,FPRF,LLLT,DL,NN,RP,RQ,LMNB,IMNB,IRC)

      Include          'sterr.f'

      Character*(*)     FSCL
      Character*(*)     FPRF

      Real*8            DL
      Integer           NN
      Real              RP
      Real              RQ
      Logical           LLLT
      Logical           LMNB
      Integer           IMNB

      Character*4096    CARG

* initializations

      LLLT=.TRUE.
      LLLT=.FALSE.
      IMNB=1
      FSCL=' '
      FPRF=' '
      DL=10.0
      NN=14147368
      RP=0.0001
      RQ=0.000001
      IRC=0

* interpret command line arguments

      N1=Iargc()

      K1=0
      I2=1
      Do I1=1,N1
         Call GetArg(I2,CARG)
         If     (CARG(1:1).EQ.'-'.AND.CARG(2:2).NE.' ') then
            If(Index(CARG,'l').NE.0) LLLT=.FALSE.
            If(Index(CARG,'h').NE.0) go to 900
            If(Index(CARG,'L').NE.0) then
               If(CARG(3:3).NE.' ') then
                  If(CARG(3:3).EQ.'e'.OR.CARG(3:3).EQ.'E') then
                     DL=EXP(1.0)
                  Else
                     Read(CARG(3:),*,Err=900) DL
                  End if
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  If(CARG(1:1).EQ.'e'.OR.CARG(1:1).EQ.'E') then
                     DL=EXP(1.0)
                  Else
                     Read(CARG,*,Err=900) DL
                  End if
               End if
            End if
            If(Index(CARG,'N').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) NN
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) NN
               End if
            End if
            If(Index(CARG,'P').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RP
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RP
               End if
            End if
            If(Index(CARG,'Q').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RQ
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RQ
               End if
            End if
            If(Index(CARG,'M').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) IMNB
                  LMNB=.TRUE.
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) IMNB
                  LMNB=.TRUE.
               End if
            End if

         Else if(CARG(1:3).EQ.'L=e'.OR.CARG(1:3).EQ.'L=E') then
            DL=EXP(1.0)
         Else if(CARG(1:2).EQ.'L=') then
            Read(CARG(3:),*,Err=900) DL
         Else if(CARG(1:2).EQ.'N=') then
            Read(CARG(3:),*,Err=900) NN
         Else if(CARG(1:2).EQ.'P=') then
            Read(CARG(3:),*,Err=900) RP
         Else if(CARG(1:2).EQ.'Q=') then
            Read(CARG(3:),*,Err=900) RQ
         Else if(CARG(1:2).EQ.'M=') then
            Read(CARG(3:),*,Err=900) IMNB
            LMNB=.TRUE.
         Else if(K1.LE.1) then
            K1=K1+1
            If     (K1.EQ.1) then
               FSCL=CARG
            Else if(K1.EQ.2) then
               FPRF=CARG
            End if
C         Else
C            Go to 900
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 20
      End do

 20   If(DL.LE.1) Go to 901
      If(NN.LT.1) Go to 902
      If(RP.LT.0.OR.RP.GT.1) Go to 903
      If(RQ.LT.0.OR.RQ.GT.1) Go to 904
      If(LMNB.AND.IMNB.LT.1) Go to 905
 100  Return
 900  IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Value of option -L is out of bound.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: Value of option -N is out of bound.'
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Value of option -P is out of bound.'
      IRC=1
      Go to 100
 904  Write(NERR,*) 'Error: Value of option -Q is out of bound.'
      IRC=1
      Go to 100
 905  Write(NERR,*) 'Warning: Mode numbers should be greater or ',
     *   'equal to 1.'
      Go to 100
      End
*----------------------------------------------------------------------*
      Include          'reprf.f'
      Include          'wrprf.f'
      Include          'recmd.f'
      Include          'NtoR.f'
      Include          'lblnk.f'
      Include          'Xblnk.f'

*----------------------------------------------------------------------*     
* $Id: rhmmer.f,v 2.5 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine RHMMER(NPRF,FPRF,LPRF,RIHM,RMHM,IDMP,NABC,CABC,
     *   INBP,IRC)

      Include          'pfind.f' 
      Include          'sterr.f'

      Character*(*)     FPRF

      Include          'hmdat.f'

      Character         CABC(0:26)

      Character*512     RCIN
      Character*32      CMIS

* initializatons 
      
      IRC=0

* open HMM file

      If(FPRF.NE.'-') then
         Open(NPRF,File=FPRF,Status='OLD',Err=900)
      End if

* read header lines

 1    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:8).EQ.'HMMER2.0') Go to 910
      If(RCIN(1:1).EQ.'#') Go to   1
      CMIS='profile length'
      Read(RCIN,*,Err=903,End=903) LPRF 
      If(LPRF.GT.IDMP) Go to 904

 2    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:1).EQ.'#') Go to   2
      CMIS='alphabet length'
      Read(RCIN,*,Err=903,End=903) NABC
      If(NABC.GT.26) Go to 904

 3    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:1).EQ.'#') Go to   3

 4    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:1).EQ.'#') Go to   4
      CMIS='alphabet'
      Read(RCIN,'(26A)',Err=903,End=903)
     *   (CABC(ii1),ii1=1,NABC)

 5    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:1).EQ.'#') Go to   5

 6    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:1).EQ.'#') Go to   6

* read model parameters

      CMIS=' '
      Do I1=0,LPRF

* - match state

         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(MM,I1)
         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(MD,I1)
         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(MI,I1)

         Do I2=1,NABC
            If(next(NPRF,RCIN).NE.0) Go to 902
            Read(RCIN,*,Err=903) RMHM(I2,I1)
         End do 

* - delete state

         If(next(NPRF,RCIN).NE.0) Go to 902
         Read(RCIN,*,Err=903) RIHM(DM,I1)
         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(DD,I1)
         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(DI,I1)

         RMHM( D,I1)=1.0

* - insert state

         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(IM,I1)
         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(ID,I1)
         If(next(NPRF,RCIN).NE.0) Go to 902 
         Read(RCIN,*,Err=903) RIHM(II,I1)

         Do I2=1,NABC
            If(next(NPRF,RCIN).NE.0) Go to 902 
            Read(RCIN,*,Err=903) RIHM(I2,I1)
         End do 

      End do 

 100  Return

 900  Write(NERR,*) 'Error: Unable to open profile file'//
     *   ' ''',FPRF(1:Lblnk(FPRF)),'''.'
      IRC=1
      Go to 100

 901  Write(NERR,*) 'Error: Unable to read profile file'//
     *   ' ''',FPRF(1:Lblnk(FPRF)),'''.'
      IRC=1
      Go to 100

 902  Write(NERR,*) 'Error: Unexpected end of file.'
      Write(NERR,*) '       No profile read.'
      IRC=1
      Go to 100

 903  Write(NERR,*) 'Error: Unable to read value of parameter(s) '//
     *   CMIS(1:Lblnk(CMIS))
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100

 904  Write(NERR,*) 'Error: Value of parameter '''//
     *   CMIS(1:Lblnk(CMIS)),''' exceeds buffer size.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100

 910  Write(NERR,*) 'Error: HMM profile file in wrong format.'//
     *   ' Try without option -o.'
      IRC=1
      Go to 100

      End
*----------------------------------------------------------------------*
      Integer function next(NPRF,RCIN)

      Character*(*)     RCIN       

 1    Read(NPRF,'(A)',Iostat=NEXT) RCIN
      If(RCIN(1:1).EQ.'#') go to   1
      Return

      End

*       Program ptof
*----------------------------------------------------------------------*
* $Id: ptof.f,v 2.12 2003/12/01 13:33:04 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: converts a protein profile into a framesearch profile
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

* array dimensions and I/O units

      Include          'ardim.f'

      Parameter        (NOUT=   6)

      Parameter        (NPRF=  11)
      Parameter        (NNUL=  12)

* profile

      Character*4096    FPRF

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'

      Include          'sterr.f'


* function return types

      Integer           Xblnk
      External          Xblnk

* parameters and options

      Logical           OPTR
      Logical           LLLT

      Real              RB
      Real              RF
      Real              RI
      Real              RX
      Real              RY
      Real              RZ

      Integer           INBP
      Logical           LEOF
      Logical           LRNM

* initialization of controlled vocabularies

      Include          'cvini.f'

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      IRC=0
      FPRF='stdout'
      LRNM=.FALSE.
      INBP=0

* command line arguments

      Call Repar(FPRF,OPTR,LLLT,RB,RF,RI,RX,RY,RZ,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''ptof 2.3 revision 5.d'',//
     *      ''Usage: ptof [ -hlrBFIXYZ ] [ profile | - ] '',
     *      ''[ parameters ]'',//
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -h: print usage help text.'',/
     *      ''    -l: do not impose limit on line length.'',/
     *      ''    -r: parameters given as normalized score units.''
     *      )')
         Write(NERR,'(
     *      ''    -B<value>:'',/
     *      ''        minimal initiation/termination score (default: '',
     *      ''-50 or -0.5 with option -r).'',/
     *      ''    -F<value>:'',/
     *      ''        frameshift error penalty (default: '',
     *      ''-100 or -1.0 with option -r).'',/
     *      ''    -I<value>:'',/
     *      ''        insert score multiplier (default: 1/3).'',/
     *      ''    -X<value>:'',/
     *      ''        stop codon penalty (default: '',
     *      ''-100 or -1.0 with option -r).'',/
     *      ''    -Y<value>:'',/
     *      ''        intron opening penalty (default: '',
     *      ''-300 or -3.0 with option -r).'',/
     *      ''    -Z<value>:'',/
     *      ''        intron extension penalty (default: '',
     *      ''-1 or -0.01 with option -r).'',/
     *      )')
         Write(NERR,'(
     *      ''   valid (but deprecated) parameters are:'',/,
     *      ''    [B=min-beg-end-score]   use option -B instead'',/
     *      ''    [F=deletion-frameshift] use option -F instead'',/
     *      ''    [I=insert-score-mult]   use option -I instead'',/
     *      ''    [X=stop-codon-score]    use option -X instead'',/
     *      ''    [Y=intron-open-penalty] use option -Y instead'',/
     *      ''    [Z=intron-ext-penalty]  use option -Z instead'',/
     *      )')
         Call Exit(IRC)
      End if

* read profile

      If(FPRF.EQ.'-') then
         MPRF=5
      Else
         MPRF=NPRF
      End if

      Call REPRF
     *   (MPRF,FPRF,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   BLOG,FABC,P0,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,CHIL,IIPL,ILIP,
     *   CHID,IIPD,CHMD,IMPD,
     *   INBP,LEOF,.FALSE.,IRC)

      If(IRC.NE.0) go to 100

* expanded profile size check

      If(LPRF*3.GT.IDMP) go to 901
      If(NABC.LE.4) go to 920

* add command-line to footer lines

 10   Continue
      LFTR=LFTR+1
      If(LFTR.GT.1024) LFTR=1024
      Do I1=LFTR,2,-1
         CFTR(I1)=CFTR(I1-1)
      End do

      CFTR(1)='CC   /GENERATED_BY="'
      Call Recmd(CFTR(1)(21:130))
      IC=Lblnk(CFTR(1))
      CFTR(1)(IC+1:)='";'

*----------------------------------------------------------------------*
* CONVERSION SECTION
*----------------------------------------------------------------------*

* Adjust frame search parameters to normalization function

      If(OPTR) then
         R2=0.01
         K1=1
         J1=NNPR( 1)
         Do I1=2,JNOR
            If(NNPR(I1).LT.J1) then
               K1=I1
               JN=NNPR(I1)
            End if
         End do
         If(MNOR(K1).EQ.1) R2=RNOP(2,K1)

         RB=RB / R2
         RF=RF / R2
         RX=RX / R2
         RY=RY / R2
         RZ=RZ / R2
      End if

* Expand alphabet

      NABC=NABC+1
      CABC(NABC)='O'
      NX=NINT(RX)
      J2=0
      Do I2=1,NABC-1
         J2=J2+IIPD(I2)
      End do
      IIPD(NABC)=J2/(NABC-1)
      J2=0
      Do I2=1,NABC-1
         J2=J2+IIPP(I2,0)
      End do
      IIPP(NABC,0)=J2/(NABC-1)
      Do I1=1,LPRF
         IMPP(NABC,I1)=NX
         J2=0
         Do I2=1,NABC-1
            J2=J2+IIPP(I2,I1)
         End do
         IIPP(NABC,I1)=J2/(NABC-1)
      End do

* - default begin, end score

      IIPD(B0)=MAX(IIPD(B0),NINT(RB))
      IIPD(B1)=MAX(IIPD(B1),NINT(RB))
      IIPD(E0)=MAX(IIPD(E0),NINT(RB))
      IIPD(E1)=MAX(IIPD(E1),NINT(RB))

* - eliminate II transitions

      Do I1=0,LPRF
         If(IIPP(BI,I1).NE.NLOW) IIPP(BI,I1)=IIPP(BI,I1)-IIPP(II,I1)
         If(IIPP(MI,I1).NE.NLOW) IIPP(MI,I1)=IIPP(MI,I1)-IIPP(II,I1)
         If(IIPP(DI,I1).NE.NLOW) IIPP(DI,I1)=IIPP(DI,I1)-IIPP(II,I1)
         Do I2=0,26
            If(IIPP(I2,I1).NE.NLOW)
     *         IIPP(I2,I1)=IIPP(I2,I1)+IIPP(II,I1)
         End do
         IIPP(II,I1)=0
      End do

* Expand profile

* -define architecture of profile according to topology

      If(LPCI) then
         NBB=1
         NB=2
         NE=3*LPRF-1
         NEE=3*LPRF
      Else
         NBB=1
         NB=1
         NE=3*LPRF-2
         NEE=3*LPRF-2
      End if

* - move last insert position to new end of profile

      Do I1=0,46
         IIPP(I1,NEE)=IIPP(I1,LPRF)
      End do
      CHIP(NEE)=CHIP(LPRF)

* - move other positions

      K1=NE
      Do I1=LPRF,1,-1
         Do I2=0,27
            IMPP(I2,K1)=IMPP(I2,I1)
         End do
         CHMP(K1)=CHMP(I1)
         K1=K1-3
      End do

      K1=NE-2
      Do I1=LPRF-1,1,-1
         Do I2= 0,26
            IIPP(I2,K1)=NINT(IIPP(I2,I1)*RI)
         End do
         Do I2=27,46
            IIPP(I2,K1)=IIPP(I2,I1)
         End do
         CHIP(K1)=CHIP(I1)
         K1=K1-3
      End do

* - fill in m-1, m+1 positions

      Do I1=NB+1,NEE,3
         Do I2=0,27
            IMPP(I2,I1)=0
         End do
         CHMP(I1)='>'
      End do

      J1=NB-1
      If(J1.LE.0) J1=J1+3
      Do I1=J1,NEE,3
         Do I2=0,27
            IMPP(I2,I1)=0
         End do
         CHMP(I1)='<'
      End do

*- fill i-1 position

      Do I2= 0,26
         IIPP(I2,NB)=0
      End do
      Do I2=27,46
         IIPP(I2,NB)=NLOW
      End do
      IIPP(MM,NB)=0
      IIPP(DD,NB)=0
      IIPP(MI,NB)=NINT(RF/2)
      IIPP(II,NB)=NINT(RF)
      IIPP(IM,NB)=NINT(RF/2)
      CHIP(NB)='*'
      Do I1=NB+3,NEE-1,3
         Do I2= 0,47
            IIPP(I2,I1)=IIPP(I2,NB)
         End do
         CHIP(I1)='*'
      End do

* - fill i+1 position

      J1=3
      If(LPCI) J1=1
      Do I2= 0,26
         IIPP(I2,J1)=0
      End do
      Do I2=27,46
         IIPP(I2,J1)=NLOW
      End do
      IIPP(MM,J1)=0
      IIPP(DD,J1)=0
      IIPP(MI,J1)=NINT(RY/2)
      IIPP(II,J1)=MIN(-1,NINT(RZ))
      IIPP(IM,J1)=NINT(RY/2)
      CHIP(J1)=':'
      Do I1=J1+3,NEE-1,3
         Do I2=0,46
            IIPP(I2,I1)=IIPP(I2,J1)
         End do
         CHIP(I1)=':'
      End do

* frameshift deletetion scores:

      J1=2
      If(LPCI) J1=1
      K1=3
      If(LPCI) K1=1
      Do I1=J1,LPRF-1
         IIPP(MD,K1)=(NINT(RF-IMPP( D,K1+1))/2)
         IIPP(DM,K1+1)=NINT(RF-IIPP(MD,K1)-IMPP( D,K1+1))
         K1=K1+3
      End do

* begin and end scores

      If(.NOT.LPCI) then
         Do I1=2,NEE,3
            IIPP(B0,I1-1)=IIPP(B0,I1)
            IIPP(B1,I1-1)=IIPP(B1,I1)
            IIPP(BM,I1-1)=IIPP(BM,I1)
            IIPP(BI,I1-1)=IIPP(BI,I1)
            IIPP(BD,I1-1)=IIPP(BD,I1)
            IIPP(E0,I1-1)=IIPP(E0,I1)
            IIPP(E1,I1-1)=IIPP(E1,I1)
            IIPP(ME,I1-1)=IIPP(ME,I1)
            IIPP(IE,I1-1)=IIPP(IE,I1)
            IIPP(DE,I1-1)=IIPP(DE,I1)
            IIPP(B0,I1+1)=IIPP(B0,I1)
            IIPP(B1,I1+1)=IIPP(B1,I1)
            IIPP(BM,I1+1)=IIPP(BM,I1)
            IIPP(BI,I1+1)=IIPP(BI,I1)
            IIPP(BD,I1+1)=IIPP(BD,I1)
            IIPP(E0,I1+1)=IIPP(E0,I1)
            IIPP(E1,I1+1)=IIPP(E1,I1)
            IIPP(ME,I1+1)=IIPP(ME,I1)
            IIPP(IE,I1+1)=IIPP(IE,I1)
            IIPP(DE,I1+1)=IIPP(DE,I1)
         End do
      Else
         Do I1=2,NEE,3
            IIPP(B0,I1-1)=IIPP(B0,I1-2)
            IIPP(B1,I1-1)=IIPP(B1,I1-2)
            IIPP(BM,I1-1)=IIPP(BM,I1-2)
            IIPP(BI,I1-1)=IIPP(BI,I1-2)
            IIPP(BD,I1-1)=IIPP(BD,I1-2)
            IIPP(E0,I1-1)=IIPP(E0,I1-2)
            IIPP(E1,I1-1)=IIPP(E1,I1-2)
            IIPP(ME,I1-1)=IIPP(ME,I1-2)
            IIPP(IE,I1-1)=IIPP(IE,I1-2)
            IIPP(DE,I1-1)=IIPP(DE,I1-2)
            IIPP(B0,I1  )=IIPP(B0,I1+1)
            IIPP(B1,I1  )=IIPP(B1,I1+1)
            IIPP(BM,I1  )=IIPP(BM,I1+1)
            IIPP(BI,I1  )=IIPP(BI,I1+1)
            IIPP(BD,I1  )=IIPP(BD,I1+1)
            IIPP(E0,I1  )=IIPP(E0,I1+1)
            IIPP(E1,I1  )=IIPP(E1,I1+1)
            IIPP(ME,I1  )=IIPP(ME,I1+1)
            IIPP(IE,I1  )=IIPP(IE,I1+1)
            IIPP(DE,I1  )=IIPP(DE,I1+1)
         End do
      End if

      Do I1=NBB,NEE-1
         IIPP(B0,I1)=MAX(IIPD(B0),IIPP(B0,I1))
         IIPP(B1,I1)=MAX(IIPD(B1),IIPP(B1,I1))
         IIPP(E0,I1)=MAX(IIPD(E0),IIPP(E0,I1))
         IIPP(E1,I1)=MAX(IIPD(E1),IIPP(E1,I1))
      End do

* disjointness definition

      If(MDIS.EQ.2) then
         NDIP(1)=NDIP(1)*3-2
         NDIP(2)=NDIP(2)*3-2
      End if

* adjust length

      LPRF=NEE

*----------------------------------------------------------------------*
* OUTPUT SECTION
*----------------------------------------------------------------------*

* write profile

      Call WRPRF
     *   (NOUT,LLLT,LRNM,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   BLOG,FABC,P0,
     *   CHID,IIPD,CHMD,IMPD,
     *   IRC)

 100  Call Exit(IRC)

* errors

 901  Write(NERR,*) 'Error: Expanded profile length exceeds buffer ',
     *   'size (',IDMP,').'
      IRC=1
      Go to 100

* warnings

 920  Write(NERR,*) 'Warning: Profile seems to be DNA. Check input '//
     *   'file.'
      Go to 10

      End
*----------------------------------------------------------------------*
      Subroutine Repar
     *   (FPRF,OPTR,LLLT,RB,RF,RI,RX,RY,RZ,IRC)

      Character*(*)     FPRF
      Character*4096    CARG

      Logical           OPTR
      Logical           LLLT
      Real              RB
      Real              RF
      Real              RI
      Real              RX
      Real              RY
      Real              RZ

      IRC=0

* initializations

      FPRF='-'

      OPTR=.FALSE.
      LLLT=.TRUE.
      RB=-50
      RF=-100
      RI=1/3.0
      RX=-100
      RY=-300
      RZ=-1

      N1=Iargc()

      K1=0
      I2=1
      Do I1=1,N1
         Call GetArg(I2,CARG)
         If     (CARG(1:1).EQ.'-'.AND.CARG(2:2).NE.' ') then
            If(Index(CARG,'h').NE.0) go to 900
            If(Index(CARG,'l').NE.0) LLLT=.FALSE.
            If(Index(CARG,'r').NE.0) then
               OPTR=.TRUE.
               RB=-0.5
               RF=-1.0
               RX=-1.0
               RY=-3.0
               RZ=-0.01
            End if
            If(Index(CARG,'B').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RB
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RB
               End if
            End if
            If(Index(CARG,'F').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RF
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RF
               End if
            End if
            If(Index(CARG,'I').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RI
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RI
               End if
            End if
            If(Index(CARG,'X').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RX
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RX
               End if
            End if
            If(Index(CARG,'Y').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RY
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RY
               End if
            End if
            If(Index(CARG,'Z').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) RZ
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) RZ
               End if
            End if
         Else if(CARG(1:2).EQ.'B=') then
            Read(CARG(3:),*,Err=900) RB
         Else if(CARG(1:2).EQ.'F=') then
            Read(CARG(3:),*,Err=900) RF
         Else if(CARG(1:2).EQ.'I=') then
            Read(CARG(3:),*,Err=900) RI
         Else if(CARG(1:2).EQ.'X=') then
            Read(CARG(3:),*,Err=900) RX
         Else if(CARG(1:2).EQ.'Y=') then
            Read(CARG(3:),*,Err=900) RY
         Else if(CARG(1:2).EQ.'Z=') then
            Read(CARG(3:),*,Err=900) RZ
         Else if(K1.LE.0) then
            K1=K1+1
            If     (K1.EQ.1) then
               FPRF=CARG
            End if
         Else
            Go to 900
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 20
      End do

 20   Continue

 100  Return
 900  IRC=-1
      Go to 100
      End
*----------------------------------------------------------------------*
      Include          'reprf.f'
      Include          'recmd.f'
      Include          'wrprf.f'
      Include          'lblnk.f'
      Include          'Xblnk.f'

*----------------------------------------------------------------------*     
* $Id: rhmmer2.f,v 2.7 2003/11/28 11:57:32 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine RHMMER2 
     *   (NPRF,FPRF,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,NABC,CABC,LPRF,LPCI,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,
     *   BLOG,FABC,P0,
     *   CHID,IIPD,CHMD,IMPD, 
     *   INBP,LEOF,IRC)

      Character*(*)     FPRF

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'
      Include          'sterr.f'

* work fields

      Character*512     RCIN
      Logical           LOPN
      Logical           LIDF
      Logical           LEOF
      Logical           LRPF
      Character*8       CHIN(0:26)
      Character*32      CMIS
      Integer           LREA

* initializatons 
      
      IRC=0
      BL=LOG(2.0)
      LEOF=.FALSE.
      LRPF=.FALSE.

* open hmm file 
      
      LIDF=.FALSE.
      CMIS='HMMER2.0'
      Inquire(File=FPRF,OPENED=LOPN)
      If(LOPN) go to   1
      If(FPRF.NE.'-'.OR.NPRF.NE.5)
     *   Open(NPRF,File=FPRF,Status='OLD',Err=900)

* read first line

 1    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:8).NE.'HMMER2.0') go to   1

* name (Id)
      
      CMIS='NAME'
 2    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:4).NE.'NAME') go to   2

      K2=Lblnk(RCIN)
      Do I1=K2,5,-1
         If(RCIN(I1:I1).EQ.' ') then
            K1=I1+1
*** To be modified into goto ?
            go to 3
***
         End if
      End do 

* - lower case to upper, dash to underscore

 3    CPID=' '
      J1=0
      Do I1=K1,K2
         J1=J1+1
         M1=Ichar(RCIN(I1:I1))
         If(M1.LE.122.AND.M1.GE.97) then
            CPID(J1:J1)=Char(M1-32)
         Else
            CPID(J1:J1)=RCIN(I1:I1)
            If(CPID(J1:J1).EQ.'-') CPID(J1:J1)='_'
         End if
      End do 
      LIDF=.TRUE.

* AC, DE

      CPAC=' '
      CPDT=' '
      CPDE=' '
      CMIS='LENG'

 4    Read(NPRF,'(A)',Err=901,End=902) RCIN

      If(RCIN(1:2).EQ.'//') then 
         go to 920
      Else if(RCIN(1:4).EQ.'ACC ') then
         CPAC=RCIN(7:)
         Go to   4
      Else if(RCIN(1:4).EQ.'LENG') then
         Go to   6
      Else if(RCIN(1:4).NE.'DESC') then
         Go to   4
      Else 
         CPDE=RCIN(7:)
      End if

* length

 5    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:4).NE.'LENG') go to   5

 6    Read(RCIN(5:),*,Err=910) LPRF
      If(LPRF.GE.IDMP.OR.LPRF.LE.0) go to 904

* alphabet

      CMIS='ALPH'
 7    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:4).NE.'ALPH') go to   7

      If(Index(RCIN,'Amino').NE.0) then 
         NABC=20
         RCIN='ACDEFGHIKLMNPQRSTVWY'
         Read(RCIN,'(26A)')(CABC(ii1),ii1=1,NABC)
      Else if(Index(RCIN,'Nucleic').NE.0) then 
         NABC=4
         RCIN='ACGT'
         Read(RCIN,'(26A)')(CABC(ii1),ii1=1,NABC)
      Else
         Go to 911
      End if 

* comment lines 

      LHDR=0
      CMIS='XT'
 8    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:2).NE.'XT') then 
         LHDR=LHDR+1
         If(LHDR.LT.512)
     *      CHDR(LHDR)='CC   ' // RCIN
         Go to   8
      End if 
      
* XT (only NB and EC are relevant)

      Read(RCIN(3:),*,Err=910) NXNB,NXNN,NXEC,NXEJ,NXCT,NXCC,NXJB,NXJJ

* Null model (NI is null model residue extension score).

      CMIS='NULT'
 9    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:4).NE.'NULT') Go to 9

      Read(RCIN(5:),*,Err=910) NI
      BLOG=EXP(BL/1000) 
      P0=EXP(Real(NI)/1000.0*BL)
      
      CMIS='NULE'
 10   Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:4).NE.'NULE') Go to  10

      Read(RCIN(5:),*,Err=910)(IIPP(ii1,0),ii1=1,NABC)
      Do I1=1,NABC
         FABC(I1)=(EXP(Real(IIPP(I1,0))/1000*BL))/20.0
      End do 

* Normalization parameters, cut-off values        

      RNOP(1,1)=-LOG10(350.0)
      RNOP(2,1)=1.0
      CMIS='HMM'
 11   Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:3).EQ.'EVD') then 
         CMIS='EVD'
         Read(RCIN(4:),*,Err=910) RNOP(1,1),RNOP(2,1)
      Else if(RCIN(1:3).NE.'HMM') then
         Go to  11 
      End if 

      MDIS=2
      NDIP(1)=1
      NDIP(2)=LPRF

      JNOR=1
      MNOR(1)=1
      NNOR(1)=1
      NNPR(1)=1
      CNTX(1)='bitscore'

      RNOP(1,1)=-RNOP(1,1)*RNOP(2,1)/LOG(10.0)
      RNOP(2,1)= RNOP(2,1)*0.001/LOG(10.0)

* cut-off value

      JCUT=1
      MCLE(1)=0
      CCUT(1)=' '
      JCNM(1)=1
      MCUT(1,1)=1

*** This is done in htop.f:
C     RCUT(1,1)=RC
C     ICUT(1)=NINT((RCUT(1,1)-RNOP(1,1))/RNOP(2,1))+1
***
      
* defaults

      CHID='-'
      Do I1=0,26
         IIPD(I1)=0
      End do   
      
      IIPD(B0)=NLOW
      IIPD(B1)=NLOW
      IIPD(E0)=NLOW
      IIPD(E1)=NLOW
      
      IIPD(BM)=0
      IIPD(BI)=NLOW
      IIPD(BD)=NLOW
      IIPD(BE)=NLOW
      IIPD(MM)=NLOW
      IIPD(MI)=NLOW
      IIPD(MD)=NLOW
      IIPD(ME)=0
      IIPD(IM)=NLOW
      IIPD(II)=NLOW
      IIPD(ID)=NLOW
      IIPD(IE)=NLOW
      IIPD(DM)=NLOW
      IIPD(DI)=NLOW
      
      IIPD(DD)=0
      IIPD(DE)=NLOW

      CHMD='X'
      Do I1=0,26
         IMPD(I1)=0
      End do   
      IMPD(D )=0

* initialize main model

      LPCI=.FALSE.

      Do I1=0,LPRF
         CHIP(I1)='-' 
         Do I2=0,47
            IIPP(I2,I1)=IIPD(I2)
         End do 
      End do 
      Do I2=0,NABC
         IIPP(I2, 0)=NLOW
      End do
      Do I1=1,LPRF
         CHMP(I1)='X'
         Do I2=0,47
            IMPP(I2,I1)=IMPD(I2)
         End do 
      End do 

* main model parameters

      CMIS='HMM'
      Go to  13
 12   Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
 13   If(RCIN(1:3).NE.'HMM') Go to  12 
      Read(NPRF,'(A)',Err=901,End=903) RCIN
      If(RCIN(1:2).EQ.'//') go to 903

* first line (position zero) 

      Read(NPRF,'(A)',Err=901,End=903) RCIN
      If(RCIN(1:2).EQ.'//') go to 903
      Call c2i(RCIN,CHIN,1,3)
      If(CHIN(1).EQ.'*') then
         IIPP(BM, 0)=NLOW
      Else
         Read(CHIN(1),*,Err=912) IIPP(BM, 0)
      End if 
      If(CHIN(2).EQ.'*') then
         IIPP(BI, 0)=NLOW
      Else
         Read(CHIN(2),*,Err=912) IIPP(BI, 0)
      End if 
      If(CHIN(3).EQ.'*') then
         IIPP(BD, 0)=NLOW
      Else
         Read(CHIN(3),*,Err=912) IIPP(BD, 0)
      End if 

* subsequent lines (positions 1 to LPRF) 

      LREA=0
      Do I1=1,LPRF
         Read(NPRF,'(A)',Err=901,End=903) RCIN
         If(RCIN(1:2).EQ.'//') go to 903
         Call c2i(RCIN,CHIN,0,NABC)
         Do I2=1,NABC
            If(CHIN(I2).EQ.'*') then
               IMPP(I2,I1)=NLOW
            Else
               Read(CHIN(I2),*,Err=912) IMPP(I2,I1)
            End if 
         End do
         Read(NPRF,'(A)',Err=901,End=903) RCIN
         Call c2i(RCIN,CHIN,0,NABC)
         Do I2=1,NABC
            If(CHIN(I2).EQ.'*') then
               IIPP(I2,I1)=NLOW
            Else
               Read(CHIN(I2),*,Err=912) IIPP(I2,I1)
            End if 
         End do
         Read(NPRF,'(A)',Err=901,End=903) RCIN
         Call c2i(RCIN,CHIN,0,9)
         Do I2=1,NABC
            If(CHIN(I2).EQ.'*') then
               IIPP(I2,I1+1)=NLOW
            Else
               Read(CHIN(I2),*,Err=912) IIPP(I2,I1+1)
            End if 
         End do
         IIPP(MM,I1)=IIPP( 1,I1+1)
         IIPP(MI,I1)=IIPP( 2,I1+1)
         IIPP(MD,I1)=IIPP( 3,I1+1)
         IIPP(IM,I1)=IIPP( 4,I1+1)
         IIPP(II,I1)=IIPP( 5,I1+1)
         IIPP(DM,I1)=IIPP( 6,I1+1)
         IIPP(DD,I1)=IIPP( 7,I1+1)
         IIPP(B1,I1-1)=IIPP( 8,I1+1)
         IIPP(B0,I1-1)=IIPP( 8,I1+1)
         IIPP(E1,I1)=IIPP( 9,I1+1)
         IIPP(E0,I1)=IIPP( 9,I1+1)
         LREA=LREA+1
      End do     

      IIPP(BM,   0)=IIPP(B0,   0)
      IIPP(B0,   0)=0
      IIPP(B1,   0)=0

      IIPP(BM,LPRF)=IIPP(B0,LPRF)
      IIPP(E0,LPRF)=0
      IIPP(E1,LPRF)=0

* null model corrections, other modifications:

      Do I1=0,LPRF
         If(IIPP(B0,I1).NE.NLOW)
     *      IIPP(B0,I1)=IIPP(B0,I1)+NXNB
         If(IIPP(B1,I1).NE.NLOW)
     *      IIPP(B1,I1)=IIPP(B1,I1)+NXNB
         If(IIPP(E0,I1).NE.NLOW)
     *      IIPP(E0,I1)=IIPP(E0,I1)+NXEC
         If(IIPP(E1,I1).NE.NLOW) 
     *      IIPP(E1,I1)=IIPP(E1,I1)+NXEC
         X=0
         Do I2=1,NABC
            If(IIPP(I2,I1).NE.NLOW) then
               IIPP(I2,I1)=IIPP(I2,I1)-NI
            End if 
            X=X+FABC(I2)*IIPP(I2,I1) 
         End do 
         IIPP(I0,I1)=NINT(X)
         If(IIPP(I0,I1).LE.NLOW+27) IIPP(I0,I1)=NLOW
      End do 
      Do I1=1,LPRF
         X=0
         Do I2=1,NABC
            If(IMPP(I2,I1).NE.NLOW) then
               IMPP(I2,I1)=IMPP(I2,I1)-NI
            End if 
            X=X+FABC(I2)*IMPP(I2,I1) 
         End do 
         IMPP(I0,I1)=NINT(X)
         If(IMPP(I0,I1).LE.NLOW+27) IMPP(I0,I1)=NLOW
      End do 

* add consensus characters: 

      Do I1=1,LPRF
         K1=IMPP( 0,I1) 
         Do I2=1,NABC
            If(IMPP(I2,I1).GE.K1) then
               K1=IMPP(I2,I1)
               CHMP(I1)=CABC(I2)
            End if
         End do
      End do  
      
      INBP=INBP+1
      LIDF=.FALSE.
      LRPF=.TRUE.
      If(LREA.NE.LPRF) Go to 921

 15   Read(NPRF,'(A)',Err=901,End=905) RCIN
      If(RCIN(1:2).NE.'//') go to  15

 100  If(LRPF) IRC=0
      Return

 110  If(LIDF) then
         Write(NERR,*) '       While processing profile ',
     *      CPID(1:Lblnk(CPID))
      End if
      Go to 100

* errors

 900  Write(NERR,*) 'Error: Unable to open profile file'//
     *   ' ''',FPRF(1:Lblnk(FPRF)),'''.'
      IRC=1
      Go to 110
 901  Write(NERR,*) 'Error: Unable to read profile file'//
     *   ' ''',FPRF(1:Lblnk(FPRF)),'''.'
      IRC=1
      Go to 110
 902  LEOF=.TRUE.
      If(INBP.LT.1.OR.CMIS.NE.'HMMER2.0') then
         Write(NERR,*) 'Error: Unexpected end of file. '//
     *      'Unable to find profile ',CMIS(1:Lblnk(CMIS)),' line.'
         Write(NERR,*) '       No profile read.'
         IRC=1
      Else
C         LEOF=.TRUE.
         IRC=-1
      End if
      Go to 110
 903  LEOF=.TRUE.
      If(INBP.LT.1) then
         Write(NERR,*) 'Error: Unexpected end of file. '
         Write(NERR,*) '       Profile length does not match ',
     *      'expected length (',LPRF,').'
         Write(NERR,*) '       No profile read.'
         IRC=1
      Else
C         LEOF=.TRUE.
         IRC=0
      End if
      Go to 110
 904  Write(NERR,*) 'Error: Profile length exceeds buffer size (',
     *   IDMP,').'
      IRC=1
      Go to 110
 905  LEOF=.TRUE.
      Go to 100

 910  Write(NERR,*) 'Error: Unable to read value of parameter(s) '//
     *   CMIS(1:Lblnk(CMIS))
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 110
 911  Write(NERR,*) 'Error: Unknown alphabet type defined.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 110
 912  Write(NERR,*) 'Error: Unable to read profile values.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 110

* warnings

 920  Write(NERR,*) 'Warning: Unexpected profile separator (''//'')',
     *   ' found.'
      Write(NERR,*) '         Unable to find ',
     *   CMIS(1:Lblnk(CMIS)),' line.'
      If(LIDF) then
         Write(NERR,*) '         While processing profile ',
     *      CPID(1:Lblnk(CPID))
      End if
      Write(NERR,*) '         Reading next profile.'
      IRC=0
      LIDF=.FALSE.
      CMIS='HMMER2.0'
      Go to 1
 921  Write(NERR,*) 'Warning: Expected (',LPRF,' and ',
     *   'actual (',LREA,') profile sizes do not match.'
      Write(NERR,*) '         Check profile syntax.'
      If(LIDF) then
         Write(NERR,*) '         While processing profile ',
     *      CPID(1:Lblnk(CPID))
      End if
      Go to 15
      
      End
*----------------------------------------------------------------------*
      Subroutine c2i(RCIN,CHIN,N1,N2)
      
      Character*(*)     RCIN
      Character*8       CHIN(0:26)
      Logical           LSTR

      K1=N1-1
      J1=1
      LSTR=.FALSE.
      Do I1=1,Lblnk(RCIN)+1
         If(LSTR) then
            If(RCIN(I1:I1).NE.' ') then
               Continue
            Else
               CHIN(K1)=RCIN(J1:I1-1)
               LSTR=.FALSE.
            End if 
         Else
            If(RCIN(I1:I1).NE.' ') then
               K1=K1+1
*** To be modified into Go to ?
               If(K1.GT.N2) Return
***
               J1=I1
               LSTR=.TRUE.
            Else
               Continue
            End if
         End if 
      End do 
      Return
      End    

*----------------------------------------------------------------------*     
* $Id: pfdat.f,v 2.5 2003/02/19 08:38:25 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
* PROFILE 

      Integer           B0 
      Integer           B1 
      Integer           E0 
      Integer           E1 
      Integer           BM 
      Integer           BI 
      Integer           BD 
      Integer           BE 
      Integer           MM 
      Integer           MI 
      Integer           MD 
      Integer           ME 
      Integer           DM 
      Integer           DI 
      Integer           DD 
      Integer           DE 
      Integer           IM 
      Integer           II 
      Integer           ID 
      Integer           IE 

      Integer           M0
      Integer           I0
      Integer           D 

      Parameter        (B0=  27) 
      Parameter        (B1=  28)
      Parameter        (E0=  29)
      Parameter        (E1=  30)
      Parameter        (BM=  31)
      Parameter        (BI=  32)
      Parameter        (BD=  33)
      Parameter        (BE=  34)
      Parameter        (MM=  35)
      Parameter        (MI=  36)
      Parameter        (MD=  37)
      Parameter        (ME=  38)
      Parameter        (IM=  39)
      Parameter        (II=  40)
      Parameter        (ID=  41)
      Parameter        (IE=  42)
      Parameter        (DM=  43)
      Parameter        (DI=  44)
      Parameter        (DD=  45)
      Parameter        (DE=  46)

      Parameter        (M0=   0)
      Parameter        (I0=   0)
      Parameter        (D =  27)
* 
      Integer           NLOW
      Parameter        (NLOW=-536870912)   
      
      Character*01      CHIP(0:IDMP)
      Integer           IIPP(0:46,0:IDMP)     
      
      Character*01      CHMP(IDMP)
      Integer           IMPP(0:27,0:IDMP)
      
* Storage of circular profile last insert position

      Character*01      CHIL
      Integer           IIPL(0:46)
      Integer           ILIP
      

*----------------------------------------------------------------------*     
* $Id: remsa.f,v 1.2 2003/07/03 13:08:58 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine REMSA
     *   (NERR,NMSF,FMSF,
     *   IDMS,CSEQ,NSEQ,LSEQ,
     *   IDMF,RWGT,SQID,
     *   IRC)

      Character*(*)    FMSF

      Character        CSEQ(*) 
      Real*4           RWGT(*)
      Character*(*)    SQID(*) 

      Character*512    RCIN 

      IRC=0
      NSEQ=0
      LSEQ=0

      If(FMSF.NE.'-') then 
         Open(NMSF,File=FMSF,Status='OLD',Err=900)
      End if 

 1    Read(NMSF,'(A)',Err=901,End=999,Iostat=IOS) RCIN
 2    If(RCIN(1:1).NE.'>') go to   1   

* read sequence weight in xpsa header if available

      If(NSEQ+1.GT.IDMF) go to 906
      IW=Index(RCIN,'weight=')
      If(IW.NE.0) then
         Read(RCIN(IW+7:),*,Err=905) RWGT(NSEQ+1)
      Else
         RWGT(NSEQ+1)=1.0
      End if

* read sequence identifier

      L=Lblnk(RCIN)
      Do I1=2,L
         If(RCIN(I1:I1).NE.' ') go to 3
      End do
 3    Do I2=I1,L
         If(RCIN(I2:I2).EQ.' ') go to 4
      End do
 4    If(I2-I1.GT.64) I2=I1+64
      SQID(NSEQ+1)=RCIN(I1:I2)

* read sequences in multiple alignment

      J1=NSEQ*LSEQ
 10   RCIN=' '
      Read(NMSF,'(A)',Err=901,Iostat=IOS) RCIN
      L=Lblnk(RCIN)
      If((RCIN(1:1).EQ.'>').OR.
     *   (L.EQ.0.AND.IOS.EQ.-1)) go to 20
      Do 15 I1=1,L
         If(RCIN(I1:I1).NE.' ') then
            J1=J1+1
            If(J1.GT.IDMS) go to 902
            CSEQ(J1)=RCIN(I1:I1)
         End if
 15   Continue
      Go to 10

 20   If(J1.EQ.(NSEQ*LSEQ)) go to 903
      If(NSEQ.EQ.0) then
         LSEQ=J1
      Else if(J1.NE.(NSEQ+1)*LSEQ) then
         go to 904
      End if
      NSEQ=NSEQ+1
      
      If(IOS.NE.-1) go to 2

 100  Return

 110  IX=Lblnk(SQID(NSEQ+1))
      If(IX.GT.1) then
         Write(NERR,*) '       While processing sequence ',
     *      SQID(NSEQ+1)(1:IX)
      End if
      Go to 100

* errors

 900  Write(NERR,*) 'Error: Unable to open MSA file'//
     *   ' ''',FMSF(1:Lblnk(FMSF)),'''.'
      IRC=1
      Go to 100
 901  Write(NERR,*) 'Error: Unable to read MSA file'//
     *   ' ''',FMSF(1:Lblnk(FMSF)),'''.'
      IRC=1
      Go to 100
 902  Write(NERR,*) 'Error: MSA length exceeds buffer ',
     *   'size (',IDMS,').'
      IRC=1
      Go to 110
 903  Write(NERR,*) 'Error: Unexpected end of sequence.'//
     *   ' Sequence has zero length.'
      IRC=1
      Go to 110
 904  Write(NERR,*) 'Error: Sequence length differs from expected ',
     *   'length.'
      IRC=1
      Go to 110
 905  Write(NERR,*) 'Error: Unable to read weight in sequence ',
     *   'header.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Lblnk(RCIN))
      IRC=1
      Go to 100
 906  Write(NERR,*) 'Error: Number of sequences in MSA file exceeds ',
     *   'buffer size (',IDMF,').'
      IRC=1
      Go to 100

 999  If(NSEQ.EQ.0) then
         Write(NERR,*) 'Error: No sequence has been read.'
         IRC=1
      End if
      Go to 100

      End

*----------------------------------------------------------------------*     
* $Id: reprf.f,v 2.17 2003/11/18 10:50:07 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine REPRF
     *   (NPRF,FPRF,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   BLOG,FABC,P0,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,CHIL,IIPL,ILIP,
     *   CHID,IIPD,CHMD,IMPD,
     *   INBP,LEOF,OPTV,IRC)

* profile data fields

      Character*(*)     FPRF

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'dfdat.f'
      Include          'pfdat.f'
      Include          'sterr.f'

      Character*512     RCIN


* function return types

      Integer           Xblnk
      External          Xblnk

* work fields

      Integer           NKEY 
      Character*64      CPAR
      Character*512     CVAL 
      Logical           LNEW
      Logical           LIDF
      Logical           LZCO
      Integer           ISCO(26)

      Character*64      CH64
      Character*2       CMIS
      Logical           LOPN
      Logical           LEOF
      Logical           OPTV
      
      IRC=0
      RCIN=' '
      LZCO=.FALSE.
      LEOF=.FALSE.

* open profile file 

      Inquire(File=FPRF,OPENED=LOPN)
      If(LOPN) go to   1
      If(FPRF.NE.'-'.OR.NPRF.NE.5)
     *   Open(NPRF,File=FPRF,Status='OLD',Err=900)

* profile-id 
      
 1    LIDF=.FALSE.
      CMIS='ID'
      Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:2).NE.'ID') go to   1   
      LR=Xblnk(RCIN,64)
      IC=Index(RCIN,';')
      If(IC.LE.0) go to 916
      CPID=RCIN( 6:IC-1)
      If(Index(RCIN(IC:LR),'MATRIX').EQ.0) go to 924 
      LIDF=.TRUE.

* ac-number 
      
      CMIS='AC'
 2    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:2).NE.'AC') go to   2   
      IX=Index(RCIN,';')-1
      If(IX.LE.0) go to 916
C      CPAC=RCIN( 6:IC-1)
      CPAC=RCIN(6:IX) // '|'

* date, description 

      CMIS='DE'
      CPDT=' '
 3    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920
      If(RCIN(1:2).EQ.'DT') then 
         LR=Xblnk(RCIN,64)
         CPDT=RCIN( 6:LR)
         Go to   3
      End if 
      If(RCIN(1:2).NE.'DE') go to   3   
      LR=Xblnk(RCIN,64)
      CPDE=RCIN( 6:LR)

* go to first MA line, read additional header lines 
      
      LHDR=0
      CMIS='MA'
 5    Read(NPRF,'(A)',Err=901,End=902) RCIN
      If(RCIN(1:2).EQ.'//') go to 920 
      If(RCIN(1:2).NE.'MA') then
         If(LHDR.LT.512) then
            LHDR=LHDR+1
            CHDR(LHDR)=RCIN
         End if
         go to   5   
      End if
*      LR=Lblnk(RCIN)

* initialize position-independent profile parameters

* - general specifications

      CVAL='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      NABC=26
      Read(CVAL,'(26A)')(CABC(ii1),ii1=1,NABC)

      LPRF=0
      LENP=0

      LPCI=.FALSE.
      P0=0.0

* - disjoint mode

      MDIS=1

* - normalization modes

      JNOR=0 
      Do  11 I1=1,MAXN
         NNOR(I1)=I1
         NNPR(I1)=I1
 11   Continue

* - cut-off

      JCUT=0

* - defaults for match and insert position  

      JI=-1
      JM=0
      
      Call INITD(IIPD,IMPD,CHMD,CHID,NLOW)

      Do  18 I1=0,27
         IMPP(I1,0)=NLOW
 18   Continue 

* intialize profile input buffers.

      LR=Xblnk(RCIN,64)
      If(Ichar(RCIN(LR:LR)).EQ.13)LR=LR-1 
      JR=5

* read next parameter 

 20   Continue
      LFTR=0
      Call NEXTP(NPRF,RCIN,LR,JR,NKEY,LNEW,CPAR,CVAL,LFTR,CFTR,IRC) 
      If(IRC.GT.0) go to 940
      If(IRC.LT.0) go to 930

* interpret parameters

* - GENERAL_SPEC:

      If     (NKEY.EQ.1) then 

         If     (CPAR.EQ.'ALPHABET') then
            Read(CVAL,*,Err=910) CH64
            NABC=Lblnk(CH64)
            If(NABC.GT.26) Go to 908
            Read(CH64,'(64A)',Err=910)(CABC(ii1),ii1=1,NABC)

            If(NABC.LT.20) then
               CABC(0)='N'
            Else
               CABC(0)='X'
            End if
         Else if(CPAR.EQ.'LENGTH') then
            Read(CVAL,*,Err=910) LENP
         Else if(CPAR.EQ.'TOPOLOGY'.AND.CVAL.EQ.'CIRCULAR') then 
            LPCI=.TRUE.
         Else if(CPAR.EQ.'LOG_BASE') then
            Read(CVAL,*,Err=910) BLOG
            If(P0.EQ.0.0) P0=1.0
         Else if(CPAR.EQ.'P0') then
            Read(CVAL,*,Err=910) P0 
         Else if(CPAR.EQ.'P') then
            L1=Xblnk(CVAL,64) 
            J1=1
            Do  I1=1,L1
               If(CVAL(I1:I1).EQ.',') J1=J1+1
            End do 
            If(J1.GT.26) Go to 908
            Read(CVAL,*,Err=910)(FABC(ii1),ii1=1,J1)
         End if
         
* - DISJOINT:

      Else if(NKEY.EQ.2) then 

         If     (CPAR.EQ.'DEFINITION') then 
            Do  31 I1=1,KDIS
               If(CVAL.EQ.CDIS(I1)) MDIS=I1
 31         Continue
         Else
            If     (CPAR.EQ.'N1') then
               Read(CVAL,*,Err=910) NDIP(1) 
            Else if(CPAR.EQ.'N2') then
               Read(CVAL,*,Err=910) NDIP(2) 
            End if
         End if           

* - NORMALIZATION:

      Else if(NKEY.EQ.3) then 

         If(LNEW) then
            If(JNOR.GE.MAXN) Go to 912
            JNOR=JNOR+1
            CNTX(JNOR)=' '
         End if

         If     (CPAR.EQ.'FUNCTION') then
            If(CVAL.EQ.'GRIBSKOV') CVAL='GLE_ZSCORE'
            Do  41 I1=1,KNOR
               If(CVAL.EQ.CNOR(I1)) MNOR(JNOR)=I1
 41         Continue
            If (MNOR(JNOR).EQ.0) Go to 911
         Else if(CPAR.EQ.'MODE') then
            Read(CVAL,*,Err=910) NNOR(JNOR)
         Else if(CPAR.EQ.'PRIORITY') then
            Read(CVAL,*,Err=910) NNPR(JNOR)
         Else if(CPAR.EQ.'TEXT') then
            Read(CVAL,*,Err=910) CNTX(JNOR)
         Else
            If     (CPAR.EQ.'R1') then
               Read(CVAL,*,Err=910) RNOP(1,JNOR) 
            Else if(CPAR.EQ.'R2') then
               Read(CVAL,*,Err=910) RNOP(2,JNOR) 
            Else if(CPAR.EQ.'R3') then
               Read(CVAL,*,Err=910) RNOP(3,JNOR) 
            Else if(CPAR.EQ.'R4') then
               Read(CVAL,*,Err=910) RNOP(4,JNOR) 
            Else if(CPAR.EQ.'R5') then
               Read(CVAL,*,Err=910) RNOP(5,JNOR) 
            End if
         End if

* - CUT_OFF:

      Else if(NKEY.EQ.4) then 

         If(LNEW) then 
            If(JCUT.GE.MAXC) Go to 913
            JCUT=JCUT+1
            MCLE(JCUT)=0
            CCUT(JCUT)=' '
            JCNM(JCUT)=0
         End if

         If     (CPAR.EQ.'LEVEL') then
            Read(CVAL,*,Err=910) MCLE(JCUT)
            If(MCLE(JCUT).EQ.0) LZCO=.TRUE.
         Else if(CPAR.EQ.'SCORE') then
            Read(CVAL,*,Err=910) ICUT(JCUT)
         Else if(CPAR.EQ.'TEXT') then
            Read(CVAL,*,Err=910) CCUT(JCUT)
         Else if(CPAR.EQ.'N_SCORE') then
            L1=Xblnk(CVAL,64) 
            J1=1
            Do  51 I1=1,L1
               If(CVAL(I1:I1).EQ.',') J1=J1+1
 51         Continue
            Read(CVAL,*,Err=910)(RCUT(ii1,JCUT),ii1=1,J1)
            JCNM(JCUT)=J1
         Else if(CPAR.EQ.'MODE') then
            L1=Xblnk(CVAL,64) 
            J1=1
            Do  52 I1=1,L1
               If(CVAL(I1:I1).EQ.',') J1=J1+1
 52         Continue
            Read(CVAL,*,Err=910)(MCUT(ii1,JCUT),ii1=1,J1)
         End if

* - DEFAULT:

      Else if(NKEY.EQ.5) then 

         If     (CPAR.EQ.' ') then
            Call INITD(IIPD,IMPD,CHMD,CHID,NLOW)
         Else if(CPAR.EQ.'SY_I') then
            Read(CVAL,*,Err=910) CHID 
         Else if(CPAR.EQ.'SY_M') then
            Read(CVAL,*,Err=910) CHMD
         Else if(CPAR.EQ.'M0'.OR.CPAR.EQ.'M'.OR.CPAR.EQ.'D') then
            Call GETPM(CPAR,CVAL,INDX,ISCO,NABC,NLOW,IRC)
            If(IRC.NE.0) Go to 950
            If(INDX.EQ.1) then
               Do  61 I1=1,NABC
                  IMPD(I1)=ISCO(I1)
 61            Continue
            Else
               IMPD(INDX)=ISCO(1)
            End if
         Else
            Call GETPI(CPAR,CVAL,INDX,ISCO,NABC,NLOW,IRC)
            If(IRC.NE.0) Go to 950
            If(INDX.EQ.1) then
               Do  62 I1=1,NABC
                  IIPD(I1)=ISCO(I1)
 62            Continue
            Else
               IIPD(INDX)=ISCO(1)
            End if
         End if
         
* - I:

      Else if(NKEY.EQ.6) then 

         If(LNEW) then
            JI=JI+1

            If (JI.GE.IDMP.OR.JM.GT.IDMP) then
               Go to 915
            End if

            CHIP(JI)=CHID 
            Do  71 I1=0,46
               IIPP(I1,JI)=IIPD(I1)
 71         Continue
            If(JI.GT.JM) then
               JM=JM+1
               CHMP(JM)=CHMD 
               Do  72 I1=0,27
                  IMPP(I1,JM)=IMPD(I1)
 72            Continue
            End if
         End if 

         If     (CPAR.EQ.' ') then
            Go to  20
         Else if(CPAR.EQ.'SY') then
            Read(CVAL,*,Err=910) CHIP(JI) 
         Else
            Call GETPI(CPAR,CVAL,INDX,ISCO,NABC,NLOW,IRC)
            If(IRC.NE.0) Go to 950
            If(INDX.EQ.1) then
               Do  73 I1=1,NABC
                  IIPP(I1,JI)=ISCO(I1)
 73            Continue
            Else
               IIPP(INDX,JI)=ISCO(1)
            End if
         End if

* - M:

      Else if(NKEY.EQ.7) then 

         If(LNEW) then
            JM=JM+1

            If (JI.GE.IDMP.OR.JM.GT.IDMP) then
               Go to 915
            End if

            CHMP(JM)=CHMD 
            Do  81 I1=0,27
               IMPP(I1,JM)=IMPD(I1)
 81         Continue
            If(JM-1.GT.JI) then
               JI=JI+1
               CHIP(JI)=CHID 
               Do  82 I1=0,46
                  IIPP(I1,JI)=IIPD(I1)
 82            Continue
            End if
         End if 

         If     (CPAR.EQ.' ') then
            Go to  20
         Else if(CPAR.EQ.'SY') then
            Read(CVAL,*,Err=910) CHMP(JM) 
         Else
            Call GETPM(CPAR,CVAL,INDX,ISCO,NABC,NLOW,IRC)
            If(IRC.NE.0) Go to 950
            If(INDX.EQ.1) then
               Do  83 I1=1,NABC
                  IMPP(I1,JM)=ISCO(I1)
 83            Continue
            Else
               IMPP(INDX,JM)=ISCO(1)
            End if
         End if
      Else 
         Continue
      End if  

C      Print *,JI,JM,NKEY,' ',LNEW,' ',
C     *   CPAR(1:Lblnk(CPAR)),'=',
C     *   CVAL(1:Lblnk(CVAL))

      Go to  20

 90   Continue
      IRC=0

* last insert position 
* store values for multiple matches of circular profiles

      If(LPCI) then
         If(JI.EQ.JM) then 
            ILIP=0
            CHIL=CHIP(0)
            CHIP(    0)=CHIP(   JI)
            Do  91 I1=0,46
               IIPL(I1)=IIPP(I1, 0)
               IIPP(I1, 0)=IIPP(I1,JI)
 91         Continue
         Else
            JI=JI+1
            ILIP=JI
            CHIL=CHID
            CHIP(   JI)=CHIP(    0)
            Do  92 I1=0,46
               IIPL(I1)=IIPD(I1)
               IIPP(I1,JI)=IIPP(I1, 0)
 92         Continue
         End if
      Else if(JI.LT.JM) then 
         JI=JI+1
         CHIP(   JI)=CHID
         Do  93 I1=0,46
            IIPP(I1,JI)=IIPD(I1)
 93      Continue
      End if


* set length of profile
 
      LPRF=JI

* check consistency of some parameters

 94   If(.NOT.LZCO.OR.JCUT.EQ.0) go to 919
      If(LPRF.LT.1) then
         Go to 918
      Else
         INBP=INBP+1
      End if
      If(NDIP(1).LE.0.OR.NDIP(1).GT.LPRF) then
         NDIP(1)=1
         Go to 923
      End if
      If(NDIP(2).LE.0.OR.NDIP(2).GT.LPRF) then
         NDIP(2)=LPRF
         Go to 923
      End if
      If(NDIP(2).LT.NDIP(1)) then
         I1=NDIP(2)
         NDIP(2)=NDIP(1)
         NDIP(1)=I1
      End if
C      Do 95 I1=0,JI
C         Write(NERR,*) 'I[',I1,']: '
C         Write(NERR,*)(IIPP(ii1,I1),ii1=0,46)
C 95   Continue
C
C      Do 96 I1=0,JM
C         Write(NERR,*) 'M[',I1,']: '
C         Write(NERR,*)(IMPP(ii1,I1),ii1=0,27)
C 96   Continue

 100  Return

 110  If(LIDF.AND.IRC.NE.0) then
         Write(NERR,*) '       While processing profile ',
     *      CPID(1:Lblnk(CPID))
      End if
      Go to 100

* errors

 900  Write(NERR,*) 'Error: Unable to open profile file'//
     *   ' ''',FPRF(1:Xblnk(FPRF,64)),'''.'
      IRC=1
      Go to 110
 901  Write(NERR,*) 'Error: Unable to read profile file'//
     *   ' ''',FPRF(1:Xblnk(FPRF,64)),'''.'
      IRC=1
      Go to 110
 902  If(INBP.LT.1.OR.LIDF) then
         Write(NERR,*) 'Error: Unexpected end of file. '//
     *      'Unable to find profile ',CMIS,' line.'
         If(INBP.LT.1)
     *      Write(NERR,*) '       No profile read.'
         IRC=1
      Else
         LEOF=.TRUE.
         IRC=0
      End if
      Go to 110
 906  Write(NERR,*) 'Error: Unknown data block at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 908  Write(NERR,*) 'Error: Too many values for parameter '//
     *   CPAR(1:Lblnk(CPAR))
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 910  Write(NERR,*) 'Error: Unable to read value of parameter '//
     *   CPAR(1:Lblnk(CPAR))
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 911  Write(NERR,*) 'Error: Unknown value '//
     *   CVAL(1:Xblnk(CVAL,64)),' for parameter '//
     *   CPAR(1:Lblnk(CPAR))
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 912  Write(NERR,*) 'Error: Maximum number of NORMALIZATION '//
     *   'data blocks exceeded '
      IRC=1
      Go to 110
 913  Write(NERR,*) 'Error: Maximum number of CUT_OFF '//
     *   'data blocks exceeded '
      IRC=1
      Go to 110
 914  Write(NERR,*) 'Error: Unknown parameter '//
     *   CPAR(1:Lblnk(CPAR))
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 915  Write(NERR,*) 'Error: Profile length exceeds buffer size (',
     *   IDMP,').'
      IRC=1
      Go to 110
 916  Write(NERR,*) 'Error: Missing semicolon.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 917  Write(NERR,*) 'Error: Missing ''MATRIX'' keyword in ID line.'
      Write(NERR,*) '       at line: ',
     *   RCIN(1:Xblnk(RCIN,64))
      IRC=1
      Go to 110
 918  Write(NERR,*) 'Error: Unexpected end of profile. Profile has '//
     *   'zero length. Check profile syntax.'
      IRC=1
      Go to 110

 919  Write(NERR,*) 'Error: No level 0 ''CUT-OFF'' data-block'//
     *   ' in profile.'
      Write(NERR,*) '       Check profile syntax.'
      IRC=1
      Go to 110

* warnings

 920  If(.NOT.OPTV) then
         Write(NERR,*)'Warning: Unexpected profile separator (''//'')'//
     *      ' found. Unable to find ',CMIS,' line.'
         If(LIDF) then
            Write(NERR,*) '         While processing profile ',
     *         CPID(1:Lblnk(CPID))
         End if
         Write(NERR,*) '         Reading next profile.'
      End if
      IRC=0
      Go to 1

 921  If(.NOT.OPTV) then
         Write(NERR,*) 'Warning: Parameter name too long at line: ',
     *      RCIN(1:Xblnk(RCIN,64))
         If(LIDF) then
            Write(NERR,*) '         While processing profile ',
     *         CPID(1:Lblnk(CPID))
         End if
         Write(NERR,*) '         Skipping parameter.'
      End if
      IRC=0
      Go to 20
      
 922  If(.NOT.OPTV) then
         Write(NERR,*) 'Warning: Parameter value too long at line: ',
     *      RCIN(1:Xblnk(RCIN,64))
         If(LIDF) then
            Write(NERR,*) '         While processing profile ',
     *         CPID(1:Lblnk(CPID))
         End if
         Write(NERR,*) '         Skipping parameter.'
      End if
      IRC=0
      Go to 20

 923  If(.NOT.OPTV) then
         Write(NERR,*) 'Warning: Disjointness parameter out of bound. '
         Write(NERR,*) '         Setting parameter to acceptable value.'
         If(LIDF) then
            Write(NERR,*) '         While processing profile ',
     *         CPID(1:Lblnk(CPID))
         End if
      End if
      Go to 94

 924  If(.NOT.OPTV) then
         Write(NERR,*) 'Warning: Missing ''MATRIX'' keyword in ID line.'
         Write(NERR,*) '         at line: ',
     *      RCIN(1:Xblnk(RCIN,64))
         IRC=0
         If(LIDF) then
            Write(NERR,*) '         While processing profile ',
     *         CPID(1:Lblnk(CPID))
         End if
         Write(NERR,*) '         Reading next profile.'
      End if
      IRC=0
      Go to 1


* process warnings occuring in NEXTP()

 930  If(IRC.EQ.-3) Go to 921
      If(IRC.EQ.-4) Go to 922
      Go to 90

* process errors occuring in NEXTP()

 940  If(IRC.EQ.2) Go to 906
      Go to 901

* process errors occuring in GETPI() or GETPM()

 950  If(IRC.GT.0) Go to 910
      If(IRC.EQ.-1) Go to 914
      If(IRC.EQ.-2) Go to 908
      Go to 90

      End


*----------------------------------------------------------------------*
* Initializes all parameters to their implicit defaults
*----------------------------------------------------------------------*

      Subroutine INITD(IIPD,IMPD,CHMD,CHID,NLOW)

      Integer           B0 
      Integer           B1 
      Integer           E0 
      Integer           E1 
      Integer           BM 
      Integer           BI 
      Integer           BD 
      Integer           BE 
      Integer           MM 
      Integer           MI 
      Integer           MD 
      Integer           ME 
      Integer           DM 
      Integer           DI 
      Integer           DD 
      Integer           DE 
      Integer           IM 
      Integer           II 
      Integer           ID 
      Integer           IE 

      Integer           M0
      Integer           I0
      Integer           D 

      Parameter        (B0=  27) 
      Parameter        (B1=  28)
      Parameter        (E0=  29)
      Parameter        (E1=  30)
      Parameter        (BM=  31)
      Parameter        (BI=  32)
      Parameter        (BD=  33)
      Parameter        (BE=  34)
      Parameter        (MM=  35)
      Parameter        (MI=  36)
      Parameter        (MD=  37)
      Parameter        (ME=  38)
      Parameter        (IM=  39)
      Parameter        (II=  40)
      Parameter        (ID=  41)
      Parameter        (IE=  42)
      Parameter        (DM=  43)
      Parameter        (DI=  44)
      Parameter        (DD=  45)
      Parameter        (DE=  46)

      Parameter        (M0=   0)
      Parameter        (I0=   0)
      Parameter        (D =  27)

      Integer           IIPD(0:46)
      Integer           IMPD(0:27)
      Character         CHMD
      Character         CHID

      CHID='-'
      Do  10 I1=1,26 
         IIPD(I1)=0
 10   Continue

      IIPD(B0)=0
      IIPD(B1)=0
      IIPD(E0)=0
      IIPD(E1)=0

      IIPD(BM)=0
      IIPD(BI)=NLOW
      IIPD(BD)=NLOW
      IIPD(BE)=NLOW
      IIPD(MM)=0
      IIPD(MI)=NLOW
      IIPD(MD)=NLOW
      IIPD(ME)=0
      IIPD(IM)=NLOW
      IIPD(II)=0
      IIPD(ID)=NLOW
      IIPD(IE)=NLOW
      IIPD(DM)=NLOW
      IIPD(DI)=NLOW
      IIPD(DD)=0
      IIPD(DE)=NLOW

      IIPD(I0)=0

      CHMD='X'
      Do  15 I1=1,26 
         IMPD(I1)=0
 15   Continue

      IMPD(M0)=0 
      IMPD(D )=0

 100  Return

      End

*----------------------------------------------------------------------*
      Subroutine NEXTP(NPRF,RCIN,LR,JR,NKEY,LNEW,CPAR,CVAL,LFTR,
     *   CFTR,IRC) 

* function return types

      Integer           Xblnk
      External          Xblnk

      Character*(*)     RCIN
      Character*(*)     CPAR 
      Character*(*)     CVAL 
      Character*(*)     CFTR(1024)
      Logical           LNEW 

      LNEW=.FALSE.
 3    Do  4 I1=JR+1,LR
         JR=JR+1
         If(Index(' ;,.        ',RCIN(JR:JR)).EQ.0) go to 10
 4    Continue

 5    Read(NPRF,'(A)',Err=999,End=901) RCIN
      If     (RCIN(1:2).EQ.'MA') then
         LFTR=0
      Else if(RCIN(1:2).EQ.'CC') then
         If(LFTR.LT.1024) then 
            LFTR=LFTR+1
            CFTR(LFTR)=RCIN
         End if
         Go to   5 
      Else if(RCIN(1:2).EQ.'//') then
         Go to 902
      Else
         Go to 102
      End if 

      LR=Xblnk(RCIN,64)
      If(Ichar(RCIN(LR:LR)).EQ.13) LR=LR-1 
      JR=5
      Go to   3

* identify keyword 

 10   If(RCIN(JR:JR).EQ.'/') then 
         LNEW=.TRUE.
         If     (RCIN(JR:JR+13).EQ.'/GENERAL_SPEC:') then
            NKEY=1
            JR=JR+13
         Else if(RCIN(JR:JR+ 9).EQ.'/DISJOINT:') then
            NKEY=2
            JR=JR+ 9
         Else if(RCIN(JR:JR+14).EQ.'/NORMALIZATION:') then
            NKEY=3
            JR=JR+14
         Else if(RCIN(JR:JR+ 8).EQ.'/CUT_OFF:') then
            NKEY=4
            JR=JR+ 8
         Else if(RCIN(JR:JR+ 8).EQ.'/DEFAULT:') then
            NKEY=5
            JR=JR+ 8
         Else if(RCIN(JR:JR+ 2).EQ.'/I:') then
            NKEY=6
            JR=JR+ 2
         Else if(RCIN(JR:JR+ 2).EQ.'/M:') then
            NKEY=7
            JR=JR+ 2
         Else
            Go to 900
         End if
      Else 
         JR=JR-1
      End if 

* read parameter 

      LPAR=0
      CPAR=' '  

 20   JR=JR+1  

      If(JR.GT.LR) then 
 21      Read(NPRF,'(A)',Err=999,End=901) RCIN
         If(RCIN(1:2).EQ.'CC') then
            If(LFTR.LT.1024) then
               LFTR=LFTR+1
               CFTR(LFTR)=RCIN
            End if
            Go to  21
         End if
         LR=Xblnk(RCIN,64)
         If(Ichar(RCIN(LR:LR)).EQ.13) LR=LR-1 
         If(RCIN(1:2).NE.'MA') then 
            JR=LR
            CVAL=' '
            Go to  100
         End if
         LFTR=0
         JR=6
      End if  

      If(RCIN(JR:JR).EQ.'/') then
         JR=JR-1
         CVAL=' '
         Go to  100
      End if   

      If(RCIN(JR:JR).NE.'=') then
         If(LPAR.NE.0.OR.RCIN(JR:JR).NE.' ') then 
            LPAR=LPAR+1
            If(LPAR.LE.64) then
               CPAR(LPAR:LPAR)=RCIN(JR:JR)
            End if
         End if 
         Go to  20
      End if

* read value 

      LVAL=0
      CVAL=' '  

 30   JR=JR+1  

      If(JR.GT.LR) then 
 31      Read(NPRF,'(A)',Err=999,End=901) RCIN
         If(RCIN(1:2).EQ.'CC') then 
            If(LFTR.LT.1024) then
               LFTR=LFTR+1 
               CFTR(LFTR)=RCIN 
            End if
            Go to  31
         End if
         LR=Xblnk(RCIN,64)
         If(Ichar(RCIN(LR:LR)).EQ.13) LR=LR-1
         If(RCIN(1:2).NE.'MA') go to 102
         LFTR=0
         JR=6
      End if  

      If(Index('/;',RCIN(JR:JR)).EQ.0) then
         If(LVAL.NE.0.OR.RCIN(JR:JR).NE.' ') then 
            LVAL=LVAL+1
            If(LVAL.LE.512) then
               CVAL(LVAL:LVAL)=RCIN(JR:JR)
            End if
         End if
         Go to  30
      End if

* check parameter length against buffer size and exit
      
 100  If(LPAR.GT.64) Go to 903
      If(LVAL.GT.512) Go to 904
 101  Return

 102  If(LFTR.LT.1024) then 
         LFTR=LFTR+1
         CFTR(LFTR)=RCIN
      End if
 103  Read(NPRF,'(A)',Err=999,End=901) RCIN
      If(RCIN(1:2).NE.'//') then
         Go to 102
      Else 
         Go to 902
      End if 

* Error unknown data block

 900  IRC=2
      Go to 101

* Warn end of file

 901  IRC=-1
      Go to 101

* Warn profile separator found

 902  IRC=-2
      Go to 101

* Warn parameter name too long

 903  IRC=-3
      Go to 101

* Warn parameter value too long

 904  IRC=-4
      Go to 101

* Error reading file

 999  IRC=1
      Go to 101

      End
*----------------------------------------------------------------------*
      Integer Function PINTR(CVAL,NLOW,IRC)

      Integer           NLOW
      Character*(*)     CVAL 

      If(Index(CVAL,'*').NE.0) then
         PINTR=NLOW
      Else     
         Read(CVAL,*,Err= 101) PINTR
      End if
 100  Return
 101  IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine PINTS(NSCO,ISCO,CVAL,NLOW,NABC,IRC)

* function return types

      Integer           Xblnk
      External          Xblnk

      Integer           ISCO(*)
      Character*(*)     CVAL 
      Integer           NLOW

      L1=Xblnk(CVAL,64) 
      NSCO=0
      J1=1
      Do  10 I1=1,L1
         If(CVAL(I1:I1).EQ.',') then
            J2=I1-1
            NSCO=NSCO+1
            If(NSCO.GT.NABC) Go to 102
            If(J2.LT.J1) then 
               ISCO(NSCO)=0 
            Else
               If(Index(CVAL(J1:J2),'*').NE.0) then
                  ISCO(NSCO)=NLOW
               Else
                  Read(CVAL(J1:J2),*,Err=101) ISCO(NSCO) 
               End if
            End if 
            J1=I1+1
         End if
 10   Continue
      J2=L1
      NSCO=NSCO+1
      If(NSCO.GT.NABC) Go to 102
      If(J2.LT.J1) then 
         ISCO(NSCO)=0 
      Else
         If(Index(CVAL(J1:J2),'*').NE.0) then
            ISCO(NSCO)=NLOW
         Else
            Read(CVAL(J1:J2),*,Err=101) ISCO(NSCO) 
         End if
      End if 
      
 100  Return
      
 101  IRC=1
      Go to 100
 102  IRC=-2
      Go to 100
      End
*----------------------------------------------------------------------*
      Subroutine GETPI(CPAR,CVAL,INDX,ISCO,NABC,NLOW,IRC)

      Character*(*)     CPAR
      Character*(*)     CVAL
      Integer           ISCO(*)
      Integer           NLOW
      Integer           PINTR

      If     (CPAR.EQ.'I0') then
         INDX= 0
      Else if(CPAR.EQ.'I' ) then
         INDX= 1
      Else if(CPAR.EQ.'B0') then
         INDX=27 
      Else if(CPAR.EQ.'B1') then
         INDX=28
      Else if(CPAR.EQ.'E0') then
         INDX=29
      Else if(CPAR.EQ.'E1') then
         INDX=30

      Else if(CPAR.EQ.'BM') then
         INDX=31
      Else if(CPAR.EQ.'BI') then
         INDX=32
      Else if(CPAR.EQ.'BD') then
         INDX=33
      Else if(CPAR.EQ.'BE') then
         INDX=34

      Else if(CPAR.EQ.'MM') then
         INDX=35
      Else if(CPAR.EQ.'MI') then
         INDX=36
      Else if(CPAR.EQ.'MD') then
         INDX=37
      Else if(CPAR.EQ.'ME') then
         INDX=38

      Else if(CPAR.EQ.'IM') then
         INDX=39
      Else if(CPAR.EQ.'II') then
         INDX=40
      Else if(CPAR.EQ.'ID') then
         INDX=41
      Else if(CPAR.EQ.'IE') then
         INDX=42

      Else if(CPAR.EQ.'DM') then
         INDX=43
      Else if(CPAR.EQ.'DI') then
         INDX=44
      Else if(CPAR.EQ.'DD') then
         INDX=45
      Else if(CPAR.EQ.'DE') then
         INDX=46
      Else 
         Go to 900
      End if 

      If(INDX.EQ.1) then
         Call PINTS(NSCO,ISCO,CVAL,NLOW,NABC,IRC)
         If(NSCO.EQ.1) then
            Do  10 I1=2,NABC
               ISCO(I1)=ISCO( 1)
 10         Continue
         End if
      Else
         ISCO(1)=PINTR(CVAL,NLOW,IRC)
      End if 

 100  Return 
 900  IRC=-1
      Go to 100
      End 
*----------------------------------------------------------------------*
      Subroutine GETPM(CPAR,CVAL,INDX,ISCO,NABC,NLOW,IRC)

      Character*(*)     CPAR
      Character*(*)     CVAL
      Integer           ISCO(*)
      Integer           NLOW
      Integer           PINTR

      If     (CPAR.EQ.'M0') then
         INDX= 0
      Else if(CPAR.EQ.'M' ) then
         INDX= 1
      Else if(CPAR.EQ.'D ') then
         INDX=27 
      Else
         Go to 900
      End if

      If(INDX.EQ.1) then
         Call PINTS(NSCO,ISCO,CVAL,NLOW,NABC,IRC)
         If(NSCO.EQ.1) then
            Do  10 I1=2,NABC
               ISCO(I1)=ISCO( 1)
 10         Continue
         End if
      Else
         ISCO(1)=PINTR(CVAL,NLOW,IRC)
      End if 

 100  Return 
 900  IRC=-1
      Go to 100
      End 

*       Program pfscan
*----------------------------------------------------------------------*
* $Id: pfscan.f,v 2.17 2003/12/09 13:42:42 vflegel Exp $
*----------------------------------------------------------------------*
*       Function: Scan a DNA or protein sequences with a profile library
*       Author:   Philipp Bucher
*       Contact:  pftools@sib.swiss
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*
* DATA
*----------------------------------------------------------------------*

* array dimensions and I/O units

      Include          'ardim.f'

      Parameter        (NOUT=   6)

      Parameter        (NPRF=  11)
      Parameter        (NSEQ=  12)

* profile

      Character*4096    FPRF

      Include          'psdat.f'
      Include          'gsdat.f'
      Include          'djdat.f'
      Include          'nodat.f'
      Include          'codat.f'
      Include          'pfdat.f'
      Include          'dfdat.f'
      Include          'pxdat.f'
      Include          'avdat.f'
      Include          'sterr.f'

      Logical           LUNI
      Logical           LNOR
      Logical           LREV
      Logical           LTRA
      Logical           LPFA
      Logical           LEOF
      Logical           LOUT

      Character         DABC(0:26)

* sequence

      Character*4096    FSEQ

      Character*64      CSID
      Character*64      CSAC
      Character*64      CSFH
      Character*512     CSDE

      Integer           LSEQ
      Integer           BSEQ

      Integer*2         ISEQ(IDMS)
      Character         CSEQ(IDMS)

      Logical           LCKS(IDMS)

      Integer*2         IS

* number of sequences, profiles read

      Integer           INBS
      Integer           INBP


* function return types

      Integer           Xblnk
      External          Xblnk

* options and command line parameters

      Logical           OPTA
      Logical           OPTB
      Logical           OPTF
      Logical           OPTL
      Logical           OPTR
      Logical           OPTS
      Logical           OPTU
      Logical           OPTX
      Logical           OPTY
      Logical           OPTZ
      Logical           OPLU
      Logical           OPTM
      Logical           OPTK
      Logical           OPTO
      Logical           OPTD
      Logical           OPTV

      Logical           LCMM
      Logical           OOPR
      Logical           LDRS

* alignments

      Integer           NALI
      Integer           IALS(IDMN)
      Integer           IALB(IDMN)
      Integer           IAL1(IDMN)
      Integer           IAL2(IDMN)
      Integer           IALE(IDMN)

      Integer           LALI
      Character         CALI(IDMA)
      Character         CPMA(IDMM)

* multiple matches of circular profile

      Integer           NMAT(IDMN)
C      Integer           IMMB(IDMN,IDML)
C      Integer           IMME(IDMN,IDML)
      Integer           PK1E(IDML)
      Integer           PK1B(IDML)
      Integer           PK2E(IDML)
      Integer           PK2B(IDML)
      Integer           PK3E(IDML)
      Integer           PK3B(IDML)
      Integer           PJSE(IDML)
      Integer           PJ1E(IDML)
      Integer           PJ1B(IDML)
      Integer           PLAL(IDML)
      Integer           IMSC(IDML)

* path matrix fields

      Integer           IOPM(0:IDMP)
      Integer           IOPI(0:IDMP)
      Integer           IOPD(0:IDMP)

      Integer           IOMB(0:IDMP)
      Integer           IOM1(0:IDMP)
      Integer           IOM2(0:IDMP)

      Integer           IOIB(0:IDMP)
      Integer           IOI1(0:IDMP)
      Integer           IOI2(0:IDMP)

      Integer           IODB(0:IDMP)
      Integer           IOD1(0:IDMP)
      Integer           IOD2(0:IDMP)

* work fields
C      Character*256     RCIN
      Logical           SOPM

* initialization of controlled vocabularies

      Include          'cvini.f'
      Include          'abini.f'

*----------------------------------------------------------------------*
* INPUT SECTION
*----------------------------------------------------------------------*

      IRC=0

      LUNI=.FALSE.
      LNOR=.FALSE.
      LREV=.FALSE.
      LTRA=.FALSE.
      LPFA=.FALSE.
      LEOF=.FALSE.
      LDRS=.FALSE.

      LEOF=.FALSE.
      CABC(0)='-'

      INBS=0
      INBP=0
      BSEQ=1

* read command line arguments

      Call Repar(
     *   OPTA,OPTB,OPTF,OPTL,OPTR,OPTS,OPTU,OPLU,OPTX,OPTY,OPTZ,OPTM,
     *   OPTK,FPRF,FSEQ,LCUC,NW,NMOD,OPTO,OPTD,OPTV,IRC)
      If(IRC.NE.0) then
         Write(NERR,'(/,
     *      ''pfscan 2.3 revision 5.d'',//
     *      ''Usage: pfscan[ -abCdfhlLmMkrsuvWxyz ] [ seq-file'',
     *      '' | - ] [ profile-library-file | - ] [ parameters ]'',//
     *      )')
         Write(NERR,'(
     *      ''   options:'',/,
     *      ''    -a: report optimal alignment for all profiles.'',/
     *      ''    -b: search complementary strand of DNA sequences.'',/
     *      ''    -f: input sequence file is in FASTA format.'',/
     *      ''    -h: print usage help text.'',/
     *      ''    -l: indicate highest cut-off level (number).'',/
     *      ''    -L: indicate highest cut-off level (text).'',/
     *      ''    -m: report individual matches for circular'',
     *      '' profiles.'',/
     *      ''    -r: use raw score.'',/
     *      ''    -u: force profile disjointness to UNIQUE.''
     *      )')
         Write(NERR,'(
     *      ''    -C<value>:'',/
     *      ''        cut-off level to be used for match selection.'',
     *      '' Same as parameter L.'',/
     *      ''    -M<value>:'',/
     *      ''        set the normalization mode to use for the'',
     *      '' score computation.'',/
     *      ''        Overrides the profile PRIORITY parameter.'',/
     *      )')
         Write(NERR,'(
     *      ''   output modifiers:'',/,
     *      ''    -d: impose length limit on profile description.'',/
     *      ''    -k: output using the xPSA header (using keyword'',
     *      ''=value pairs).'',/
     *      ''    -s: list sequences of the matched regions.'',/
     *      ''    -v: suppress warnings on stderr.'',/
     *      ''    -x: list alignments in PSA format.'',/
     *      ''    -y: list alignments in human readable form.'',/
     *      ''    -z: indicate profile start and stop positions.'',/
     *      ''    -W<value>:'',/
     *      ''        specifies the output width. Same as parameter'',
     *      '' W.'',/
     *      )')
         Write(NERR,'(
     *      ''   valid (but deprecated) parameters are:'',/,
     *      ''    [L=cut-off-level]  use option -C instead'',/
     *      ''    [W=output-width]   use option -W instead'',/
     *      )')
         Call Exit(IRC)
      End if


      If(FSEQ.EQ.'-') then
         MSEQ=5
      Else
         MSEQ=NSEQ
      End if

      If(FPRF.EQ.'-') then
         MPRF=5
      Else
         MPRF=NPRF
      End if

      If(OPTR) then
         LDRS=.TRUE.
      End if

      SOPM=OPTM

* read sequence

      If(OPTF) then
         Call RFSEQ
     *      (MSEQ,FSEQ,NABC,CABC,CSID,CSAC,CSDE,CSFH,LSEQ,ISEQ,LEOF,
     *      INBS,OPTV,IRC)
      Else
         Call RESEQ
     *      (MSEQ,FSEQ,NABC,CABC,CSID,CSAC,CSDE,LSEQ,ISEQ,LEOF,
     *      INBS,OPTV,IRC)
      End if
      If(IRC.GT.0) go to 100

      If(LEOF.AND.IRC.LT.0) then
         If(INBS.GE.1) IRC=0
         go to 100
      End if

* check parameter consistency

      If(.NOT.OPTV.AND.OPTA.AND.LCUC.NE.0) then
         Write(NERR,*) 'Warning: Option -a is set. Ignoring command',
     *      ' line cut-off level (option -C).'
         LCUC=0
      End if
      OOPR=OPTR

* determine amino acid composition

      Call CFAve(ISEQ,IDMS,BSEQ,LSEQ,CABC,NABC,FAVE)

* backtranslate sequence into characters

      Do  I1=1,LSEQ
         CSEQ(I1)=CABC(ISEQ(I1))
      End do

* alignment and ouptut format switches

      If(OPTX.OR.OPTY.OR.OPTZ.OR.OPTM) then
         LTRA=.TRUE.
      Else
         LTRA=.FALSE.
      End if
      If(OPTS.OR.OPTX) then
         LPFA=.TRUE.
      Else
         LPFA=.FALSE.
      End if

* compute alignments if any output format switch is specified

      LOUT=(LTRA.OR.LPFA)

*----------------------------------------------------------------------*
* major loop over profiles
*----------------------------------------------------------------------*

 1    Continue

* save alphabet

      OPTR=OOPR
      MABC=NABC
      Do  I1=1,NABC
         DABC(I1)=CABC(I1)
      End do

* read profile

      Call REPRF
     *   (MPRF,FPRF,
     *   CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *   BLOG,FABC,P0,
     *   CDIS,JDIP,MDIS,NDIP,
     *   CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP,
     *   JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *   IDMP,CHIP,IIPP,CHMP,IMPP,CHIL,IIPL,ILIP,
     *   CHID,IIPD,CHMD,IMPD,
     *   INBP,LEOF,OPTV,IRC)

      If(IRC.NE.0.OR.LEOF) Go to 100

* check parameter consistency

      If(.NOT.OPTV.AND.OPTB.AND.NABC.GT.4) then
         Write(NERR,*) 'Warning: Not a DNA sequence. ',
     *      'Ignoring option -b.'
         OPTB=.FALSE.
      End if
      OPTM=SOPM
      If(.NOT.OPTV.AND.OPTM.AND..NOT.LPCI) then
         Write(NERR,*) 'Warning: Profile not circular. ',
     *      'Ignoring option -m.'
         Write(NERR,*) '         While processing profile ',
     *      CPID(1:Lblnk(CPID))
         OPTM=.FALSE.
      End if

* cut-off value

      LCUT=0
      Do   3 I1=1,JCUT
         If(   (MCLE(I1).GE.LCUC.AND.MCLE(I1).LT.LCUT.AND.LCUC.LT.LCUT).
     *      OR.(MCLE(I1).LE.LCUC.AND.MCLE(I1).GT.LCUT.AND.LCUC.GT.LCUT))
     *      LCUT=MCLE(I1)
 3    Continue

      If (.NOT.OPTV.AND.LCUT.NE.LCUC) then
         Write(NERR,*) 'Warning: Cut-off level',LCUC,' is not '//
     *      'defined. Using nearest level',LCUT,'.'
         Write(NERR,*) '         While processing profile ',
     *      CPID(1:Lblnk(CPID))
      End if

      KCUT=0

* find normalisation mode and cut-off level

      LNOR=.FALSE.
      If(OPTO) then
         J1=0
*   find the specified normalisation mode
         Do I1=1,JNOR
            If(NNOR(I1).EQ.NMOD) J1=I1
         End do
*   exit if mode number not specified in profile
         If(J1.EQ.0) Go to 901

*   find mode number in list of cut-off levels
         INOR=0
         Do I1=1,JCUT
            If(MCLE(I1).EQ.LCUT) then
               If(JCNM(I1).NE.0) then
                  J2=0
                  Do I2=1,JCNM(I1)
                     If(MCUT(I2,I1).EQ.NMOD) J2=I2
                  End do
                  If(J2.EQ.0) Go to 903
                  LNOR=.TRUE.
                  INOR=J1
                  MNUM=NNOR(J1)
                  IFUN=MNOR(J1)
                  KCUT=ICUT(I1)
                  XCUT=RCUT(J2,I1)
               Else
                  Go to 903
               End if
            End if
         End do
         If(INOR.EQ.0) Go to 901
      Else

* search cut-off level in profile if normalisation was not specified

         Do   6 I1=1,JCUT
            If(MCLE(I1).EQ.LCUT) then
               INOR=0
               If(JCNM(I1).NE.0) then
                  LNOR=.TRUE.
C                  J2=1
                  Do  5 I2=1,JCNM(I1)
                     J3=0
                     Do  4 I3=1,JNOR
                        If(MCUT(I2,I1).EQ.NNOR(I3)) J3=I3
 4                   Continue
                     If(J3.EQ.0) Go to 904

                     If     (I2.EQ.1) then
                        INOR=J3
                        MNUM=NNOR(J3)
                        NPRI=NNPR(J3)
                        IFUN=MNOR(J3)
                        KCUT=ICUT(I1)
                        XCUT=RCUT(I2,I1)
                     Else if(NNPR(J3).LT.NPRI) then
                        INOR=J3
                        MNUM=NNOR(J3)
                        NPRI=NNPR(J3)
                        IFUN=MNOR(J3)
                        KCUT=ICUT(I1)
                        XCUT=RCUT(I2,I1)
                     End if
 5                Continue
               End if

               If(JCNM(I1).EQ.0.OR.INOR.EQ.0) then
                  KCUT=ICUT(I1)
                  LNOR=.FALSE.
               End if
            End if
 6       Continue
      End if

      If(.NOT.LNOR) OPTR=.TRUE.
*      If(OPTR) LNOR=.FALSE.

* disjoint definition
* set disjointness position to begin and end of profile if necessary

      If(MDIS.EQ.1.OR.OPTU.OR.OPTA) then
         LUNI=.TRUE.
         If(MDIS.EQ.1) then
            NDIP(1)=1
            NDIP(2)=LPRF
         End if
      Else
         LUNI=.FALSE.
      End if

* - initialize profile lock

      If(.NOT.LPCI) then
         Do  8 I1=0,NDIP(1)-1
            IIPP(E0,I1)=NLOW
            IIPP(E1,I1)=NLOW
 8       Continue

         Do  9 I1=NDIP(2),LPRF
            IIPP(B0,I1)=NLOW
            IIPP(B1,I1)=NLOW
 9       Continue
      End if

C      End if

* profile extra parameters

      MLOW=NLOW/4*3
      Do  10 I1=0,LPRF
         IIPX( XM,I1) = MAX(MLOW,IIPP( B1,I1) + IIPP( BM,I1))
         IIPX( XI,I1) = MAX(MLOW,IIPP( B1,I1) + IIPP( BI,I1))
         IIPX( XD,I1) = MAX(MLOW,IIPP( B1,I1) + IIPP( BD,I1))
         IIPX( YM,I1) = MAX(MLOW,IIPP( B0,I1) + IIPP( BM,I1))
         IIPX( YI,I1) = MAX(MLOW,IIPP( B0,I1) + IIPP( BI,I1))
         IIPX( YD,I1) = MAX(MLOW,IIPP( B0,I1) + IIPP( BD,I1))
         IIPX( MX,I1) = MAX(MLOW,IIPP( E1,I1) + IIPP( ME,I1))
         IIPX( IX,I1) = MAX(MLOW,IIPP( E1,I1) + IIPP( IE,I1))
         IIPX( DX,I1) = MAX(MLOW,IIPP( E1,I1) + IIPP( DE,I1))
         IIPX( MY,I1) = MAX(MLOW,IIPP( E0,I1) + IIPP( ME,I1))
         IIPX( IY,I1) = MAX(MLOW,IIPP( E0,I1) + IIPP( IE,I1))
         IIPX( DY,I1) = MAX(MLOW,IIPP( E0,I1) + IIPP( DE,I1))
 10   Continue

* check alphabet

      If(NABC.EQ.MABC) then
         Do  I1=1,NABC
            If(CABC(I1).NE.DABC(I1)) go to  15
         End do
         Go to  21
      End if
 15   Continue

* reconvert sequence into numbers (if necessary)

      Do  20 I1=1,LSEQ
         ISEQ(I1)=0
         Do  19 I2=1,NABC
            If(CSEQ(I1).EQ.CABC(I2)) then
               ISEQ(I1)=I2
               Go to  20
            End if
 19      Continue
 20   Continue
      If(.NOT.OPTR.AND.IFUN.EQ.3)
     *   Call CFAve(ISEQ,IDMS,BSEQ,LSEQ,CABC,NABC,FAVE)

 21   Continue

* compute cut-off in raw score units

      If(.NOT.OPTR) then
         If(IFUN.EQ.3) then
            Call CPAve(IMPP,IDMP,LPRF,CABC,NABC,PAVE)
            RAVE=0
            Do  I1=0,NABC
               RAVE=RAVE+FAVE(I1)*PAVE(I1)
            End do
         End if
         Call NtoR(XCUT,KCUT,RNOP,KNPM,MAXN,INOR,IFUN,LSEQ,RAVE)
      End if

      JSEQ=0

 25   Continue

* should alignments of repeats be computed

      If(OPTM) then
         LCMM=.TRUE.
      Else
         LCMM=.FALSE.
      End if


* compute optimal alignment score

      Call XALI1
     *   (LPRF,LPCI,
     *   KCUT,IIPP,IMPP,IIPX,
     *   BSEQ,LSEQ,ISEQ,
     *   IOPM,IOPI,IOPD,
     *   IOPT,LUNI,
     *   IRC)

      If(OPTA) then
         Continue
      Else if(IOPT.LT.KCUT) then
         go to  50
      End if

* do not compute alignments if no format modifier specified
* and the disjointness is 'UNIQUE'

      If(.NOT.LOUT.AND.LUNI) go to  30

* initialize sequence lock

      Do  I1=1,LSEQ
         LCKS(I1)=.FALSE.
      End do

* find optimal match

      If(LUNI) then
         Call XALIP
     *      (NABC,LPRF,LPCI,NDIP(1),NDIP(2),
     *      IOPT,IIPP,IMPP,CHIP,CHMP,IIPX,
     *      BSEQ,LSEQ,ISEQ,LCKS,
     *      IOPM,IOPI,IOPD,
     *      IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2,
     *      NALI,IALS,IALB,IAL1,IAL2,IALE,
     *      LUNI,
     *      IRC)
      Else

* find all matches

         Call XALIP
     *      (NABC,LPRF,LPCI,NDIP(1),NDIP(2),
     *      KCUT,IIPP,IMPP,CHIP,CHMP,IIPX,
     *      BSEQ,LSEQ,ISEQ,LCKS,
     *      IOPM,IOPI,IOPD,
     *      IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2,
     *      NALI,IALS,IALB,IAL1,IAL2,IALE,
     *      LUNI,
     *      IRC)
      End if
      If(IRC.NE.0) then
         Write(NERR,*) '       While processing sequence ',
     *      CSID(1:Lblnk(CSID))
         IRC=0
         Go to 50
      End if

* remove sequence lock if alignments are to be generated

      If(LTRA) then
         Do I1=1,LSEQ
            LCKS(I1)=.FALSE.
         End do
      End if

* OUTPUT

 30   Continue

      If(LUNI) then
         NALI=1
         IALS(1)=IOPT
      End if
      Do  40 I1=1,NALI
         JSEQ=JSEQ+1

         If(LTRA) then
            Call XALIT
     *         (CABC,LPRF,LPCI,NDIP(1),NDIP(2),
     *         IIPP,IMPP,IIPX,
     *         LSEQ,ISEQ,LCKS,
     *         IOPM,IOPI,IOPD,
     *         LALI,CALI,CPMA,IMSC,
     *         IALS(I1),IALB(I1),IALE(I1),
     *         NMAT(I1),
     *         PK2E,PK2B,PK3E,PK3B,
     *         PJ1E,PJ1B,PLAL,
     *         OPTM,
     *         IPMB,IPME,
     *         IRC)
            If(IRC.GT.0) Go to 100
            Do  I2=IAL1(I1),IAL2(I1)
               LCKS(I2)=.FALSE.
            End do
         End if

         If(.NOT.OPTK) then
            Call WPRSM(JSEQ,NMAT(I1),.FALSE.,
     *         LUNI,LOUT,LNOR,LREV,LPFA,OPTZ,OPTL,OPLU,NW,
     *         CPID,CPAC,CPDE,OPTD,OPTR,LDRS,
     *         IALS(I1),IALB(I1),IALE(I1),NALI,IPMB,IPME,
     *         JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *         RNOP,KNPM,MAXN,INOR,IFUN,MNUM,LSEQ,RAVE)
         Else
            Call XPRSM(JSEQ,NMAT(I1),.FALSE.,
     *         LUNI,LOUT,LNOR,LREV,OPTZ,OPTL,OPLU,OPTB,
     *         CSID,CSAC,CSFH,CPID,CPAC,OPTR,OPTF,LDRS,
     *         IALS(I1),IALB(I1),IALE(I1),NALI,IPMB,IPME,
     *         JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *         RNOP,KNPM,MAXN,INOR,IFUN,MNUM,LSEQ,RAVE)
         End if

         If     (OPTS) then
            Call PRSP(CABC,ISEQ,CALI,IALB(I1),IALE(I1),NW,OPTS,OPTX)
         Else if(OPTX) then
            Call PRSP(CABC,ISEQ,CALI,1,LALI,NW,OPTS,OPTX)
         Else if(OPTY) then
            Call PRALI
     *         (LPRF,CHIP,CHMP,IDMP,LSEQ,LREV,
     *         CALI,LALI,IALB(I1),IALE(I1),NW)
         End if

*----------------------------------------------------------------------*
* Compute single repeats for circular profiles
*----------------------------------------------------------------------*

         If(OPTM) then
            If(NMAT(I1).GT.1) then
               Do I2=NMAT(I1),1,-1
                  If(.NOT.OPTK) then
                     Call WPRSM(JSEQ,NMAT(I1)-I2+1,.TRUE.,
     *                  LUNI,LOUT,LNOR,LREV,LPFA,OPTZ,OPTL,OPLU,NW,
     *                  CPID,CPAC,CPDE,OPTD,OPTR,LDRS,
     *                  IMSC(I2),PK2B(I2),PK2E(I2),NALI,
     *                  PK3B(I2),PK3E(I2)-LPRF-1,
     *                  JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *                  RNOP,KNPM,MAXN,INOR,IFUN,MNUM,LSEQ,RAVE)
                  Else
                     Call XPRSM(JSEQ,NMAT(I1)-I2+1,.TRUE.,
     *                  LUNI,LOUT,LNOR,LREV,OPTZ,OPTL,OPLU,OPTB,
     *                  CSID,CSAC,CSFH,CPID,CPAC,OPTR,OPTF,LDRS,
     *                  IMSC(I2),PK2B(I2),PK2E(I2),NALI,
     *                  PK3B(I2),PK3E(I2)-LPRF-1,
     *                  JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *                  RNOP,KNPM,MAXN,INOR,IFUN,MNUM,LSEQ,RAVE)
                  End if

                  If     (OPTS) then
                     Call PRSP(CABC,ISEQ,CALI,PK2B(I2),PK2E(I2),
     *                  NW,OPTS,OPTX)
                  Else if(OPTX) then
                     Call PRXP(CALI,PJ1B(I2),PJ1B(I2)+PLAL(I2)-1,
     *                  PK3B(I2),PK3E(I2),LPRF,NW)
                  Else if(OPTY) then
                     Call PMALI
     *                  (LPRF,CHIP,CHMP,IDMP,LSEQ,LREV,CALI,
     *                  PK2B(I2),PK3E(I2),PK3B(I2),PJ1E(I2),PJ1B(I2),NW)
                  End if

               End do
* End loop over repeats
            End if
         End if
* End loop over matches

 40   Continue

 50   If(OPTB) then

         If(LREV) then

* regenerate original strand

            J1=LSEQ
            Do  I1=1,LSEQ/2
               IS=ISEQ(I1)
               ISEQ(I1)=ISEQ(J1)
               ISEQ(J1)=IS
               J1=J1-1
            End do

            Do  I1=1,LSEQ
               If(ISEQ(I1).NE.0) ISEQ(I1)=NABC-ISEQ(I1)+1
            End do

            LREV=.FALSE.
            Go to   1
         End if
      Else
         Go to   1
      End if

*----------------------------------------------------------------------*
* Complementary strand
*----------------------------------------------------------------------*

* generate complementary sequence

      J1=LSEQ
      Do  I1=1,LSEQ/2
         IS=ISEQ(I1)
         ISEQ(I1)=ISEQ(J1)
         ISEQ(J1)=IS
         J1=J1-1
      End do

      Do  I1=1,LSEQ
         If(ISEQ(I1).NE.0) ISEQ(I1)=NABC-ISEQ(I1)+1
      End do

      LREV=.TRUE.

      Go to  25

 100  Call Exit(IRC)

* errors

 901  Write(NERR,*) 'Error: Normalisation mode',NMOD,' is not'//
     *   ' defined.'
      Write(NERR,*) '       While processing profile ',
     *   CPID(1:Lblnk(CPID))
      IRC=1
      Go to 100
 903  Write(NERR,*) 'Error: Normalisation mode',NMOD,' is not'//
     *   ' defined for level',LCUT,' cut-off.'
      Write(NERR,*) '       While processing profile ',
     *   CPID(1:Lblnk(CPID))
      IRC=1
      Go to 100
 904  Write(NERR,*) 'Error: Normalisation mode(s) of level',LCUT,
     *   ' is not defined in the profile.'
      Write(NERR,*) '       While processing profile ',
     *   CPID(1:Lblnk(CPID))
      IRC=1
      Go to 100

      End
*----------------------------------------------------------------------*
      Subroutine Repar(
     *   OPTA,OPTB,OPTF,OPTL,OPTR,OPTS,OPTU,OPLU,OPTX,OPTY,OPTZ,OPTM,
     *   OPTK,FPRF,FSEQ,LCUC,NW,NMOD,OPTO,OPTD,OPTV,IRC)

      Logical           OPTA
      Logical           OPTB
      Logical           OPTF
      Logical           OPTL
      Logical           OPLU
      Logical           OPTR
      Logical           OPTS
      Logical           OPTU
      Logical           OPTX
      Logical           OPTY
      Logical           OPTZ
      Logical           OPTM
      Logical           OPTK
      Logical           OPTO
      Logical           OPTD
      Logical           OPTV

      Character*(*)     FPRF
      Character*(*)     FSEQ
      Character*4096   CARG

      IRC=0

      OPTA=.FALSE.
      OPTB=.FALSE.
      OPTF=.FALSE.
      OPTL=.FALSE.
      OPLU=.FALSE.
      OPTR=.FALSE.
      OPTS=.FALSE.
      OPTU=.FALSE.
      OPTX=.FALSE.
      OPTY=.FALSE.
      OPTZ=.FALSE.
      OPTM=.FALSE.
      OPTO=.FALSE.
      OPTK=.FALSE.
      OPTD=.FALSE.
      OPTV=.FALSE.

      LCUC=0
      NW=60
      N1=Iargc()

      K1=0
      I2=1
      Do I1=1,N1
         Call GetArg(I2,CARG)
         If     (CARG(1:1).EQ.'-'.
     *      AND.CARG(2:2).NE.' '.AND.K1.LT.1) then
            If(Index(CARG,'h').NE.0) go to 900
            If(Index(CARG,'a').NE.0) OPTA=.TRUE.
            If(Index(CARG,'b').NE.0) OPTB=.TRUE.
            If(Index(CARG,'d').NE.0) OPTD=.TRUE.
            If(Index(CARG,'f').NE.0) OPTF=.TRUE.
            If(Index(CARG,'l').NE.0) OPTL=.TRUE.
            If(Index(CARG,'L').NE.0) OPLU=.TRUE.
            If(Index(CARG,'r').NE.0) OPTR=.TRUE.
            If(Index(CARG,'s').NE.0) OPTS=.TRUE.
            If(Index(CARG,'u').NE.0) OPTU=.TRUE.
            If(Index(CARG,'x').NE.0) OPTX=.TRUE.
            If(Index(CARG,'y').NE.0) OPTY=.TRUE.
            If(Index(CARG,'z').NE.0) OPTZ=.TRUE.
            If(Index(CARG,'m').NE.0) OPTM=.TRUE.
            If(Index(CARG,'k').NE.0) OPTK=.TRUE.
            If(Index(CARG,'v').NE.0) OPTV=.TRUE.
            If(Index(CARG,'W').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) NW
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) NW
               End if
            End if
            If(Index(CARG,'C').NE.0) then
               If(CARG(3:3).NE.' ') then
                  CARG(1:2)='  '
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
               End if
               Read(CARG,*,Err=900) LCUC
            End if
            If(Index(CARG,'M').NE.0) then
               If(CARG(3:3).NE.' ') then
                  Read(CARG(3:),*,Err=900) NMOD
               Else
                  I2=I2+1
                  Call GetArg(I2,CARG)
                  Read(CARG,*,Err=900) NMOD
               End if
               OPTO=.TRUE.
            End if
         Else if(K1.LE.1) then
            K1=K1+1
            If     (K1.EQ.1) then
               FSEQ=CARG
            Else if(K1.EQ.2) then
               FPRF=CARG
            End if
         Else

* - cut-off level on command line

            If(CARG(1:2).EQ.'L=') then
               CARG(1:2)=' '
               LCUC=0
               Read(CARG,*,Err=900) LCUC

* - output width on command line

            Else if(CARG(1:2).EQ.'W=') then
               Read(CARG(3:),*,Err=900) NW
            End if
         End if
         I2=I2+1
         If(I2.GT.N1) Go to 20
      End do

 20   If(K1.NE.2) IRC=1

 100  If(NW.LE.0.OR.NW.GT.512) NW=60
      Return
 900  IRC=1
      Go to 100
      End
*----------------------------------------------------------------------*
      Include          'reprf.f'
      Include          'reseq.f'
      Include          'rfseq.f'
      Include          'xali1.f'
      Include          'xalip.f'
      Include          'RtoN.f'
      Include          'NtoR.f'
      Include          'CFAve.f'
      Include          'CPAve.f'
      Include          'wprsm.f'
      Include          'xprsm.f'
      Include          'xalit.f'
      Include          'lblnk.f'
      Include          'prali.f'
      Include          'pmali.f'
      Include          'prsp.f'
      Include          'prxp.f'
      Include          'Xblnk.f'

*----------------------------------------------------------------------*     
* $Id: xalit.f,v 2.9 2003/04/11 13:43:53 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine XALIT
     *   (CABC,LPRF,LPCI,N1,N2,
     *   IIPP,IMPP,IIPX, 
     *   LSEQ,ISEQ,LCKS, 
     *   IOPM,IOPI,IOPD, 
     *   LALI,CALI,CPMA,IMSC,
     *   IOPT,JALB,JALE, 
     *   NMAT,
     *   PK2E,PK2B,PK3E,PK3B,
     *   PJ1E,PJ1B,PLAL,
     *   OPTM,
     *   IPMB,IPME,
     *   IRC) 

* profile and sequence fields :

      Include           'ardim.f'
      Include           'gsdat.f'
      Include           'pfdat.f'
      Include           'pxdat.f'
      Include           'sterr.f'

* sequence

      Integer           LSEQ
      Integer*2         ISEQ(IDMS)
      Logical           LCKS(IDMS)

* alignment
      
      Integer           LALI
      Character         CALI(IDMA)
      Character         CPMA(IDMM)
      Character         CH

* multiple matches of circular profile

      Integer           NMAT
C      Integer           IMMB(IDMN,IDML)
C      Integer           IMME(IDMN,IDML)
      Integer           PK2E(*)
      Integer           PK2B(*)
      Integer           PK3E(*)
      Integer           PK3B(*)
      Integer           PJ1E(*)
      Integer           PJ1B(*)
      Integer           PLAL(*)
      Integer           IMSC(*)
C      Integer           IMMS(512)

      Logical           OPTM

* prune delete positions at beginning and end of multiple matches
      Logical           LDFE
* Logical Delete To Begin
      Logical           LDTB
* Position (in alignment) Delete To Begin
      Integer           PDTB
* Score Delete to Begin
      Integer           SDTB
* Temp Delete to Begin score
      Integer           TDTB

* work fields

      Integer           TK1B
      Integer           TK2B
      Integer           TK3B
      Integer           TJ1B
      Integer           TLAL

      Integer           IOPM(0:IDMP)
      Integer           IOPI(0:IDMP)
      Integer           IOPD(0:IDMP)

      Integer           ZM
      Integer           ZI
      Integer           ZD

      Integer           MZ
      Integer           IZ
      Integer           DZ

      Integer           KOPM

      Logical           LIMM


      IRC=0
      MLOW=NLOW/4*3

C       If(NABC.LT.20) then 
C          CABC(0)='N'
C       Else 
C          CABC(0)='X'
C       End if    

      If((LPRF+1)*(JALE-JALB+1).GT.IDMM) then
         Write(NERR,*) ' Error: Alignment path matrix exceeds buffer ',
     *      'size (',IDMM,').'
         IRC=1
         Go to 100
      End if  
      If((JALE-JALB+1).GT.IDMA) then
         Write(NERR,*) ' Error: Alignment exceeds buffer ',
     *      'size (',IDMA,').'
         IRC=1
         Go to 100
      End if  

      K1=0

* beginning of sequence segment  

      If(JALB.EQ.1) then
         ZM=YM
         ZI=YI
         ZD=YD
      Else
         ZM=XM
         ZI=XI
         ZD=XD
      End if
      MZ=MX
      IZ=IX
      DZ=DX

      K1=K1+1
      I2=0

      KM=NLOW
      KI=NLOW
      KD=NLOW

      Call MaxP
     *   (IOPM(I2),IOPI(I2),IOPD(I2),JM,JI,JD,KM,KI,KD,
     *   IIPP(MM,I2),IIPP(MI,I2),IIPP(MD,I2),
     *   IIPP(IM,I2),IIPP(II,I2),IIPP(ID,I2),
     *   IIPP(DM,I2),IIPP(DI,I2),IIPP(DD,I2),
     *   IIPX(ZM,I2),IIPX(ZI,I2),IIPX(ZD,I2))
      Call Ncode(CPMA(K1),JM,JI,JD)
      
      Do   9, I2=1,LPRF

         K1=K1+1

         KM=NLOW
         KI=NLOW 
         KD=IOPD(I2-1)+IMPP( D,I2)

         Call MaxP
     *      (IOPM(I2),IOPI(I2),IOPD(I2),JM,JI,JD,KM,KI,KD,
     *      IIPP(MM,I2),IIPP(MI,I2),IIPP(MD,I2),
     *      IIPP(IM,I2),IIPP(II,I2),IIPP(ID,I2),
     *      IIPP(DM,I2),IIPP(DI,I2),IIPP(DD,I2),
     *      IIPX(ZM,I2),IIPX(ZI,I2),IIPX(ZD,I2))
         Call Ncode(CPMA(K1),JM,JI,JD)

 9    Continue

* - circular extensions

      If(LPCI) then
         L1=K1-LPRF
         Call Dcode(CPMA(L1),LM,LI,LD)
         If(IOPM( 0).LT.IOPM(LPRF)) then
            IOPM( 0)=IOPM(LPRF)
            LM=JM 
         End if 
         If(IOPI( 0).LT.IOPI(LPRF)) then
            IOPI( 0)=IOPI(LPRF)
            LI=JI 
         End if 
         If(IOPD( 0).LT.IOPD(LPRF)) then
            IOPD( 0)=IOPD(LPRF)
            LD=JD 
         End if 
         Call Ncode(CPMA(L1),LM,LI,LD)

         Do I2=1,LPRF
            L1=L1+1
            KD=IOPD(I2-1)+IMPP( D,I2)
            If(IOPD(I2).GE.KD+IIPP(DD,I2)) then
               Go to  10
            Else
               Call Dcode(CPMA(L1),LM,LI,LD)
               If(IOPM(I2).LT.KD+IIPP(DM,I2)) then
                  IOPM(I2)=KD+IIPP(DM,I2)
                  LM=3
               End if 
               If(IOPI(I2).LT.KD+IIPP(DI,I2)) then
                  IOPI(I2)=KD+IIPP(DI,I2)
                  LI=3
               End if 
               IOPD(I2)=KD+IIPP(DD,I2)
               LD=3
               Call Ncode(CPMA(L1),LM,LI,LD)
            End if
         End do
 10      Continue
      End if
C          Call wtrace(IDMP,IDMM,LPRF,CPMA,K1-LPRF,IOPM,IOPI,IOPD)
* -----------------------------------------------------------


* internal sequence positions

      ZM=XM
      ZI=XI
      ZD=XD

      Do  25 I1=JALB,JALE-1

         If(LCKS(I1)) then
            IOPM(N1-1)=NLOW
            Do I2=N1,N2-1
               IOPM(I2)=NLOW
               IOPI(I2)=NLOW
            End do 
         End if

         J1=ISEQ(I1)
         K1=K1+1
         I2=0

         KM=NLOW
         KI=IOPI( 0)+IIPP(J1, 0)
         KD=NLOW

         KOPM=IOPM( 0)

         Call MaxP
     *      (IOPM(I2),IOPI(I2),IOPD(I2),JM,JI,JD,KM,KI,KD,
     *      IIPP(MM,I2),IIPP(MI,I2),IIPP(MD,I2),
     *      IIPP(IM,I2),IIPP(II,I2),IIPP(ID,I2),
     *      IIPP(DM,I2),IIPP(DI,I2),IIPP(DD,I2),
     *      IIPX(ZM,I2),IIPX(ZI,I2),IIPX(ZD,I2))
         Call Ncode(CPMA(K1),JM,JI,JD)

         Do  19 I2=1,LPRF

            K1=K1+1

            KM=KOPM      +IMPP(J1,I2)
            KI=IOPI(I2  )+IIPP(J1,I2)
            KD=IOPD(I2-1)+IMPP( D,I2)

            KOPM=IOPM(I2)

            Call MaxP
     *         (IOPM(I2),IOPI(I2),IOPD(I2),JM,JI,JD,KM,KI,KD,
     *         IIPP(MM,I2),IIPP(MI,I2),IIPP(MD,I2),
     *         IIPP(IM,I2),IIPP(II,I2),IIPP(ID,I2),
     *         IIPP(DM,I2),IIPP(DI,I2),IIPP(DD,I2),
     *         IIPX(ZM,I2),IIPX(ZI,I2),IIPX(ZD,I2))
            Call Ncode(CPMA(K1),JM,JI,JD)
 19      Continue

* - circular extensions

         If(LPCI) then
            L1=K1-LPRF
            Call Dcode(CPMA(L1),LM,LI,LD)
            If(IOPM( 0).LT.IOPM(LPRF)) then
               IOPM( 0)=IOPM(LPRF)
               LM=JM 
            End if 
            If(IOPI( 0).LT.IOPI(LPRF)) then
               IOPI( 0)=IOPI(LPRF)
               LI=JI 
            End if 
            If(IOPD( 0).LT.IOPD(LPRF)) then
               IOPD( 0)=IOPD(LPRF)
               LD=JD 
            End if 
            Call Ncode(CPMA(L1),LM,LI,LD)

            Do I2=1,LPRF
               L1=L1+1
               KD=IOPD(I2-1)+IMPP( D,I2)
               If(IOPD(I2).GE.KD+IIPP(DD,I2)) then
                  Go to  20
               Else
                  Call Dcode(CPMA(L1),LM,LI,LD)
                  If(IOPM(I2).LT.KD+IIPP(DM,I2)) then
                     IOPM(I2)=KD+IIPP(DM,I2)
                     LM=3
                  End if 
                  If(IOPI(I2).LT.KD+IIPP(DI,I2)) then
                     IOPI(I2)=KD+IIPP(DI,I2)
                     LI=3
                  End if 
                  IOPD(I2)=KD+IIPP(DD,I2)
                  LD=3
                  Call Ncode(CPMA(L1),LM,LI,LD)
               End if
            End do
 20         Continue
         End if
* -----------------------------------------------------------
C          Call wtrace(IDMP,IDMM,LPRF,CPMA,K1-LPRF,IOPM,IOPI,IOPD)

 25   Continue

* end of sequence 

      If(JALE.EQ.LSEQ) then
         MZ=MY
         IZ=IY
         DZ=DY
      End if  

      If(LCKS(JALE)) then
         IOPM(N1-1)=NLOW
         Do I2=N1,N2-1
            IOPM(I2)=NLOW
            IOPI(I2)=NLOW
         End do 
      End if

      J1=ISEQ(JALE)
      K1=K1+1
      I2=0

      KM=NLOW
      KI=IOPI( 0)+IIPP(J1, 0)
      KD=NLOW 

      KOPM=IOPM( 0)

      Call MaxP
     *   (IOPM(I2),IOPI(I2),IOPD(I2),JM,JI,JD,KM,KI,KD,
     *   IIPP(MM,I2),IIPP(MI,I2),IIPP(MD,I2),
     *   IIPP(IM,I2),IIPP(II,I2),IIPP(ID,I2),
     *   IIPP(DM,I2),IIPP(DI,I2),IIPP(DD,I2),
     *   IIPX(ZM,I2),IIPX(ZI,I2),IIPX(ZD,I2))
      Call Ncode(CPMA(K1),JM,JI,JD)

      I2=0
      If(KI+IIPX(IZ,I2).GE.IOPT) then
         JS=1
         Go to  50
      End if

      Do  29 I2=1,LPRF

         K1=K1+1

         KM=KOPM      +IMPP(J1,I2)
         KI=IOPI(I2  )+IIPP(J1,I2)
         KD=IOPD(I2-1)+IMPP( D,I2)

         KOPM=IOPM(I2)

         Call MaxP
     *      (IOPM(I2),IOPI(I2),IOPD(I2),JM,JI,JD,KM,KI,KD,
     *      IIPP(MM,I2),IIPP(MI,I2),IIPP(MD,I2),
     *      IIPP(IM,I2),IIPP(II,I2),IIPP(ID,I2),
     *      IIPP(DM,I2),IIPP(DI,I2),IIPP(DD,I2),
     *      IIPX(ZM,I2),IIPX(ZI,I2),IIPX(ZD,I2))
         Call Ncode(CPMA(K1),JM,JI,JD)

         If     (KI+IIPX(IZ,I2).GE.IOPT) then 
            JS=1
            Go to  50
         Else if(KM+IIPX(MZ,I2).GE.IOPT) then 
            JS=2
            Go to  50
         Else if(KD+IIPX(DZ,I2).GE.IOPT) then 
            JS=3
            Go to  50
         End if 

 29   Continue

* - circular extensions

      If(LPCI) then
         L1=K1-LPRF
         Call Dcode(CPMA(L1),LM,LI,LD)
         If(IOPD( 0).LT.IOPD(LPRF)) then
            IOPD( 0)=IOPD(LPRF)
            LD=JD 
         End if 
         Call Ncode(CPMA(L1),LM,LI,LD)

         Do I2=1,LPRF
            L1=L1+1
            KD=IOPD(I2-1)+IMPP( D,I2)
            If(KD+IIPX(DZ,I2).GE.IOPT) then
               JS=3
               K1=L1
            End if 
            If(IOPD(I2).GE.KD+IIPP(DD,I2)) then
               Go to  30
            Else
               Call Dcode(CPMA(L1),LM,LI,LD)
               IOPD(I2)=KD+IIPP(DD,I2)
               LD=3
               Call Ncode(CPMA(L1),LM,LI,LD)
            End if
         End do
 30      Continue
      End if
* -----------------------------------------------------------

 50   Continue

C          Call wtrace(IDMP,IDMM,LPRF,CPMA,K1-LPRF,IOPM,IOPI,IOPD)

      K2=JALE
      K3=I2
      IPME=K3-LPRF-1
C      Write(NERR,*) 'K1: ',K1,' K2: ',K2,' K3: ',K3,
C     *   ' IPME: ',IPME,' OPTM: ',OPTM


* trace back
      
      JO=0
      K4=0
      K5=IOPT
      J1=0
      Do  I1=LPRF,K3+1,-1
         J1=J1+1
         CALI(J1)='-'
      End do

      LIMM=.FALSE.
      SDTB=MLOW
      TDTB=MLOW
      LDTB=.FALSE.
 60   Continue
C       Write(6,'(5I5)') K1,K2,K3,JS

* insert position

C      Write(NERR,*)'JO: ',JO,' JS: ',JS

      If     (JS.EQ.1) then 
         LDTB=.FALSE.
         If(LIMM.AND.OPTM) then
            LDFE=.FALSE.
            If(JO.EQ.1) then
               IMSC(K4)=IMSC(K4)+IIPP(II,K3)
C               Write(NERR,*)'Score: ',IIPP(II,K3)
            Else if(JO.EQ.2) then
               IMSC(K4)=IMSC(K4)+IIPP(MI,K3)
C               Write(NERR,*)'Score: ',IIPP(IM,K3)
            Else if(JO.EQ.3) then
               IMSC(K4)=IMSC(K4)+IIPP(DI,K3)
C               Write(NERR,*)'Score: ',IIPP(ID,K3)
            End if
            IMSC(K4)=IMSC(K4)+IIPP(ISEQ(K2),K3)
C            Write(NERR,*)'Score: ',IIPP(ISEQ(K2),K3)
         End if
         J1=J1+1
         CALI(J1)=Char(Ichar(CABC(ISEQ(K2)))+32)
C         Write(NERR,*) 'CALI(',J1,'): ',CALI(J1),' No Match',
C     *      ' JS: ',JS
         K1=K1-LPRF-1
         K2=K2-1

* match position

      Else if(JS.EQ.2) then
         LDTB=.FALSE.
         If(LIMM.AND.OPTM) then
            If(JO.EQ.1) then
               IMSC(K4)=IMSC(K4)+IMPP(ISEQ(K2),K3)
C               Write(NERR,*)'Score: ',IMPP(ISEQ(K2),K3)
               IMSC(K4)=IMSC(K4)+IIPP(MI,K3)
C               Write(NERR,*)'Score: ',IIPP(MI,K3)
            Else if(JO.EQ.2) then
               LDFE=.FALSE.
               IMSC(K4)=IMSC(K4)+IMPP(ISEQ(K2),K3)
C               Write(NERR,*)'Score: ',IMPP(ISEQ(K2),K3)
               IMSC(K4)=IMSC(K4)+IIPP(MM,K3)
C               Write(NERR,*)'Score: ',IIPP(MM,K3)
            Else if(JO.EQ.3) then
               If((LDFE.EQV..TRUE.).AND.
     *            (IIPX(MX,K3).GE.(IMSC(K4)+IIPP(MD,K3)))) then
                  PK2E(K4)=K2
                  PK3E(K4)=K3
                  PJ1E(K4)=J1
                  IMSC(K4)=IIPX(MX,K3)+IMPP(ISEQ(K2),K3)
               Else
                  IMSC(K4)=IMSC(K4)+IMPP(ISEQ(K2),K3)
C               Write(NERR,*)'Score: ',IMPP(ISEQ(K2),K3)
                  IMSC(K4)=IMSC(K4)+IIPP(MD,K3)
C               Write(NERR,*)'Score: ',IIPP(MD,K3)
               End if
            End if
            LDFE=.FALSE.
         Else if(.NOT.LIMM.AND.OPTM) then
            K4=K4+1
            PK2E(K4)=K2
            PK3E(K4)=K3
            PJ1E(K4)=J1
            If(K2.GE.LSEQ.AND.IIPX(MY,K3).GT.MLOW) then
               IMSC(K4)=IIPX(MY,K3)
C               Write(NERR,*)'Score: ',IIPX(MY,K3)
            Else if(IIPX(MX,K3).GT.MLOW) then
               IMSC(K4)=IIPX(MX,K3)
C               Write(NERR,*)'Score: ',IIPX(MX,K3)
            Else
               IMSC(K4)=0
C               Write(NERR,*)'Score: 0'
            End if
            IMSC(K4)=IMSC(K4)+IMPP(ISEQ(K2),K3)
C            Write(NERR,*)'Score: ',IMPP(ISEQ(K2),K3)
C            Write(NERR,*) 'End mult match nb: ',K4,' in match'
C            Write(NERR,*) 'PK2E: ',PK2E(K4)
C            Write(NERR,*) 'PK3E: ',PK3E(K4)
C            Write(NERR,*) 'PJ1E: ',PJ1E(K4)
            LIMM=.TRUE.
            LDFE=.FALSE.
            SDTB=MLOW
            TDTB=MLOW
         End if
         J1=J1+1
         CALI(J1)=CABC(ISEQ(K2))
C         Write(NERR,*) 'CALI(',J1,'): ',CALI(J1),' Match',
C     *      ' JS: ',JS
         K1=K1-LPRF-2
         K2=K2-1
         K3=K3-1  
         If(LPCI.AND.K3.EQ.0) then 
            If(LIMM.AND.OPTM) then
               PK2B(K4)=K2+1
               PK3B(K4)=K3+1
               PJ1B(K4)=J1
               PLAL(K4)=PJ1B(K4)-PJ1E(K4)
               If(K2.LE.1.AND.IIPX(YM,K3).GT.MLOW) then
                  IMSC(K4)=IMSC(K4)+IIPX(YM,K3)
C                  Write(NERR,*)'Score: ',IIPX(YM,K3)
               Else if(IIPX(XM,K3).GT.MLOW) then
                  IMSC(K4)=IMSC(K4)+IIPX(XM,K3)
C                  Write(NERR,*)'Score: ',IIPX(XM,K3)
*              Else
*                 Do nothing
               End if
C               Write(NERR,*) 'Begin mult match nb: ',K4,' in match'
C               Write(NERR,*) 'PK2B: ',PK2B(K4)
C               Write(NERR,*) 'PK3B: ',PK3B(K4)
C               Write(NERR,*) 'PJ1B: ',PJ1B(K4)
C               Write(NERR,*) 'PLAL: ',PLAL(K4)
               LIMM=.FALSE.
            End if
            K3=K3+LPRF
            K1=K1+LPRF
         End if

* delete position

      Else if(JS.EQ.3) then 
         LDTB=.TRUE.
         If(LIMM.AND.OPTM) then
            If(JO.EQ.1) then
               TDTB=IMSC(K4)+IIPX(XI,K3)
               IMSC(K4)=IMSC(K4)+IMPP(D,K3)
C               Write(NERR,*)'Score: ',IMPP(D,K3)
               IMSC(K4)=IMSC(K4)+IIPP(DI,K3)
C               Write(NERR,*)'Score: ',IIPP(DI,K3)
            Else if(JO.EQ.2) then
               TDTB=IMSC(K4)+IIPX(XM,K3)
               IMSC(K4)=IMSC(K4)+IMPP(D,K3)
C               Write(NERR,*)'Score: ',IMPP(D,K3)
               IMSC(K4)=IMSC(K4)+IIPP(DM,K3)
C               Write(NERR,*)'Score: ',IIPP(DM,K3)
            Else if(JO.EQ.3) then
               TDTB=IMSC(K4)+IIPX(XD,K3)
               IMSC(K4)=IMSC(K4)+IMPP(D,K3)
C               Write(NERR,*)'Score: ',IMPP(D,K3)
               IMSC(K4)=IMSC(K4)+IIPP(DD,K3)
C               Write(NERR,*)'Score: ',IIPP(DD,K3)
            End if
            If(TDTB.LT.MLOW) TDTB=MLOW
            If(TDTB.GT.SDTB) then
               SDTB=TDTB
               TK1B=K1
               TK2B=K2+1
               TK3B=K3
               TJ1B=J1
               TLAL=TJ1B-PJ1E(K4)
            End if
         Else if(.NOT.LIMM.AND.OPTM) then
            K4=K4+1
            PK2E(K4)=K2
            PK3E(K4)=K3
            PJ1E(K4)=J1
            If(K2.GE.LSEQ.AND.IIPX(DY,K3).GT.MLOW) then
               IMSC(K4)=IIPX(DY,K3)
C               Write(NERR,*)'Score: ',IIPX(DY,K3)
            Else if(IIPX(DX,K3).GT.MLOW) then
               IMSC(K4)=IIPX(DX,K3)
C               Write(NERR,*)'Score: ',IIPX(DX,K3)
            Else
               IMSC(K4)=0
            End if
            IMSC(K4)=IMSC(K4)+IMPP(D,K3)
C            Write(NERR,*)'Score: ',IMPP(D,K3)
C            Write(NERR,*) 'End mult match nb: ',K4,' in del'
C            Write(NERR,*) 'PK2E: ',PK2E(K4)
C            Write(NERR,*) 'PK3E: ',PK3E(K4)
C            Write(NERR,*) 'PJ1E: ',PJ1E(K4)
            LIMM=.TRUE.
            LDFE=.TRUE.
            SDTB=NLOW
            TDTB=NLOW
         End if
         J1=J1+1
         CALI(J1)='-'
C         Write(NERR,*) 'CALI(',J1,'): ',CALI(J1),' Deletion',
C     *      ' JS: ',JS
         K1=K1-1
         K3=K3-1
         If(LPCI.AND.K3.EQ.0) then 
            If(LIMM.AND.OPTM) then
               If(K2.LE.1.AND.IIPX(YD,K3).GT.MLOW) then
                  IMSC(K4)=IMSC(K4)+IIPX(YD,K3)
C                  Write(NERR,*)'Score: ',IIPX(YD,K3)
               Else if(IIPX(XD,K3).GT.MLOW) then
                  IMSC(K4)=IMSC(K4)+IIPX(XD,K3)
C                  Write(NERR,*)'Score: ',IIPX(XD,K3)
*              Else
*                 Do nothing
               End if
               If(.NOT.LDTB.OR.IMSC(K4).LE.-99999
     *            .OR.SDTB.LT.IMSC(K4)) then
                  PK2B(K4)=K2+1
                  PK3B(K4)=K3+1
                  PJ1B(K4)=J1
                  PLAL(K4)=PJ1B(K4)-PJ1E(K4)
C                  Write(NERR,*) 'Begin mult match nb: ',K4,' in del'
C                  Write(NERR,*) 'LDTB: ',LDTB
C                  Write(NERR,*) 'IMSC: ',IMSC(K4)
C                  Write(NERR,*) 'PK2B: ',PK2B(K4)
C                  Write(NERR,*) 'PK3B: ',PK3B(K4)
C                  Write(NERR,*) 'PJ1B: ',PJ1B(K4)
C                  Write(NERR,*) 'PLAL: ',PLAL(K4)
               Else
                  IMSC(K4)=SDTB
                  PK2B(K4)=TK2B
                  PK3B(K4)=TK3B+1
                  PJ1B(K4)=TJ1B
                  PLAL(K4)=TLAL
C                  Write(NERR,*) 'Begin mult match nb: ',K4,' in del_t_b'
C                  Write(NERR,*) 'LDTB: ',LDTB
C                  Write(NERR,*) 'IMSC: ',IMSC(K4)
C                  Write(NERR,*) 'PK2B: ',PK2B(K4)
C                  Write(NERR,*) 'PK3B: ',PK3B(K4)
C                  Write(NERR,*) 'PJ1B: ',PJ1B(K4)
C                  Write(NERR,*) 'PLAL: ',PLAL(K4)
               End if
               LIMM=.FALSE.
            End if
            K3=K3+LPRF
            K1=K1+LPRF
         End if
      End if 

* next traceback step

      Call Dcode(CPMA(K1),JM,JI,JD)
C      Write(NERR,*) 'K1: ',K1,' JM: ',JM,' JI: ',JI,
C     *   ' JD: ',JD,' JS: ',JS

      JO=JS

      If     (JS.EQ.1) then 
         JS=JI
      Else if(JS.EQ.2) then
         JS=JM
      Else if(JS.EQ.3) then
         JS=JD
      End if

      If(JS.NE.0) Go to 60

C      Write(NERR,*) 'JS eq 0 for: ',K2
      
      If(LIMM.AND.OPTM) then
         If(K2.LT.1) then
            If(JO.EQ.1.AND.IIPX(YI,K3).GT.MLOW) then
               IMSC(K4)=IMSC(K4)+IIPX(YI,K3)
C               Write(NERR,*)'Score: ',IIPX(YI,K3)
            Else if(JO.EQ.2.AND.IIPX(YM,K3).GT.MLOW) then
               IMSC(K4)=IMSC(K4)+IIPX(YM,K3)
C               Write(NERR,*)'Score: ',IIPX(YM,K3)
            Else if(JO.EQ.3.AND.IIPX(YD,K3).GT.MLOW) then
               IMSC(K4)=IMSC(K4)+IIPX(YD,K3)
C               Write(NERR,*)'Score: ',IIPX(YD,K3)
            End if
         Else
            If(JO.EQ.1.AND.IIPX(XI,K3).GT.MLOW) then
               IMSC(K4)=IMSC(K4)+IIPX(XI,K3)
C               Write(NERR,*)'Score: ',IIPX(XI,K3)
            Else if(JO.EQ.2.AND.IIPX(XM,K3).GT.MLOW) then
               IMSC(K4)=IMSC(K4)+IIPX(XM,K3)
C               Write(NERR,*)'Score: ',IIPX(XM,K3)
            Else if(JO.EQ.3.AND.IIPX(XD,K3).GT.MLOW) then
               IMSC(K4)=IMSC(K4)+IIPX(XD,K3)
C               Write(NERR,*)'Score: ',IIPX(XD,K3)
            End if
         End if
         If(.NOT.LDTB.OR.IMSC(K4).LE.-99999
     *      .OR.SDTB.LT.IMSC(K4)) then 
            PK2B(K4)=K2+1
            PK3B(K4)=K3+1
            PJ1B(K4)=J1
            PLAL(K4)=PJ1B(K4)-PJ1E(K4)
         Else
            IMSC(K4)=SDTB
            PK2B(K4)=TK2B
            PK3B(K4)=TK3B+1
            PJ1B(K4)=TJ1B
            PLAL(K4)=TLAL
         End if
C         Write(NERR,*) 'Begin mult match: ',K4
C         Write(NERR,*) 'PK2B: ',PK2B(K4)
C         Write(NERR,*) 'PK3B: ',PK3B(K4)
C         Write(NERR,*) 'PJ1B: ',PJ1B(K4)
C         Write(NERR,*) 'PLAL: ',PLAL(K4)
      End if

      If(K3.GE.LPRF) K3=0

      Do I1=K3,1,-1
C         Write(NERR,*) 'Add deletions'
         J1=J1+1
         CALI(J1)='-'
      End do

      LALI=J1
      If(OPTM) then
         NMAT=K4
C         Write(NERR,*)'*** Scores:'
C         Write(NERR,*)(IMSC(ii1),ii1=1,NMAT)
      End if

* reverse begin and end positions in alignment

      If(OPTM) then
         Do I1=1,NMAT
            PJ1B(I1)=LALI-PJ1B(I1)+1
            PJ1E(I1)=LALI-PJ1E(I1)
         End do
      End if

* reverse alignment

      J1=(LALI+1)/2
      Do I1=LALI/2+1,LALI 
         CH=CALI(I1)
         CALI(I1)=CALI(J1)
         CALI(J1)=CH         
         J1=J1-1
      End do

      IPMB=K3+1

 100  Return

      End 
*----------------------------------------------------------------------*
      Subroutine MaxP
     *   (IOPM,IOPI,IOPD,JM,JI,JD,KM,KI,KD,
     *   IMM,IMI,IMD,IIM,III,IID,
     *   IDM,IDI,IDD,IZM,IZI,IZD)

      JMM=KM+IMM
      JMI=KM+IMI
      JMD=KM+IMD
      JIM=KI+IIM
      JII=KI+III
      JID=KI+IID
      JDM=KD+IDM
      JDI=KD+IDI
      JDD=KD+IDD

      IOPM=IZM
      JM=0
      IOPI=IZI
      JI=0
      IOPD=IZD
      JD=0

      If(JIM.GT.IOPM) then
         IOPM=JIM
         JM=1
      End if
      If(JMM.GT.IOPM) then
         IOPM=JMM
         JM=2
      End if
      If(JDM.GT.IOPM) then
         IOPM=JDM
         JM=3
      End if

      If(JII.GT.IOPI) then
         IOPI=JII
         JI=1
      End if
      If(JMI.GT.IOPI) then
         IOPI=JMI
         JI=2
      End if
      If(JDI.GT.IOPI) then
         IOPI=JDI
         JI=3
      End if

      If(JID.GT.IOPD) then
         IOPD=JID
         JD=1
      End if
      If(JMD.GT.IOPD) then
         IOPD=JMD
         JD=2
      End if
      If(JDD.GT.IOPD) then
         IOPD=JDD
         JD=3
      End if

      Return
      End
*----------------------------------------------------------------------*
      Subroutine Ncode(CPMA,JM,JI,JD)

      Character         CPMA

      CPMA=Char(JM*16+JI*4+JD) 
      Return 
      End 
*----------------------------------------------------------------------*
      Subroutine Dcode(CPMA,JM,JI,JD)

      Character         CPMA

      JD=Ichar(CPMA)
      JM=JD/16
      JD=JD-JM*16
      JI=JD/ 4
      JD=JD-JI* 4
      Return 
      End 
*----------------------------------------------------------------------*
      Subroutine wtrace(IDMP,IDMM,LPRF,CPMA,K1,IOPM,IOPI,IOPD)

      Character CPMA(IDMM)
      Integer   IOPM(0:IDMP)
      Integer   IOPI(0:IDMP)
      Integer   IOPD(0:IDMP)

      Integer   IM(20)
      Integer   II(20)
      Integer   ID(20)

      J1=1
      Do I1=K1,K1+LPRF
         Call Dcode(CPMA(I1),IM(J1),II(J1),ID(J1))
         J1=J1+1
      End do

      Write(6,'(I4)') K1/(LPRF+1)
      Write(6,'(20(I4,I2))')(IOPM(ii1-1),IM(ii1),ii1=1,LPRF+1)
      Write(6,'(20(I4,I2))')(IOPI(ii1-1),II(ii1),ii1=1,LPRF+1)
      Write(6,'(20(I4,I2))')(IOPD(ii1-1),ID(ii1),ii1=1,LPRF+1)
      Return
      End

*       Program pfsearch
*----------------------------------------------------------------------*     
*       Function: Scan a protein or DNA sequence library for profile 
*                 matches 
*       Author:   Philipp Bucher
*       Version:  This file is part of pftools release 2.2 June 1999
*----------------------------------------------------------------------*     
* DATA
*----------------------------------------------------------------------*     

* array dimensions and I/O units

        Include         'ardim.f' 

        Parameter        (NOUT=   6)    

        Parameter        (NPRF=  11)    
        Parameter        (NSEQ=  12)    

* profile 

        Character*64      FPRF

        Include          'psdat.f'
        Include          'gsdat.f'
        Include          'djdat.f'
        Include          'nodat.f'
        Include          'codat.f'
        Include          'pfdat.f'
        Include          'dfdat.f'
        Include          'pxdat.f'
        Include          'avdat.f'
        Include          'sterr.f'

        Logical           LUNI
        Logical           LNOR
        Logical           LREV
        Logical           LTRA
        Logical           LPFA
        Logical           LEOF

* sequence

        Character*64      FSEQ

        Character*64      CSID
        Character*64      CSAC
        Character*256     CSDE

        Integer           LSEQ
        Integer*2         ISEQ(IDMS)

        Logical           LCKS(IDMS)

        Integer*2         IS

* options and command line parameters

        Logical           OPTA
        Logical           OPTB 
        Logical           OPTF 
        Logical           OPTL 
        Logical           OPLU 
        Logical           OPTR 
        Logical           OPTS 
        Logical           OPTU 
        Logical           OPTX 
        Logical           OPTY 
        Logical           OPTZ 
        
        Integer           NCUC
        Integer           KCUC
        real              XCUC

* alignments

        Integer           NALI
        Integer           IALS(IDMN)
        Integer           IALB(IDMN)
        Integer           IAL1(IDMN)
        Integer           IAL2(IDMN)
        Integer           IALE(IDMN)

        Integer           LALI
        Character         CALI(IDMA) 
        Character         CPMA(IDMM)

* path matrix fields

        Integer           IOPM(0:IDMP)
        Integer           IOPI(0:IDMP)
        Integer           IOPD(0:IDMP)

        Integer           IOMB(0:IDMP)
        Integer           IOM1(0:IDMP)
        Integer           IOM2(0:IDMP)

        Integer           IOIB(0:IDMP)
        Integer           IOI1(0:IDMP)
        Integer           IOI2(0:IDMP)

        Integer           IODB(0:IDMP)
        Integer           IOD1(0:IDMP)
        Integer           IOD2(0:IDMP)

* work fields

        Character*256     RCIN

* initialization of controlled vocabularies

        Include          'cvini.f' 

*----------------------------------------------------------------------*     
* INPUT SECTION 
*----------------------------------------------------------------------*     

        IRC=0

        LUNI=.FALSE.
        LNOR=.FALSE.
        LREV=.FALSE.
        LTRA=.FALSE.
        LPFA=.FALSE.
        LEOF=.FALSE.

        LEOF=.FALSE.
        CABC(0)='-'
 
* read command line arguments

        Call Repar(
     *     OPTA,OPTB,OPTF,OPTL,OPLU,OPTR,OPTS,OPTU,OPTX,OPTY,OPTZ,
     *     FPRF,FSEQ,NCUC,KCUC,XCUC,NW,IRC)
        If(IRC.NE.0) then 
           Write(NERR,'(
     *      ''Usage: pfsearch [ -abflLrsuxyz ] [ profile-file | - ] '',
     *      ''[ seq-library-file | - ] [ parameters ]'',//,
     *      ''   valid parameters are:'',//,
     *      ''                 [C=cut-off-value]          '',/
     *      ''                 [W=output-width]           '',/
     *        )')
           Stop
        End if

        If(FSEQ.EQ.'-') then 
           MSEQ=5
        Else
           MSEQ=NSEQ
        End if

        If(FPRF.EQ.'-') then 
           MPRF=5
        Else
           MPRF=NPRF
        End if

* read profile

        Call REPRF
     *    (MPRF,FPRF,
     *     CPID,CPAC,CPDT,CPDE,LHDR,CHDR,LFTR,CFTR,NABC,CABC,LPRF,LPCI,
     *     BLOG,FABC,P0,
     *     CDIS,JDIP,MDIS,NDIP,
     *     CNOR,JNOP,JNOR,MNOR,NNOR,NNPR,CNTX,RNOP, 
     *     JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT, 
     *     IDMP,CHIP,IIPP,CHMP,IMPP,
     *     CHID,IIPD,CHMD,IMPD,
     *     IRC)

        If(IRC.GT.0) go to 100

* cut-off form profile 

           KCUT=0
        Do   6 I1=1,JCUT
           If(MCLE(I1).EQ.0) then
                 INOR=0
              If(JCNM(I1).NE.0) then 
                 LNOR=.TRUE.
                       J2=1
                 Do  5 I2=1,JCNM(I1)
                          J3=0
                    Do  4 I3=1,JNOR
                       If(MCUT(I2,I1).EQ.NNOR(I3)) J3=I3
    4               Continue
                 
                    If     (I2.EQ.1) then 
                       INOR=J3
                       NPRI=NNPR(J3)    
                       IFUN=MNOR(J3)
                       KCUT=ICUT(I1)
                       XCUT=RCUT(I2,I1)
                    Else if(NNPR(J3).LT.NPRI) then
                       INOR=J3
                       NPRI=NNPR(J3)    
                       IFUN=MNOR(J3)
                       KCUT=ICUT(I1)
                       XCUT=RCUT(I2,I1)
                    End if
    5            Continue
              End if 

              If(JCNM(I1).EQ.0.OR.INOR.EQ.0) then
                 KCUT=ICUT(I1)
                 LNOR=.FALSE.
              End if
           End if
    6   Continue

* cut-off from command line 

        If     (NCUC.EQ.1) then 
           KCUT=KCUC 
           LNOR=.FALSE.
        Else if(NCUC.EQ.2.AND.LNOR) then
           XCUT=XCUC 
        End if

        If(OPTR) LNOR=.FALSE.

* disjointness definition

        If(MDIS.EQ.1.OR.OPTU.OR.OPTA) then
           LUNI=.TRUE.
        Else
           LUNI=.FALSE.

* - initialize profile lock

           If(.NOT.LPCI) then
              Do  8 I1=0,NDIP(1)-1 
                 IIPP(E0,I1)=NLOW
                 IIPP(E1,I1)=NLOW
    8         Continue

              Do  9 I1=NDIP(2),LPRF 
                 IIPP(B0,I1)=NLOW
                 IIPP(B1,I1)=NLOW
    9         Continue
           End if

        End if

* profile extra parameters

           MLOW=NLOW/4*3
        Do  10 I1=0,LPRF
           IIPX( XM,I1) = MAX(MLOW,IIPP( B1,I1) + IIPP( BM,I1)) 
           IIPX( XI,I1) = MAX(MLOW,IIPP( B1,I1) + IIPP( BI,I1)) 
           IIPX( XD,I1) = MAX(MLOW,IIPP( B1,I1) + IIPP( BD,I1)) 
           IIPX( YM,I1) = MAX(MLOW,IIPP( B0,I1) + IIPP( BM,I1)) 
           IIPX( YI,I1) = MAX(MLOW,IIPP( B0,I1) + IIPP( BI,I1)) 
           IIPX( YD,I1) = MAX(MLOW,IIPP( B0,I1) + IIPP( BD,I1)) 
           IIPX( MX,I1) = MAX(MLOW,IIPP( E1,I1) + IIPP( ME,I1)) 
           IIPX( IX,I1) = MAX(MLOW,IIPP( E1,I1) + IIPP( IE,I1)) 
           IIPX( DX,I1) = MAX(MLOW,IIPP( E1,I1) + IIPP( DE,I1)) 
           IIPX( MY,I1) = MAX(MLOW,IIPP( E0,I1) + IIPP( ME,I1)) 
           IIPX( IY,I1) = MAX(MLOW,IIPP( E0,I1) + IIPP( IE,I1)) 
           IIPX( DY,I1) = MAX(MLOW,IIPP( E0,I1) + IIPP( DE,I1))
	   print *, "DBG", i1, "B1", IIPP( B1,I1), "BM", IIPP( BM,I1)
     *             , IIPX( XM,I1)
   10   Continue

* average match score for average amino acid composition 

        If(LNOR.AND.IFUN.EQ.3) 
     *     Call CPAve(IMPP,IDMP,LPRF,CABC,NABC,PAVE)

* alignment and ouptut format switches 

        If(OPTX.OR.OPTY.OR.OPTZ) then 
           LTRA=.TRUE.
        Else
           LTRA=.FALSE.
        End if
        If(OPTS.OR.OPTX) then
           LPFA=.TRUE.
        Else
           LPFA=.FALSE.
        End if
  
*----------------------------------------------------------------------*
* major loop over sequences
*----------------------------------------------------------------------*

* read sequence  

   20   Continue
        If(LEOF) go to 100
        If(OPTF) then 
           Call RFSEQ
     *      (MSEQ,FSEQ,NABC,CABC,CSID,CSAC,CSDE,LSEQ,ISEQ,LEOF,RCIN,IRC)
        Else 
           Call RESEQ
     *      (MSEQ,FSEQ,NABC,CABC,CSID,CSAC,CSDE,LSEQ,ISEQ,LEOF,RCIN,IRC)
        End if 
        If(IRC.EQ.-1) go to 100

        If(IRC.NE.0) then 
           Write(NERR,'(
     *      ''Sequence file unreadable or in wrong format.''
     *        )')
           Stop
        End if 

        JSEQ=0

   25   Continue

* compute cut-off in raw score units

        If(LNOR) then
           If(IFUN.EQ.3) then
              Call CFAve(ISEQ,IDMS,LSEQ,CABC,NABC,FAVE)
                 RAVE=0
              Do  I1=0,NABC
                 RAVE=RAVE+FAVE(I1)*PAVE(I1)
              End do
           End if
           Call NtoR(XCUT,KCUT,RNOP,KNPM,MAXN,INOR,IFUN,LSEQ,RAVE)
        End if

* compute optimal alignment score

        Call XALI1
     *    (NABC,CABC,LPRF,LPCI,
     *     KCUT,IDMP,IIPP,IMPP,CHIP,CHMP,IIPX,
     *     IDMS,LSEQ,ISEQ,
     *     IOPM,IOPI,IOPD,
     *     IOPT,LUNI,  
     *     IRC)

        If(OPTA) then
           Continue         
        Else if(IOPT.LT.KCUT) then
           go to  50
        End if 

        If(LUNI) go to  30 

* initialize sequence lock

        Do I1=1,LSEQ
           LCKS(I1)=.FALSE.
        End do  

* find multiple matches 

        Call XALIP
     *    (NABC,CABC,LPRF,LPCI,NDIP(1),NDIP(2),
     *     KCUT,IDMP,IIPP,IMPP,CHIP,CHMP,IIPX,
     *     IDMS,LSEQ,ISEQ,LCKS,
     *     IOPM,IOPI,IOPD,
     *     IOMB,IOM1,IOM2,IOIB,IOI1,IOI2,IODB,IOD1,IOD2,
     *     IDMN,NALI,IALS,IALB,IAL1,IAL2,IALE, 
     *     IRC)

* remove sequence lock if alignments are to be generated

        If(LTRA) then 
           Do I1=1,LSEQ
              LCKS(I1)=.FALSE.
           End do 
        End if 

* OUTPUT 

   30   Continue         
 
        If(LUNI) then 
           NALI=1
           IALS(1)=IOPT
        End if 
        
        Do  40 I1=1,NALI
           JSEQ=JSEQ+1

           If(LTRA) then 
              Call XALIT
     *          (NABC,CABC,LPRF,LPCI,NDIP(1),NDIP(2),
     *           KCUT,IDMP,IIPP,IMPP,CHIP,CHMP,IIPX,
     *           IDMS,LSEQ,ISEQ,LCKS,
     *           IOPM,IOPI,IOPD,
     *           LALI,IDMA,CALI,IDMM,CPMA,
     *           IALS(I1),IALB(I1),IALE(I1), 
     *           IPMB,IPME,
     *           IRC)
              Do  I2=IAL1(I1),IAL2(I1)
                 LCKS(I2)=.TRUE.
              End do
           End if 

           Call WPRSM(JSEQ,
     *       LUNI,LNOR,LREV,LPFA,OPTZ,OPTL,OPLU,NW,
     *       CSID,CSAC,CSDE,
     *       IALS(I1),IALB(I1),IALE(I1),NALI,IPMB,IPME,
     *       JCUT,MCLE,CCUT,ICUT,JCNM,RCUT,MCUT,
     *       RNOP,KNPM,MAXN,INOR,IFUN,LSEQ,RAVE)

           If     (OPTS) then
              Write(6,'((60A))')(CABC(ISEQ(ii1)),ii1=IALB(I1),IALE(I1))
           Else if(OPTX) then
              Write(6,'((60A))')(CALI(ii1),ii1=1,LALI)
           Else if(OPTY) then 
              Call PRALI
     *          (LPRF,CHIP,CHMP,IDMP,LSEQ,LREV,
     *           CALI,LALI,IALB(I1),IALE(I1))
           End if 

   40   Continue

   50   Continue

        If(OPTB) then 
           If(LREV) then 
              LREV=.FALSE.
              Go to  20
           Else
              Continue
           End if
        Else
           Go to  20
        End if

*----------------------------------------------------------------------*
* Complementary strand 
*----------------------------------------------------------------------*

        LREV=.TRUE.

* generate complementary sequence

           J1=LSEQ          
        Do  I1=1,LSEQ/2
           IS=ISEQ(I1)
           ISEQ(I1)=ISEQ(J1)
           ISEQ(J1)=IS
           J1=J1-1
        End do  

        Do  I1=1,LSEQ
           If(ISEQ(I1).NE.0) ISEQ(I1)=NABC-ISEQ(I1)+1
        End do

        Go to  25

  100   Stop
        End
*----------------------------------------------------------------------*     
        Subroutine Repar(
     *     OPTA,OPTB,OPTF,OPTL,OPLU,OPTR,OPTS,OPTU,OPTX,OPTY,OPTZ,
     *     FPRF,FSEQ,NCUC,KCUC,XCUC,NW,IRC)

        Logical           OPTA 
        Logical           OPTB 
        Logical           OPTF 
        Logical           OPTL 
        Logical           OPLU 
        Logical           OPTR 
        Logical           OPTS 
        Logical           OPTU 
        Logical           OPTX 
        Logical           OPTY 
        Logical           OPTZ 

        Character*64      FPRF
        Character*64      FSEQ
        Character*64      CARG

        IRC=0
        NCUC=0
        OPTA=.FALSE.
        OPTB=.FALSE.
        OPTF=.FALSE.
        OPTL=.FALSE.
        OPLU=.FALSE.
        OPTR=.FALSE.
        OPTS=.FALSE.
        OPTU=.FALSE.
        OPTX=.FALSE.
        OPTY=.FALSE.
        OPTZ=.FALSE.

        NW=132

        N1=Iargc()

           K1=0
        Do  10 I1=1,N1
           Call GetArg(I1,CARG)
           If     (CARG(1:1).EQ.'-'.
     *                AND.CARG(2:2).NE.' '.AND.K1.LT.1) then
              If(Index(CARG,'a').NE.0) OPTA=.TRUE.
              If(Index(CARG,'b').NE.0) OPTB=.TRUE.
              If(Index(CARG,'f').NE.0) OPTF=.TRUE.
              If(Index(CARG,'l').NE.0) OPTL=.TRUE.
              If(Index(CARG,'L').NE.0) OPLU=.TRUE.
              If(Index(CARG,'r').NE.0) OPTR=.TRUE.
              If(Index(CARG,'s').NE.0) OPTS=.TRUE.
              If(Index(CARG,'u').NE.0) OPTU=.TRUE.
              If(Index(CARG,'x').NE.0) OPTX=.TRUE.
              If(Index(CARG,'y').NE.0) OPTY=.TRUE.
              If(Index(CARG,'z').NE.0) OPTZ=.TRUE.
           Else if(K1.LE.1) then
              K1=K1+1
              If     (K1.EQ.1) then 
                 FPRF=CARG
              Else if(K1.EQ.2) then
                 FSEQ=CARG
              End if  
           Else 

* - cut-off value on command line    

              If     (CARG(1:2).EQ.'C=') then
                 CARG(1:2)='  '
                 If(Index(CARG,'.').EQ.0) then
                    NCUC=1 
                    Read(CARG,*) KCUC
                 Else 
                    NCUC=2
                    Read(CARG,*) XCUC
                 End if 
              Else if(CARG(1:2).EQ.'W=') then
                 Read(CARG(3:64),*,Err=900) NW
              End if
           End if
   10   Continue 

        If (K1.NE.2) IRC=1 
           
  100   Return
  900   IRC=1
        Go to 100
        End 
*----------------------------------------------------------------------*     
        Include          'reprf.f'
        Include          'reseq.f'
        Include          'rfseq.f'
#include "xali1.f"
        Include          'xalip.f'
        Include          'RtoN.f'
        Include          'NtoR.f'
        Include          'CFAve.f'
        Include          'CPAve.f'
        Include          'wprsm.f'
        Include          'xalit.f'
        Include          'lblnk.f'
        Include          'prali.f'

*----------------------------------------------------------------------*     
* $Id: wrhmr.f,v 2.4 2003/03/26 14:40:29 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
      Subroutine WRHMR
     *   (NOUT,NERR,IDMP,RIHM,RMHM,LHMM,NABC,CABC,FLOW,RSCA,BLOG) 

      Include         'pfind.f' 
      Include         'hmdat.f'

      Real*8           BLOG
      Character        CABC(0:26)

      Character*64     RCEX        
      

* Log to Prob

      Do  10 I1=0,LHMM
         Do I2=1,46
            If     (RIHM(I2,I1).LE.FLOW) then
               RIHM(I2,I1)=0.0
            Else If(RIHM(I2,I1).LE.-6.0) then
               RIHM(I2,I1)=0.000001
            Else
               RIHM(I2,I1)=EXP(RIHM(I2,I1))
            End if 
         End do
         If(I1.GT.0) then  
            Do I2=1,27
               If     (RMHM(I2,I1).LE.FLOW) then
                  RMHM(I2,I1)=0.0
               Else If(RIHM(I2,I1).LE.-6.0) then
                  RMHM(I2,I1)=0.000001
               Else
                  RMHM(I2,I1)=EXP(RMHM(I2,I1))
               End if 
            End do
         End if 
 10   Continue

* header 

      Write(NOUT,'(''# HMM v1.7'')')
      RSCA=RSCA/BLOG
      Write(NERR,'(
     *   ''# HMM converted from generalized profile'',
     *   '' with pftools program htop.'',
     *   /,''# Logarithic base of profile: '',F12.8,''.'',
     *   /,''# Offset: profile score = '',E10.4,'' + Log(Prob).'')')
     *   exp(BLOG),RSCA

      Write(RCEX(1:8),'(I8)') LHMM 
      Do I1=1,8
         If(RCEX(I1:I1).NE.' ') Go to  12 
      End do
 12   RCEX(1:8)=RCEX(I1:8) // RCEX(1:I1-1)
      Write(NOUT,'(A8,''# M -- length of model'')') RCEX(1:8) 
      If(NABC.EQ.4) then  
         Write(NOUT,'(''4       # alphabet length'')') 
         Write(NOUT,'(''1       # alphabet type'')') 
         Write(NOUT,'( 4A,''    # alphabet'')')(CABC(ii1),ii1=1,NABC) 
      Else
         Write(NOUT,'(''20      # alphabet length'')') 
         Write(NOUT,'(''3       # alphabet type'')') 
         Write(NOUT,'(20A,''    # alphabet'')')(CABC(ii1),ii1=1,NABC) 
      End if
      Write(NOUT,
     *   '(''no      # Optional reference line annotation?'')')
      Write(NOUT,
     *   '(''no      # Optional consensus structure annotation?'')')

* make sure that meaningless parameter at pos. 0 equal 0 

      Do I1=1,27
         RMHM(I1,0)=0.0
      End do

* write HMM probabilites

      Do  I1=0,LHMM

* match state

         Write(RCEX(1:8),'(I8)') I1
         Do I2=1,8
            If(RCEX(I2:I2).NE.' ') Go to  21 
         End do
 21      RCEX='###MATCH_STATE ' // RCEX(I2:8)
         RCEX=RCEX(1:Lblnk(RCEX)) // ' ( ) ( )'
         Write(NOUT,'(64A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))

         Write(NOUT,'(F8.6,''        # t_m1'')') RIHM(MM,I1)
         Write(NOUT,'(F8.6,''        # t_d1'')') RIHM(MD,I1)
         Write(NOUT,'(F8.6,''        # t_i0'')') RIHM(MI,I1)

         Do I2=1,NABC
            Write(NOUT,
     *         '(F8.6,''        # Symbol '',A,'' probability'')')
     *         RMHM(I2,I1),CABC(I2)
         End do 

* delete state

         Write(RCEX(1:8),'(I8)') I1
         Do I2=1,8
            If(RCEX(I2:I2).NE.' ') Go to  22 
         End do
 22      RCEX='###DELETE_STATE ' // RCEX(I2:8)
         RCEX=RCEX(1:Lblnk(RCEX)) // ' ( ) ( )'
         Write(NOUT,'(64A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))

         Write(NOUT,'(F8.6,''        # t_m1'')') RIHM(DM,I1)
         Write(NOUT,'(F8.6,''        # t_d1'')') RIHM(DD,I1)
         Write(NOUT,'(F8.6,''        # t_i0'')') RIHM(DI,I1)

* insert state 

         Write(RCEX(1:8),'(I8)') I1
         Do I2=1,8
            If(RCEX(I2:I2).NE.' ') Go to  23 
         End do
 23      RCEX='###INSERT_STATE ' // RCEX(I2:8)
         RCEX=RCEX(1:Lblnk(RCEX)) // ' ( ) ( )'
         Write(NOUT,'(64A)')(RCEX(ii1:ii1),ii1=1,Lblnk(RCEX))

         Write(NOUT,'(F8.6,''        # t_m1'')') RIHM(IM,I1)
         Write(NOUT,'(F8.6,''        # t_d1'')') RIHM(ID,I1)
         Write(NOUT,'(F8.6,''        # t_i0'')') RIHM(II,I1)

         Do I2=1,NABC
            Write(NOUT,
     *         '(F8.6,''        # Symbol '',A,'' probability'')')
     *         RIHM(I2,I1),CABC(I2)
         End do 

      End do 

 100  Return
      End 

*----------------------------------------------------------------------*     
* $Id: pxdat.f,v 2.4 2003/04/10 11:58:37 vflegel Exp $
*----------------------------------------------------------------------*     
*       Version:  File under developpment for release 2.3
*----------------------------------------------------------------------*     
* PROFILE EXTRA PARAMETERS  

      Integer           XM 
      Integer           XI 
      Integer           XD 
      Integer           YM 
      Integer           YI 
      Integer           YD 
      Integer           MX 
      Integer           IX 
      Integer           DX 
      Integer           MY 
      Integer           IY 
      Integer           DY 

      Parameter        (XM=   1) 
      Parameter        (XI=   2)
      Parameter        (XD=   3)
      Parameter        (YM=   4)
      Parameter        (YI=   5)
      Parameter        (YD=   6)
      Parameter        (MX=   7)
      Parameter        (IX=   8)
      Parameter        (DX=   9)
      Parameter        (MY=  10)
      Parameter        (IY=  11)
      Parameter        (DY=  12)
* 
      Integer           IIPX(1:12,0:IDMP)     
      
